
package pe.siso.academia.DAO;

import java.util.ArrayList;
import pe.siso.academia.Beans.Aula;
import pe.siso.academia.Beans.Matricula;
import pe.siso.academia.Beans.Pension;

public interface MatriculaDAO {
    public ArrayList<Matricula> listarMatriculas(int sede, String filtro,int inicio, int cant) throws Exception;
    public ArrayList<Matricula> listarMatriculados(int sede, String filtro,int inicio, int cant) throws Exception;
    public ArrayList<Matricula> listarCentros(int codSede) throws Exception;
    public ArrayList<Matricula> listarNiveles(int codSede, int idCentro) throws Exception;
    public ArrayList<Matricula> listarTiposGrado(int codSede, int idCentro, int idNivel) throws Exception;
    public ArrayList<Matricula> listarGrados(int codSede, int idCentro, int idNivel, int idTipo) throws Exception;
    public ArrayList<Matricula> listarTurnos(int codSede, int idCentro, int idNivel, int idTipo, int idGrado) throws Exception;
    public ArrayList<Matricula> listarSecciones(int codAula) throws Exception;
    public Aula obtenerAula(int codAula) throws Exception;
    public int contarMatriculas(int sede, String filtro) throws Exception;
    public int contarMatriculados(int sede, String filtro) throws Exception;
    
    public int validarMatriculaExistente(int aula, int estudiante) throws Exception;
    
    public int matricularAlumno(int cod_estu, String fechaMatricula, int codAula, String seccion, String condicion, String observaciones, String informo, String eligio, String[] codDoc, String[] valDoc, String[] codPen, String[] monPen, String motDes, double monDes,String autorizacion) throws Exception;
    public int deshabilitarMatricula(int cod_matricula) throws Exception;
    public Matricula obtenerMatricula(int cod_matricula) throws Exception;
    public Matricula mostrarMatriculaCompleta(int cod_matricula) throws Exception;
    //PENSION
    public ArrayList<Pension> obtenerPensionesPorAula(int aula) throws Exception;
    // ACTUALIZAR MATRICULA
    public int actualizarMatricula(int cod_matricula, String obs, int aula, String seccion) throws Exception;
}