
package pe.siso.academia.DAO;

import java.util.ArrayList;
import pe.siso.academia.Beans.Monto;
public interface MontoDAO {
    /*  Listar  */
    public ArrayList<Monto> listarCentros(String nombre, int inicio, int cantidad) throws Exception;
    public ArrayList<Monto> listarNiveles(int sede, String nombre, int inicio, int cantidad) throws Exception;
    public ArrayList<Monto> listarGrados(int nivel, String nombre, int inicio, int cantidad) throws Exception;
    public ArrayList<Monto> listarCiclos(int grado, String nombre, int inicio, int cantidad) throws Exception;
    public ArrayList<Monto> listarTurnos() throws Exception;
    
    /*  Contabilizar  */
    public int contarCentros(String nombre) throws Exception;
    public int contarNiveles(int sede, String nombre) throws Exception;
    public int contarGrados(int nivel, String nombre) throws Exception;
    public int contarCiclos(int grado, String nombre) throws Exception;
    
    /*  Insertar  */
    public int insertarCentros(String nombre) throws Exception;
    public int insertarNiveles(int idCentro, String nombre) throws Exception;
    public int insertarGrados(int idNivel, String nombre) throws Exception;
    public int insertarCiclos(int idGrado, String nombre) throws Exception;
    
    /*  Cambiar Estado  */
    public int cambiarEstadoCentros(int codCentro, int estado) throws Exception;
    public int cambiarEstadoNiveles(int codNivel, int estado) throws Exception;
    public int cambiarEstadoGrados(int codGrado, int estado) throws Exception;
    public int cambiarEstadoCiclos(int codCiclo, int estado) throws Exception;
    
    /*  Editar Estado  */
    public int editarCentro(int codCentro, String nombre) throws Exception;
    public int editarNivel(int codNivel, String nombre) throws Exception;
    public int editarGrado(int codGrado, String nombre) throws Exception;
    public int editarCiclo(int codCiclo, String nombre) throws Exception;
}
