
package pe.siso.academia.DAO;

import java.util.ArrayList;
import org.json.simple.JSONArray;
import org.json.simple.JSONObject;
import pe.siso.academia.Beans.Cierre;
import pe.siso.academia.Beans.Pension;

public interface PensionDAO {
    public ArrayList<Pension> listarPensionesPorAlumno(int codMatricula) throws Exception;
    public int activarPension(int codPension) throws Exception;
    public int anularPension(int codPension, String motivo,int codUsuario,String fecha_actual) throws Exception;
    public JSONObject ComprobanteElectronicoAnular(int codPagoCuota) throws Exception;
    public int devolverPension(int codPension, double monto,double monto_neto, String tipoDoc, String numSerie, String numDoc, String motivo,String cod_usu,String cod_sede,int tipo_nota_credito) throws Exception;
    public int pagarPension(int codsede ,int codPension, int codigoUsuario, String monto, String nomDscto, String montoDscto, String fechaPago, String formaPago, String tipoDoc, String obs, double regu,int num_serie,int num_doc,String razon_social,String ruc,int  cod_enlace_desc) throws Exception;
    public int fraccionarPension(int codPagoCuota, String[] monto,String[] posDescuento) throws Exception;
    public Pension obtenerPension(int codPension) throws Exception;
    public Pension obtenerDetalle(int codPension) throws Exception;
    /* Documentación: BOLETA */
     public String generarNumBoleta(int codSede) throws Exception;
     public String imprimirBoletaPago(int codPension) throws Exception;
     public JSONObject ComprobanteElectronico(int codPension) throws Exception;
     public int GuardarUrl(int codCuotaPago, String url,String TipoDocumento) throws Exception;
    
    /* Actualizacion de Matricula */
    public boolean verificarPensionesActualizarMatri(int codmatricula) throws Exception;
    public int actualizarPensiones(int codMatricula,String codPen[], String monPen[],String nom_desc,double mon_desc) throws Exception;
    public int duplicarPensionAnulada(int codPagoCuota) throws Exception;
    public int anularPensionesPorMatricula(int codMatricula,int valueradio,String observ) throws Exception;
    public int habilitarPensionAnulada(int codPagoCuota) throws  Exception;
    public ArrayList<Cierre> AdvertenciaCierreDiario(int codsede)throws Exception;
    public int  guardarDescuento(int codPagoCuota,String nombreDescuento,double montoDescuento,String motivoDescuento,int cod_enlace_dsc) throws Exception;
    public int maxMontoFraccionado(int codPagoCuota) throws Exception;
    
//    NUBEFACT
    public JSONArray tipoNotaDeCredito()throws Exception;
    public int GuardarJsonErrorNubeFact(JSONObject jsonNubefact,String motivo,int codPagoCuota,String codsede,String estado_nubefact) throws Exception; 
    public JSONArray listarBackupErrorNubeFact()throws Exception;

}
