
package pe.siso.academia.MySqlDAO;

import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.Statement;
import java.util.ArrayList;
import pe.siso.academia.Beans.Aula;
import pe.siso.academia.Beans.Pension;
import pe.siso.academia.DAO.AulaDAO;

public class MySqlAulaDAO implements AulaDAO {

    @Override
    public ArrayList<Aula> listarAulas(int codsed, int inicio, int cant) throws Exception {
        ArrayList<Aula> lista = new ArrayList<>();
        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "SELECT a.codAula,a.codSede,s.deslocal,a.codCentro,c.nom_centro,\n" +
            "a.codNivel,n.nivel,a.codTipoGrado,tg.grado,a.codGrado,ci.ciclo,\n" +
            "a.codTurno,tur.turno,a.fechaInicio,a.fechaTermino,a.cuotas,a.estado,a.tipoSeccion,\n" +
            "COUNT(nomaula) AS secciones,(select COUNT(*) from matricula WHERE codAula=a.codAula) as CantidadMatriculados FROM aula AS a\n" +
            "LEFT JOIN sede as s ON a.codSede = s.idlocal\n" +
            "LEFT JOIN centro as c ON a.codCentro = c.cod_centro\n" +
            "LEFT JOIN academia_nivel as n ON a.codNivel = n.idnivel\n" +
            "LEFT JOIN academia_grado as tg ON a.codTipoGrado = tg.idgrado\n" +
            "LEFT JOIN academia_ciclo as ci ON a.codGrado = ci.idciclo\n" +
            "LEFT JOIN seccion as sec ON a.codAula = sec.idaula\n" +
            "LEFT JOIN academia_turno as tur ON a.codTurno = tur.idturno\n" +
            "WHERE a.codSede = " + codsed + "\n" +
            "GROUP BY(codAula) ORDER BY codAula desc LIMIT " + inicio + "," + cant;
        
        ResultSet rs = st.executeQuery(query);
        System.out.println(" Sentencia Aula  \n "+query);
        while(rs.next()){
            Aula aula = new Aula();
            aula.setCodAula(rs.getString("codAula"));
            aula.setCodSede(rs.getString("codSede"));
            aula.setNomSede(rs.getString("deslocal"));
            aula.setCodCentro(rs.getString("codCentro"));
            aula.setNomCentro(rs.getString("nom_centro"));
            aula.setCodNivel(rs.getString("codNivel"));
            aula.setNomNivel(rs.getString("nivel"));
            aula.setCodTipoGrado(rs.getString("codTipoGrado"));
            aula.setNomTipoGrado(rs.getString("grado"));
            aula.setCodGrado(rs.getString("codGrado"));
            aula.setNomGrado(rs.getString("ciclo"));
            aula.setCodTurno(rs.getString("codTurno"));
            aula.setNomTurno(rs.getString("turno"));
            aula.setFechaInicio(rs.getString("fechaInicio"));
            aula.setFechaTermino(rs.getString("fechaTermino"));
            aula.setCuotas(rs.getString("cuotas"));
            aula.setEstado(rs.getString("estado"));
            aula.setSecciones(rs.getString("secciones"));
            aula.setTipoSeccion(rs.getString("tipoSeccion"));
            aula.setCantMatriculados(rs.getString("CantidadMatriculados"));
            lista.add(aula);
        }
          cnx.close(); return lista;
    }

    @Override
    public int contarAulas(int sede) throws Exception {
        
        int cantidad = 0;
        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "SELECT COUNT(*) AS cant \n" +
            "FROM aula AS a \n" +
            "INNER JOIN sede as s ON a.codSede = s.idlocal \n" +
            "INNER JOIN centro as c ON a.codCentro = c.cod_centro \n" +
            "INNER JOIN academia_nivel as n ON a.codNivel = n.idnivel \n" +
            "INNER JOIN academia_grado as tg ON a.codTipoGrado = tg.idgrado \n" +
            "INNER JOIN academia_ciclo as ci ON a.codGrado = ci.idciclo \n" +
            "WHERE a.codSede = " + sede + "\n";
        ResultSet rs = st.executeQuery(query);
        while(rs.next()){
            cantidad = rs.getInt("cant");
        }
      
          cnx.close(); return cantidad;
    }
    
    @Override
    public ArrayList<Aula> listarAulasPorSede(int codsede, int inicio, int cant) throws Exception {
        ArrayList<Aula> lista = new ArrayList<>();
        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "SELECT a.codAula,a.codSede,s.deslocal,a.codCentro,c.nom_centro,\n" +
            "a.codNivel,n.nivel,a.codTipoGrado,tg.grado,a.codGrado,ci.ciclo,\n" +
            "a.codTurno,tur.turno,a.fechaInicio,a.fechaTermino,a.cuotas,a.estado,\n" +
            "COUNT(nomaula) AS secciones FROM aula AS a\n" +
            "LEFT JOIN sede as s ON a.codSede = s.idlocal\n" +
            "LEFT JOIN centro as c ON a.codCentro = c.cod_centro\n" +
            "LEFT JOIN academia_nivel as n ON a.codNivel = n.idnivel\n" +
            "LEFT JOIN academia_grado as tg ON a.codTipoGrado = tg.idgrado\n" +
            "LEFT JOIN academia_ciclo as ci ON a.codGrado = ci.idciclo\n" +
            "LEFT JOIN seccion as sec ON a.codAula = sec.idaula\n" +
            "LEFT JOIN academia_turno as tur ON a.codTurno = tur.idturno\n" +
            "WHERE codSede = " + codsede + " \n" +
            "GROUP BY(codAula) ORDER BY codAula LIMIT " + inicio + "," + cant;
        
        ResultSet rs = st.executeQuery(query);
        
        while(rs.next()){
            Aula aula = new Aula();
            aula.setCodAula(rs.getString("codAula"));
            aula.setCodSede(rs.getString("codSede"));
            aula.setNomSede(rs.getString("deslocal"));
            aula.setCodCentro(rs.getString("codCentro"));
            aula.setNomCentro(rs.getString("nom_centro"));
            aula.setCodNivel(rs.getString("codNivel"));
            aula.setNomNivel(rs.getString("nivel"));
            aula.setCodTipoGrado(rs.getString("codTipoGrado"));
            aula.setNomTipoGrado(rs.getString("grado"));
            aula.setCodGrado(rs.getString("codGrado"));
            aula.setNomGrado(rs.getString("ciclo"));
            aula.setCodTurno(rs.getString("codTurno"));
            aula.setNomTurno(rs.getString("turno"));
            aula.setFechaInicio(rs.getString("fechaInicio"));
            aula.setFechaTermino(rs.getString("fechaTermino"));
            aula.setCuotas(rs.getString("cuotas"));
            aula.setEstado(rs.getString("estado"));
            aula.setSecciones(rs.getString("secciones"));
            lista.add(aula);
        }
          cnx.close(); return lista;
    }

    @Override
    public int contarAulasPorSede(int codsede) throws Exception {
        int cantidad = 0;
        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "SELECT COUNT(*) AS cant\n" +
            "FROM aula AS a\n" +
            "INNER JOIN sede as s ON a.codSede = s.idlocal\n" +
            "INNER JOIN centro as c ON a.codCentro = c.cod_centro\n" +
            "INNER JOIN academia_nivel as n ON a.codNivel = n.idnivel\n" +
            "INNER JOIN academia_grado as tg ON a.codTipoGrado = tg.idgrado\n" +
            "INNER JOIN academia_ciclo as ci ON a.codGrado = ci.idciclo" +
            "WHERE codSede = " + codsede + " \n" ;
        ResultSet rs = st.executeQuery(query);
        while(rs.next()){
            cantidad = rs.getInt("cant");
        }
          cnx.close(); return cantidad;
    }

    @Override
    public ArrayList<Aula> listarAulasPorFechaInicio(int sede, String f1, String f2, int inicio, int cant) throws Exception {
        ArrayList<Aula> lista = new ArrayList<>();
        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "SELECT a.codAula,a.codSede,s.deslocal,a.codCentro,c.nom_centro,\n" +
            "a.codNivel,n.nivel,a.codTipoGrado,tg.grado,a.codGrado,ci.ciclo,\n" +
            "a.codTurno,tur.turno,a.fechaInicio,a.fechaTermino,a.cuotas,a.estado,\n" +
            "COUNT(nomaula) AS secciones FROM aula AS a\n" +
            "LEFT JOIN sede as s ON a.codSede = s.idlocal\n" +
            "LEFT JOIN centro as c ON a.codCentro = c.cod_centro\n" +
            "LEFT JOIN academia_nivel as n ON a.codNivel = n.idnivel\n" +
            "LEFT JOIN academia_grado as tg ON a.codTipoGrado = tg.idgrado\n" +
            "LEFT JOIN academia_ciclo as ci ON a.codGrado = ci.idciclo\n" +
            "LEFT JOIN seccion as sec ON a.codAula = sec.idaula\n" +
            "LEFT JOIN academia_turno as tur ON a.codTurno = tur.idturno\n" +
            "WHERE fechaInicio >= '" + f1 + "' AND fechaInicio <= '" + f2 + "' AND a.codSede = " + sede + " \n" +
            "GROUP BY(codAula) ORDER BY codAula LIMIT " + inicio + "," + cant;
        
        ResultSet rs = st.executeQuery(query);
        
        while(rs.next()){
            Aula aula = new Aula();
            aula.setCodAula(rs.getString("codAula"));
            aula.setCodSede(rs.getString("codSede"));
            aula.setNomSede(rs.getString("deslocal"));
            aula.setCodCentro(rs.getString("codCentro"));
            aula.setNomCentro(rs.getString("nom_centro"));
            aula.setCodNivel(rs.getString("codNivel"));
            aula.setNomNivel(rs.getString("nivel"));
            aula.setCodTipoGrado(rs.getString("codTipoGrado"));
            aula.setNomTipoGrado(rs.getString("grado"));
            aula.setCodGrado(rs.getString("codGrado"));
            aula.setNomGrado(rs.getString("ciclo"));
            aula.setCodTurno(rs.getString("codTurno"));
            aula.setNomTurno(rs.getString("turno"));
            aula.setFechaInicio(rs.getString("fechaInicio"));
            aula.setFechaTermino(rs.getString("fechaTermino"));
            aula.setCuotas(rs.getString("cuotas"));
            aula.setEstado(rs.getString("estado"));
            aula.setSecciones(rs.getString("secciones"));
            lista.add(aula);
        }
          cnx.close(); return lista;
    }

    @Override
    public int contarAulasPorFechaInicio(int sede, String f1, String f2) throws Exception {
        int cantidad = 0;
        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "SELECT COUNT(*) AS cant \n" +
            "FROM aula AS a \n" +
            "INNER JOIN sede as s ON a.codSede = s.idlocal \n" +
            "INNER JOIN centro as c ON a.codCentro = c.cod_centro \n" +
            "INNER JOIN academia_nivel as n ON a.codNivel = n.idnivel \n" +
            "INNER JOIN academia_grado as tg ON a.codTipoGrado = tg.idgrado \n" +
            "INNER JOIN academia_ciclo as ci ON a.codGrado = ci.idciclo \n" +
            "WHERE fechaInicio >= '" + f1 + "' AND fechaInicio <= '" + f2 + "' AND a.codSede = " + sede + " \n" ;
        ResultSet rs = st.executeQuery(query);
        while(rs.next()){
            cantidad = rs.getInt("cant");
        }
          cnx.close(); return cantidad;
    }

    @Override
    public ArrayList<Aula> listarAulasPorFechaCese(int sede, String f1, String f2, int inicio, int cant) throws Exception {
        ArrayList<Aula> lista = new ArrayList<>();
        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "SELECT a.codAula,a.codSede,s.deslocal,a.codCentro,c.nom_centro,\n" +
            "a.codNivel,n.nivel,a.codTipoGrado,tg.grado,a.codGrado,ci.ciclo,\n" +
            "a.codTurno,tur.turno,a.fechaInicio,a.fechaTermino,a.cuotas,a.estado,\n" +
            "COUNT(nomaula) AS secciones FROM aula AS a\n" +
            "LEFT JOIN sede as s ON a.codSede = s.idlocal\n" +
            "LEFT JOIN centro as c ON a.codCentro = c.cod_centro\n" +
            "LEFT JOIN academia_nivel as n ON a.codNivel = n.idnivel\n" +
            "LEFT JOIN academia_grado as tg ON a.codTipoGrado = tg.idgrado\n" +
            "LEFT JOIN academia_ciclo as ci ON a.codGrado = ci.idciclo\n" +
            "LEFT JOIN seccion as sec ON a.codAula = sec.idaula\n" +
            "LEFT JOIN academia_turno as tur ON a.codTurno = tur.idturno\n" +
            "WHERE fechaTermino >= '" + f1 + "' AND fechaTermino <= '" + f2 + "' AND a.codSede = " + sede + " \n" +
            "GROUP BY(codAula) ORDER BY codAula LIMIT " + inicio + "," + cant;
        
        ResultSet rs = st.executeQuery(query);
        
        while(rs.next()){
            Aula aula = new Aula();
            aula.setCodAula(rs.getString("codAula"));
            aula.setCodSede(rs.getString("codSede"));
            aula.setNomSede(rs.getString("deslocal"));
            aula.setCodCentro(rs.getString("codCentro"));
            aula.setNomCentro(rs.getString("nom_centro"));
            aula.setCodNivel(rs.getString("codNivel"));
            aula.setNomNivel(rs.getString("nivel"));
            aula.setCodTipoGrado(rs.getString("codTipoGrado"));
            aula.setNomTipoGrado(rs.getString("grado"));
            aula.setCodGrado(rs.getString("codGrado"));
            aula.setNomGrado(rs.getString("ciclo"));
            aula.setCodTurno(rs.getString("codTurno"));
            aula.setNomTurno(rs.getString("turno"));
            aula.setFechaInicio(rs.getString("fechaInicio"));
            aula.setFechaTermino(rs.getString("fechaTermino"));
            aula.setCuotas(rs.getString("cuotas"));
            aula.setEstado(rs.getString("estado"));
            aula.setSecciones(rs.getString("secciones"));
            lista.add(aula);
        }
          cnx.close(); return lista;
    }

    @Override
    public int contarAulasPorFechaCese(int sede, String f1, String f2) throws Exception {
        int cantidad = 0;
        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "SELECT COUNT(*) AS cant \n" +
            "FROM aula AS a \n" +
            "INNER JOIN sede as s ON a.codSede = s.idlocal \n" +
            "INNER JOIN centro as c ON a.codCentro = c.cod_centro \n" +
            "INNER JOIN academia_nivel as n ON a.codNivel = n.idnivel \n" +
            "INNER JOIN academia_grado as tg ON a.codTipoGrado = tg.idgrado \n" +
            "INNER JOIN academia_ciclo as ci ON a.codGrado = ci.idciclo \n" +
            "WHERE fechaTermino >= '" + f1 + "' AND fechaTermino <= '" + f2 + "' AND a.codSede = " + sede + " \n" ;
        ResultSet rs = st.executeQuery(query);
        while(rs.next()){
            cantidad = rs.getInt("cant");
        }
          cnx.close(); return cantidad;
    }
    
    
    @Override
    public int insertarAula(int codSede,int codCentro,int codNivel,int codTipoGrado,int codGrado,int codTurno,String fechaInicio,String fechaTermino,int cuotas, int tipoSeccion,String[] pensionDes, double[] pensionMonto, String[] pensionVencimiento) throws Exception {
        int codigo = 0;
        String seccion = "";
        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "INSERT INTO aula(codSede,codCentro,codNivel,codTipoGrado,codGrado,codTurno,fechaInicio,fechaTermino,cuotas,tipoSeccion) "
                + "VALUES ('" + codSede + "', '" + codCentro + "', '" + codNivel + "', '" + codTipoGrado + "', '" + codGrado + "', "
                + "'" + codTurno + "', '" + fechaInicio + "', '" + fechaTermino + "', '" + cuotas + "','" + tipoSeccion + "');";
        int r = st.executeUpdate(query);
        //OBTENER ID
        ResultSet rs = st.getGeneratedKeys();
        if (rs.next()){
            codigo=rs.getInt(1);
        }
        for (int i = 0; i < cuotas; i++) {
            query = "INSERT INTO pension(codAula,tipPension,desPension,montoPension,cadPension) VALUES ('" + codigo + "', '1', '" + pensionDes[i] + "', '" + pensionMonto[i] + "', '" + pensionVencimiento[i] + "')";
            r = st.executeUpdate(query);
        }
        switch(tipoSeccion){
            case 1:
                seccion = "A";
                break;
            case 2:
                seccion = "I";
                break;
            case 3:
                seccion = "1";
                break;
            default:
                seccion = "A";
        }
        query = "INSERT INTO seccion(idaula,nomaula) VALUES ('" + codigo + "', '" + seccion + "')";
            r = st.executeUpdate(query);
          cnx.close(); return r;
    }

    @Override
    public int cambiarEstadoAula(int idAula, int estado) throws Exception {
        int cantidad = 0;
        int r = 0;
        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query="";
      //  String query = "SELECT COUNT(*) AS cant from matricula WHERE estado_matri = 1 and matricula.codAula = " + idAula;
       // ResultSet rs = st.executeQuery(query);
//        while(rs.next()){
//            cantidad = rs.getInt("cant");
//        }
        if(estado == 1){
            query = "UPDATE aula SET estado='" + estado + "' WHERE codAula='" + idAula + "'";
           r = st.executeUpdate(query);
           query = "update  matricula as m \n" +
                "INNER JOIN pagocuota as pg on pg.codmatricula=m.cod_matricula set pg.estado=0,pg.detalles=''\n" +
                "WHERE m.codAula="+idAula+" and pg.detalles='Anulado por cierre del Aula(Admistrador)' and pg.estado=2";
            st.executeUpdate(query);
            
        }else{
            query = "UPDATE aula SET estado='" + estado + "' WHERE codAula='" + idAula + "'";
         r =  st.executeUpdate(query);
              query = "update  matricula as m \n" +
                    "INNER JOIN pagocuota as pg on pg.codmatricula=m.cod_matricula set pg.estado=2,pg.detalles='Anulado por cierre del Aula(Admistrador)' \n" +
                    "WHERE m.codAula="+idAula+" and pg.estado=0";
            st.executeUpdate(query);
           
        }
          cnx.close(); return r;
    }

    @Override
    public int cerrarCiclo(int codCiclo) throws Exception {
        int cantidad = 0, r = 0;
        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "SELECT COUNT(codpagocuota) AS cantidad FROM matricula AS m \n" +
            "INNER JOIN pagocuota AS p ON p.codmatricula = m.cod_matricula \n" +
            "WHERE p.estado = 0 AND m.codAula = " + codCiclo + ";";
        ResultSet rs = st.executeQuery(query);
        while(rs.next()){
            cantidad = Integer.parseInt(rs.getString("cantidad"));
        }
        if(cantidad == 0){
            query = "UPDATE matricula SET estado_matri = '0' WHERE codAula = " + codCiclo + ";";
            r = st.executeUpdate(query);
            query = "UPDATE aula SET estado = '-1' WHERE codAula = " + codCiclo + ";";
            r = st.executeUpdate(query);
        }
          cnx.close(); return r;
    }

    @Override
    public ArrayList<Aula> listarSeccionesPorAula(int codAula) throws Exception {
        ArrayList<Aula> lista = new ArrayList<>();
        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "SELECT idseccion,nomaula,estado_seccion FROM seccion WHERE idaula = '" + codAula + "';";
        ResultSet rs = st.executeQuery(query);
        
        while(rs.next()){
            Aula aula = new Aula();
            aula.setCodSeccion(rs.getString("idseccion"));
            aula.setNomSeccion(rs.getString("nomaula"));
            aula.setEstSeccion(rs.getString("estado_seccion"));
            lista.add(aula);
        }
          cnx.close(); return lista;
    }

    @Override
    public int insertarSeccion(int codaula, int seccion) throws Exception {
        String[] letras = {"A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R","S","T","U","V","W","X","Y","Z"};
        String[] romano = {"I","II","III","VI","V","VI","VII","VIII","IX","X","XI","XII","XIII","XIV","XV","XVI","XVII","XVIII","XIX","XX"};
        String valor_seccion = "";
        int index = 0;
        int r = 0;
        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "SELECT COUNT(*) AS cant from seccion WHERE idaula = " + codaula;
        ResultSet rs = st.executeQuery(query);
        while(rs.next()){
            index = rs.getInt("cant");
        }
        switch(seccion){
            case 1:
                valor_seccion = letras[index];
                break;
            case 2:
                valor_seccion = romano[index];
                break;
            case 3:
                valor_seccion = String.valueOf((index + 1));
                break;
        }
        query = "INSERT INTO seccion(idaula,nomaula) VALUES ('" + codaula + "', '" + valor_seccion + "')";
        r = st.executeUpdate(query);
          cnx.close(); return r;
    }

    @Override
    public int cambiarEstadoSeccion(int codseccion,int estado) throws Exception {
        int r = 0;
        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        //String query = "UPDATE seccion SET estado_seccion='" + estado + "' WHERE idseccion='" + codseccion + "';";
        String query = "SELECT COUNT(cod_matricula) AS cant FROM matricula \n" +
            "WHERE codAula = (SELECT idaula FROM seccion WHERE idseccion = " + codseccion + ") \n" +
            "AND seccion = (SELECT nomaula FROM seccion WHERE idseccion = " + codseccion + ")\n" +
            "AND estado_matri= 1 ;";
        ResultSet rs = st.executeQuery(query);
        while(rs.next()){
            r = rs.getInt("cant");
        }
        if(r==0){
            query = "UPDATE seccion SET estado_seccion='" + estado + "' WHERE idseccion='" + codseccion + "';";
            r = st.executeUpdate(query);
        }
        else{
            r = 2;
        }
          cnx.close(); return r;
    }

    @Override
    public int obtenerTipoSeccion(int codAula) throws Exception {
        int tipoSeccion = 0;
        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "SELECT tipoSeccion FROM aula WHERE codAula="+codAula;
        ResultSet rs = st.executeQuery(query);
        
        while(rs.next()){
            tipoSeccion = rs.getInt("tipoSeccion");
        }
          cnx.close(); return tipoSeccion;
    }

    @Override
    public ArrayList<Pension> ListarAulaporPensiones(int cod_aula) throws Exception {
         ArrayList<Pension> lista = new ArrayList<>();
        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "select codPension,tipPension,desPension,montoPension,DATE_FORMAT(cadPension,'%d/%m/%Y')as fechaP,estadoPension from pension WHERE codAula="+cod_aula+" ORDER BY cadPension ASC";
        
        ResultSet rs = st.executeQuery(query);
       // //System.out.println(" Sentencia PRUEBA "+query);
        while(rs.next()){
            Pension pension = new Pension();
            pension.setCodPension(rs.getString("codPension"));
            pension.setDescPension(rs.getString("desPension"));
            pension.setMontoPension(rs.getString("montoPension"));
            pension.setFecha_pago(rs.getString("fechaP"));
            pension.setEstadoPension(rs.getString("estadoPension"));
            
            lista.add(pension);
        }
          cnx.close(); return lista;
    }

    @Override
    public int contarPensionesPagadas(int cod_aula) throws Exception {
    int cantidad = 0;
        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "select COUNT(p.codAula) as cant from pagocuota as pg \n" +
                        "INNER JOIN pension as p on p.codPension=pg.codpension "
                + "     WHERE pg.estado<>0 and p.codAula="+cod_aula;
        ResultSet rs = st.executeQuery(query);
        while(rs.next()){
            cantidad = rs.getInt("cant");
        }
          cnx.close(); return cantidad;
    }

    @Override
    public int insertarPension(int cod_aula,String fecha,String monto) throws Exception {
         int codigo = 0;
        String seccion = "";
        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "INSERT INTO pension(codAula,tipPension,cadPension,desPension,montoPension) VALUES ("+cod_aula+",1,'"+fecha+"','',"+monto+")";
        int r = st.executeUpdate(query);
        //OBTENER ID
        
          cnx.close(); return r;
    }

    @Override
    public int EliminarPension(int cod_pension) throws Exception {
 int codigo = 0;
        String seccion ="";
        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "delete from pension WHERE codPension="+cod_pension;
        int r = st.executeUpdate(query);
        //OBTENER ID
        
          cnx.close(); return r;
    }

    @Override
    public int EditarAula(int cod_aula,int codSede, int codCentro, int codNivel, int codTipoGrado, int codGrado, int codTurno, String fechaInicio, String fechaTermino, int cuotas, int tipoSeccion,String[] cod_pensiones, String[] pensionDes, String[] pensionMonto, String[] pensionVencimiento) throws Exception {
        int codigo = 0;
        String seccion = "";
        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "update aula set codSede="+codSede+",codCentro="+codCentro+",codNivel="+codNivel+",codTipoGrado="+codTipoGrado+",codGrado="+codGrado+",codTurno="+codTurno+",fechaInicio='"+fechaInicio+"',fechaTermino='"+fechaTermino+"',tipoSeccion="+tipoSeccion+",cuotas="+cuotas+" WHERE codAula="+cod_aula+" ;";
        int r = st.executeUpdate(query);
        //OBTENER ID
        
        for (int i = 0; i < cuotas; i++) {
            String query2="update pension set desPension='"+pensionDes[i]+"',montoPension="+pensionMonto[i]+",cadPension='"+pensionVencimiento[i]+"' WHERE codPension="+cod_pensiones[i];
           ////System.out.println("codpensiones="+cod_pensiones[i]+" Descripcion="+pensionDes[i]+" mionto="+pensionMonto[i]+" fecha="+pensionVencimiento[i]);
           r=st.executeUpdate(query2);
        }
        
          cnx.close(); return r;
    }
    

}
