package pe.siso.academia.MySqlDAO;

import java.sql.Connection;
import java.sql.DriverManager;
import pe.siso.academia.DAO.AulaDAO;
import pe.siso.academia.DAO.BoletaDAO;
import pe.siso.academia.DAO.CarreraDAO;
import pe.siso.academia.DAO.ColegioDAO;
import pe.siso.academia.DAO.DAOFactory;
import pe.siso.academia.DAO.DescuentoDAO;
import pe.siso.academia.DAO.DocumentoDAO;
import pe.siso.academia.DAO.EstudianteDAO;
import pe.siso.academia.DAO.GestionDAO;
import pe.siso.academia.DAO.GradoInstruccionDAO;
import pe.siso.academia.DAO.MatriculaDAO;
import pe.siso.academia.DAO.MatriculadosDAO;
import pe.siso.academia.DAO.MenuDAO;
import pe.siso.academia.DAO.MontoDAO;
import pe.siso.academia.DAO.PensionDAO;
import pe.siso.academia.DAO.ProfesionDAO;
import pe.siso.academia.DAO.SedeDAO;
import pe.siso.academia.DAO.UbigeoDAO;
import pe.siso.academia.DAO.UniversidadDAO;
import pe.siso.academia.DAO.UsuarioDAO;
import pe.siso.academia.DAO.ubigeo_FloresDAO;

public class MySqlDAOFactory extends DAOFactory {

    static {
        try {
            Class.forName("com.mysql.jdbc.Driver");
        } catch (Exception e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
    }

    public static Connection obtenerConexion(String base) {
        Connection conexion = null;
        if (base.equals("academianew")) {

            try {

                conexion = DriverManager.getConnection(
                        "jdbc:mysql://172.16.2.38:3306/academianew",
                        "root",
                        "mysql123");
//                                                                "jdbc:mysql://172.16.0.18:3306/academianew", 
//                                                                "backup", 
//                                                                "mysql2016");

            } catch (Exception e) {
                // TODO Auto-generated catch block
                e.printStackTrace();
                System.out.println("El error es: " + e.getMessage());
            }

        } else if (base.equals("prueba")) {

            try {

                conexion = DriverManager.getConnection(
                        /*"jdbc:mysql://172.16.0.18:3306/encuesta_docente", 
                                                                "eduardo", 
                                                                "mysql");*/
                        "jdbc:mysql://localhost:3306/prueba",
                        "root",
                        "Mysql2016");

            } catch (Exception e) {
                // TODO Auto-generated catch block
                e.printStackTrace();
                System.out.println("El error es: " + e.getMessage());
            }

        }

        return conexion;
    }

    @Override
    public UsuarioDAO getUsuarioDAO() {
        return new MySqlUsuarioDAO();
    }

    @Override
    public MenuDAO getMenuDAO() {
        return new MySqlMenuDAO();
    }

    @Override
    public EstudianteDAO getEstudianteDAO() {
        return new MySqlEstudianteDAO();
    }

    @Override
    public SedeDAO getSedeDAO() {
        return new MySqlSedeDAO();
    }

    @Override
    public UbigeoDAO getUbigeoDAO() {
        return new MySqlUbigeoDAO();
    }

    @Override
    public CarreraDAO getCarreraDAO() {
        return new MySqlCarreraDAO();
    }

    @Override
    public GradoInstruccionDAO getGradoInstruccionDAO() {
        return new MySqlGradoInstruccionDAO();
    }

    @Override
    public ProfesionDAO getProfesionDAO() {
        return new MySqlProfesionDAO();
    }

    @Override
    public UniversidadDAO getUniversidadDAO() {
        return new MySqlUniversidadDAO();
    }

    @Override
    public ColegioDAO getColegioDAO() {
        return new MySqlColegioDAO();
    }

    @Override
    public DescuentoDAO getDescuentoDAO() {
        return new MySqlDescuentoDAO();
    }

    @Override
    public DocumentoDAO getDocumentoDAO() {
        return new MySqlDocumentoDAO();
    }

    @Override
    public MontoDAO getMontoDAO() {
        return new MySqlMontoDAO();
    }

    @Override
    public MatriculaDAO getMatriculaDAO() {
        return new MySqlMatriculaDAO();
    }

    @Override
    public AulaDAO getAulaDAO() {
        return new MySqlAulaDAO();
    }

    @Override
    public PensionDAO getPension() {
        return new MySqlPensionDAO();
    }

    @Override
    public BoletaDAO getBoletaDAO() {
        return new MySqlBoletaDAO();
    }

    @Override
    public ubigeo_FloresDAO getubigeo_Flores() {
        return new MySqlubigeo_FloresDAO();
    }

    @Override
    public MatriculadosDAO getmatriculadosDAO() {
        return new MySqlMatriculadosDAO();
    }

    @Override
    public GestionDAO getGestionDAO() {
        return new MysqlGestionDAO();
    }
}
