/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package pe.siso.academia.MySqlDAO;

import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.Statement;
import java.util.ArrayList;
import org.json.simple.JSONArray;
import org.json.simple.JSONObject;
import pe.siso.academia.Beans.Descuento;
import pe.siso.academia.DAO.DescuentoDAO;

/**
 *
 * @author sistem08user
 */
public class MySqlDescuentoDAO implements DescuentoDAO {

    @Override
    public ArrayList<Descuento> listarDescuentosPorNombre(String nombre, int inicio, int cantidad) throws Exception {
        ArrayList<Descuento> lista = new ArrayList<>();
        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "SELECT codDescuento,nomDescuento,estDescuento "
                + "FROM descuento WHERE nomDescuento like '%" + nombre + "%' "
                + "ORDER BY codDescuento LIMIT " + inicio + "," + cantidad;
        ResultSet rs = st.executeQuery(query);

        while (rs.next()) {
            Descuento descuento = new Descuento();
            descuento.setCodDescuento(rs.getString("codDescuento"));
            descuento.setNomDescuento(rs.getString("nomDescuento"));
            descuento.setEstDescuento(rs.getString("estDescuento"));
            lista.add(descuento);
        }
        cnx.close();
        cnx.close();
        return lista;
    }

    @Override
    public int cantidadDescuentosPorNombre(String nombre) throws Exception {
        int cantidad = 0;
        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "SELECT COUNT(*) AS cant "
                + "FROM descuento WHERE nomDescuento like '%" + nombre + "%'";

        ResultSet rs = st.executeQuery(query);

        while (rs.next()) {
            cantidad = rs.getInt("cant");
        }
        cnx.close();
        cnx.close();
        return cantidad;
    }

    @Override
    public int cambiarEstado(int id, String estado) throws Exception {
        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "UPDATE descuento SET estDescuento='" + estado + "' WHERE codDescuento='" + id + "'";
        int r = st.executeUpdate(query);
        cnx.close();
        cnx.close();
        return r;
    }

    @Override
    public int editarDescuento(int id, String nombre) throws Exception {
        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "UPDATE descuento SET nomDescuento='" + nombre + "' WHERE codDescuento='" + id + "'";
        int r = st.executeUpdate(query);
        cnx.close();
        cnx.close();
        return r;
    }

    @Override
    public int nuevoDescuento(String nombre) throws Exception {
        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "INSERT INTO descuento (nomDescuento,estdescuento) VALUES ('" + nombre + "',1)";
        int r = st.executeUpdate(query);
        cnx.close();
        return r;
    }

    @Override
    public ArrayList<Descuento> listarDescuentosPorSede(int sede, String tipoUsuario) throws Exception {

        ArrayList<Descuento> lista = new ArrayList<>();
        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String estado = "";
        if (!tipoUsuario.equals("1")) {
            estado = " AND estDescuento=1 ";
        }
        String query = "SELECT codEnlace_Desc,nomDescuento,montoDescuento,tip_moneda "
                + "FROM enlace_descuento AS e "
                + "INNER JOIN descuento AS d ON e.codDescuento=d.codDescuento "
                + "WHERE 1=1  " + estado + " AND codSede=" + sede + " order by nomDescuento";
        System.out.println("listat descuento por sede \n" + query);
        ResultSet rs = st.executeQuery(query);

        while (rs.next()) {
            Descuento descuento = new Descuento();
            descuento.setCodEnlace(rs.getString("codEnlace_Desc"));
            descuento.setNomDescuento(rs.getString("nomDescuento"));
            descuento.setMonto(rs.getString("montoDescuento"));
            descuento.setTip_mon(rs.getInt("tip_moneda"));
            lista.add(descuento);
        }
        cnx.close();
        return lista;
    }

    @Override
    public ArrayList<Descuento> listarDescuentosPorSedeSinAsignar(int sede) throws Exception {
        ArrayList<Descuento> lista = new ArrayList<>();
        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "SELECT codDescuento,nomDescuento FROM descuento "
                + "WHERE  codDescuento NOT IN "
                + "(SELECT codDescuento FROM enlace_descuento WHERE codSede=" + sede + ")";
        ResultSet rs = st.executeQuery(query);

        while (rs.next()) {
            Descuento descuento = new Descuento();
            descuento.setCodDescuento(rs.getString("codDescuento"));
            descuento.setNomDescuento(rs.getString("nomDescuento"));
            lista.add(descuento);
        }
        cnx.close();
        cnx.close();
        return lista;
    }

    @Override
    public int agregarDescuentoSede(int codSede, int codDscto, double monto, int tip_mon) throws Exception {
        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "INSERT INTO enlace_descuento(codDescuento,codSede,montoDescuento,tip_moneda) "
                + "VALUES ('" + codDscto + "', '" + codSede + "', '" + monto + "'," + tip_mon + ")";
        int r = st.executeUpdate(query);
        cnx.close();
        cnx.close();
        return r;
    }

    @Override
    public int eliminarDescuentoSede(int codDesctoEnlace) throws Exception {
        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "DELETE FROM enlace_descuento "
                + "WHERE codEnlace_Desc='" + codDesctoEnlace + "'";
        int r = st.executeUpdate(query);
        cnx.close();
        cnx.close();
        return r;
    }

    @Override
    public int cantEnlacesDscto(int id) throws Exception {
        int cantidad = 0;
        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "SELECT COUNT(*) AS cant FROM enlace_descuento "
                + "WHERE codDescuento = " + id;
        ResultSet rs = st.executeQuery(query);
        while (rs.next()) {
            cantidad = rs.getInt("cant");
        }
        cnx.close();
        return cantidad;
    }

    @Override
    public JSONArray TipoDocumentoxSede(int codSede) throws Exception {

        JSONArray jsonresultado = new JSONArray();
        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "SELECT nom_tipo_documento,cod_tipo_usuario,selected FROM tipo_documento WHERE cod_sede=" + codSede + " AND estado_tipo_documento=1";
        ResultSet rs = st.executeQuery(query);
        while (rs.next()) {
            JSONObject jsonObjt = new JSONObject();
            jsonObjt.put("nomTipoDocumento", rs.getString("nom_tipo_documento"));
            jsonObjt.put("codTipoUsuario", rs.getString("cod_tipo_usuario"));
            jsonObjt.put("selectedTipoDocumento", rs.getString("selected"));
//            cantidad = rs.getInt("cant");
            jsonresultado.add(jsonObjt);
        }
        cnx.close();
        return jsonresultado;
    }

}
