/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package pe.siso.academia.MySqlDAO;

import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.Statement;
import java.util.ArrayList;
import pe.siso.academia.Beans.Documento;
import pe.siso.academia.DAO.DocumentoDAO;

/**
 *
 * @author sistem08user
 */
public class MySqlDocumentoDAO implements DocumentoDAO {

    @Override
    public ArrayList<Documento> listarDocumentosPorSede(int sede) throws Exception {
        ArrayList<Documento> lista = new ArrayList<>();
        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "SELECT codEnlace_Doc,d.codDocumento,nomDocumento " + 
               "FROM enlace_documento AS e " +
               "INNER JOIN documento AS d ON e.codDocumento=d.codDocumento " +
               "WHERE estDocumento=1 AND codSede="+sede;
        ResultSet rs = st.executeQuery(query);
        
        while(rs.next()){
            Documento doc = new Documento();
            doc.setCodEnlace(rs.getString("codEnlace_Doc"));
            doc.setCodDocumento(rs.getString("codDocumento"));
            doc.setNomDocumento(rs.getString("nomDocumento"));
            lista.add(doc);
        }
          cnx.close(); return lista;
    }

    @Override
    public ArrayList<Documento> listarDocumentosPorSedeSinAsignar(int sede) throws Exception {
        ArrayList<Documento> lista = new ArrayList<>();
        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "SELECT codDocumento,nomDocumento FROM documento " +
            "WHERE estDocumento=1 AND codDocumento NOT IN " +
            "(SELECT codDocumento FROM enlace_documento WHERE codSede="+sede+")";
        ResultSet rs = st.executeQuery(query);
        
        while(rs.next()){
            Documento doc = new Documento();
            doc.setCodDocumento(rs.getString("codDocumento"));
            doc.setNomDocumento(rs.getString("nomDocumento"));
            lista.add(doc);
        }
          cnx.close(); return lista;
    }

    @Override
    public int agregarDocumentoSede(int codSede, int codDoc) throws Exception {
        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "INSERT INTO enlace_documento(codDocumento,codSede) "
                + "VALUES ('"+codDoc+"', '"+codSede+"')";
        int r = st.executeUpdate(query);
          cnx.close(); return r;
    }

    @Override
    public int eliminarDocumentoSede(int codDocEnlace) throws Exception {
        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "DELETE FROM enlace_documento "
                + "WHERE codEnlace_Doc='"+codDocEnlace+"'";
        int r = st.executeUpdate(query);
          cnx.close(); return r;
    }

    @Override
    public ArrayList<Documento> listarDocumentosPorNombre(String nombre, int inicio, int cantidad) throws Exception {
        ArrayList<Documento> lista = new ArrayList<>();
        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "SELECT codDocumento,nomDocumento,estDocumento " +
        "FROM documento WHERE nomDocumento like '%"+nombre+"%' " +
        "ORDER BY codDocumento LIMIT "+inicio+","+cantidad;
        ResultSet rs = st.executeQuery(query);
        
        while(rs.next()){
            Documento doc = new Documento();
            doc.setCodDocumento(rs.getString("codDocumento"));
            doc.setNomDocumento(rs.getString("nomDocumento"));
            doc.setEstDocumento(rs.getString("estDocumento"));
            lista.add(doc);
        }
          cnx.close(); return lista;
    }

    @Override
    public int cantidadDocumentosPorNombre(String nombre) throws Exception {
        int cantidad = 0;
        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "SELECT COUNT(*) AS cant "
                + "FROM documento WHERE nomDocumento like '%"+nombre+"%' " ;
        
        ResultSet rs = st.executeQuery(query);
        
        while(rs.next()){
            cantidad = rs.getInt("cant");
        }
          cnx.close(); return cantidad;
    }

    @Override
    public int cambiarEstado(int id, String estado) throws Exception {
        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "UPDATE documento SET estDocumento='"+estado+"' WHERE codDocumento='"+id+"'";
        int r = st.executeUpdate(query);
          cnx.close(); return r;
    }

    @Override
    public int editarDocumento(int id, String nombre) throws Exception {
        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "UPDATE documento SET nomDocumento='"+nombre+"' WHERE codDocumento='"+id+"'";
        int r = st.executeUpdate(query);
          cnx.close(); return r;
    }

    @Override
    public int nuevoDocumento(String nombre) throws Exception {
        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "INSERT INTO documento(nomDocumento) VALUES ('"+nombre+"')";
        int r = st.executeUpdate(query);
          cnx.close(); return r;
    }

    @Override
    public int cantEnlacesDoc(int id) throws Exception {
        int cantidad = 0;
        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "SELECT COUNT(*) AS cant FROM enlace_documento "
                + "WHERE codDocumento =  " + id;
        ResultSet rs = st.executeQuery(query);
        while(rs.next()){
            cantidad = rs.getInt("cant");
        }
          cnx.close(); return cantidad;
    }

    @Override
    public ArrayList<Documento> obtenerDocumentosMatricula(int codMatricula) throws Exception {
        ArrayList<Documento> lista = new ArrayList<>();
        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "SELECT coddocumento FROM requisito WHERE estadorequisito = 1 AND codmatricula = "+codMatricula;
        ResultSet rs = st.executeQuery(query);
        
        while(rs.next()){
            Documento doc = new Documento();
            doc.setCodDocumento(rs.getString("coddocumento"));
            lista.add(doc);
        }
          cnx.close(); return lista;
    }
    
    @Override
    public int actualizarDocumentosMat(int codMatricula,String codDoc[], String valDoc[]) throws Exception {
        int rpta=0;
        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "DELETE FROM requisito WHERE codmatricula = " + codMatricula;
        int rs1 = st.executeUpdate(query);
        for (int i = 0; i < codDoc.length; i++) {
            if("true".equals(valDoc[i].trim())){
                valDoc[i]="1";
            }
            else{
                valDoc[i]="0";
            }
            query = "INSERT INTO requisito(codmatricula,coddocumento,estadorequisito) VALUES ('"+codMatricula+"','"+codDoc[i]+"','"+valDoc[i]+"')";
            rpta = st.executeUpdate(query);
        }
        
          cnx.close(); return rpta;
    }
}
