package pe.siso.academia.MySqlDAO;

import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.Statement;
import java.util.ArrayList;
import pe.siso.academia.Beans.Aula;
import pe.siso.academia.Beans.Matricula;
import pe.siso.academia.Beans.Pension;
import pe.siso.academia.DAO.MatriculaDAO;

public class MySqlMatriculaDAO implements MatriculaDAO {

    @Override
    public ArrayList<Matricula> listarMatriculas(int sede, String filtro, int inicio, int cant) throws Exception {
        //     filtro = filtro.trim().replace(' ', '|');
        //     if(filtro.trim().length()==0){filtro = ".";}
        ArrayList<Matricula> lista = new ArrayList<>();
        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "SELECT e.codestudiante,e.dni,CONCAT(TRIM(e.paterno),\" \",TRIM(e.materno),\" \",TRIM(e.nombres)) AS nombre_completo,m.cod_matricula, \n"
                + "m.fechaMatricula,s.idlocal,s.deslocal,n.nivel,g.grado,c.ciclo,t.turno,m.seccion,m.estado_matri, \n"
                + "(SELECT COUNT(*) FROM pagocuota AS pc WHERE pc.codmatricula = m.cod_matricula AND pc.estado<>0) AS pensiones_editadas  \n"
                + "FROM estudiante AS e \n"
                + "LEFT JOIN matricula AS m ON e.codestudiante = m.cod_estud_matri \n"
                + "LEFT JOIN aula AS a ON m.codAula = a.codAula \n"
                + "LEFT JOIN sede AS s ON a.codSede = s.idlocal \n"
                + "LEFT JOIN academia_nivel AS n ON a.codNivel = n.idnivel \n"
                + "LEFT JOIN academia_grado AS g ON a.codTipoGrado = g.idgrado \n"
                + "LEFT JOIN academia_ciclo AS c ON a.codGrado = c.idciclo \n"
                + "LEFT JOIN academia_turno AS t ON a.codTurno = t.idturno  \n"
                + "WHERE a.codSede = " + sede + " HAVING nombre_completo LIKE '%" + filtro + "%' \n"
                + " order by m.fechaMatricula desc,m.cod_matricula desc LIMIT " + inicio + "," + cant;
        ResultSet rs = st.executeQuery(query);
        System.out.println("listarMatriculas \n" + query);
        while (rs.next()) {
            Matricula mat = new Matricula();
            mat.setCodEstudiante(rs.getString("codestudiante"));
            mat.setDocEstudiante(rs.getString("dni"));
            mat.setNombres_est(rs.getString("nombre_completo"));
            mat.setCodMatricula(rs.getString("cod_matricula"));
            mat.setFecha_matri(rs.getString("fechaMatricula"));
            mat.setCod_Sede(rs.getString("idlocal"));
            mat.setNom_Sede(rs.getString("deslocal"));
            mat.setNom_nivel(rs.getString("nivel"));
            mat.setNom_grado(rs.getString("grado"));
            mat.setNom_Ciclo(rs.getString("ciclo"));
            mat.setNom_Turno(rs.getString("turno"));
            mat.setNom_Seccion(rs.getString("seccion"));
            mat.setEstado(rs.getString("estado_matri"));
            mat.setCantPensionesEditadas(rs.getInt("pensiones_editadas"));
            lista.add(mat);
        }
        cnx.close();
        return lista;
    }

    @Override
    public int contarMatriculas(int sede, String filtro) throws Exception {
        //   filtro = filtro.trim().replace(' ', '|');
        //   if(filtro.trim().length()==0){filtro = ".";}
        int cantidad = 0;
        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "SELECT COUNT(*) AS cant\n"
                + "FROM estudiante AS e \n"
                + "INNER JOIN matricula AS m ON e.codestudiante = m.cod_estud_matri \n"
                + "LEFT JOIN aula AS a ON m.codAula = a.codAula \n"
                + "LEFT JOIN sede AS s ON a.codSede = s.idlocal \n"
                + "LEFT JOIN academia_nivel AS n ON a.codNivel = n.idnivel \n"
                + "LEFT JOIN academia_grado AS g ON a.codTipoGrado = g.idgrado \n"
                + "LEFT JOIN academia_ciclo AS c ON a.codGrado = c.idciclo \n"
                + "LEFT JOIN academia_turno AS t ON a.codTurno = t.idturno \n"
                + "WHERE s.idlocal = " + sede + " AND CONCAT(TRIM(e.paterno),\" \",TRIM(e.materno),\" \",TRIM(e.nombres)) like '%" + filtro + "%' ";
        ResultSet rs = st.executeQuery(query);

        while (rs.next()) {
            cantidad = rs.getInt("cant");
        }
        //System.out.println("cant  + \n "+query);
        cnx.close();
        return cantidad;
    }

    @Override
    public ArrayList<Matricula> listarCentros(int codSede) throws Exception {
        ArrayList<Matricula> lista = new ArrayList<>();
        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "SELECT cod_centro,nom_centro FROM aula AS a \n"
                + "INNER JOIN centro AS c ON a.codCentro = c.cod_centro \n"
                + "WHERE estado_centro = 1 AND codSede = " + codSede + " \n"
                + "GROUP BY cod_centro";
        ResultSet rs = st.executeQuery(query);

        while (rs.next()) {
            Matricula mat = new Matricula();
            mat.setCod_Centro(rs.getString("cod_centro"));
            mat.setNom_Centro(rs.getString("nom_centro"));
            lista.add(mat);
        }
        cnx.close();
        return lista;
    }

    @Override
    public ArrayList<Matricula> listarNiveles(int idSede, int idCentro) throws Exception {
        ArrayList<Matricula> lista = new ArrayList<>();
        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "SELECT codNivel,codTipoGrado,CONCAT(nivel,' ',IF(grado='NORMAL','',grado)) ciclo FROM aula AS a\n"
                + "INNER JOIN academia_nivel AS n ON a.codNivel = n.idnivel \n"
                + "INNER JOIN academia_grado AS tg ON a.codTipoGrado = tg.idgrado \n"
                + "WHERE a.estado = 1 AND codSede =" + idSede + " AND codCentro =" + idCentro + "  \n"
                + "GROUP BY codNivel,codTipoGrado";
        ResultSet rs = st.executeQuery(query);
        System.out.println("query NIVELES ->>>>" + query);
        while (rs.next()) {
            Matricula mat = new Matricula();
            mat.setCod_nivel(rs.getString("codNivel"));
            mat.setCod_grado(rs.getString("codTipoGrado"));
            mat.setNom_nivel(rs.getString("ciclo"));
            lista.add(mat);
        }
        cnx.close();
        return lista;
    }

    @Override
    public ArrayList<Matricula> listarTiposGrado(int codSede, int idCentro, int idNivel) throws Exception {
        ArrayList<Matricula> lista = new ArrayList<>();
        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "SELECT codTipoGrado,grado FROM aula AS a \n"
                + "INNER JOIN academia_grado AS tg ON a.codTipoGrado = tg.idgrado \n"
                + "WHERE a.estado = 1 AND codSede = " + codSede + " AND codCentro = " + idCentro + " AND codNivel = " + idNivel + " \n"
                + "GROUP BY codTipoGrado ";
        ResultSet rs = st.executeQuery(query);
        System.out.println("query GRADO ->>>>" + query);
        while (rs.next()) {
            Matricula mat = new Matricula();
            mat.setCod_grado(rs.getString("codTipoGrado"));
            mat.setNom_grado(rs.getString("grado"));
            lista.add(mat);
        }
        cnx.close();
        return lista;
    }

    @Override
    public ArrayList<Matricula> listarGrados(int codSede, int idCentro, int idNivel, int idTipo) throws Exception {
        ArrayList<Matricula> lista = new ArrayList<>();
        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "SELECT codGrado,ciclo FROM aula AS a \n"
                + "INNER JOIN academia_ciclo AS g ON a.codGrado = g.idciclo \n"
                + "WHERE a.estado = 1 AND codSede = " + codSede + " AND codCentro = " + idCentro + " AND codNivel = " + idNivel + " \n"
                + "AND codTipoGrado = " + idTipo + " \n"
                + "GROUP BY codGrado ";
        ResultSet rs = st.executeQuery(query);

        while (rs.next()) {
            Matricula mat = new Matricula();
            mat.setCod_Ciclo(rs.getString("codGrado"));
            mat.setNom_Ciclo(rs.getString("ciclo"));
            lista.add(mat);
        }
        cnx.close();
        return lista;
    }

    @Override
    public ArrayList<Matricula> listarTurnos(int codSede, int idCentro, int idNivel, int idTipo, int idGrado) throws Exception {
        ArrayList<Matricula> lista = new ArrayList<>();
        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "SELECT codAula,codTurno,turno,fechaInicio,fechaTermino,cuotas FROM aula AS a \n"
                + "INNER JOIN academia_turno AS t ON a.codTurno = t.idturno \n"
                + "WHERE a.estado = 1 AND codSede = " + codSede + " AND codCentro = " + idCentro + " AND codNivel = " + idNivel + " \n"
                + "AND codTipoGrado = " + idTipo + " AND codGrado = " + idGrado + " \n"
                + "GROUP BY codTurno ";
        ResultSet rs = st.executeQuery(query);

        while (rs.next()) {
            Matricula mat = new Matricula();
            mat.setCod_aula(rs.getString("codAula"));
            mat.setCod_Turno(rs.getString("codTurno"));
            mat.setNom_Turno(rs.getString("turno"));
            mat.setfInicio(rs.getString("fechaInicio"));
            mat.setfFinal(rs.getString("fechaTermino"));
            mat.setCuotas(rs.getString("cuotas"));
            lista.add(mat);
        }
        cnx.close();
        return lista;
    }

    @Override
    public ArrayList<Matricula> listarSecciones(int codAula) throws Exception {
        ArrayList<Matricula> lista = new ArrayList<>();
        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "SELECT idaula, nomaula FROM seccion WHERE estado_seccion = 1 AND idaula = " + codAula;
        ResultSet rs = st.executeQuery(query);

        while (rs.next()) {
            Matricula mat = new Matricula();
            mat.setCod_Seccion(rs.getString("idaula"));
            mat.setNom_Seccion(rs.getString("nomaula"));
            lista.add(mat);
        }
        cnx.close();
        return lista;
    }

    @Override
    public Aula obtenerAula(int codAula) throws Exception {
        Aula aula = new Aula();
        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "SELECT fechaInicio,fechaTermino,cuotas FROM aula "
                + "WHERE estado = 1 AND codAula = " + codAula;
        ResultSet rs = st.executeQuery(query);

        while (rs.next()) {
            aula.setFechaInicio(rs.getString("fechaInicio"));
            aula.setFechaTermino(rs.getString("fechaTermino"));
            aula.setCuotas(rs.getString("cuotas"));
        }
        cnx.close();
        return aula;
    }

    @Override
    public ArrayList<Pension> obtenerPensionesPorAula(int aula) throws Exception {
        ArrayList<Pension> lista = new ArrayList<>();
        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "SELECT codPension,tipPension,codAula,desPension,montoPension,"
                + "cadPension,estadoPension FROM pension WHERE codAula=" + aula;
        ResultSet rs = st.executeQuery(query);

        while (rs.next()) {
            Pension pension = new Pension();
            pension.setCodPension(rs.getString("codPension"));
            pension.setTipoPension(rs.getString("tipPension"));
            pension.setCodAula(rs.getString("codAula"));
            pension.setDescPension(rs.getString("desPension"));
            pension.setMontoPension(rs.getString("montoPension"));
            pension.setCaducidadPension(rs.getString("cadPension"));
            pension.setEstadoPension(rs.getString("estadoPension"));
            lista.add(pension);
        }
        cnx.close();
        return lista;
    }

    @Override
    public int matricularAlumno(int cod_estu, String fechaMatricula, int codAula, String seccion, String condicion, String observaciones, String informo, String eligio, String[] codDoc, String[] valDoc, String[] codPen, String[] monPen, String motDes, double monDes, String autorizacion) throws Exception {
        if (monDes <= 0) {
            motDes = "";
        }

        //INSERTAR MATRICULA
        int idMatricula = 0;
        fechaMatricula = fechaMatricula.split("/")[2] + "/" + fechaMatricula.split("/")[1] + "/" + fechaMatricula.split("/")[0];
        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "INSERT INTO matricula(cod_estud_matri,fechaMatricula,codAula,Seccion,observaciones,condicion,informo,eligio,autorizacion_desc) "
                + "VALUES ('" + cod_estu + "', '" + fechaMatricula + "', '" + codAula + "', '" + seccion + "', '" + observaciones + "', '" + condicion + "', '" + informo + "', '" + eligio + "','" + autorizacion + "')";
        int r = st.executeUpdate(query);
        ResultSet rs = st.getGeneratedKeys();
        if (rs.next()) {
            idMatricula = rs.getInt(1);
        }
        for (int i = 0; i < codDoc.length; i++) {
            if ("true".equals(valDoc[i].trim())) {
                valDoc[i] = "1";
            } else {
                valDoc[i] = "0";
            }
            query = "INSERT INTO requisito(codmatricula,coddocumento,estadorequisito) VALUES ('" + idMatricula + "','" + codDoc[i] + "','" + valDoc[i] + "')";
            r = st.executeUpdate(query);
            //System.out.println("eeeee \n "+query);
        }
        for (int i = 0; i < codPen.length; i++) {
            query = "INSERT INTO pagocuota(codmatricula,codpension,monto,pagado,estado,nom_dscto,monto_dscto) VALUES ('" + idMatricula + "', '" + codPen[i] + "', '" + monPen[i].replace("S/.", "") + "', '0', '0','" + motDes + "' ,'" + monDes + "')";
            r = st.executeUpdate(query);
            //System.out.println("rrrrrrrrrrrrrrrrrrrrr \n "+query);
        }

        query = "update pagocuota as pg \n"
                + "INNER JOIN pension as p on pg.codpension=p.codPension  \n"
                + "set pg.estado=7,detalles='Anulado por fecha de vencimiento'  \n"// estado 7=Eliminado
                + "WHERE pg.estado=0 and pg.codmatricula=" + idMatricula + " and LAST_DAY(p.cadPension)< DATE(NOW());";
        r = st.executeUpdate(query);
        cnx.close();
        return idMatricula;
    }

    @Override
    public ArrayList<Matricula> listarMatriculados(int sede, String filtro, int inicio, int cant) throws Exception {
        // filtro = filtro.trim().replace(' ', '|');
        // if(filtro.length()==0){filtro = ".";}
        ArrayList<Matricula> lista = new ArrayList<>();
        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "SELECT e.codestudiante,e.dni,CONCAT(TRIM(e.paterno),\" \",TRIM(e.materno),\" \",TRIM(e.nombres)) AS nombre_completo,m.cod_matricula, \n"
                + "m.fechaMatricula,s.idlocal,s.deslocal,n.nivel,g.grado,c.ciclo,t.turno,m.seccion,m.estado_matri,(select COUNT(*) from pagocuota  WHERE codmatricula =m.cod_matricula and estado=0 ) as cant \n"
                + "FROM estudiante AS e \n"
                + "INNER JOIN matricula AS m ON e.codestudiante = m.cod_estud_matri \n"
                + "LEFT JOIN aula AS a ON m.codAula = a.codAula \n"
                + "LEFT JOIN sede AS s ON a.codSede = s.idlocal \n"
                + "LEFT JOIN academia_nivel AS n ON a.codNivel = n.idnivel \n"
                + "LEFT JOIN academia_grado AS g ON a.codTipoGrado = g.idgrado \n"
                + "LEFT JOIN academia_ciclo AS c ON a.codGrado = c.idciclo \n"
                + "LEFT JOIN academia_turno AS t ON a.codTurno = t.idturno \n"
                + "WHERE s.idlocal = " + sede + " HAVING nombre_completo LIKE '%" + filtro + "%' and m.estado_matri=1 \n"
                + "ORDER BY m.fechaMatricula desc,m.cod_matricula desc LIMIT " + inicio + "," + cant + "";
        ResultSet rs = st.executeQuery(query);
        System.out.println("bUSCADOPR \n" + query);
        while (rs.next()) {
            Matricula mat = new Matricula();
            mat.setCodEstudiante(rs.getString("codestudiante"));
            mat.setDocEstudiante(rs.getString("dni"));
            mat.setNombres_est(rs.getString("nombre_completo"));
            mat.setCodMatricula(rs.getString("cod_matricula"));
            mat.setFecha_matri(rs.getString("fechaMatricula"));
            mat.setCod_Sede(rs.getString("idlocal"));
            mat.setNom_Sede(rs.getString("deslocal"));
            mat.setNom_nivel(rs.getString("nivel"));
            mat.setNom_grado(rs.getString("grado"));
            mat.setNom_Ciclo(rs.getString("ciclo"));
            mat.setNom_Turno(rs.getString("turno"));
            mat.setNom_Seccion(rs.getString("seccion"));
            mat.setEstado(rs.getString("estado_matri"));
            mat.setCant(rs.getInt("cant"));
            lista.add(mat);
        }
        cnx.close();
        return lista;
    }

    @Override
    public int contarMatriculados(int sede, String filtro) throws Exception {
        //filtro = filtro.trim().replace(' ', '|');
        //if(filtro.length()==0){filtro = ".";}
        int cantidad = 0;
        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "SELECT COUNT(*) AS cant \n"
                + "FROM estudiante AS e \n"
                + "INNER JOIN matricula AS m ON e.codestudiante = m.cod_estud_matri \n"
                + "LEFT JOIN aula AS a ON m.codAula = a.codAula \n"
                + "LEFT JOIN sede AS s ON a.codSede = s.idlocal \n"
                + "LEFT JOIN academia_nivel AS n ON a.codNivel = n.idnivel \n"
                + "LEFT JOIN academia_grado AS g ON a.codTipoGrado = g.idgrado \n"
                + "LEFT JOIN academia_ciclo AS c ON a.codGrado = c.idciclo \n"
                + "LEFT JOIN academia_turno AS t ON a.codTurno = t.idturno \n"
                + "WHERE s.idlocal = " + sede + " AND CONCAT(TRIM(e.paterno),\" \",TRIM(e.materno),\" \",TRIM(e.nombres)) LIKE '%" + filtro + "%' \n";
        ResultSet rs = st.executeQuery(query);

        while (rs.next()) {
            cantidad = rs.getInt("cant");
        }
        cnx.close();
        return cantidad;
    }

    @Override
    public int deshabilitarMatricula(int cod_matricula) throws Exception {
        int pensiones_activas = 0;
        int r = 0;
        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "select COUNT(codpagocuota) AS cantidad \n"
                + "from matricula AS m INNER JOIN \n"
                + "pagocuota AS p ON p.codmatricula = m.cod_matricula\n"
                + "WHERE p.estado not in (0,2)  AND m.cod_matricula = "+cod_matricula+";";
        ResultSet rs = st.executeQuery(query);
        System.out.println(" ddddd \n" + query);
        while (rs.next()) {
            pensiones_activas = rs.getInt("cantidad");
        }
        if (pensiones_activas <= 0) {
            query = "UPDATE matricula SET estado_matri='0' WHERE cod_matricula='" + cod_matricula + "';";
            r = st.executeUpdate(query);

        } else {
            r = -1;
        }

        cnx.close();
        return r;
    }

    @Override
    public Matricula obtenerMatricula(int cod_matricula) throws Exception {
        String base = "academianew";
        Matricula mat = new Matricula();
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "SELECT e.codestudiante,e.dni,e.paterno,e.materno,e.nombres,m.cod_matricula,m.informo, m.eligio, \n"
                + "m.fechaMatricula,s.idlocal,s.deslocal,n.nivel,g.grado,c.ciclo,t.turno,m.seccion,m.estado_matri,a.fechaInicio,a.fechaTermino, \n"
                + "ce.cod_centro,ce.nom_centro,IFNULL(m.observaciones,'') AS observaciones,m.condicion,COUNT(pe.codPension) AS cantpens, \n"
                + "a.codCentro,a.codNivel,a.codTipoGrado,a.codGrado,a.codTurno FROM estudiante AS e \n"
                + "INNER JOIN matricula AS m ON e.codestudiante = m.cod_estud_matri \n"
                + "LEFT JOIN aula AS a ON m.codAula = a.codAula \n"
                + "INNER JOIN pension AS pe ON pe.codAula = a.codAula \n"
                + "LEFT JOIN sede AS s ON a.codSede = s.idlocal \n"
                + "LEFT JOIN centro AS ce ON a.codCentro = ce.cod_centro \n"
                + "LEFT JOIN academia_nivel AS n ON a.codNivel = n.idnivel \n"
                + "LEFT JOIN academia_grado AS g ON a.codTipoGrado = g.idgrado \n"
                + "LEFT JOIN academia_ciclo AS c ON a.codGrado = c.idciclo \n"
                + "LEFT JOIN academia_turno AS t ON a.codTurno = t.idturno \n"
                + "WHERE m.cod_matricula = " + cod_matricula + " GROUP BY pe.codAula";
        ResultSet rs = st.executeQuery(query);

        while (rs.next()) {

            mat.setCodEstudiante(rs.getString("codestudiante"));
            mat.setDocEstudiante(rs.getString("dni"));
            mat.setAp_paterno_est(rs.getString("paterno"));
            mat.setAp_materno_est(rs.getString("materno"));
            mat.setNombres_est(rs.getString("nombres"));
            mat.setCodMatricula(rs.getString("cod_matricula"));
            mat.setFecha_matri(rs.getString("fechaMatricula"));
            mat.setCod_Sede(rs.getString("idlocal"));
            mat.setNom_Sede(rs.getString("deslocal"));
            mat.setNom_Centro(rs.getString("nom_centro"));
            mat.setNom_nivel(rs.getString("nivel"));
            mat.setNom_grado(rs.getString("grado"));
            mat.setNom_Ciclo(rs.getString("ciclo"));
            mat.setNom_Turno(rs.getString("turno"));
            mat.setCod_Centro(rs.getString("codCentro"));
            mat.setCod_nivel(rs.getString("codNivel"));
            mat.setCod_grado(rs.getString("codTipoGrado"));
            mat.setCod_Ciclo(rs.getString("codGrado"));
            mat.setCod_Turno(rs.getString("codTurno"));
            mat.setNom_Seccion(rs.getString("seccion"));
            mat.setEstado(rs.getString("estado_matri"));
            mat.setInformo(rs.getString("informo"));
            mat.setEligio(rs.getString("eligio"));
            mat.setfInicio(rs.getString("fechaInicio"));
            mat.setfFinal(rs.getString("fechaTermino"));
            mat.setNropensiones(rs.getString("cantpens"));
            mat.setCondicion(rs.getString("condicion"));
            mat.setObservacion(rs.getString("observaciones"));
        }
        cnx.close();
        return mat;
    }

    @Override
    public Matricula mostrarMatriculaCompleta(int cod_matricula) throws Exception {
        String base = "academianew";
        Matricula mat = new Matricula();
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "SELECT e.codestudiante,e.dni,e.paterno,e.materno,e.nombres,m.cod_matricula, \n"
                + "m.fechaMatricula,s.idlocal,s.deslocal,n.nivel,g.grado,c.ciclo,t.turno,m.seccion,m.estado_matri \n"
                + "FROM estudiante AS e \n"
                + "INNER JOIN matricula AS m ON e.codestudiante = m.cod_estud_matri \n"
                + "LEFT JOIN aula AS a ON m.codAula = a.codAula \n"
                + "LEFT JOIN sede AS s ON a.codSede = s.idlocal \n"
                + "LEFT JOIN academia_nivel AS n ON a.codNivel = n.idnivel \n"
                + "LEFT JOIN academia_grado AS g ON a.codTipoGrado = g.idgrado \n"
                + "LEFT JOIN academia_ciclo AS c ON a.codGrado = c.idciclo \n"
                + "LEFT JOIN academia_turno AS t ON a.codTurno = t.idturno \n"
                + "WHERE m.cod_matricula = " + cod_matricula;
        ResultSet rs = st.executeQuery(query);

        while (rs.next()) {

            mat.setCodEstudiante(rs.getString("codestudiante"));
            mat.setDocEstudiante(rs.getString("dni"));
            mat.setAp_paterno_est(rs.getString("paterno"));
            mat.setAp_materno_est(rs.getString("materno"));
            mat.setNombres_est(rs.getString("nombres"));
            mat.setCodMatricula(rs.getString("cod_matricula"));
            mat.setFecha_matri(rs.getString("fechaMatricula"));
            mat.setCod_Sede(rs.getString("idlocal"));
            mat.setNom_Sede(rs.getString("deslocal"));
            mat.setNom_nivel(rs.getString("nivel"));
            mat.setNom_grado(rs.getString("grado"));
            mat.setNom_Ciclo(rs.getString("ciclo"));
            mat.setNom_Turno(rs.getString("turno"));
            mat.setNom_Seccion(rs.getString("seccion"));
            mat.setEstado(rs.getString("estado_matri"));
        }
        cnx.close();
        return mat;
    }

    @Override
    public int actualizarMatricula(int cod_matricula, String obs, int aula, String seccion) throws Exception {
        int r = 0;
        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "UPDATE matricula SET codAula = '" + aula + "', seccion = '" + seccion
                + "',observaciones = '" + obs + "' WHERE cod_matricula = " + cod_matricula;
        r = st.executeUpdate(query);
        cnx.close();
        return r;
    }

    @Override
    public int validarMatriculaExistente(int aula, int estudiante) throws Exception {
        int cantidad = 0;
        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "SELECT COUNT(*) AS cant FROM matricula WHERE "
                + "codAula = " + aula + " AND cod_estud_matri = " + estudiante + " and estado_matri=1";
        ResultSet rs = st.executeQuery(query);
        System.out.println("query +++++++>>>>>>>>" + query);
        while (rs.next()) {
            cantidad = rs.getInt("cant");
        }
        cnx.close();
        return cantidad;
    }
}
