/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package pe.siso.academia.MySqlDAO;

import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.Statement;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import javax.swing.JOptionPane;
import pe.siso.academia.Beans.Aula;
import pe.siso.academia.Beans.Matricula;
import pe.siso.academia.Beans.Matriculados;
import pe.siso.academia.Beans.Monto;
import pe.siso.academia.DAO.MatriculadosDAO;

/**
 *
 * @author sistem08user
 */
public class MySqlMatriculadosDAO implements MatriculadosDAO {

    @Override
    public ArrayList<Matriculados> ListarCentro(int cod_sede) throws Exception {
        ArrayList<Matriculados> lista = new ArrayList<>();
        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "SELECT c.cod_centro,c.nom_centro  FROM aula AS a\n"
                + "LEFT JOIN sede as s ON a.codSede = s.idlocal\n"
                + "LEFT JOIN centro as c ON a.codCentro = c.cod_centro\n"
                + "LEFT JOIN academia_nivel as n ON a.codNivel = n.idnivel\n"
                + "LEFT JOIN academia_grado as tg ON a.codTipoGrado = tg.idgrado\n"
                + "LEFT JOIN academia_ciclo as ci ON a.codGrado = ci.idciclo\n"
                + "LEFT JOIN seccion as sec ON a.codAula = sec.idaula\n"
                + "LEFT JOIN academia_turno as tur ON a.codTurno = tur.idturno\n"
                + "WHERE s.idlocal=" + cod_sede + "  \n"
                + "GROUP BY(codCentro) ";

        ResultSet rs = st.executeQuery(query);

        while (rs.next()) {
            Matriculados monto = new Matriculados();
            monto.setCodCentro(rs.getString("cod_centro"));
            monto.setNomCentro(rs.getString("nom_centro"));
            lista.add(monto);
        }
        cnx.close();
        return lista;
    }

    @Override
    public ArrayList<Matriculados> ListarNivel(int cod_sede, int cod_centro) throws Exception {
        ArrayList<Matriculados> lista = new ArrayList<>();
        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "select n.idnivel,n.nivel from aula as a\n"
                + "INNER JOIN sede as s on a.codSede=s.idlocal\n"
                + "INNER JOIN centro as c on c.cod_centro=a.codCentro\n"
                + "INNER JOIN academia_nivel as n on n.idnivel=a.codNivel\n"
                + "\n"
                + "WHERE s.idlocal=" + cod_sede + " AND codCentro=" + cod_centro + " \n"
                + "GROUP BY n.idnivel ";

        ResultSet rs = st.executeQuery(query);

        while (rs.next()) {
            Matriculados monto = new Matriculados();
            monto.setCodNivel(rs.getString("idnivel"));
            monto.setNomNivel(rs.getString("nivel"));
            lista.add(monto);
        }
        cnx.close();
        return lista;
    }

    @Override
    public ArrayList<Matriculados> ListarGrado(int cod_nivel) throws Exception {
        ArrayList<Matriculados> lista = new ArrayList<>();
        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "select * from aula as a\n"
                + "INNER JOIN sede as s on a.codSede=s.idlocal\n"
                + "INNER JOIN centro as c on c.cod_centro=a.codCentro\n"
                + "INNER JOIN academia_nivel as n on n.idnivel=a.codNivel\n"
                + "LEFT JOIN academia_grado as g on a.codTipoGrado = g.idgrado\n"
                + "LEFT JOIN academia_ciclo as cl on a.codGrado = cl.idciclo\n"
                + "WHERE  n.idnivel=" + cod_nivel + " GROUP BY g.idgrado";

        ResultSet rs = st.executeQuery(query);

        while (rs.next()) {
            Matriculados monto = new Matriculados();
            monto.setCodGrado(rs.getString("idgrado"));
            monto.setNomGrado(rs.getString("grado"));
            lista.add(monto);
        }
        cnx.close();
        return lista;
    }

    @Override
    public ArrayList<Matriculados> ListarCiclo(int cod_grado) throws Exception {
        ArrayList<Matriculados> lista = new ArrayList<>();
        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "select * from aula as a\n"
                + "INNER JOIN sede as s on a.codSede=s.idlocal\n"
                + "INNER JOIN centro as c on c.cod_centro=a.codCentro\n"
                + "INNER JOIN academia_nivel as n on n.idnivel=a.codNivel\n"
                + "LEFT JOIN academia_grado as g on a.codTipoGrado = g.idgrado \n"
                + "LEFT JOIN academia_ciclo as cl on a.codGrado = cl.idciclo \n"
                + "WHERE  g.idgrado=" + cod_grado + " GROUP BY cl.idciclo";

        ResultSet rs = st.executeQuery(query);

        while (rs.next()) {
            Matriculados monto = new Matriculados();
            monto.setCodCiclo(rs.getString("idciclo"));
            monto.setNomCiclo(rs.getString("ciclo"));
            lista.add(monto);
        }
        cnx.close();
        return lista;
    }

    @Override
    public ArrayList<Matriculados> ListarCentroTable(int cod_sede, int cod_centro, int cod_nivel, int cod_grado, int cod_ciclo, int turno, String seccion, String estado_m, int CantidadMatricula, int tipo_colegio, int cod_univ, String Descuento, String fecha_i, String fecha_f, int tipo_Buscar, String nombre, int inicio, int cantidad) throws Exception {
        ArrayList<Matriculados> lista = new ArrayList<>();
        String a1 = "";
        String a2 = "";
        String a3 = "";
        String a4 = "";
        String a5 = "";
        String a6 = "";
        String a7 = "";
        String a8 = "";
        String a9 = "";
        String a10 = "";
        String a11 = "";
        String a12 = "";
        String a13 = "";
        String a14 = "";
        String a15 = "";
        String a16 = "";

        if (cod_centro != 0) {
            a1 = " and ct.cod_centro=" + cod_centro + " ";
        }
        if (cod_nivel != 0) {
            a2 = "and n.idnivel=" + cod_nivel + " ";
        }
        if (cod_grado != 0) {
            a3 = "and g.idgrado=" + cod_grado + " ";
        }
        if (cod_ciclo != 0) {
            a4 = " and c.idciclo=" + cod_ciclo + " ";
        }
        if (turno != 0) {
            a5 = " and t.idturno=" + turno + " ";
        }

        if (seccion.equals("0")) {
            a6 = "";
        } else {
            a6 = " and m.seccion='" + seccion + "' ";
        }

        if (Integer.parseInt(estado_m) != 2) {
            a7 = " and estado=" + estado_m + " ";
        }
        if (CantidadMatricula != 0) {//having
            if (CantidadMatricula == 1) {
                a8 = " and cantidadM <= 1 ";
            }
            if (CantidadMatricula == 2) {
                a8 = " and cantidadM >= 2 ";
            }
        }
        if (tipo_colegio != 0) {
            if (tipo_colegio == 1) {
                a9 = " and e.tipo_colegio='Nacional' ";
            }
            if (tipo_colegio == 2) {
                a9 = " and e.tipo_colegio='Particular' ";
            }
        }
        if (cod_univ != 0) {
            a10 = " and uni.coduniversidad=" + cod_univ + " ";
        }
        if (Descuento.equals("0")) {
            a11 = "";
        } else {
            a11 = " and pg.nom_dscto='" + Descuento + "' ";
        }
        if (fecha_i.equals("0")) {
            a12 = "";
        } else {
            a12 = " and DATE(m.fechaMatricula)>='" + fecha_i + "' ";
        }
        if (fecha_f.equals("0")) {
            a13 = "";
        } else {
            a13 = " and DATE(m.fechaMatricula)<='" + fecha_f + "' ";
        }
        if (tipo_Buscar != 0) {
            if (tipo_Buscar == 1) {
                if (CantidadMatricula == 0) {//having
                    a15 = " and nombre_completo LIKE '%" + nombre + "%' ";
                } else {
                    a15 = " and nombre_completo LIKE '%" + nombre + "%' ";
                }

            }
            if (tipo_Buscar == 2) {
                a16 = " and e.dni='" + nombre + "' ";
            }
        }
        String sentencia = a1 + a2 + a3 + a4 + a5 + a6 + a9 + a10 + a11 + a12 + a13 + a14 + a16;
        String having1 = a8 + a15 + a7;

        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "SELECT 			"
                + "s.idlocal,\n"
                + "s.deslocal,\n"
                + "						s.deslocal,\n"
                + "						e.codestudiante,\n"
                + "						pg.nom_dscto,\n"
                + "						e.dni,\n"
                + "						CONCAT(TRIM(e.paterno),\" \",TRIM(e.materno),\" \",TRIM(e.nombres)) AS nombre_completo,\n"
                + "						m.cod_matricula,\n"
                + "						m.fechaMatricula,\n"
                + "						ct.cod_centro,\n"
                + "						ct.nom_centro,\n"
                + "						n.idnivel,\n"
                + "						n.nivel,\n"
                + "						g.idgrado,\n"
                + "						g.grado,\n"
                + "						c.idciclo,\n"
                + "						c.ciclo,\n"
                + "						t.idturno,\n"
                + "						t.turno,\n"
                + "						m.seccion,\n"
                + "						e.tipo_colegio,\n"
                + "						m.estado_matri,\n"
                + "						(SELECT COUNT(*) FROM pagocuota AS pc WHERE pc.codmatricula = m.cod_matricula AND pc.estado<>0) \n"
                + "					AS pensiones_editadas,\n"
                + "						(IF(e.estado=1,IF((select COUNT(1) from pagocuota pc  WHERE codmatricula=pg.codmatricula  and estado=0)>0,1,0),0)) estado,\n"
                + "(select count(*) from matricula as mt where mt.cod_estud_matri=e.codestudiante ) as cantidadM,\n"
                + "uni.coduniversidad,\n"
                + "uni.nomuniversidad\n"
                + "					\n"
                + "					FROM estudiante AS e \n"
                + "						LEFT JOIN matricula AS m ON e.codestudiante = m.cod_estud_matri\n"
                + "						LEFT JOIN universidad AS uni on e.coduniversidad1=uni.coduniversidad\n"
                + "						LEFT JOIN pagocuota as pg on m.cod_matricula=pg.codmatricula\n"
                + "						LEFT JOIN aula AS a ON m.codAula = a.codAula \n"
                + "						LEFT JOIN sede AS s ON a.codSede = s.idlocal \n"
                + "						LEFT JOIN centro as ct on a.codCentro=ct.cod_centro\n"
                + "						LEFT JOIN academia_nivel AS n ON a.codNivel = n.idnivel \n"
                + "						LEFT JOIN academia_grado AS g ON a.codTipoGrado = g.idgrado \n"
                + "						LEFT JOIN academia_ciclo AS c ON a.codGrado = c.idciclo \n"
                + "						LEFT JOIN academia_turno AS t ON a.codTurno = t.idturno  \n"
                + "						\n"
                + "						WHERE a.estado=1 and s.idlocal=" + cod_sede + " " + sentencia + " GROUP BY m.cod_matricula HAVING 1=1 " + having1 + " order by m.cod_matricula desc  LIMIT " + inicio + "," + cantidad + " ;";

        ResultSet rs = st.executeQuery(query);
        System.out.println("Listar Matriculados \n" + query);

        while (rs.next()) {
            Matriculados matriculados = new Matriculados();
            matriculados.setDni(rs.getString("dni"));
            matriculados.setNombreCompleto(rs.getString("nombre_completo"));
            matriculados.setNomSede(rs.getString("deslocal"));
            matriculados.setCodCentro(rs.getString("cod_centro"));
            matriculados.setNomCentro(rs.getString("nom_centro"));

            matriculados.setCodNivel(rs.getString("idnivel"));
            matriculados.setNomNivel(rs.getString("nivel"));

            matriculados.setCodGrado(rs.getString("idgrado"));
            matriculados.setNomGrado(rs.getString("grado"));

            matriculados.setCodCiclo(rs.getString("idciclo"));
            matriculados.setNomCiclo(rs.getString("ciclo"));

            matriculados.setCodTurno(rs.getString("idturno"));
            matriculados.setNomTurno(rs.getString("turno"));
            matriculados.setSeccion(rs.getString("seccion"));
            matriculados.setEstado_m(Integer.parseInt(rs.getString("estado")));
            matriculados.setFecha_m(rs.getString("fechaMatricula"));
            matriculados.setCant_matricula(Integer.parseInt(rs.getString("cantidadM")));
            lista.add(matriculados);
        }
        cnx.close();
        return lista;
    }

    @Override
    public int CantidadCentro(int cod_sede, int cod_centro, int cod_nivel, int cod_grado, int cod_ciclo, int turno, String seccion, String estado_m, int CantidadMatricula, int tipo_colegio, int cod_univ, String Descuento, String fecha_i, String fecha_f, int tipo_Buscar, String nombre) throws Exception {
        int cant = 0;
        String a1 = "";
        String a2 = "";
        String a3 = "";
        String a4 = "";
        String a5 = "";
        String a6 = "";
        String a7 = "";
        String a8 = "";
        String a9 = "";
        String a10 = "";
        String a11 = "";
        String a12 = "";
        String a13 = "";
        String a14 = "";
        String a15 = "";
        String a16 = "";

        if (cod_centro != 0) {
            a1 = " and ct.cod_centro=" + cod_centro + " ";
        }
        if (cod_nivel != 0) {
            a2 = "and n.idnivel=" + cod_nivel + " ";
        }
        if (cod_grado != 0) {
            a3 = "and g.idgrado=" + cod_grado + " ";
        }
        if (cod_ciclo != 0) {
            a4 = " and c.idciclo=" + cod_ciclo + " ";
        }
        if (turno != 0) {
            a5 = " and t.idturno=" + turno + " ";
        }

        if (seccion.equals("0")) {
            a6 = "";
        } else {
            a6 = " and m.seccion='" + seccion + "' ";
        }

        if (Integer.parseInt(estado_m) != 2) {
            a7 = " and estado=" + estado_m + " ";
        }
        if (CantidadMatricula != 0) {//having
            if (CantidadMatricula == 1) {
                a8 = " and cantidadM <= 1 ";
            }
            if (CantidadMatricula == 2) {
                a8 = " and cantidadM >= 2 ";
            }
        }
        if (tipo_colegio != 0) {
            if (tipo_colegio == 1) {
                a9 = " and e.tipo_colegio='Nacional' ";
            }
            if (tipo_colegio == 2) {
                a9 = " and e.tipo_colegio='Particular' ";
            }
        }
        if (cod_univ != 0) {
            a10 = " and uni.coduniversidad=" + cod_univ + " ";
        }
        if (Descuento.equals("0")) {
            a11 = "";
        } else {
            a11 = " and pg.nom_dscto='" + Descuento + "' ";
        }
        if (fecha_i.equals("0")) {
            a12 = "";
        } else {
            a12 = " and DATE(m.fechaMatricula)>='" + fecha_i + "' ";
        }
        if (fecha_f.equals("0")) {
            a13 = "";
        } else {
            a13 = " and DATE(m.fechaMatricula)<='" + fecha_f + "' ";
        }
        if (tipo_Buscar != 0) {
            if (tipo_Buscar == 1) {
                if (CantidadMatricula == 0) {//having
                    a15 = " and nombre_completo LIKE '%" + nombre + "%' ";
                } else {
                    a15 = " and nombre_completo LIKE '%" + nombre + "%' ";
                }

            }
            if (tipo_Buscar == 2) {
                a16 = " and e.dni='" + nombre + "' ";
            }
        }
        String sentencia = a1 + a2 + a3 + a4 + a5 + a6 + a7 + a9 + a10 + a11 + a12 + a13 + a14 + a16;
        String having1 = a8 + a15;

        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "SELECT  count(DISTINCT(m.cod_matricula)) as cant \n"
                + "\n"
                + "			FROM estudiante AS e  \n"
                + "						LEFT JOIN matricula AS m ON e.codestudiante = m.cod_estud_matri\n"
                + "						LEFT JOIN universidad AS uni on e.coduniversidad1=uni.coduniversidad\n"
                + "						LEFT JOIN pagocuota as pg on m.cod_matricula=pg.codmatricula\n"
                + "						LEFT JOIN aula AS a ON m.codAula = a.codAula \n"
                + "						LEFT JOIN sede AS s ON a.codSede = s.idlocal \n"
                + "						LEFT JOIN centro as ct on a.codCentro=ct.cod_centro\n"
                + "						LEFT JOIN academia_nivel AS n ON a.codNivel = n.idnivel \n"
                + "						LEFT JOIN academia_grado AS g ON a.codTipoGrado = g.idgrado \n"
                + "						LEFT JOIN academia_ciclo AS c ON a.codGrado = c.idciclo \n"
                + "						LEFT JOIN academia_turno AS t ON a.codTurno = t.idturno  \n"
                + "						\n"
                + "						WHERE a.estado=1 and s.idlocal=" + cod_sede + " " + sentencia + " HAVING 1=1" + having1 + " ";

        ResultSet rs = st.executeQuery(query);

        while (rs.next()) {
            cant = rs.getInt("cant");
        }

        cnx.close();
        return cant;
    }

//  
    @Override
    public ArrayList<Matriculados> ListarSeccion(int cod_aula) throws Exception {
        ArrayList<Matriculados> lista = new ArrayList<>();
        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "SELECT idaula, nomaula FROM seccion WHERE estado_seccion = 1 AND idaula = " + cod_aula;
        ResultSet rs = st.executeQuery(query);

        while (rs.next()) {
            Matriculados mat = new Matriculados();
            mat.setCod_seccion(rs.getString("idaula"));
            mat.setSeccion(rs.getString("nomaula"));
            lista.add(mat);
        }
        cnx.close();
        return lista;
    }

    @Override
    public ArrayList<Matriculados> ListarUniversidad() throws Exception {
        ArrayList<Matriculados> lista = new ArrayList<>();
        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "select * from universidad ";

        ResultSet rs = st.executeQuery(query);

        while (rs.next()) {
            Matriculados monto = new Matriculados();
            monto.setCodUni(rs.getString("coduniversidad"));
            monto.setNomUni(rs.getString("nomuniversidad"));
            lista.add(monto);
        }
        cnx.close();
        return lista;
    }

    @Override
    public ArrayList<Matriculados> ListarTurno(int cod_sede, int cod_centro, int cod_nivel, int cod_grado, int ciclo) throws Exception {
        ArrayList<Matriculados> lista = new ArrayList<>();
        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "SELECT codAula,codTurno,turno,fechaInicio,fechaTermino,cuotas FROM aula AS a \n"
                + "INNER JOIN academia_turno AS t ON a.codTurno = t.idturno \n"
                + "WHERE a.estado = 1 AND codSede = " + cod_sede + " AND codCentro = " + cod_centro + " AND codNivel = " + cod_nivel + " \n"
                + "AND codTipoGrado = " + cod_grado + " AND codGrado = " + ciclo + " \n"
                + "GROUP BY codTurno ";
        ResultSet rs = st.executeQuery(query);

        while (rs.next()) {
            Matriculados mat = new Matriculados();
            mat.setCod_aula(rs.getInt("codAula"));
            mat.setCodTurno(rs.getString("codTurno"));
            mat.setNomTurno(rs.getString("turno"));

            lista.add(mat);
        }
        cnx.close();
        return lista;
    }

    @Override
    public ArrayList<Matriculados> ListarReporteIngreso(int cod_sede, int cod_centro, int cod_nivel, int cod_grado, int cod_ciclo, int turno, String seccion, String fecha_i, String fecha_f, int tipo_Buscar, String nombre, String nombTipodoc, int inicio, int cantidad) throws Exception {
        ArrayList<Matriculados> lista = new ArrayList<>();
        String a1 = "";
        String a2 = "";
        String a3 = "";
        String a4 = "";
        String a5 = "";
        String a6 = "";
        String a7 = "";
        String a8 = "";
        String a9 = "";
        String a10 = "";
        String a11 = "";
        String a12 = "";
        String a13 = "";
        String a14 = "";
        String a15 = "";
        String a16 = "";

        if (cod_centro != 0) {
            a1 = " and c.cod_centro=" + cod_centro + " ";
        }
        if (cod_nivel != 0) {
            a2 = "and n.idnivel=" + cod_nivel + " ";
        }
        if (cod_grado != 0) {
            a3 = "and g.idgrado=" + cod_grado + " ";
        }
        if (cod_ciclo != 0) {
            a4 = " and cl.idciclo=" + cod_ciclo + " ";
        }
        if (turno != 0) {
            a5 = " and t.idturno=" + turno + " ";
        }
        if (seccion.equals("0")) {
            a6 = "";
        } else {
            a6 = " and m.seccion='" + seccion + "' ";
        }
        if (fecha_i.equals("0")) {
            a12 = "";
        } else {
            a12 = " and DATE(pg.fecha_pago)>='" + fecha_i + "' ";
        }
        if (fecha_f.equals("0")) {
            a13 = "";
        } else {
            a13 = " and DATE(pg.fecha_pago)<='" + fecha_f + "' ";
        }
        if (tipo_Buscar != 0) {
            if (tipo_Buscar == 1) {
                //having
                a15 = " and nombre_completo LIKE '%" + nombre + "%' ";
            }
            if (tipo_Buscar == 2) {
                a16 = " and e.dni='" + nombre + "' ";
            }
        }

        String sentencia = a1 + a2 + a3 + a4 + a5 + a6 + a7 + a9 + a10 + a11 + a12 + a13 + a14 + a16;
        String having1 = a15;

        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "select e.dni,m.cod_matricula,\n"
                + "CONCAT(TRIM(e.paterno),\" \",TRIM(e.materno),\" \",TRIM(e.nombres)) AS nombre_completo,\n"
                + "s.deslocal,s.idlocal,\n"
                + "c.nom_centro,\n"
                + "n.nivel,\n"
                + "g.idgrado,\n"
                + "g.grado,\n"
                + "cl.ciclo,\n"
                + "t.turno,\n"
                + "m.seccion,\n"
                + "pg.codpagocuota,pg.tipo_documento, \n"
                + "DATE_FORMAT(pg.fecha_pago,'%d/%m/%Y-%h:%i %p')as fechapago,s.codigo_tk,"
                + " IF(pg.estado=5 or pg.estado=6 ,CONCAT(LPAD(pg.num_serie,4,\"0\"),\"-\",LPAD(pg.num_docu,6,\"0\")),CONCAT(IF(pg.tipo_documento=\"CPE BOLETA\" or ref_tipo_de_comprobante=2,\"B\",\"F\"),LPAD(pg.num_serie,3,\"0\"),\"-\",LPAD(pg.num_docu,5,\"0\"))) AS nroDocumento,\n"
                + "pg.num_serie,pg.num_docu,pg.pagado,(select CONCAT(TRIM(usu.nom_usu)) from usuario as usu WHERE usu.cod_usu=pg.usuario_gestor) as nombre_usuario,\n"
                + "case pg.estado WHEN 1 THEN 'CANCELADO' WHEN 2 THEN 'ANULADO' WHEN 3 THEN 'DEVUELTO' WHEN 4 THEN 'ANULADO' WHEN 5 THEN 'CANCELADO' WHEN 6 THEN 'CANCELADO' END as estadopago,\n"
                + "case pg.fraccion WHEN '1/1' THEN 'Pensión' ELSE 'Pensión-Frac' end as pagoF,pg.monto_dscto,pg.nom_dscto,pg.regularizacion ,IFNULL(m.autorizacion_desc,'') autorizacion_desc,forma_pago,pg.motivo_dscto\n"
                + "from aula as a\n"
                + "INNER JOIN matricula as m on m.codAula=a.codAula\n"
                + "INNER JOIN estudiante as e on e.codestudiante=m.cod_estud_matri\n"
                + "INNER JOIN pagocuota as pg on pg.codmatricula=m.cod_matricula\n"
                + "INNER JOIN sede as s on a.codSede=s.idlocal\n"
                + "INNER JOIN centro as c on c.cod_centro=a.codCentro\n"
                + "INNER JOIN academia_nivel as n on n.idnivel=a.codNivel\n"
                + "LEFT JOIN academia_grado as g on g.idgrado=a.codTipoGrado\n"
                + "LEFT JOIN academia_ciclo as cl on cl.idciclo=a.codGrado\n"
                + "LEFT JOIN academia_turno as t on t.idturno=a.codTurno\n"
                + "WHERE s.idlocal=" + cod_sede + "  " + sentencia + " and pg.estado<>0 and pg.num_docu<>0\n"
                + "GROUP BY pg.codpagocuota  HAVING 1=1" + having1 + " and tipo_documento like '%" + nombTipodoc + "%' ORDER BY pg.fecha_pago desc LIMIT " + inicio + "," + cantidad + ";";

        ResultSet rs = st.executeQuery(query);
        System.out.println("Listar Reporte Ingreso \n " + query);
        while (rs.next()) {
            Matriculados matriculados = new Matriculados();
            matriculados.setDni(rs.getString("dni"));
            matriculados.setNombreCompleto(rs.getString("nombre_completo"));
            matriculados.setNomSede(rs.getString("deslocal"));
            matriculados.setCodSede(rs.getString("idlocal"));
            //   matriculados.setCodCentro(rs.getString("cod_centro"));
            matriculados.setNomCentro(rs.getString("nom_centro"));
            //    matriculados.setCodNivel(rs.getString("idnivel"));
            matriculados.setNomNivel(rs.getString("nivel"));
            //    matriculados.setCodGrado(rs.getString("idgrado"));
            matriculados.setNomGrado(rs.getString("grado"));
            //   matriculados.setCodCiclo(rs.getString("idciclo"));
            matriculados.setNomCiclo(rs.getString("ciclo"));
            //    matriculados.setCodTurno(rs.getString("idturno")); 
            matriculados.setNomTurno(rs.getString("turno"));
            matriculados.setSeccion(rs.getString("seccion"));
            matriculados.setFecha_m(rs.getString("fechapago"));
            matriculados.setCODTK(rs.getString("nroDocumento"));
            matriculados.setNom_doc(rs.getInt("num_docu"));
            matriculados.setNombrTipopago(rs.getString("tipo_documento"));
            matriculados.setMonto(rs.getDouble("pagado"));
            matriculados.setNombre_usuario(rs.getString("nombre_usuario"));
            matriculados.setEstadoPago(rs.getString("estadopago"));
            matriculados.setTipoPago(rs.getString("pagoF"));
            matriculados.setMontoDesc(rs.getString("monto_dscto"));
            matriculados.setNombDesc(rs.getString("nom_dscto"));
            matriculados.setRegula(rs.getDouble("regularizacion"));
            matriculados.setAutorizacion_desc(rs.getString("autorizacion_desc"));
            matriculados.setFormaPago(rs.getInt("forma_pago"));
            matriculados.setMotivo_dscto(rs.getString("motivo_dscto"));
            lista.add(matriculados);
        }
        cnx.close();
        return lista;
    }

    @Override
    public int CantidadReporteIngreso(int cod_sede, int cod_centro, int cod_nivel, int cod_grado, int cod_ciclo, int turno, String seccion1, String fecha_i, String fecha_f, int tipo_Buscar, String nombre) throws Exception {
        int cant = 0;
        String a1 = "";
        String a2 = "";
        String a3 = "";
        String a4 = "";
        String a5 = "";
        String a6 = "";
        String a7 = "";
        String a8 = "";
        String a9 = "";
        String a10 = "";
        String a11 = "";
        String a12 = "";
        String a13 = "";
        String a14 = "";
        String a15 = "";
        String a16 = "";

        if (cod_centro != 0) {
            a1 = " and c.cod_centro=" + cod_centro + " ";
        }
        if (cod_nivel != 0) {
            a2 = "and n.idnivel=" + cod_nivel + " ";
        }
        if (cod_grado != 0) {
            a3 = "and g.idgrado=" + cod_grado + " ";
        }
        if (cod_ciclo != 0) {
            a4 = " and cl.idciclo=" + cod_ciclo + " ";
        }
        if (turno != 0) {
            a5 = " and t.idturno=" + turno + " ";
        }
        if (seccion1.equals("0")) {
            a6 = "";
        } else {
            a6 = " and m.seccion='" + seccion1 + "' ";
        }
        if (fecha_i.equals("0")) {
            a12 = "";
        } else {
            a12 = " and DATE(pg.fecha_pago)>='" + fecha_i + "' ";
        }
        if (fecha_f.equals("0")) {
            a13 = "";
        } else {
            a13 = " and DATE(pg.fecha_pago)<='" + fecha_f + "' ";
        }
        if (tipo_Buscar != 0) {
            if (tipo_Buscar == 1) {
                //having
                a15 = " and nombre_completo LIKE '%" + nombre + "%' ";

            }
            if (tipo_Buscar == 2) {
                a16 = " and e.dni='" + nombre + "' ";
            }
        }
        String sentencia = a1 + a2 + a3 + a4 + a5 + a6 + a7 + a9 + a10 + a11 + a12 + a13 + a14 + a16;
        String having1 = a8 + a15;

        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "select count(1) as cant   from(   select e.dni,m.cod_matricula,\n"
                + "CONCAT(TRIM(e.paterno),\" \",TRIM(e.materno),\" \",TRIM(e.nombres)) AS nombre_completo,\n"
                + "s.deslocal,s.idlocal,\n"
                + "c.nom_centro,\n"
                + "n.nivel,\n"
                + "g.idgrado,\n"
                + "g.grado,\n"
                + "cl.ciclo,\n"
                + "t.turno,\n"
                + "m.seccion,\n"
                + "pg.codpagocuota,\n"
                + "DATE_FORMAT(pg.fecha_pago,'%d/%m/%Y %h:%i %p')as fechapago,s.codigo_tk,\n"
                + "pg.num_docu,pg.monto\n"
                + "from aula as a\n"
                + "INNER JOIN matricula as m on m.codAula=a.codAula\n"
                + "INNER JOIN estudiante as e on e.codestudiante=m.cod_estud_matri\n"
                + "INNER JOIN pagocuota as pg on pg.codmatricula=m.cod_matricula\n"
                + "INNER JOIN sede as s on a.codSede=s.idlocal\n"
                + "INNER JOIN centro as c on c.cod_centro=a.codCentro\n"
                + "INNER JOIN academia_nivel as n on n.idnivel=a.codNivel\n"
                + "LEFT JOIN academia_grado as g on g.idgrado=a.codTipoGrado\n"
                + "LEFT JOIN academia_ciclo as cl on cl.idciclo=a.codGrado\n"
                + "LEFT JOIN academia_turno as t on t.idturno=a.codTurno\n"
                + "WHERE s.idlocal=" + cod_sede + " and pg.estado<>0 and pg.num_docu<>0 " + sentencia + "  \n"
                + "GROUP BY pg.codpagocuota HAVING 1=1" + having1 + "  ORDER BY pg.num_docu) x";

//        "WHERE s.idlocal="+cod_sede+" and pg.pagado<>0 "+sentencia+" \n" +
//                            "GROUP BY pg.codpagocuota  "+having1+" ORDER BY pg.num_docu ) x ";
        ResultSet rs = st.executeQuery(query);
        System.out.println("Sentencia cant ffffffffffffffffffffffffffffff \n" + query);
        while (rs.next()) {
            cant = rs.getInt("cant");
        }

        cnx.close();
        return cant;

    }

    @Override
    public ArrayList<Matriculados> ListarReporteDeudores(int cod_sede, int cod_centro, int cod_nivel, int cod_grado, int cod_ciclo, int turno, String seccion, String fecha_i, String fecha_f, int tipo_Buscar, String nombre, int inicio, int cantidad) throws Exception {
        ArrayList<Matriculados> lista = new ArrayList<>();
        String a1 = "";
        String a2 = "";
        String a3 = "";
        String a4 = "";
        String a5 = "";
        String a6 = "";
        String a7 = "";
        String a8 = "";
        String a9 = "";
        String a10 = "";
        String a11 = "";
        String a12 = "";
        String a13 = "";
        String a14 = "";
        String a15 = "";
        String a16 = "";

        if (cod_centro != 0) {
            a1 = " and c.cod_centro=" + cod_centro + " ";
        }
        if (cod_nivel != 0) {
            a2 = "and n.idnivel=" + cod_nivel + " ";
        }
        if (cod_grado != 0) {
            a3 = "and g.idgrado=" + cod_grado + " ";
        }
        if (cod_ciclo != 0) {
            a4 = " and cl.idciclo=" + cod_ciclo + " ";
        }
        if (turno != 0) {
            a5 = " and t.idturno=" + turno + " ";
        }
        if (seccion.equals("0")) {
            a6 = "";
        } else {
            a6 = " and m.seccion='" + seccion + "' ";
        }
        if (fecha_i.equals("0")) {
            a12 = "";
        } else {
            a12 = "   and DATE(p.cadPension)>='" + fecha_i + "' ";
        }
        if (fecha_f.equals("0")) {
            a13 = "";
        } else {
            a13 = "and DATE(p.cadPension)<='" + fecha_f + "' ";
        }
        if (tipo_Buscar != 0) {
            if (tipo_Buscar == 1) {
                //having
                a15 = " and nombre_completo LIKE '%" + nombre + "%' ";
            }
            if (tipo_Buscar == 2) {
                a16 = " and e.dni='" + nombre + "' ";
            }
        }
        String sentencia = a1 + a2 + a3 + a4 + a5 + a6 + a7 + a9 + a10 + a11 + a12 + a13 + a14 + a16;
        String having1 = a8 + a15;

        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "select \n"
                + "e.dni ,"
                + "             CONCAT(TRIM(e.paterno),\" \",TRIM(e.materno),\" \",TRIM(e.nombres)) AS nombre_completo,\n"
                + "m.cod_matricula,e.codestudiante ,\n"
                + "pg.estado,\n"
                + "s.idlocal,s.deslocal,\n"
                + "c.cod_centro,c.nom_centro,\n"
                + "n.idnivel,n.nivel,\n"
                + "g.idgrado,g.grado,\n"
                + "cl.idciclo,cl.ciclo,\n"
                + "t.idturno,t.turno,\n"
                + "m.seccion,\n"
                + "pg.fecha_pago,p.cadPension,\n"
                + "pg.pagado,\n"
                + "sum(pg.monto)as suma_pensiones,\n"
                + "COUNT(m.cod_matricula)as coutas,\n"
                + "pg.fraccion\n"
                + "from matricula as m \n"
                + "inner join estudiante as e on e.codestudiante=m.cod_estud_matri\n"
                + "inner join pagocuota as pg on pg.codmatricula=m.cod_matricula\n"
                + "inner join pension as p on p.codPension=pg.codpension\n"
                + "inner join aula as a on a.codAula=m.codAula\n"
                + "INNER JOIN sede as s on a.codSede=s.idlocal\n"
                + "INNER JOIN centro as c on a.codCentro=c.cod_centro\n"
                + "INNER JOIN academia_nivel as n on a.codNivel=n.idnivel\n"
                + "LEFT JOIN academia_grado as g ON a.codTipoGrado = g.idgrado\n"
                + "LEFT JOIN academia_ciclo as cl ON a.codGrado = cl.idciclo\n"
                + "\n"
                + "LEFT JOIN academia_turno as t ON a.codTurno = t.idturno\n"
                + "WHERE s.idlocal=" + cod_sede + " and pg.estado=0 " + sentencia + "   GROUP BY m.cod_matricula HAVING 1=1" + having1 + " ORDER BY COUNT(m.cod_matricula) desc,m.cod_matricula DESC   LIMIT " + inicio + "," + cantidad + " ;";

        ResultSet rs = st.executeQuery(query);
        //System.out.println("Listar Deudores \n"+query);
        while (rs.next()) {
            Matriculados matriculados = new Matriculados();
            matriculados.setDni(rs.getString("dni"));
            matriculados.setNombreCompleto(rs.getString("nombre_completo"));
            matriculados.setNomSede(rs.getString("deslocal"));
            matriculados.setCodMatricula(rs.getString("cod_matricula"));
            matriculados.setCodEstudiante(rs.getString("codestudiante"));
            matriculados.setNomCentro(rs.getString("nom_centro"));

            //    matriculados.setCodNivel(rs.getString("idnivel"));
            matriculados.setNomNivel(rs.getString("nivel"));

            //    matriculados.setCodGrado(rs.getString("idgrado"));
            matriculados.setNomGrado(rs.getString("grado"));

            //   matriculados.setCodCiclo(rs.getString("idciclo"));
            matriculados.setNomCiclo(rs.getString("ciclo"));

            //    matriculados.setCodTurno(rs.getString("idturno")); 
            matriculados.setNomTurno(rs.getString("turno"));
            matriculados.setSeccion(rs.getString("seccion"));

            matriculados.setFecha_m(rs.getString("cadPension"));
            matriculados.setTipoPago(rs.getString("fraccion"));
            matriculados.setCoutas(rs.getInt("coutas"));
            matriculados.setMonto(rs.getDouble("suma_pensiones"));
            lista.add(matriculados);
        }
        cnx.close();
        return lista;

    }

    @Override
    public int CantidadReporteDeudores(int cod_sede, int cod_centro, int cod_nivel, int cod_grado, int cod_ciclo, int turno, String seccion1, String fecha_i, String fecha_f, int tipo_Buscar, String nombre) throws Exception {
        int cant = 0;
        String a1 = "";
        String a2 = "";
        String a3 = "";
        String a4 = "";
        String a5 = "";
        String a6 = "";
        String a7 = "";
        String a8 = "";
        String a9 = "";
        String a10 = "";
        String a11 = "";
        String a12 = "";
        String a13 = "";
        String a14 = "";
        String a15 = "";
        String a16 = "";

        if (cod_centro != 0) {
            a1 = " and c.cod_centro=" + cod_centro + " ";
        }
        if (cod_nivel != 0) {
            a2 = "and n.idnivel=" + cod_nivel + " ";
        }
        if (cod_grado != 0) {
            a3 = "and g.idgrado=" + cod_grado + " ";
        }
        if (cod_ciclo != 0) {
            a4 = " and cl.idciclo=" + cod_ciclo + " ";
        }
        if (turno != 0) {
            a5 = " and t.idturno=" + turno + " ";
        }

        if (fecha_i.equals("0")) {
            a12 = "";
        } else {
            a12 = " and DATE(p.cadPension)>='" + fecha_i + "' ";
        }
        if (fecha_f.equals("0")) {
            a13 = "";
        } else {
            a13 = " and DATE(p.cadPension)<='" + fecha_f + "' ";
        }
        if (tipo_Buscar != 0) {
            if (tipo_Buscar == 1) {
                //having
                a15 = " and nombre_completo LIKE '%" + nombre + "%' ";

            }
            if (tipo_Buscar == 2) {
                a16 = " and e.dni='" + nombre + "' ";
            }
        }
        String sentencia = a1 + a2 + a3 + a4 + a5 + a6 + a7 + a9 + a10 + a11 + a12 + a13 + a14 + a16;
        String having1 = a8 + a15;

        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "select count(1) as cant\n"
                + "from (select \n"
                + "            CONCAT(TRIM(e.paterno),\" \",TRIM(e.materno),\" \",TRIM(e.nombres)) AS nombre_completo\n"
                + "from matricula as m \n"
                + "inner join estudiante as e on e.codestudiante=m.cod_estud_matri\n"
                + "inner join pagocuota as pg on pg.codmatricula=m.cod_matricula\n"
                + "inner join pension as p on p.codPension=pg.codpension\n"
                + "inner join aula as a on a.codAula=m.codAula\n"
                + "INNER JOIN sede as s on a.codSede=s.idlocal\n"
                + "INNER JOIN centro as c on a.codCentro=c.cod_centro\n"
                + "INNER JOIN academia_nivel as n on a.codNivel=n.idnivel\n"
                + "LEFT JOIN academia_grado as g ON a.codTipoGrado = g.idgrado\n"
                + "LEFT JOIN academia_ciclo as cl ON a.codGrado = cl.idciclo\n"
                + "LEFT JOIN seccion as sec ON a.codAula = sec.idaula\n"
                + "LEFT JOIN academia_turno as t ON a.codTurno = t.idturno\n"
                + "WHERE s.idlocal=" + cod_sede + " and pg.estado=0 " + sentencia + " GROUP BY m.cod_matricula HAVING 1=1" + having1 + " ) x";

        ResultSet rs = st.executeQuery(query);
        ////System.out.println("Cantidad Deudores \n"+query);
        while (rs.next()) {
            cant = rs.getInt("cant");
        }

        cnx.close();
        return cant;

    }

    @Override
    public ArrayList<Matriculados> ListadoDeCajeras(int cod_sede, String Fecha_actual) throws Exception {
        ArrayList<Matriculados> lista = new ArrayList<>();
        String Fecha_ultimo_cierre = "";
        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "select DATE_FORMAT(MAX(c.f_inicio),'%Y/%m/%d %T') as maxfecha from cierrediario as c WHERE c.f_inicio<'" + Fecha_actual + "' and c.codsede='" + cod_sede + "' ";
        ResultSet max = st.executeQuery(query);
        while (max.next()) {
            Fecha_ultimo_cierre = max.getString("maxfecha");
        }
        query = "select max(DATE_FORMAT(pg.fecha_pago,'%d/%m/%Y')) as fecha_pago,\n"
                + "pg.codpagocuota,\n"
                + "s.deslocal, \n"
                + "usu.nom_usu,\n"
                + "usu.cod_usu,\n"
                + "COUNT(pg.estado)as cant_vb,sum(pg.monto) as valor_bruto,\n"
                + "(select COUNT(*) from pagocuota WHERE estado=3 and usuario_gestor=usu.cod_usu and fecha_pago>='" + Fecha_ultimo_cierre + "'  and fecha_pago<='" + Fecha_actual + "')as cant_dev,\n"
                + "(select SUM(devol_monto) from pagocuota WHERE estado=3 and usuario_gestor=usu.cod_usu and fecha_pago>='" + Fecha_ultimo_cierre + "'  and fecha_pago<='" + Fecha_actual + "') as devolucion,\n"
                + "(select COUNT(*) from pagocuota WHERE estado<>3 and monto_dscto<>0 and usuario_gestor=usu.cod_usu and num_docu<>0 and fecha_pago>='" + Fecha_ultimo_cierre + "'  and fecha_pago<='" + Fecha_actual + "') as cant_descuento,\n"
                + "sum(pg.monto_dscto) as descuento,\n"
                + "(select COUNT(*) from pagocuota as pc INNER JOIN usuario as u on pc.usuario_gestor=u.cod_usu WHERE pc.estado in (2,4) and pc.num_docu<>0 and u.cod_usu=usu.cod_usu and fecha_anulacion>='" + Fecha_ultimo_cierre + "'  and fecha_anulacion<='" + Fecha_actual + "') as cant_null,\n"
                + "(select sum(pc.monto-pc.monto_dscto-pc.regularizacion) from pagocuota as pc INNER JOIN usuario as u on pc.usuario_gestor=u.cod_usu WHERE pc.estado in (2,4)  and pc.num_docu<>0  and u.cod_usu=usu.cod_usu and fecha_anulacion>='" + Fecha_ultimo_cierre + "'  and fecha_anulacion<='" + Fecha_actual + "') as sum_null,\n"
                + "sum(pg.regularizacion) as regula,\n"
                + "min(pg.num_docu),max(pg.num_docu) \n"
                + " from pagocuota as pg \n"
                + "INNER JOIN usuario as usu on usu.cod_usu=pg.usuario_gestor/*---------el monto con anulacion debe ser restado------------*/\n"
                + "INNER JOIN sede as s on s.idlocal=usu.cod_sed_usu\n"
                + "WHERE s.idlocal=" + cod_sede + " and pg.num_docu<>0  and pg.estado<>0 and pg.estado<>6 and pg.estado<>5 and (pg.fecha_pago BETWEEN '" + Fecha_ultimo_cierre + "' and '" + Fecha_actual + "')\n"
                + "GROUP BY usu.cod_usu\n"
                + "ORDER BY fecha_pago;";
        System.out.println("listado de Cajeras \n" + query);
        ResultSet rs = st.executeQuery(query);

        while (rs.next()) {
            SimpleDateFormat formateador = new SimpleDateFormat("yyyy/MM/dd HH:mm:ss");
            SimpleDateFormat formateador1 = new SimpleDateFormat("dd/MM/yyyy HH:mm:ss");
            Date fecha = formateador.parse(Fecha_actual);
            String fecha_actual_2 = formateador1.format(fecha);
            Matriculados cd = new Matriculados();
            cd.setNombreCompleto(rs.getString("nom_usu"));
            cd.setCant_VB(rs.getInt("cant_vb"));
            cd.setSum_VB(rs.getDouble("valor_bruto"));
            cd.setCant_descuento(rs.getInt("cant_descuento"));
            cd.setSum_descuento(rs.getDouble("descuento"));
            cd.setCant_desvolucion(rs.getInt("cant_dev"));
            cd.setSum_desvolucion(rs.getDouble("devolucion"));
            cd.setCant_anulacion(rs.getInt("cant_null"));
            cd.setSum_anulacion(rs.getDouble("sum_null"));
            cd.setRegula(rs.getDouble("regula"));
            cd.setFecha_m(rs.getString("fecha_pago"));
            cd.setFecha_i_tick(Fecha_ultimo_cierre);
            cd.setFecha_f_tick(fecha_actual_2);
            lista.add(cd);

        }
        if (lista.size() == 0) {
            query = "select u.nom_usu ,COUNT(*)as cant_vb,0.00 as valor_bruto,\n"
                    + "(select COUNT(*) from pagocuota WHERE usuario_gestor=pg.usuario_gestor and devol_monto<>0 and estado in (2,4,3) and fecha_anulacion BETWEEN '" + Fecha_ultimo_cierre + "' and '" + Fecha_actual + "' AND DATE(fecha_pago)<>DATE(fecha_anulacion)) as cant_dev,\n"
                    + "(select SUM(devol_monto) from pagocuota WHERE usuario_gestor=pg.usuario_gestor and devol_monto<>0 and estado in (2,4,3) and fecha_anulacion BETWEEN '" + Fecha_ultimo_cierre + "' and '" + Fecha_actual + "' AND DATE(fecha_pago)<>DATE(fecha_anulacion)) as devolucion,\n"
                    + "(select COUNT(*) from pagocuota as pc INNER JOIN usuario as u on pc.usuario_gestor=u.cod_usu WHERE pc.usuario_gestor=pg.usuario_gestor and pc.estado in (2,4)  and pc.num_docu<>0 and u.cod_sed_usu='" + cod_sede + "' and fecha_anulacion BETWEEN '" + Fecha_ultimo_cierre + "' and '" + Fecha_actual + "') as cant_null,\n"
                    + "(select IFNULL(sum(pc.monto-pc.monto_dscto-pc.regularizacion),0) from pagocuota as pc INNER JOIN usuario as u on pc.usuario_gestor=u.cod_usu WHERE pc.usuario_gestor=pg.usuario_gestor and pc.estado in (2,4)  and pc.num_docu<>0  and u.cod_sed_usu='" + cod_sede + "' and fecha_anulacion BETWEEN '" + Fecha_ultimo_cierre + "' and '" + Fecha_actual + "') as sum_null\n"
                    + " from pagocuota as pg\n"
                    + "INNER JOIN usuario as u on pg.usuario_gestor=u.cod_usu\n"
                    + "WHERE pg.estado in (2,4,3) and pg.fecha_anulacion BETWEEN '" + Fecha_ultimo_cierre + "' and '" + Fecha_actual + "' AND DATE(fecha_pago)<>DATE(fecha_anulacion)\n"
                    + "GROUP BY u.cod_usu;";
            rs = st.executeQuery(query);
            while (rs.next()) {
                Matriculados cd = new Matriculados();
                cd.setNombreCompleto(rs.getString("nom_usu"));
                cd.setCant_VB(0);
                cd.setSum_VB(rs.getDouble("valor_bruto"));
                cd.setCant_descuento(0);
                cd.setSum_descuento(0);
                cd.setCant_desvolucion(rs.getInt("cant_dev"));
                cd.setSum_desvolucion(rs.getDouble("devolucion"));
                cd.setCant_anulacion(rs.getInt("cant_null"));
                cd.setSum_anulacion(rs.getDouble("sum_null"));
                cd.setRegula(0);
                cd.setFecha_i_tick(Fecha_ultimo_cierre);
                cd.setFecha_f_tick(Fecha_actual);
                lista.add(cd);
            }
        }

        cnx.close();
        return lista;
    }

    @Override
    public ArrayList<Matriculados> ResumenDeVenta(int cod_sede, String Fecha_actual) throws Exception {
        ArrayList<Matriculados> lista = new ArrayList<>();
        String Fecha_ultimo_cierre = "";
        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "select MAX(c.f_inicio)as maxfecha from cierrediario as c WHERE c.f_inicio<'" + Fecha_actual + "' and c.codsede='" + cod_sede + "' ";
        ResultSet max = st.executeQuery(query);
        while (max.next()) {
            Fecha_ultimo_cierre = max.getString("maxfecha");
        }

        query = "select pg.fecha_pago,\n"
                + "pg.codpagocuota,\n"
                + "s.deslocal,s.idlocal,s.codigo_tk, \n"
                + "usu.nom_usu,\n"
                + "usu.cod_usu,\n"
                + "COUNT(pg.estado)as cant_vb,sum(pg.monto) as valor_bruto,\n"
                + "(select COUNT(*) from pagocuota WHERE estado=3 and usuario_gestor=usu.cod_usu and fecha_pago>='" + Fecha_ultimo_cierre + "'  and fecha_pago<='" + Fecha_actual + "')as cant_dev,\n"
                + "(select SUM(devol_monto) from pagocuota WHERE estado=3 and usuario_gestor=usu.cod_usu and fecha_pago>='" + Fecha_ultimo_cierre + "'  and fecha_pago<='" + Fecha_actual + "') as devolucion,\n"
                + "(select COUNT(*) from pagocuota as pc INNER JOIN usuario as u on pc.usuario_gestor=u.cod_usu WHERE pc.estado<>3 and pc.monto_dscto<>0  and pc.num_docu<>0 and pc.fecha_pago>='" + Fecha_ultimo_cierre + "'  and pc.fecha_pago<='" + Fecha_actual + "' and u.cod_sed_usu=" + cod_sede + " ) as cant_descuento,\n"
                + "sum(pg.monto_dscto) as descuento,\n"
                + "(select COUNT(*) from pagocuota as pc INNER JOIN usuario as u on pc.usuario_gestor=u.cod_usu WHERE pc.estado in (2,4)  and pc.num_docu<>0 and u.cod_sed_usu=" + cod_sede + " and fecha_anulacion>='" + Fecha_ultimo_cierre + "'  and fecha_anulacion<='" + Fecha_actual + "') as cant_null,\n"
                + "(select sum(pc.monto-pc.monto_dscto-pc.regularizacion) from pagocuota as pc INNER JOIN usuario as u on pc.usuario_gestor=u.cod_usu WHERE pc.estado in (2,4)  and pc.num_docu<>0  and u.cod_sed_usu=" + cod_sede + " and fecha_anulacion>='" + Fecha_ultimo_cierre + "'  and fecha_anulacion<='" + Fecha_actual + "') as sum_null, \n"
                + "sum(pg.regularizacion) as regula,\n"
                + "min(pg.num_docu) as min_tick,max(pg.num_docu) as max_tick \n"
                + " from pagocuota as pg \n"
                + "INNER JOIN usuario as usu on usu.cod_usu=pg.usuario_gestor/*---------el monto con anulacion debe ser restado------------*/\n"
                + "INNER JOIN sede as s on s.idlocal=usu.cod_sed_usu\n"
                + "WHERE s.idlocal=" + cod_sede + " and pg.num_docu<>0  and pg.estado<>5 and pg.estado<>6 and pg.estado<>0 and (pg.fecha_pago BETWEEN '" + Fecha_ultimo_cierre + "' and '" + Fecha_actual + "')\n"
                + "GROUP BY s.idlocal\n"
                + "ORDER BY fecha_pago;";

        ResultSet rs = st.executeQuery(query);
        System.out.println("Resumen de Ventas \n" + query);
        while (rs.next()) {
            Matriculados cd = new Matriculados();
            cd.setNombreCompleto(rs.getString("nom_usu"));
            cd.setCant_VB(rs.getInt("cant_vb"));
            cd.setSum_VB(rs.getDouble("valor_bruto"));
            cd.setCant_descuento(rs.getInt("cant_descuento"));
            cd.setSum_descuento(rs.getDouble("descuento"));
            cd.setCant_desvolucion(rs.getInt("cant_dev"));
            cd.setSum_desvolucion(rs.getDouble("devolucion"));
            cd.setCant_anulacion(rs.getInt("cant_null"));
            cd.setSum_anulacion(rs.getDouble("sum_null"));
            cd.setCod_tk(rs.getInt("min_tick"));
            cd.setCod_tk_max(rs.getInt("max_tick"));
            cd.setCodSede(rs.getString("idlocal"));
            cd.setCodSede_boleto(rs.getString("codigo_tk"));
            cd.setRegula(rs.getDouble("regula"));
            lista.add(cd);
        }
        if (lista.size() == 0) {
            query = "select u.nom_usu ,COUNT(*)as cant_vb,0.00 as valor_bruto,\n"
                    + "(select COUNT(*) from pagocuota WHERE devol_monto<>0 and estado in (2,4,3) and fecha_anulacion BETWEEN '" + Fecha_ultimo_cierre + "' and '" + Fecha_actual + "' AND DATE(fecha_pago)<>DATE(fecha_anulacion)) as cant_dev,\n"
                    + "(select SUM(devol_monto) from pagocuota WHERE devol_monto<>0 and estado in (2,4,3) and fecha_anulacion BETWEEN '" + Fecha_ultimo_cierre + "' and '" + Fecha_actual + "' AND DATE(fecha_pago)<>DATE(fecha_anulacion)) as devolucion,\n"
                    + "(select COUNT(*) from pagocuota as pc INNER JOIN usuario as u on pc.usuario_gestor=u.cod_usu WHERE pc.estado in (2,4)  and pc.num_docu<>0 and u.cod_sed_usu='" + cod_sede + "' and fecha_anulacion BETWEEN '" + Fecha_ultimo_cierre + "' and '" + Fecha_actual + "') as cant_null,\n"
                    + "(select IFNULL(sum(pc.monto-pc.monto_dscto-pc.regularizacion),0) from pagocuota as pc INNER JOIN usuario as u on pc.usuario_gestor=u.cod_usu WHERE  pc.estado in (2,4)  and pc.num_docu<>0  and u.cod_sed_usu='" + cod_sede + "' and fecha_anulacion BETWEEN '" + Fecha_ultimo_cierre + "' and '" + Fecha_actual + "') as sum_null,\n"
                    + "s.idlocal,s.codigo_tk\n"
                    + " from pagocuota as pg\n"
                    + "INNER JOIN usuario as u on pg.usuario_gestor=u.cod_usu\n"
                    + "INNER JOIN sede as s on s.idlocal=u.cod_sed_usu\n"
                    + "WHERE pg.estado in (2,4,3) and pg.fecha_anulacion BETWEEN '" + Fecha_ultimo_cierre + "' and '" + Fecha_actual + "' AND DATE(fecha_pago)<>DATE(fecha_anulacion)\n"
                    + "GROUP BY s.idlocal;";
            rs = st.executeQuery(query);

            while (rs.next()) {
                Matriculados cd = new Matriculados();
                cd.setNombreCompleto(rs.getString("nom_usu"));
                cd.setCant_VB(0);
                cd.setSum_VB(rs.getDouble("valor_bruto"));
                cd.setCant_descuento(0);
                cd.setSum_descuento(0);
                cd.setCant_desvolucion(rs.getInt("cant_dev"));
                cd.setSum_desvolucion(rs.getDouble("devolucion"));
                cd.setCant_anulacion(rs.getInt("cant_null"));
                cd.setSum_anulacion(rs.getDouble("sum_null"));
                cd.setCod_tk(0);
                cd.setCod_tk_max(0);
                cd.setCodSede(rs.getString("idlocal"));
                cd.setCodSede_boleto(rs.getString("codigo_tk"));
                cd.setRegula(0);
                lista.add(cd);
            }
        }
        cnx.close();
        return lista;
    }

    @Override
    public int GuardarDatosCierre(int codsede, int codusuario, String f_inicio, String hora, String tkinicio, String tkfinal, double efectivo, double deposito, String cod_operacion, String fecha_cierre) throws Exception {
        //  int codigo = 0;
        // String seccion = "";
        SimpleDateFormat formateador = new SimpleDateFormat("yyyy-MM-dd");
        SimpleDateFormat formateador1 = new SimpleDateFormat("dd/MM/yyyy");
        Date fecha = formateador1.parse(fecha_cierre);
        String fecha_c = formateador.format(fecha);
        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "insert cierrediario(codsede,codusuario,f_inicio,hora,tkinicio,tkfinal,efectivo,deposito,cod_operacion,estadcierre,f_emision) "
                + "VALUES(" + codsede + "," + codusuario + ",'" + f_inicio + "','" + hora + "','" + tkinicio + "','" + tkfinal + "'," + efectivo + "," + deposito + ",'" + cod_operacion + "',1,'" + fecha_c + "')";
        int r = st.executeUpdate(query);
        //OBTENER ID

        cnx.close();
        return r;
    }

    @Override
    public ArrayList<Matriculados> ListarCierreDiario(int cod_sede, int inicio, int cantidad) throws Exception {
        ArrayList<Matriculados> lista = new ArrayList<>();
        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "select u.nom_usu,DATE_FORMAT(cd.f_inicio,'%d/%m/%Y %T')as fecha_reg,DATE_FORMAT(f_emision,'%d/%m/%Y') as f_emision,cd.hora,cd.tkinicio,cd.tkfinal,cd.efectivo,cd.deposito,cd.cod_operacion from usuario as u \n"
                + "INNER JOIN cierrediario as cd on cd.codusuario=u.cod_usu\n"
                + "WHERE cd.codsede=" + cod_sede + " and cd.estadcierre=1 ORDER BY cd.f_inicio desc LIMIT " + inicio + "," + cantidad + " ;";
        ////System.out.println("Sentencis \n "+query);
        ResultSet rs = st.executeQuery(query);

        while (rs.next()) {
            Matriculados cd = new Matriculados();
            cd.setNombreCompleto(rs.getString("nom_usu"));
            cd.setFecha_m(rs.getString("fecha_reg"));
            cd.setHora_cierre(rs.getString("hora"));
            cd.setTick_i(rs.getString("tkinicio"));
            cd.setTick_f(rs.getString("tkfinal"));
            cd.setSum_VB(rs.getDouble("efectivo"));
            cd.setDeposito(rs.getDouble("deposito"));
            cd.setCod_opera(rs.getInt("cod_operacion"));
            cd.setF_emision(rs.getString("f_emision"));
            lista.add(cd);
        }
        cnx.close();
        return lista;
    }

    public int CantCierreDiario(int cod_sede) throws Exception {
        int cantidad = 0;
        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "select count(*) as cant from usuario as u \n"
                + "INNER JOIN cierrediario as cd on cd.codusuario=u.cod_usu\n"
                + "WHERE cd.codsede=" + cod_sede + " ORDER BY cd.f_inicio desc;";
        ResultSet rs = st.executeQuery(query);
        while (rs.next()) {
            cantidad = rs.getInt("cant");
        }
        cnx.close();
        return cantidad;
    }

    @Override
    public int CantASindatos(int cod_sede) throws Exception {
        int cantidad = 0;
        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "select COUNT(*) as cant from (select e.codestudiante,CASE e.tipodoc WHEN 1 THEN 'DNI' WHEN 2 THEN 'CARNÉ DE EXTRANJERIA' WHEN 3 THEN 'PASAPORTE' WHEN 4 THEN 'PARTIDA DE NACIMIENTO' END as tip_doc,\n"
                + "CONCAT(TRIM(paterno),\" \",TRIM(materno),\" \",TRIM(nombres)) AS nombre_completo,max(m.fechaMatricula) as fmatricula  from estudiante as e\n"
                + "inner join matricula as m on e.codestudiante=m.cod_estud_matri \n"
                + "WHERE e.dni='' and e.codsede=" + cod_sede + " and DATE(m.fechaMatricula)>'2016-01-01' GROUP BY e.codestudiante ORDER BY m.fechaMatricula desc) as x";
        ResultSet rs = st.executeQuery(query);
        while (rs.next()) {
            cantidad = rs.getInt("cant");
        }
        cnx.close();
        return cantidad;
    }

    @Override
    public ArrayList<Aula> ListaAlumnoAsistencia(Aula aula) throws Exception {
        ArrayList<Aula> lista = new ArrayList<>();

        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "select \n"
                + "e.dni,CONCAT(TRIM(e.paterno),\" \",TRIM(e.materno),\" \",TRIM(e.nombres)) AS nombre_completo,\n"
                + "m.cod_matricula,e.codestudiante ,\n"
                + "s.idlocal,s.deslocal,s.deslocal,CONCAT(n.nivel,(CASE g.grado WHEN 'NORMAL' THEN '' ELSE CONCAT(' ',g.grado) END ),'/',cl.ciclo,'/',t.turno) ciclo,\n"
                + " (IF(e.estado=1,IF((select COUNT(1) from pagocuota pc  WHERE codmatricula=pg.codmatricula  and estado=0)>0,1,0),0)) estado \n"
                + "from matricula as m \n"
                + "inner join estudiante as e on e.codestudiante=m.cod_estud_matri\n"
                + "inner join aula as a on a.codAula=m.codAula\n"
                + "INNER JOIN sede as s on a.codSede=s.idlocal\n"
                + "LEFT JOIN pagocuota as pg on m.cod_matricula=pg.codmatricula \n"
                + "INNER JOIN centro as c on a.codCentro=c.cod_centro\n"
                + "INNER JOIN academia_nivel as n on a.codNivel=n.idnivel\n"
                + "LEFT JOIN academia_grado as g ON a.codTipoGrado = g.idgrado\n"
                + "LEFT JOIN academia_ciclo as cl ON a.codGrado = cl.idciclo\n"
                + "LEFT JOIN academia_turno as t ON a.codTurno = t.idturno\n"
                + "WHERE\n"
                + "s.idlocal =" + aula.getCodSede() + " \n"
                + "AND c.cod_centro =" + aula.getCodCentro() + " \n"
                + "AND n.idnivel =" + aula.getCodNivel() + " \n"
                + "AND g.idgrado =" + aula.getCodTipoGrado() + " \n"
                + "AND cl.idciclo =" + aula.getCodGrado() + " \n"
                + "AND t.idturno =" + aula.getCodTurno() + " \n"
                + "AND m.seccion = '" + aula.getSecciones() + "'\n"
                + "AND a.estado = 1\n"
                + "GROUP BY m.cod_matricula HAVING estado=1 ORDER BY e.paterno, e.materno,e.nombres;";
        ResultSet rs = st.executeQuery(query);
        while (rs.next()) {
//            Fecha_ultimo_cierre=max.getString("maxfecha");
            Aula au = new Aula();
            au.setDni(rs.getString("dni"));
            au.setNombCompleto(rs.getString("nombre_completo"));
            au.setNomSede(rs.getString("deslocal"));
            au.setNombAula(rs.getString("ciclo"));
            lista.add(au);
        }

        cnx.close();
        return lista;
    }

}
