
package pe.siso.academia.MySqlDAO;

import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.Statement;
import java.util.ArrayList;
import pe.siso.academia.Beans.Monto;
import pe.siso.academia.DAO.MontoDAO;

public class MySqlMontoDAO implements MontoDAO {

    @Override
    public ArrayList<Monto> listarCentros(String nombre, int inicio, int cantidad) throws Exception {
        ArrayList<Monto> lista = new ArrayList<>();
        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "SELECT cod_centro,nom_centro,estado_centro FROM centro " +
                " WHERE nom_centro like '%" + nombre + "%' LIMIT "+ inicio +"," + cantidad;

        ResultSet rs = st.executeQuery(query);
        
        while(rs.next()){
            Monto monto = new Monto();
            monto.setCodCentro(rs.getString("cod_centro"));
            monto.setNomCentro(rs.getString("nom_centro"));
            monto.setEstCentro(rs.getString("estado_centro"));
            lista.add(monto);
        }
          cnx.close(); return lista;
    }

    @Override
    public int contarCentros(String nombre) throws Exception {
        int cantidad = 0;
        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "SELECT COUNT(*) AS cant FROM centro " +
                " WHERE nom_centro like '%" + nombre + "%'";
        
        ResultSet rs = st.executeQuery(query);
        
        while(rs.next()){
            cantidad = rs.getInt("cant");
        }
          cnx.close(); return cantidad;
    }
    
    @Override
    public ArrayList<Monto> listarNiveles(int centro, String nombre, int inicio, int cantidad) throws Exception {
        ArrayList<Monto> lista = new ArrayList<>();
        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "SELECT idnivel,nivel,estado FROM academia_nivel WHERE idcentro=" + centro + 
                " AND nivel like '%" + nombre + "%' LIMIT "+ inicio +"," + cantidad;

        ResultSet rs = st.executeQuery(query);
        
        while(rs.next()){
            Monto monto = new Monto();
            monto.setCodNivel(rs.getString("idnivel"));
            monto.setNomNivel(rs.getString("nivel"));
            monto.setEstNivel(rs.getString("estado"));
            lista.add(monto);
        }
          cnx.close(); return lista;
    }

    @Override
    public ArrayList<Monto> listarGrados(int nivel, String nombre, int inicio, int cantidad) throws Exception {
        ArrayList<Monto> lista = new ArrayList<>();
        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "SELECT idgrado,grado,estado FROM academia_grado WHERE idnivel=" + nivel + 
                " AND grado like '%" + nombre + "%' LIMIT "+ inicio +"," + cantidad;
        ResultSet rs = st.executeQuery(query);
        
        while(rs.next()){
            Monto monto = new Monto();
            monto.setCodGrado(rs.getString("idgrado"));
            monto.setNomGrado(rs.getString("grado"));
            monto.setEstGrado(rs.getString("estado"));
            lista.add(monto);
        }
          cnx.close(); return lista;
    }

    @Override
    public ArrayList<Monto> listarCiclos(int grado, String nombre, int inicio, int cantidad) throws Exception {
        ArrayList<Monto> lista = new ArrayList<>();
        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "SELECT idciclo,ciclo,estado FROM academia_ciclo WHERE idgrado=" + grado + 
                " AND ciclo like '%" + nombre + "%' LIMIT "+ inicio +"," + cantidad;
        ResultSet rs = st.executeQuery(query);
        
        while(rs.next()){
            Monto monto = new Monto();
            monto.setCodCiclo(rs.getString("idciclo"));
            monto.setNomCiclo(rs.getString("ciclo"));
            monto.setEstCiclo(rs.getString("estado"));
            lista.add(monto);
        }
          cnx.close(); return lista;
    }

    // CONTAR
    @Override
    public int contarNiveles(int centro, String nombre) throws Exception {
        int cantidad = 0;
        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "SELECT COUNT(*) AS cant FROM academia_nivel "
                + "WHERE idcentro=" + centro + " AND nivel like '%" + nombre + "%'";

        ResultSet rs = st.executeQuery(query);
        
        while(rs.next()){
            cantidad = rs.getInt("cant");
        }
          cnx.close(); return cantidad;
    }

    @Override
    public int contarGrados(int nivel, String nombre) throws Exception {
        int cantidad = 0;
        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "SELECT COUNT(*) AS cant FROM academia_grado "
                + "WHERE idnivel=" + nivel + " AND grado like '%" + nombre + "%'";
        
        ResultSet rs = st.executeQuery(query);
        
        while(rs.next()){
            cantidad = rs.getInt("cant");
        }
          cnx.close(); return cantidad;
    }

    @Override
    public int contarCiclos(int grado, String nombre) throws Exception {
        int cantidad = 0;
        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "SELECT COUNT(*) AS cant FROM academia_ciclo "
                + "WHERE idgrado=" + grado + " AND ciclo like '%" + nombre + "%'";
        
        ResultSet rs = st.executeQuery(query);
        
        while(rs.next()){
            cantidad = rs.getInt("cant");
        }
          cnx.close(); return cantidad;
    }

    @Override
    public int insertarCentros(String nombre) throws Exception {
        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "INSERT INTO centro (nom_centro) VALUES ('" + nombre + "')";
        int r = st.executeUpdate(query);
          cnx.close(); return r;
    }

    @Override
    public int insertarNiveles(int idCentro, String nombre) throws Exception {
        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "INSERT INTO academia_nivel (nivel, idcentro) VALUES ('" + nombre + "', '" + idCentro + "')";
        int r = st.executeUpdate(query);
          cnx.close(); return r;
    }

    @Override
    public int insertarGrados(int idNivel, String nombre) throws Exception {
        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "INSERT INTO academia_grado (idnivel, grado) VALUES ('" + idNivel + "', '" + nombre + "')";
        int r = st.executeUpdate(query);
          cnx.close(); return r;
    }

    @Override
    public int insertarCiclos(int idGrado, String nombre) throws Exception {
        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "INSERT INTO academia_ciclo (idgrado, ciclo) VALUES ('" + idGrado + "', '" + nombre + "')";
        int r = st.executeUpdate(query);
          cnx.close(); return r;
    }

    @Override
    public int cambiarEstadoCentros(int codCentro, int estado) throws Exception {
        int cantidad = 0;
        int r = 0;
        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "SELECT COUNT(*) AS cant FROM aula\n" +
            "WHERE estado = 1 AND codCentro = " + codCentro;
        ResultSet rs = st.executeQuery(query);
        while(rs.next()){
            cantidad = rs.getInt("cant");
        }
        if(cantidad == 0 || estado == 1){
            query = "UPDATE centro SET estado_centro='" + estado + "' WHERE cod_centro='" + codCentro + "'";
            r = st.executeUpdate(query);
        }
        else{
            r = 2;
        }
          cnx.close(); return r;
    }

    @Override
    public int cambiarEstadoNiveles(int codNivel, int estado) throws Exception {
        int cantidad = 0;
        int r = 0;
        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "SELECT COUNT(*) AS cant FROM aula \n" +
            "WHERE estado = 1 AND codNivel = " + codNivel;
        ResultSet rs = st.executeQuery(query);
        while(rs.next()){
            cantidad = rs.getInt("cant");
        }
        if(cantidad == 0 || estado == 1){
            query = "UPDATE academia_nivel SET estado='" + estado + "' WHERE idnivel='" + codNivel + "'";
            r = st.executeUpdate(query);
        }
        else{
            r = 2;
        }
          cnx.close(); return r;
    }

    @Override
    public int cambiarEstadoGrados(int codGrado, int estado) throws Exception {
        int cantidad = 0;
        int r = 0;
        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "SELECT COUNT(*) AS cant FROM aula \n" +
            "WHERE estado = 1 AND codTipoGrado = " + codGrado;
        ResultSet rs = st.executeQuery(query);
        while(rs.next()){
            cantidad = rs.getInt("cant");
        }
        if(cantidad == 0 || estado == 1){
            query = "UPDATE academia_grado SET estado='" + estado + "' WHERE idgrado='" + codGrado + "'";
            r = st.executeUpdate(query);
        }
        else{
            r = 2;
        }
          cnx.close(); return r;
    }

    @Override
    public int cambiarEstadoCiclos(int codCiclo, int estado) throws Exception {
        int cantidad = 0;
        int r = 0;
        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "SELECT COUNT(*) AS cant FROM aula \n" +
            "WHERE estado = 1 AND codGrado = " + codCiclo;
        ResultSet rs = st.executeQuery(query);
        while(rs.next()){
            cantidad = rs.getInt("cant");
        }
        if(cantidad == 0 || estado == 1){
            query = "UPDATE academia_ciclo SET estado='" + estado + "' WHERE idciclo='" + codCiclo + "'";
            r = st.executeUpdate(query);
        }
        else{
            r = 2;
        }
          cnx.close(); return r;
    }

    @Override
    public int editarCentro(int codCentro, String nombre) throws Exception {
        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "UPDATE centro SET nom_centro='" + nombre + "' WHERE cod_centro='" + codCentro + "'";
        int r = st.executeUpdate(query);
          cnx.close(); return r;
    }

    @Override
    public int editarNivel(int codNivel, String nombre) throws Exception {
        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "UPDATE academia_nivel SET nivel='" + nombre + "' WHERE idnivel='" + codNivel + "'";
        int r = st.executeUpdate(query);
          cnx.close(); return r;
    }

    @Override
    public int editarGrado(int codGrado, String nombre) throws Exception {
        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "UPDATE academia_grado SET grado='" + nombre + "' WHERE idgrado='" + codGrado + "'";
        int r = st.executeUpdate(query);
          cnx.close(); return r;
    }

    @Override
    public int editarCiclo(int codCiclo, String nombre) throws Exception {
        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "UPDATE academia_ciclo SET ciclo='" + nombre + "' WHERE idciclo='" + codCiclo + "'";
        int r = st.executeUpdate(query);
          cnx.close(); return r;
    }

    @Override
    public ArrayList<Monto> listarTurnos() throws Exception {
        ArrayList<Monto> lista = new ArrayList<>();
        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "SELECT idturno,turno FROM academia_turno";
        ResultSet rs = st.executeQuery(query);
        
        while(rs.next()){
            Monto monto = new Monto();
            monto.setCodTurno(rs.getString("idturno"));
            monto.setNomTurno(rs.getString("turno"));
            lista.add(monto);
        }
          cnx.close(); return lista;
    }

}
