package pe.siso.academia.MySqlDAO;

import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.Statement;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import org.json.simple.JSONArray;
import org.json.simple.JSONObject;

import pe.siso.academia.Beans.Cierre;
import pe.siso.academia.Beans.Pension;
import pe.siso.academia.DAO.PensionDAO;

public class MySqlPensionDAO implements PensionDAO {

    @Override
    public ArrayList<Pension> listarPensionesPorAlumno(int codMatricula) throws Exception {
        ArrayList<Pension> lista = new ArrayList<>();
        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "SELECT codpagocuota,DATE_FORMAT(cadPension,'%d/%m/%Y') as CaducF,desPension,DATE_FORMAT(fecha_pago,'%d/%m/%Y %h:%i %p')as fecha_pag,IF(fraccion='1/1','',CONCAT('P/',LEFT(fraccion,1)))fraccion , \n"
                + "monto,monto_dscto,nom_dscto,pagado,num_docu,num_serie,estado,c.codpension,c.regularizacion,CASE estado WHEN 5 THEN '<span class=\"label label-teals\">BOLETA</span>' WHEN 0 THEN '' WHEN 2 THEN IF(num_docu=0 and num_serie=0,'','<span class=\"label label-primary\">CPE BOLETA</span>') WHEN 6 THEN '<span class=\"label label-lilac\">FACTURA</span>' WHEN 1 THEN CONCAT('<span class=\"label label-primary\">', c.tipo_documento,'</span>') WHEN 3 THEN '<span class=\"label label-primary\">NOTA CRÉDITO</span>' ELSE '<span class=\"label label-primary\">CPE BOLETA</span>' END tipdocumento,    \n"
                + " devol_NumDoc,devol_NumSer,url_comprobante_nubefac,url_comprobante_nubefac_anulado \n"
                + "FROM pagocuota AS c INNER JOIN pension AS p \n"
                + "ON c.codpension = p.codPension WHERE codmatricula = " + codMatricula + " and c.estado<>7 ORDER BY cadPension asc,fraccion asc,estado desc,fecha_pago asc;";
        ResultSet rs = st.executeQuery(query);
        System.out.println("Sentencia pensiones \n" + query);
        while (rs.next()) {
            Pension pen = new Pension();
            pen.setCodpagocuota(rs.getString("codpagocuota"));
            pen.setCaducidadPension(rs.getString("CaducF"));
            pen.setDescPension(rs.getString("desPension"));
            pen.setFecha_pago(rs.getString("fecha_pag"));
            pen.setMontoPension(rs.getString("monto"));
            pen.setMonto_dscto(rs.getString("monto_dscto"));
            pen.setNom_dscto(rs.getString("nom_dscto"));
            pen.setPagado(rs.getString("pagado"));
            pen.setNum_docu(rs.getString("num_docu"));
            pen.setNum_serie(rs.getString("num_serie"));
            pen.setDevol_NumDoc(rs.getString("devol_NumDoc"));
            pen.setDevol_NumSer(rs.getString("devol_NumSer"));
            pen.setEstadoPension(rs.getString("estado"));
            pen.setCodPension(rs.getString("codpension"));
            pen.setFraccion(rs.getString("fraccion"));
            pen.setRegularizacion(rs.getString("regularizacion"));
            pen.setTipoDocumento(rs.getString("tipdocumento"));
            pen.setUrl_nubefac(rs.getString("url_comprobante_nubefac"));
            pen.setUrl_nubefac_anulado(rs.getString("url_comprobante_nubefac_anulado"));
            lista.add(pen);
        }
        cnx.close();
        return lista;
    }

    @Override
    public int activarPension(int codPension) throws Exception {
        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "UPDATE pagocuota SET estado = '0' "
                + "WHERE codpagocuota = " + codPension;

        int r = st.executeUpdate(query);
        cnx.close();
        cnx.close();
        return r;
    }

    @Override
    public int anularPension(int codPension, String motivo, int codUsuario, String fecha_actual) throws Exception {
        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "UPDATE pagocuota SET detalles = '" + motivo + "', estado = '2', usuario_gestor=" + codUsuario + ", fecha_anulacion='" + fecha_actual + "',devol_monto=0  "
                + "WHERE codpagocuota = " + codPension;

        int r = st.executeUpdate(query);
        cnx.close();
        return r;

    }

    @Override
    public int pagarPension(int codSede, int codPension, int codigoUsuario, String monto, String nomDscto, String montoDscto, String fechaPago, String formaPago, String tipoDoc, String obs, double regu, int num_serie, int num_doc, String razon_social, String ruc, int cod_enlace_desc) throws Exception {
        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        int numero_de_serie = 0;
        int maximo_num_docu = 0;
        int minimo_num_docu = 0;
        int ultimo_num_docu = 0;
        int numero_de_docum = 0;
        String cod_enlace = "";
        String nombre_dect = "";
        int r = 0;
        String query = "";
        if (cod_enlace_desc != 0) {
            cod_enlace = " ,cod_enlace_dscto=" + cod_enlace_desc + " ";
        }
        if (nomDscto == null || "[SELECCIONE]".equals(nomDscto.trim())) {

        } else {
            nombre_dect = ", nom_dscto='" + nomDscto + "' ";
        }

        if (tipoDoc.equals("CPE BOLETA") || tipoDoc.equals("CPE FACTURA")) {
            if (tipoDoc.equals("CPE BOLETA")) {
                query = "SELECT num_serie,docu_min,docu_max FROM boleta WHERE estado = 1 and tipo_boleta=1 AND cod_sede = " + codSede + " AND cod_usuario=" + codigoUsuario + ";";

            } else {
                query = "SELECT num_serie,docu_min,docu_max FROM boleta WHERE estado = 1 and tipo_boleta=2 AND cod_sede = " + codSede + " AND cod_usuario=" + codigoUsuario + ";";

            }
            ResultSet rs = st.executeQuery(query);
            while (rs.next()) {
                numero_de_serie = rs.getInt("num_serie");
                maximo_num_docu = rs.getInt("docu_max");
                minimo_num_docu = rs.getInt("docu_min");
            }

            query = "select MAX(pg.num_docu) as maximo from pagocuota  as pg  \n"
                    + "INNER JOIN matricula as m on pg.codmatricula=m.cod_matricula\n"
                    + "INNER JOIN estudiante as e on m.cod_estud_matri=e.codestudiante WHERE pg.num_serie=" + numero_de_serie + " and codpagocuota not in (" + codPension + ") and tipo_documento='" + tipoDoc + "';";
            rs = st.executeQuery(query);
            while (rs.next()) {
                if (rs.getString("maximo") == null) {
                    ultimo_num_docu = (minimo_num_docu - 1);
                } else {
                    ultimo_num_docu = rs.getInt("maximo");
                }
            }

            if ((ultimo_num_docu + 1) <= maximo_num_docu) {
                numero_de_docum = ultimo_num_docu + 1;
            } else {
                query = "UPDATE boleta SET estado='2' WHERE estado = 1 "
                        + "AND cod_sede = " + codSede + " AND num_serie = '" + numero_de_serie + "';";
                st.executeUpdate(query);

                query = "UPDATE boleta SET estado='1' WHERE estado = 0 AND cod_sede = " + codSede + " LIMIT 1;";
                st.executeUpdate(query);

                numero_de_docum = Integer.parseInt(generarNumBoleta(codSede).trim().split("-")[1]);
                numero_de_serie = Integer.parseInt(generarNumBoleta(codSede).trim().split("-")[0]);

            }
            if (montoDscto.trim().length() == 0) {
                montoDscto = "0.00";
            }
//            if (nomDscto == null || "[SELECCIONE]".equals(nomDscto.trim())) {
//                nomDscto = "";
//            } else {
//
//            }
            query = "UPDATE pagocuota SET fecha_pago = '" + fechaPago + "', pagado = '" + monto + "', forma_pago = '" + formaPago + "', "
                    + "tipo_documento = '" + tipoDoc + "', num_serie = '" + numero_de_serie + "', num_docu = '" + numero_de_docum + "', "
                    + "detalles = '" + obs + "', monto_dscto='" + montoDscto + "' " + nombre_dect + " , "
                    + "estado = '1' , regularizacion = '" + regu + "',usuario_gestor = '" + codigoUsuario + "',razon_social='" + razon_social + "',ruc='" + ruc + "' " + cod_enlace + " "
                    + "WHERE codpagocuota =  " + codPension;
            r = st.executeUpdate(query);
        } else if (tipoDoc.equals("BOLETA")) {
            if (montoDscto.trim().length() == 0) {
                montoDscto = "0.00";
            }
//            if (nomDscto == null || "[SELECCIONE]".equals(nomDscto.trim())) {
//                nomDscto = "";
//            }
            query = "UPDATE pagocuota SET fecha_pago = '" + fechaPago + "', pagado = '" + monto + "', forma_pago = '" + formaPago + "', "
                    + "tipo_documento = '" + tipoDoc + "', num_serie = '" + num_serie + "', num_docu = '" + num_doc + "', "
                    + "detalles = '" + obs + "', monto_dscto='" + montoDscto + "' " + nombre_dect + " , "
                    + "estado = '5' , regularizacion = '" + regu + "',usuario_gestor = '" + codigoUsuario + "' " + cod_enlace + "  "
                    + "WHERE codpagocuota =  " + codPension;
            r = st.executeUpdate(query);
        } else {
            if (montoDscto.trim().length() == 0) {
                montoDscto = "0.00";
            }
//            if (nomDscto == null || "[SELECCIONE]".equals(nomDscto.trim())) {
//                nomDscto = "";
//            }
            query = "UPDATE pagocuota SET fecha_pago = '" + fechaPago + "', pagado = '" + monto + "', forma_pago = '" + formaPago + "', "
                    + "tipo_documento = '" + tipoDoc + "', num_serie = '" + num_serie + "', num_docu = '" + num_doc + "', "
                    + "detalles = '" + obs + "', monto_dscto='" + montoDscto + "' " + nombre_dect + " , "
                    + "estado = '6' , regularizacion = '" + regu + "',usuario_gestor = '" + codigoUsuario + "' ,razon_social='" + razon_social + "',ruc='" + ruc + "' " + cod_enlace + " "
                    + "WHERE codpagocuota =  " + codPension;
            r = st.executeUpdate(query);
        }

        cnx.close();
        return r;
    }

    @Override
    public int devolverPension(int codPension, double monto, double monto_neto, String tipoDoc, String numSerie, String numDoc, String motivo, String cod_usu, String cod_sede, int tipo_nota_credito) throws Exception {
        String base = "academianew";
//        int tick_max = 0;
        Date Hoy = new Date();
        SimpleDateFormat formateador = new SimpleDateFormat("yyyy/MM/dd HH:mm:ss");
        String fecha_actual = formateador.format(Hoy);
        int numero_de_serie = 0;
        int maximo_num_docu = 0;
        int minimo_num_docu = 0;
        int ultimo_num_docu = 0;
        int numero_de_docum = 0;
        String tipo_documento = "";
        int ref_tipo_de_comprobante = 0;
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "UPDATE pagocuota SET  estado = '1', devol_monto = '" + monto + "' ,"
                + "devol_TipoDoc = '" + tipoDoc + "', devol_NumSer = '" + numSerie + "', devol_NumDoc = '" + numDoc + "' ,fecha_anulacion='" + fecha_actual + "',usuario_administrador=" + cod_usu + " "
                + "WHERE codpagocuota =" + codPension + " ;";
        int r = st.executeUpdate(query);
        query = "Select tipo_documento from pagocuota WHERE codpagocuota =" + codPension + " ;";
        ResultSet rs = st.executeQuery(query);
        while (rs.next()) {
            tipo_documento = rs.getString("tipo_documento");
        }
        if (tipo_documento.equals("CPE BOLETA")) {
            query = "SELECT num_serie,docu_min,docu_max FROM boleta WHERE estado = 1 and tipo_boleta=3 AND cod_sede = " + cod_sede + " ;";
            ref_tipo_de_comprobante = 2;
        } else {
            query = "SELECT num_serie,docu_min,docu_max FROM boleta WHERE estado = 1 and tipo_boleta=4 AND cod_sede = " + cod_sede + " ;";
            ref_tipo_de_comprobante = 1;
        }
        rs = st.executeQuery(query);
        while (rs.next()) {
            numero_de_serie = rs.getInt("num_serie");
            maximo_num_docu = rs.getInt("docu_max");
            minimo_num_docu = rs.getInt("docu_min");
        }
        query = "select MAX(pg.num_docu) as maximo from pagocuota  as pg \n"
                + "            INNER JOIN matricula as m on pg.codmatricula=m.cod_matricula\n"
                + "            INNER JOIN estudiante as e on m.cod_estud_matri=e.codestudiante WHERE e.codsede=" + cod_sede + " and num_serie=" + numSerie + "  and pg.estado=3 and tipo_documento='NOTA DE CREDITO' and ref_tipo_de_comprobante=" + ref_tipo_de_comprobante + " and codpagocuota not in (" + codPension + ") ;";
        rs = st.executeQuery(query);
        while (rs.next()) {
//            tick_max = rs.getInt("maximo");

            if (rs.getString("maximo") == null) {
                ultimo_num_docu = (minimo_num_docu - 1);
            } else {
                ultimo_num_docu = rs.getInt("maximo");
            }
        }
        if ((ultimo_num_docu + 1) <= maximo_num_docu) {
            numero_de_docum = ultimo_num_docu + 1;
        } else {
            query = "UPDATE boleta SET estado='2' WHERE estado = 1 "
                    + "AND cod_sede = " + cod_sede + " AND num_serie = '" + numero_de_serie + "';";
            st.executeUpdate(query);

            query = "UPDATE boleta SET estado='1' WHERE estado = 0 AND cod_sede = " + cod_sede + " LIMIT 1;";
            st.executeUpdate(query);

//            numero_de_docum = Integer.parseInt(generarNumBoleta(cod_sede).trim().split("-")[1]);
//            numero_de_serie = Integer.parseInt(generarNumBoleta(codSede).trim().split("-")[0]);
        }
        query = "INSERT INTO pagocuota(codmatricula,codpension,monto,efectivo,pagado,devol_monto,nom_dscto,monto_dscto,estado,fraccion,fecha_pago,fecha_anulacion,num_docu,num_serie,usuario_gestor,ref_num_docu,tipo_documento,tipo_nota_credito,ref_serie_docu,ref_tipo_de_comprobante,detalles) \n"
                + "(SELECT codmatricula,codpension,0," + monto * (-1) + ",'" + monto * (-1) + "','" + monto + "',nom_dscto,0,\"3\",fraccion,'" + fecha_actual + "','" + fecha_actual + "','" + numero_de_docum + "',num_serie,usuario_gestor,num_docu,'NOTA DE CREDITO'," + tipo_nota_credito + ",num_serie," + ref_tipo_de_comprobante + ",'" + motivo + "' FROM pagocuota WHERE codpagocuota =" + codPension + ");";
        r = st.executeUpdate(query);
        ResultSet rs1 = st.getGeneratedKeys();
        while (rs1.next()) {
            r = rs1.getInt(1);
        }
        cnx.close();
        return r;
    }

    @Override
    public String generarNumBoleta(int codSede) throws Exception {
        int numero_de_serie = 0;
        int maximo_num_docu = 0;
        int minimo_num_docu = 0;
        int ultimo_num_docu = 0;
        int numero_de_docum = 0;
        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();

        String query = "SELECT num_serie,docu_min,docu_max FROM boleta WHERE estado = 1 AND cod_sede = " + codSede + ";";
        ResultSet rs = st.executeQuery(query);
        while (rs.next()) {
            numero_de_serie = rs.getInt("num_serie");
            maximo_num_docu = rs.getInt("docu_max");
            minimo_num_docu = rs.getInt("docu_min");
        }

        query = "SELECT MAX(num_docu) AS maximo FROM pagocuota WHERE num_serie = " + numero_de_serie + ";";
        rs = st.executeQuery(query);
        while (rs.next()) {
            if (rs.getString("maximo") == null) {
                ultimo_num_docu = (minimo_num_docu - 1);
            } else {
                ultimo_num_docu = rs.getInt("maximo");
            }
        }

        if ((ultimo_num_docu + 1) <= maximo_num_docu) {
            numero_de_docum = ultimo_num_docu + 1;
        } else {
            query = "UPDATE boleta SET estado='2' WHERE estado = 1 "
                    + "AND cod_sede = " + codSede + " AND num_serie = '" + numero_de_serie + "';";
            st.executeUpdate(query);

            query = "UPDATE boleta SET estado='1' WHERE estado = 0 AND cod_sede = " + codSede + " LIMIT 1;";
            st.executeUpdate(query);

            numero_de_docum = Integer.parseInt(generarNumBoleta(codSede).trim().split("-")[1]);
            numero_de_serie = Integer.parseInt(generarNumBoleta(codSede).trim().split("-")[0]);

        }

        cnx.close();
        return numero_de_serie + "-" + numero_de_docum;
    }

    @Override
    public int fraccionarPension(int codPagoCuota, String[] monto, String posDescuento[]) throws Exception {
        int parte_actual = 1;
        ArrayList<Pension> lista = new ArrayList<>();
        int resultado = 0;
        String nroFraccion = "";
        String dscto = "";
        int codMatricula = 0;
        int codPensionRef = 0;
        double montoDscto = 0.00;
        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();

        String query = "SELECT monto_dscto,nom_dscto,fraccion,codmatricula,codpension  FROM pagocuota WHERE codpagocuota = " + codPagoCuota + ";";
        ResultSet rs = st.executeQuery(query);
        while (rs.next()) {
            nroFraccion = rs.getString("fraccion");
            dscto = rs.getString("nom_dscto");
            montoDscto = Double.parseDouble(rs.getString("monto_dscto"));
            codMatricula = (rs.getInt("codmatricula"));
            codPensionRef = (rs.getInt("codpension"));
        }
        query = "SELECT codpagocuota FROM pagocuota WHERE codmatricula = " + codMatricula + " AND codpension = "
                + codPensionRef + " AND fraccion<>'" + nroFraccion + "' ORDER BY fraccion;";
        rs = st.executeQuery(query);
        while (rs.next()) {
            Pension p = new Pension();
            p.setCodPension(rs.getString("codpagocuota"));
            lista.add(p);
        }
        //ELIMINANDO ORIGINAL

        if (Integer.parseInt(nroFraccion.split("/")[1]) > 1) {
            for (int i = 0; i < (monto.length + Integer.parseInt(nroFraccion.split("/")[1]) - 1); i++) {
                if ((i + 1) < Integer.parseInt(nroFraccion.split("/")[0])) {
                    query = "UPDATE pagocuota SET fraccion ='" + (i + 1) + "/" + (monto.length - 1 + Integer.parseInt(nroFraccion.split("/")[1])) + "' WHERE codpagocuota = '" + lista.get(i).getCodPension() + "';";
                } else if ((i + 1) >= (Integer.parseInt(nroFraccion.split("/")[0]) + monto.length)) {
                    query = "UPDATE pagocuota SET fraccion ='" + (i + 1) + "/" + (monto.length - 1 + Integer.parseInt(nroFraccion.split("/")[1])) + "' WHERE codpagocuota = '" + lista.get(i - monto.length).getCodPension() + "';";
                } else {
                    if (parte_actual == monto.length) {
                        query = "INSERT INTO pagocuota(codmatricula,codpension,monto,pagado,estado,fraccion,monto_dscto,nom_dscto) "
                                + "VALUES ('" + codMatricula + "', '" + codPensionRef + "', '"
                                + monto[(i + 1 - Integer.parseInt(nroFraccion.split("/")[0]))] + "', '0', '0', '" + (i + 1) + "/"
                                + (monto.length - 1 + Integer.parseInt(nroFraccion.split("/")[1])) + "','" + montoDscto + "','" + dscto + "');";
                    } else {
                        query = "INSERT INTO pagocuota(codmatricula,codpension,monto,pagado,estado,fraccion) "
                                + "VALUES ('" + codMatricula + "', '" + codPensionRef + "', '"
                                + monto[(i + 1 - Integer.parseInt(nroFraccion.split("/")[0]))] + "', '0', '0', '" + (i + 1) + "/"
                                + (monto.length - 1 + Integer.parseInt(nroFraccion.split("/")[1])) + "')";
                        parte_actual += 1;
                    }
                }
                resultado += st.executeUpdate(query);
            }
        } else {
            for (int i = 0; i < monto.length; i++) {
                if (parte_actual == monto.length) {
                    query = "INSERT INTO pagocuota(codmatricula,codpension,monto,pagado,estado,fraccion,monto_dscto,nom_dscto) "
                            + "VALUES ('" + codMatricula + "', '" + codPensionRef + "', '" + monto[i] + "', '0', "
                            + "'0', '" + (i + 1) + "/" + monto.length + "','" + montoDscto + "','" + dscto + "')";
                } else {
                    query = "INSERT INTO pagocuota(codmatricula,codpension,monto,pagado,estado,fraccion) "
                            + "VALUES ('" + codMatricula + "', '" + codPensionRef + "', '" + monto[i] + "', '0', "
                            + "'0', '" + (i + 1) + "/" + monto.length + "')";
                    parte_actual += 1;
                }
                resultado += st.executeUpdate(query);
            }
        }
        query = "DELETE FROM pagocuota WHERE codpagocuota = '" + codPagoCuota + "'";
        resultado += st.executeUpdate(query);

        cnx.close();
        return resultado;
    }

    @Override
    public boolean verificarPensionesActualizarMatri(int codmatricula) throws Exception {
        boolean respuesta = true;
        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "SELECT COUNT(*) AS cantidad FROM pagocuota WHERE estado <> 0 AND codmatricula = " + codmatricula;
        ResultSet rs = st.executeQuery(query);
        while (rs.next()) {
            if (rs.getInt("cantidad") > 0) {
                respuesta = false;
            }
        }
        cnx.close();
        return respuesta;
    }

    @Override
    public int actualizarPensiones(int codMatricula, String codPen[], String monPen[], String nom_desc, double mon_desc) throws Exception {
        int rpta = 0;
        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "DELETE FROM pagocuota WHERE codmatricula = " + codMatricula;
        int rs1 = st.executeUpdate(query);
        for (int i = 0; i < codPen.length; i++) {
            query = "INSERT INTO pagocuota(codmatricula,codpension,monto,pagado,estado,nom_dscto,monto_dscto) VALUES ('" + codMatricula + "', '" + codPen[i] + "', '" + monPen[i].replace("S/.", "") + "', '0', '0','" + nom_desc + "'," + mon_desc + ")";
            rpta = st.executeUpdate(query);
        }
        cnx.close();
        return rpta;
    }

    @Override
    public Pension obtenerPension(int codPension) throws Exception {
        Pension pen = new Pension();
        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "SELECT codpagocuota,codmatricula,codpension,monto,pagado,fecha_pago,\n"
                + "monto_dscto,IFNULL(nom_dscto,'' )nom_dscto,num_docu,num_serie,forma_pago,detalles,estado,\n"
                + "tipo_documento,devol_monto,devol_TipoDoc,devol_NumSer,devol_NumDoc \n"
                + "FROM pagocuota WHERE codpagocuota = " + codPension + " ORDER BY codpagocuota ";
        System.out.println("obtenerPension --->>>" + query);
        ResultSet rs = st.executeQuery(query);

        while (rs.next()) {
            pen.setCodpagocuota(rs.getString("codpagocuota"));
            // pen.setCaducidadPension(rs.getString("cadPension"));
            //  pen.setDescPension(rs.getString("desPension"));
            //   pen.setFecha_pago(rs.getString("fecha_pago"));
            pen.setMontoPension(rs.getString("monto"));
            pen.setMonto_dscto(rs.getString("monto_dscto"));
            pen.setNom_dscto(rs.getString("nom_dscto"));
            pen.setPagado(rs.getString("pagado"));
            pen.setNum_docu(rs.getString("num_docu"));
            pen.setNum_serie(rs.getString("num_serie"));
            pen.setEstadoPension(rs.getString("estado"));
            pen.setCodPension(rs.getString("codpension"));
        }
        cnx.close();
        cnx.close();
        return pen;
    }

    @Override
    public int duplicarPensionAnulada(int codPagoCuota) throws Exception {
        int resultado = 0;
        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "INSERT INTO pagocuota(codmatricula,codpension,monto,pagado,nom_dscto,monto_dscto,estado,fraccion,fecha_pago,ruc,razon_social,tipo_documento,motivo_dscto) \n"
                + "(SELECT codmatricula,codpension,monto,\"0\",nom_dscto,monto_dscto,\"0\",fraccion,0,ruc,razon_social,tipo_documento,motivo_dscto FROM pagocuota "
                + "WHERE codpagocuota = " + codPagoCuota + ");";

        resultado += st.executeUpdate(query);
        query = "UPDATE pagocuota set estado=4 WHERE codpagocuota=" + codPagoCuota + ";";
        resultado = st.executeUpdate(query);

        //System.out.println("DUPLICAR PENSIONES \n"+query);
        cnx.close();
        cnx.close();
        return resultado;
    }

    @Override
    public int anularPensionesPorMatricula(int codMatricula, int valueradio, String observ) throws Exception {
        Date Hoy = new Date();
        SimpleDateFormat inicio = new SimpleDateFormat("yyyy-MM-01");
        String fecha = inicio.format(Hoy);
        String query = "";
        int resultado = 0;
        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        if (valueradio == 1) {
            query = "update pagocuota as pg \n"
                    + "INNER JOIN pension as p on pg.codpension=p.codPension  \n"
                    + "set pg.estado=2,detalles='" + observ + "'  \n"
                    + "WHERE pg.estado=0 and pg.codmatricula=" + codMatricula + " and DATE(p.cadPension)<'" + fecha + "';";
        } else {
            //Anuncio Traslado
            query = "UPDATE pagocuota SET estado = 2,detalles='" + observ + "' WHERE estado = 0 AND codmatricula = " + codMatricula + ";";
        }

        resultado += st.executeUpdate(query);
        if (resultado > 0) {
            resultado = 1;
        }
        cnx.close();
        cnx.close();
        return resultado;
    }

    @Override
    public Pension obtenerDetalle(int codPension) throws Exception {
        Pension pen = new Pension();
        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "SELECT p.desPension,p.cadPension,p.montoPension,monto,pagado,DATE_FORMAT(IFNULL(fecha_pago,\"0000-00-00\"),'%d/%m/%Y %h:%i %p') AS fecha_pago,\n"
                + "monto_dscto,nom_dscto,num_docu,num_serie,IFNULL(detalles,\"\") AS obs,devol_monto,devol_TipoDoc,\n"
                + "devol_NumSer,devol_NumDoc,regularizacion,IFNULL(ruc,\"\") ruc,IFNULL(razon_social,\"\") razon_social,IF(fraccion='1/1','',CONCAT('P/',LEFT(fraccion,1))) fraccion,tipo_documento FROM pagocuota AS pc\n"
                + "INNER JOIN pension As p ON pc.codpension = p.codPension WHERE codpagocuota = " + codPension + " LIMIT 1;";
        ResultSet rs = st.executeQuery(query);
        //System.out.println("HOPYYY \n"+query);
        while (rs.next()) {
            pen.setDescPension(rs.getString("desPension"));
            pen.setCaducidadPension(rs.getString("cadPension"));
            pen.setMontoMensual(rs.getString("montoPension"));
            pen.setMontoPension(rs.getString("monto"));
            pen.setPagado(rs.getString("pagado"));
            pen.setFecha_pago(rs.getString("fecha_pago"));
            pen.setMonto_dscto(rs.getString("monto_dscto"));
            pen.setNom_dscto(rs.getString("nom_dscto"));
            pen.setNum_serie(rs.getString("num_serie"));
            pen.setNum_docu(rs.getString("num_docu"));
            pen.setRuc(rs.getString("ruc"));
            pen.setRazon_social(rs.getString("razon_social"));
            pen.setObs(rs.getString("obs"));
            pen.setDevol_monto(rs.getString("devol_monto"));
            pen.setDevol_TipoDoc(rs.getString("devol_TipoDoc"));
            pen.setDevol_NumSer(rs.getString("devol_NumSer"));
            pen.setDevol_NumDoc(rs.getString("devol_NumDoc"));
            pen.setRegularizacion(rs.getString("regularizacion"));
            pen.setFraccion(rs.getString("fraccion"));
            pen.setTipoDocumento(rs.getString("tipo_documento"));
        }
        cnx.close();
        return pen;
    }

    @Override
    public String imprimirBoletaPago(int codPension) throws Exception {
        String boleta = "";
        String base = "academianew";
        String tick_referencia = "";
        String montopendiente = "";

        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "SELECT pc.pagado,s.direccion,s.telefono,s.autorizacion,s.maquina_regis,\n"
                + "DATE_FORMAT(DATE(pc.fecha_pago),'%d/%m/%Y') AS fecha, TIME(pc.fecha_pago) AS hora, \n"
                + "CONCAT(\"TK\",s.codigo_tk,\"-\",LPAD(pc.num_docu,5,\"0\")) AS ticket, \n"
                + "CONCAT(TRIM(e.paterno),\" \",TRIM(e.materno),\" \",TRIM(e.nombres)) AS cliente,\n"
                + "s.deslocal,n.nivel,tg.grado,ci.ciclo,t.turno,pe.desPension,IF(pc.fraccion='1/1','',CONCAT('P/',LEFT(pc.fraccion,1)))fraccion,\n"
                + "pc.monto,pc.monto_dscto,CASE pc.monto_dscto WHEN 0 THEN \"---\" ELSE CONCAT(pc.nom_dscto,"
                + "' - S/.',pc.monto_dscto) END AS descuento,pc.efectivo,\n"
                + "IFNULL((SELECT SUM(monto) FROM pagocuota WHERE codmatricula = pc.codmatricula \n"
                + "AND codpension = pe.codPension and estado = 0),\"0\") AS pendiente, \n"
                + "CONCAT(TRIM(us.app_usu),\" \",TRIM(us.apm_usu),\" \",TRIM(us.nom_usu)) AS usu,IFNULL(CONCAT(\"TK\",s.codigo_tk,\"-\",LPAD(pc.ref_num_docu,5,\"0\")),0) as ref_tick FROM pagocuota AS pc \n"
                + "INNER JOIN matricula AS m ON pc.codmatricula = m.cod_matricula \n"
                + "INNER JOIN estudiante AS e ON m.cod_estud_matri = e.codestudiante \n"
                + "INNER JOIN aula AS a ON m.codAula = a.codAula \n"
                + "INNER JOIN sede as s ON a.codSede = s.idlocal \n"
                + "INNER JOIN centro as c ON a.codCentro = c.cod_centro \n"
                + "INNER JOIN academia_nivel as n ON a.codNivel = n.idnivel \n"
                + "INNER JOIN academia_grado as tg ON a.codTipoGrado = tg.idgrado \n"
                + "INNER JOIN academia_ciclo as ci ON a.codGrado = ci.idciclo \n"
                + "INNER JOIN seccion as sec ON a.codAula = sec.idaula \n"
                + "INNER JOIN academia_turno as t ON a.codTurno = t.idturno \n"
                + "INNER JOIN pension AS pe ON pc.codpension = pe.codPension \n"
                + "LEFT JOIN usuario AS us ON pc.usuario_gestor = us.cod_usu \n"
                + "WHERE codpagocuota = " + codPension + " LIMIT 1;";
        ResultSet rs = st.executeQuery(query);
        System.out.println(" imprimirBoletaPago   ->>>>>>>>>>>>> \n" + query);
        while (rs.next()) {
            if (rs.getString("ref_tick").equals("0")) {
                tick_referencia = "";
            } else {
                tick_referencia = "<tr><td width=\"50%\">RF:</td><td width=\"50%\" align=\"right\">" + rs.getString("ref_tick") + "</td></tr>";
            }
            if (Double.parseDouble(rs.getString("pendiente")) != 0) {
                montopendiente = "<tr><td width=\"50%\">PENDIENTE:</td><td width=\"50%\" align=\"right\"><span id=\"m_pendiente\">" + rs.getString("pendiente") + "</span></td></tr>";
            }
            boleta = " \n"
                    + "            <center>\n"
                    + "                ASOCIACIÓN CIVIL EDUCATIVA <br><b>SACO OLIVEROS</b><br>\n"
                    + "                " + rs.getString("direccion") + " Teléfono: " + rs.getString("telefono") + "<br>\n"
                    + "                RUC: 20432861539<br><br>\n"
                    + "            </center>\n"
                    + "            <center>===================================<br /></center>\n"
                    + "            <center>TICKET<span id=\"copia\"></span></center>\n"
                    + "            <center>===================================<br /></center>\n"
                    + "            <table   style=\" width: 100%\"><tr><td>N/A:</td><td><span id=\"autorizacion\">" + rs.getString("autorizacion") + "</span></td></tr>"
                    + "            <tr><td>SERIE:</td><td><span id=\"registradora\">" + rs.getString("maquina_regis") + "</span></td></tr>"
                    + "            <tr><td>FECHA:</td><td><span id=\"f_emision\">" + rs.getString("fecha") + "</span> <span id=\"time\">" + rs.getString("hora") + "</span></td></tr>"
                    + "            <tr><td>TICKET:</td><td><span id=\"ticket\">" + rs.getString("ticket") + "</span></td></tr>"
                    + "            <tr><td>CLIENTE:</td><td><span id=\"cliente\">" + rs.getString("cliente") + "</span></td></tr>"
                    + "            <tr><td>LOCAL:</td><td><span id=\"sede\">" + rs.getString("deslocal") + "</span></td></tr>"
                    + "            <tr><td>CICLO/UNIV:</td><td><span id=\"nivel\">" + rs.getString("nivel") + "</span>/<span id=\"ciclo\">" + rs.getString("ciclo") + "</span></td></tr>"
                    //                    + "            <tr><td>GRADO:</td><td><span id=\"tipogrado\">" + rs.getString("grado") + "</span></td></tr>"
                    //                    + "            <tr><td>UNIVERSIDAD:</td><td><span id=\"ciclo\">" + rs.getString("ciclo") + "</span></td></tr>"
                    + "            <tr><td>TURNO:</td><td><span id=\"turno\">" + rs.getString("turno") + "</span></td></tr>"
                    + "            <tr><td>PENSIÓN N°:</td><td><span id=\"concepto\">" + rs.getString("desPension") + " " + rs.getString("fraccion") + "</span></td></tr>"
                    + "            <tr><td>DESCUENTO:</td><td><span id=\"descuento\">" + rs.getString("descuento") + "</span></td></tr>"
                    + "</table>\n"
                    + "             <center>===================================<br /></center>\n"
                    + "            <table style=\" width: 100%\"><tr><td>MONTO:</td><td width=\"50%\" align=\"right\"><span id=\"m_monto\">" + rs.getString("monto") + "</span></td></tr>"
                    + "            <tr><td width=\"50%\" >DESCUENTO:</td><td width=\"50%\" align=\"right\"><span id=\"m_descuento\">" + rs.getString("monto_dscto") + "</span></td></tr>"
                    + "            <tr><td width=\"50%\" >CANCELADO:</td><td width=\"50%\" align=\"right\"><span id=\"m_importe\">" + (rs.getDouble("pagado")) + "</span></td></tr>"
                    + "            " + montopendiente
                    //                    + "            <tr><td width=\"50%\">PENDIENTE:</td><td width=\"50%\" align=\"right\"><span id=\"m_pendiente\">" + rs.getString("pendiente") + "</span></td></tr>"

                    //                    + "            <tr><td width=\"50%\">EFECTIVO:</td><td width=\"50%\" align=\"right\"><span id=\"m_efectivo\">" + rs.getString("efectivo") + "</span></td></tr>"
                    //                    + "            <tr><td width=\"50%\">VUELTO:</td><td width=\"50%\" align=\"right\"><span id=\"m_vuelto\">" + ((rs.getDouble("efectivo") - rs.getDouble("pagado"))) + "</span></td></tr>"
                    + "            " + tick_referencia + ""
                    + " </table>\n"
                    + "            ___________________________________<br>\n"
                    + "            CAJERO: <span id=\"usuario\">" + rs.getString("usu") + "</span><br>\n";
        }
        cnx.close();
        return boleta;
    }

    @Override
    public ArrayList<Cierre> AdvertenciaCierreDiario(int codsede) throws Exception {
        ArrayList<Cierre> lista = new ArrayList<>();
        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "select COUNT(*) as cant_ticket,IFNULL(max(pg.fecha_pago),0) as fecha_pago,IFNULL(CONCAT(date(ADDDATE(MAX(pg.fecha_pago),1)),\" 00:00:00\"),0) as fechamax from pagocuota as pg \n"
                + "LEFT JOIN usuario as u on pg.usuario_gestor=u.cod_usu WHERE u.cod_sed_usu=" + codsede + " \n"
                + "and (pg.fecha_pago)>=(select MAX(f_inicio) from cierrediario WHERE codsede=" + codsede + ") and pg.num_docu<>0 AND estado<>5;";
        ResultSet rs = st.executeQuery(query);
        while (rs.next()) {
            Cierre cr = new Cierre();
            cr.setCantidad(rs.getString("cant_ticket"));
            cr.setFecha_pago(rs.getString("fecha_pago"));
            cr.setFecha_max(rs.getString("fechamax"));
            lista.add(cr);
        }
        System.out.println("query ->>>" + query);
        cnx.close();
        return lista;
    }

    @Override
    public int habilitarPensionAnulada(int codPagoCuota) throws Exception {
        int resultado = 0;
        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "update pagocuota set estado=0 WHERE codpagocuota=" + codPagoCuota + " ;";

        resultado = st.executeUpdate(query);

        //System.out.println("DUPLICAR PENSIONES \n"+query);
        cnx.close();
        return resultado;
    }

    @Override
    public int guardarDescuento(int codPagoCuota, String nombreDescuento, double montoDescuento, String motivoDescuento, int cod_enlace_dsc) throws Exception {
        int resultado = 0;
        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "update pagocuota set nom_dscto='" + nombreDescuento + "',  monto_dscto=" + montoDescuento + " , motivo_dscto='" + motivoDescuento + "',cod_enlace_dscto=" + cod_enlace_dsc + " WHERE codpagocuota=" + codPagoCuota + " ;";

        resultado = st.executeUpdate(query);

        System.out.println("guardarDescuento \n" + query);
        cnx.close();
        return resultado;

    }

    @Override
    public int maxMontoFraccionado(int codPagoCuota) throws Exception {
        int max = 0;
        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "SELECT SUM(monto) montoTotal ,SUM(IF(monto_dscto=0,0,1)) cantDesc\n"
                + "FROM pagocuota WHERE \n"
                + "codmatricula =(SELECT pg.codmatricula from pagocuota pg WHERE pg.codpagocuota  = " + codPagoCuota + ") and\n"
                + "codpension =(SELECT pg.codpension from pagocuota pg WHERE pg.codpagocuota  = " + codPagoCuota + ") GROUP BY codmatricula ORDER BY codpagocuota ;";
        ResultSet rs = st.executeQuery(query);
        while (rs.next()) {
            max = rs.getInt("montoTotal");
        }

        cnx.close();
        return max;
    }

    @Override
    public JSONObject ComprobanteElectronico(int codPension) throws Exception {
        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "SELECT pc.estado,pc.tipo_documento,CONCAT(IF(pc.tipo_documento=\"CPE BOLETA\" or ref_tipo_de_comprobante=2,\"B\",\"F\"),LPAD(pc.num_serie,3,\"0\")) serie,pc.num_docu,e.dni,CONCAT(TRIM(e.paterno),\" \",TRIM(e.materno),\", \",TRIM(e.nombres)) AS cliente,\n"
                + "s.deslocal,e.correo,pc.fecha_pago,pc.pagado,pc.detalles observacion ,CONCAT(n.nivel,\" \",ci.ciclo,\"/\",t.turno,\" (\",pe.desPension,\")\")  ciclo ,ruc,razon_social,pc.ref_num_docu,pc.tipo_nota_credito,CONCAT(IF(pc.ref_tipo_de_comprobante=2,\"B\",\"F\"),LPAD(pc.ref_serie_docu,3,\"0\")) ref_serie_docu,ref_tipo_de_comprobante,ed.tip_moneda,pc.monto_dscto,pc.monto\n"
                + ",usu.nubefact_token \n"
                + "FROM pagocuota AS pc \n"
                + "INNER JOIN matricula AS m ON pc.codmatricula = m.cod_matricula \n"
                + "INNER JOIN estudiante AS e ON m.cod_estud_matri = e.codestudiante \n"
                + "INNER JOIN aula AS a ON m.codAula = a.codAula \n"
                + "INNER JOIN sede as s ON a.codSede = s.idlocal \n"
                + "INNER JOIN centro as c ON a.codCentro = c.cod_centro \n"
                + "INNER JOIN academia_nivel as n ON a.codNivel = n.idnivel \n"
                + "INNER JOIN academia_grado as tg ON a.codTipoGrado = tg.idgrado \n"
                + "INNER JOIN academia_ciclo as ci ON a.codGrado = ci.idciclo\n"
                + "INNER JOIN academia_turno as t ON a.codTurno = t.idturno \n"
                + "INNER JOIN pension AS pe ON pc.codpension = pe.codPension \n"
                + "LEFT JOIN enlace_descuento ed on pc.cod_enlace_dscto=ed.codEnlace_Desc \n"
                + "LEFT JOIN usuario usu on usu.cod_usu=pc.usuario_gestor \n"
                + "WHERE pc.codpagocuota =" + codPension + "  LIMIT 1;";
        ResultSet rs = st.executeQuery(query);
        System.out.println("Regulizacion \n" + query);
        JSONObject jsonConcat = new JSONObject();
        JSONObject jsonResultado = new JSONObject();
        while (rs.next()) {

            double totalPagado = 0;
////CORREGIR LA NOTA DE CREDITO
            JSONArray lista = new JSONArray();
            JSONObject detalle_comprobante = new JSONObject();

            jsonConcat.put("operacion", "generar_comprobante");
            switch (rs.getString("tipo_documento")) {
                case "CPE FACTURA":

                    jsonConcat.put("tipo_de_comprobante", "1");
                    totalPagado = rs.getDouble("pagado");
                    jsonConcat.put("documento_que_se_modifica_tipo", "");
                    jsonConcat.put("documento_que_se_modifica_serie", "");
                    jsonConcat.put("documento_que_se_modifica_numero", "");
                    jsonConcat.put("tipo_de_nota_de_credito", "");
//                    }
                    jsonConcat.put("cliente_tipo_de_documento", "6");
                    jsonConcat.put("cliente_numero_de_documento", rs.getString("ruc"));
                    jsonConcat.put("cliente_denominacion", rs.getString("razon_social"));
                    //**********ITEM*****************
                    detalle_comprobante.put("descripcion", "SERVICIO EDUCATIVO");
                    //**********ITEM*****************

                    jsonConcat.put("observaciones", rs.getString("ciclo"));
                    break;
                case "CPE BOLETA":

                    jsonConcat.put("tipo_de_comprobante", "2");
                    totalPagado = rs.getDouble("pagado");
                    jsonConcat.put("documento_que_se_modifica_tipo", "");
                    jsonConcat.put("documento_que_se_modifica_serie", "");
                    jsonConcat.put("documento_que_se_modifica_numero", "");
                    jsonConcat.put("tipo_de_nota_de_credito", "");
//                    }
                    jsonConcat.put("cliente_tipo_de_documento", "1");
                    jsonConcat.put("cliente_numero_de_documento", rs.getString("dni"));
                    jsonConcat.put("cliente_denominacion", rs.getString("cliente"));
                    //**********ITEM*****************
                    detalle_comprobante.put("descripcion", rs.getString("ciclo"));
                    //**********ITEM*****************
                    jsonConcat.put("observaciones", rs.getString("observacion"));
                    break;
                case "NOTA DE CREDITO":
                    jsonConcat.put("tipo_de_comprobante", "3");
                    totalPagado = rs.getDouble("pagado") * (-1);
                    jsonConcat.put("documento_que_se_modifica_tipo", rs.getInt("ref_tipo_de_comprobante"));
                    jsonConcat.put("documento_que_se_modifica_serie", rs.getString("ref_serie_docu"));
                    jsonConcat.put("documento_que_se_modifica_numero", rs.getString("ref_num_docu"));
                    jsonConcat.put("tipo_de_nota_de_credito", rs.getString("tipo_nota_credito"));
                    if (rs.getInt("ref_tipo_de_comprobante") == 1) {
                        jsonConcat.put("cliente_tipo_de_documento", "6");
                        jsonConcat.put("cliente_numero_de_documento", rs.getString("ruc"));
                        jsonConcat.put("cliente_denominacion", rs.getString("razon_social"));
                        //*************ITEM*****************
                        detalle_comprobante.put("descripcion", "SERVICIO EDUCATIVO");
                        //*************ITEM*****************
                        jsonConcat.put("observaciones", rs.getString("ciclo"));

                    } else {
                        jsonConcat.put("cliente_tipo_de_documento", "1");
                        jsonConcat.put("cliente_numero_de_documento", rs.getString("dni"));
                        jsonConcat.put("cliente_denominacion", rs.getString("cliente"));
                        //**********ITEM*****************
                        detalle_comprobante.put("descripcion", rs.getString("ciclo"));
                        //**********ITEM*****************
                        jsonConcat.put("observaciones", rs.getString("observacion"));

                    }
                    ;

                    break;
                default:
                    jsonConcat.put("tipo_de_comprobante", "2");
                    jsonConcat.put("cliente_tipo_de_documento", "1");
                    jsonConcat.put("cliente_numero_de_documento", rs.getString("dni"));
                    jsonConcat.put("cliente_denominacion", rs.getString("cliente"));
                    //**********ITEM*****************
                    detalle_comprobante.put("descripcion", rs.getString("ciclo"));
                    //**********ITEM*****************
                    break;
            }

            jsonConcat.put("serie", rs.getString("serie"));
            jsonConcat.put("numero", rs.getInt("num_docu"));
            jsonConcat.put("sunat_transaction", "1");

            jsonConcat.put("cliente_direccion", rs.getString("deslocal"));
            jsonConcat.put("cliente_email", rs.getString("correo"));
            jsonConcat.put("cliente_email_1", "");
            jsonConcat.put("cliente_email_2", "");
            jsonConcat.put("fecha_de_emision", rs.getString("fecha_pago"));
            jsonConcat.put("fecha_de_vencimiento", "");
            jsonConcat.put("moneda", "1");
            jsonConcat.put("tipo_de_cambio", "");
            jsonConcat.put("porcentaje_de_igv", "18.00");
            if (rs.getInt("tip_moneda") == 1) {
                jsonConcat.put("descuento_global", rs.getDouble("monto_dscto"));
                jsonConcat.put("total_inafecta", rs.getDouble("monto"));// total inicial
                jsonConcat.put("total", totalPagado); //total neto
//                item
                detalle_comprobante.put("valor_unitario", rs.getDouble("monto"));
                detalle_comprobante.put("precio_unitario", rs.getDouble("monto"));
                detalle_comprobante.put("subtotal", rs.getDouble("monto"));
                detalle_comprobante.put("total", rs.getDouble("monto"));

            } else {
                jsonConcat.put("descuento_global", "");
                jsonConcat.put("total_inafecta", totalPagado);// total inicial
                jsonConcat.put("total", totalPagado); //total neto 
                //                item
                detalle_comprobante.put("valor_unitario", totalPagado);
                detalle_comprobante.put("precio_unitario", totalPagado);
                detalle_comprobante.put("subtotal", totalPagado);
                detalle_comprobante.put("total", totalPagado);
            }

            jsonConcat.put("total_anticipo", "");
            jsonConcat.put("total_gravada", "");
            jsonConcat.put("total_exonerada", "");
            jsonConcat.put("total_igv", "");
            jsonConcat.put("total_gratuita", "");
            jsonConcat.put("total_otros_cargos", "");
            jsonConcat.put("percepcion_tipo", "");
            jsonConcat.put("percepcion_base_imponible", "");
            jsonConcat.put("total_percepcion", "");
            jsonConcat.put("total_incluido_percepcion", "");
            jsonConcat.put("detraccion", "false");
            jsonConcat.put("total_descuento", "");

            jsonConcat.put("tipo_de_nota_de_debito", "");
            jsonConcat.put("enviar_automaticamente_a_la_sunat", "true");
            jsonConcat.put("enviar_automaticamente_al_cliente", "false");
            jsonConcat.put("codigo_unico", "");
            jsonConcat.put("condiciones_de_pago", "");
            jsonConcat.put("medio_de_pago", "");
            jsonConcat.put("placa_vehiculo", "");
            jsonConcat.put("orden_compra_servicio", "");
            jsonConcat.put("tabla_personalizada_codigo", "");
            jsonConcat.put("formato_de_pdf", "");

            detalle_comprobante.put("unidad_de_medida", "ZZ");
            detalle_comprobante.put("codigo", "001");
            detalle_comprobante.put("cantidad", "1");

            detalle_comprobante.put("descuento", "");

            detalle_comprobante.put("tipo_de_igv", "9");
            detalle_comprobante.put("igv", "0");
            detalle_comprobante.put("anticipo_regularizacion", "false");
            detalle_comprobante.put("anticipo_serie", "");
            detalle_comprobante.put("anticipo_documento_numero", "");
            lista.add(detalle_comprobante);

            jsonConcat.put("items", lista);

            jsonResultado.put("jsonNubeFact", jsonConcat);
            jsonResultado.put("TOKEN", rs.getString("nubefact_token"));
        }

        cnx.close();
        return jsonResultado;
    }

    @Override
    public int GuardarUrl(int codCuotaPago, String url, String TipoDocumento) throws Exception {
        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String concat = "";
        switch (TipoDocumento) {
            case "CANCELADO":
                concat += " url_comprobante_nubefac='" + url + "' ";
                break;
            case "ANULADO":
                concat += " url_comprobante_nubefac_anulado='" + url + "' ";
                break;
            case "NOTACREDITO":
                concat += " url_comprobante_nubefac_anulado='" + url + "' ";
                break;
        }

        String query = "UPDATE pagocuota set " + concat + " WHERE  codpagocuota=" + codCuotaPago + " ;";
        int rs = st.executeUpdate(query);
        cnx.close();
        return rs;
    }

    @Override
    public JSONObject ComprobanteElectronicoAnular(int codPagoCuota) throws Exception {
        JSONObject jsonCompAnulado = new JSONObject();
        JSONObject jsonResultado = new JSONObject();
        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "SELECT CONCAT(IF( pg.tipo_documento=\"CPE BOLETA\",\"B\",\"F\"),LPAD( pg.num_serie,3,\"0\")) num_serie ,pg.num_docu,pg.detalles,pg.tipo_documento,usu.nubefact_token \n"
                + "from pagocuota pg\n"
                + "LEFT JOIN usuario usu on usu.cod_usu=pg.usuario_gestor\n"
                + " WHERE pg.codpagocuota=" + codPagoCuota + ";";
        ResultSet rs = st.executeQuery(query);
        while (rs.next()) {
            jsonCompAnulado.put("serie", rs.getString("num_serie"));
            jsonCompAnulado.put("numero", rs.getString("num_docu"));
            jsonCompAnulado.put("motivo", rs.getString("detalles"));
            if (rs.getString("tipo_documento").equals("CPE BOLETA")) {
                jsonCompAnulado.put("tipo_de_comprobante", "2");
            } else {
                jsonCompAnulado.put("tipo_de_comprobante", "1");
            }
            jsonResultado.put("TOKEN", rs.getString("nubefact_token"));
        }
        jsonCompAnulado.put("operacion", "generar_anulacion");
        jsonCompAnulado.put("codigo_unico", "");

        jsonResultado.put("jsonNubeFact", jsonCompAnulado);
        cnx.close();
        return jsonResultado;
    }

    @Override
    public JSONArray tipoNotaDeCredito() throws Exception {
        JSONArray jsonResultado = new JSONArray();

        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "SELECT cod_tip_nota_credito,nom_tip_nota_credito from tipo_de_nota_de_credito WHERE est_tip_nota_credito=1;";
        ResultSet rs = st.executeQuery(query);
        while (rs.next()) {
            JSONObject jsonNtCredito = new JSONObject();
            jsonNtCredito.put("codNotaCredito", rs.getString("cod_tip_nota_credito"));
            jsonNtCredito.put("nomNotaCredito", rs.getString("nom_tip_nota_credito"));
            jsonResultado.add(jsonNtCredito);
        }
        cnx.close();
        return jsonResultado;
    }

    @Override
    public int GuardarJsonErrorNubeFact(JSONObject jsonNubefact, String motivo, int codPagoCuota, String codsede, String accion_nubefact) throws Exception {
        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "INSERT INTO cuotaspago_nubefact ( `json_nubefact`, `cod_sede`, `cod_cuotapago`,accion_nubefact,motivo_error_nubefact,estado_nubefact) VALUES ( '" + jsonNubefact + "', " + codsede + ", " + codPagoCuota + ",'" + accion_nubefact + "','" + motivo + "',1);";
        int rs = st.executeUpdate(query);
        cnx.close();
        return rs;
    }

    @Override
    public JSONArray listarBackupErrorNubeFact() throws Exception {
        JSONArray jsonResultado = new JSONArray();

        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "SELECT cod_nubesfact,json_nubefact,convert(cast(convert(motivo_error_nubefact using latin1) as binary) using utf8) AS motivo_error_nubefact,(SELECT s.deslocal FROM sede s WHERE s.idlocal=cnf.`cod_sede`) nomsede,cod_cuotapago,accion_nubefact FROM cuotaspago_nubefact cnf where cnf.estado_nubefact=1 ;";
        ResultSet rs = st.executeQuery(query);
        while (rs.next()) {
            JSONObject jsonNubeFact = new JSONObject();
            jsonNubeFact.put("codNubeFact", rs.getString("cod_nubesfact"));
            jsonNubeFact.put("jsonNubeFact", rs.getString("json_nubefact"));
            jsonNubeFact.put("motivoErrorNubeFact", rs.getString("motivo_error_nubefact"));
            jsonNubeFact.put("nomSede", rs.getString("nomsede"));
            jsonNubeFact.put("codCuotasPago", rs.getString("cod_cuotapago"));
            jsonNubeFact.put("estadoNubeFact", rs.getString("cod_cuotapago"));
            jsonNubeFact.put("accionNubefact", rs.getString("accion_nubefact"));
            jsonResultado.add(jsonNubeFact);
        }
        cnx.close();
        return jsonResultado;    }
}
