/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package pe.siso.academia.MySqlDAO;

import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.Statement;
import java.util.ArrayList;
import pe.siso.academia.Beans.Aula;
import pe.siso.academia.Beans.Gestion;
import pe.siso.academia.Beans.Menu;
import pe.siso.academia.DAO.GestionDAO;

/**
 *
 * @author sistem08user
 */
public class MysqlGestionDAO implements GestionDAO {

    @Override
    public ArrayList<Gestion> listarUsuario(String BusqNombre,int inicio,int cantidad) throws Exception {
        ArrayList<Gestion> lista = new ArrayList<>();
        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "select u.nom_usu,u.app_usu,u.apm_usu,u.cod_usu,u.cod_usu,CONCAT(TRIM(u.app_usu),\" \",TRIM(u.apm_usu),\" \",TRIM(u.nom_usu)) as NombreCompleto,u.usu_usu,u.cla_usu,u.cod_sed_usu,s.deslocal,tp.cod_tip_usu,tp.nom_tip_usu,u.est_usu\n" +
                        " from usuario as u\n" +
                        "INNER JOIN sede as s on s.idlocal=u.cod_sed_usu\n" +
                        "INNER JOIN tipo_usuario as tp on u.cod_tip_usu=tp.cod_tip_usu"
                + "     HAVING NombreCompleto LIKE '%"+BusqNombre+"%' ORDER BY u.cod_usu LIMIT "+inicio+","+cantidad;
        
        ResultSet rs = st.executeQuery(query);
        //System.out.println("Sentencia \n" +query);
        while(rs.next()){
            
            Gestion gestion = new Gestion();
            gestion.setNom(rs.getString("nom_usu"));
            gestion.setApp(rs.getString("app_usu"));
            gestion.setApm(rs.getString("apm_usu"));
            gestion.setCod_usu(rs.getInt("cod_usu"));
            gestion.setNombre(rs.getString("NombreCompleto"));
            gestion.setUsuario(rs.getString("usu_usu"));
            gestion.setPassword(rs.getString("cla_usu"));
            gestion.setSede(rs.getString("deslocal"));
            gestion.setCod_sede(rs.getInt("cod_sed_usu"));
            gestion.setCod_tipo_usu(rs.getInt("cod_tip_usu"));
            gestion.setNom_tipo_usu(rs.getString("nom_tip_usu"));
            gestion.setEstado(rs.getInt("est_usu"));
            lista.add(gestion);
        }
          cnx.close(); return lista;
    }

    @Override
    public ArrayList<Gestion> ListarTipoUsuario(String BusqNombre,int inicio,int cantidad) throws Exception {
        ArrayList<Gestion> lista=new ArrayList<>();
        String base="academianew";
        Connection cnx=MySqlDAOFactory.obtenerConexion(base);
        Statement st=cnx.createStatement();
        String query="select * from tipo_usuario WHERE nom_tip_usu LIKE '%"+BusqNombre+"%' LIMIT "+inicio+","+cantidad+" ";
        ResultSet rs=st.executeQuery(query);
        while(rs.next()){
            Gestion gestion=new Gestion();
            gestion.setCod_tipo_usu(rs.getInt("cod_tip_usu"));
            gestion.setNom_tipo_usu(rs.getString("nom_tip_usu"));
            gestion.setEstado(rs.getInt("est_usu"));
            lista.add(gestion);
        }
          cnx.close(); return lista;
    }

    @Override
    public int AgregarUsuario(String sede,String paterno,String materno,String NombreCom,String TipoUsuario,String usuario,String password) throws Exception {
        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "insert usuario(app_usu,apm_usu,nom_usu,cod_tip_usu,usu_usu,cla_usu,cod_sed_usu,est_usu) "
                + "         VALUES('"+paterno+"','"+materno+"','"+NombreCom+"',"+TipoUsuario+" ,'"+usuario+"','"+password+"',"+sede+",1 )";
        int r = st.executeUpdate(query);
     //   //System.out.println("AgregarUsuario \n"+query);
          cnx.close(); return r;
    }

    @Override
    public int UsuarioExitente(String nom_usu) throws Exception {
        int cantidad = 0;
        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "select count(*) as cant from usuario WHERE usu_usu='"+nom_usu+"'" ;
        ResultSet rs = st.executeQuery(query);
        while(rs.next()){
            cantidad = rs.getInt("cant");
        }
          cnx.close(); return cantidad;
    }

    @Override
    public int CantidadUsuario(String BusqNombre) throws Exception {
       int cantidad = 0;
        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "select COUNT(1) as cant from (\n" +
                        "select CONCAT(TRIM(u.app_usu),\" \",TRIM(u.apm_usu),\" \",TRIM(u.nom_usu)) as NombreCompleto,u.usu_usu,u.cla_usu,u.cod_sed_usu,s.deslocal,tp.cod_tip_usu,tp.nom_tip_usu from usuario as u\n" +
                        "INNER JOIN sede as s on s.idlocal=u.cod_sed_usu\n" +
                        "INNER JOIN tipo_usuario as tp on u.cod_tip_usu=tp.cod_tip_usu HAVING NombreCompleto LIKE '%"+BusqNombre+"%') x" ;
        ResultSet rs = st.executeQuery(query);
        while(rs.next()){
            cantidad = rs.getInt("cant");
        }
          cnx.close(); return cantidad;
    }

    @Override
    public int EstadoUsuario(int cod_usuario,int estado) throws Exception {
        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "update usuario set est_usu="+estado+" WHERE cod_usu="+cod_usuario;
        int r = st.executeUpdate(query);
      
          cnx.close(); return r;   
    }

    @Override
    public int EditarUsuario(String cod_usu, String Sede, String paterno, String materno, String NombreCom, String TipoUsuario, String usuario, String password) throws Exception {
     String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "UPDATE usuario set nom_usu='"+NombreCom+"',app_usu='"+paterno+"',apm_usu='"+materno+"',usu_usu='"+usuario+"',cla_usu='"+password+"',cod_sed_usu="+Sede+",cod_tip_usu="+TipoUsuario+" WHERE cod_usu="+cod_usu+";";
        int r = st.executeUpdate(query);
      
          cnx.close(); return r; 
    }

    @Override
    public int EstadoTipoUsuario(int cod_tipo_usu,int estado) throws Exception {
        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "UPDATE tipo_usuario set est_usu="+estado+" WHERE cod_tip_usu="+cod_tipo_usu;
        int r = st.executeUpdate(query);
          cnx.close(); return r;   
    }

    @Override
    public int AgregarTpUsuario(String Tpusuario) throws Exception {
        String base = "academianew";
        int cod=0;
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "insert tipo_usuario(nom_tip_usu,est_usu) VALUES('"+Tpusuario+"',1)";
        int r = st.executeUpdate(query);
        
        query = "select max(tp.cod_tip_usu) as cod ,(select COUNT(*)FROM menu_modulo_config WHERE cod_tip_usu=tp.cod_tip_usu) as cant  from tipo_usuario as tp \n" +
                "WHERE nom_tip_usu='"+Tpusuario+"' GROUP BY nom_tip_usu HAVING cant<1 ";
        ResultSet rs = st.executeQuery(query);
        while(rs.next()){
            cod = rs.getInt("cod");
        }
        
        for(int i=1;i<6;i++){
            query="insert menu_modulo_config(cod_mod,cod_tip_usu,ord_mod_con,est_mod_con) VALUES("+i+","+cod+","+i+",0)";
           r= st.executeUpdate(query);
        }
        for (int i = 1; i < 15; i++) {
             query="insert menu_categoria_config(cod_cat,cod_tip_usu,ord_cat_con,est_cat_con) VALUES("+i+","+cod+","+i+",0)";
            r= st.executeUpdate(query);
        }

     // insert menu_categoria_config(cod_cat,cod_tip_usu,ord_cat_con,est_cat_con) VALUES(2,2,2,0)   //System.out.println("AgregarUsuario \n"+query);
          cnx.close(); return r;
    }

    @Override
    public ArrayList<Menu> listarModulo(String tp_usu) throws Exception {
         ArrayList<Menu> lista=new ArrayList<>();
        String base="academianew";
        Connection cnx=MySqlDAOFactory.obtenerConexion(base);
        Statement st=cnx.createStatement();
        String query="select * from menu_modulo as mm \n" +
                    "INNER JOIN menu_modulo_config as mmc on mm.cod_mod=mmc.cod_mod  WHERE mmc.cod_tip_usu="+tp_usu+";";
        ResultSet rs=st.executeQuery(query);
        while(rs.next()){
            Menu gestion=new Menu();
            gestion.setCodigoModulo(rs.getString("cod_mod"));
            gestion.setNombreModulo(rs.getString("nom_mod"));
            gestion.setTipoModulo(rs.getString("cod_mod_con"));
            gestion.setEstadoModulo(rs.getString("est_mod_con"));
            lista.add(gestion);
        }
          cnx.close(); return lista;
    }

    @Override
    public ArrayList<Menu> listarCategoria(String tp_usu,String cod_modulo) throws Exception {
         ArrayList<Menu> lista=new ArrayList<>();
        String base="academianew";
        Connection cnx=MySqlDAOFactory.obtenerConexion(base);
        Statement st=cnx.createStatement();
        String query="select * from menu_categoria as mc  \n" +
                    "INNER JOIN menu_categoria_config as mcc on mc.cod_cat=mcc.cod_cat WHERE mcc.cod_tip_usu="+tp_usu+" and cod_mod="+cod_modulo+";";
        ResultSet rs=st.executeQuery(query);
        while(rs.next()){
            Menu gestion=new Menu();
            gestion.setCodigoCategoria(rs.getString("cod_cat"));
            gestion.setNombreCategoria(rs.getString("nom_cat"));
            gestion.setEstadoCategoria(rs.getString("est_cat_con"));
            gestion.setTipoCategoria(rs.getString("cod_cat_con"));
           
            lista.add(gestion);
        }
          cnx.close(); return lista;
    }

    @Override
    public int UpdateEstado(String[] idM, String[] estadoM, String[] idS, String[] estadoS) throws Exception {
        
        int r = 0;
        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        
        for (int i = 0; i <idM.length; i++) {
          String  query = "update menu_modulo_config set est_mod_con="+estadoM[i]+" WHERE cod_mod_con="+idM[i]+";";
            r = st.executeUpdate(query);
        }
        for (int i = 0; i <idS.length; i++) {
          String  query = "update menu_categoria_config set est_cat_con="+estadoS[i]+" WHERE cod_cat_con="+idS[i]+" ;";
            r = st.executeUpdate(query);
        }
          cnx.close(); return r;
    }

    @Override
    public int EditarTipoUsuario(String cod_tp_usu, String nombre) throws Exception {
         int r = 0;
        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query="update tipo_usuario set nom_tip_usu='"+nombre+"' WHERE cod_tip_usu="+cod_tp_usu;
        r = st.executeUpdate(query);
        
          cnx.close(); return  r;
    }

    @Override
    public int CantidaTipodUsuario(String BusqNombre) throws Exception {
        int cantidad = 0;
        String base = "academianew";
        Connection cnx = MySqlDAOFactory.obtenerConexion(base);
        Statement st = cnx.createStatement();
        String query = "select COUNT(1) as cant from (\n" +
                        "select * from tipo_usuario WHERE nom_tip_usu LIKE '%"+BusqNombre+"%'  ) x" ;
        ResultSet rs = st.executeQuery(query);
        while(rs.next()){
            cantidad = rs.getInt("cant");
        }
          cnx.close(); return cantidad;
    }

    
}
