/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package pe.siso.academia.Services;

import java.util.ArrayList;
import pe.siso.academia.Beans.Aula;
import pe.siso.academia.Beans.Pension;
import pe.siso.academia.DAO.AulaDAO;
import pe.siso.academia.DAO.DAOFactory;

/**
 *
 * @author sistem08user
 */
public class AulaService {
    DAOFactory fabrica = DAOFactory.getDAOFactory(DAOFactory.MYSQL);
    AulaDAO objAulaDAO= fabrica.getAulaDAO();
    
    public ArrayList<Aula> listarAulas(int codsed, int inicio, int cantidad){
        ArrayList<Aula> lista = null;
        try {
            lista = objAulaDAO.listarAulas(codsed,inicio,cantidad);
        } catch (Exception e) {
            e.printStackTrace();
        }
	return lista;
    }
    
    public ArrayList<Aula> listarAulasPorSede(int codsede, int inicio, int cantidad){
        ArrayList<Aula> lista = null;
        try {
            lista = objAulaDAO.listarAulasPorSede(codsede,inicio,cantidad);
        } catch (Exception e) {
            e.printStackTrace();
        }
	return lista;
    }
    
    public ArrayList<Aula> listarAulasPorInicio(int sede, String f1, String f2, int inicio, int cantidad){
        ArrayList<Aula> lista = null;
        try {
            lista = objAulaDAO.listarAulasPorFechaInicio(sede,f1,f2,inicio,cantidad);
        } catch (Exception e) {
            e.printStackTrace();
        }
	return lista;
    }
    
    public ArrayList<Aula> listarAulasPorCese(int sede, String f1, String f2, int inicio, int cantidad){
        ArrayList<Aula> lista = null;
        try {
            lista = objAulaDAO.listarAulasPorFechaCese(sede,f1,f2,inicio,cantidad);
        } catch (Exception e) {
            e.printStackTrace();
        }
	return lista;
    }
    
    public ArrayList<Aula> listarSeccionesPorAula(int codAula){
        ArrayList<Aula> lista = null;
        try {
            lista = objAulaDAO.listarSeccionesPorAula(codAula);
        } catch (Exception e) {
            e.printStackTrace();
        }
	return lista;
    }
    
    public int contarAulas(int sede){
        int cant=0;
        try {
            cant = objAulaDAO.contarAulas(sede);
        } catch (Exception e) {
            e.printStackTrace();
        }
	return cant;
    }
    
    public int contarAulasPorSede(int sede){
        int cant=0;
        try {
            cant = objAulaDAO.contarAulasPorSede(sede);
        } catch (Exception e) {
            e.printStackTrace();
        }
	return cant;
    }
    
    public int contarAulasPorInicio(int sede, String f1, String f2){
        int cant=0;
        try {
            cant = objAulaDAO.contarAulasPorFechaInicio(sede,f1, f2);
        } catch (Exception e) {
            e.printStackTrace();
        }
	return cant;
    }
    
    public int contarAulasPorCese(int sede, String f1, String f2){
        int cant=0;
        try {
            cant = objAulaDAO.contarAulasPorFechaCese(sede,f1, f2);
        } catch (Exception e) {
            e.printStackTrace();
        }
	return cant;
    }
    
    public int insertarAula(int codSede,int codCentro,int codNivel,int codTipoGrado,int codGrado,int codTurno,String fechaInicio,String fechaTermino,int cuotas,int tipoSeccion,String[] pensionDes, double[] pensionMonto, String[] pensionVencimiento) {
        int r=0;
        try {
            r = objAulaDAO.insertarAula(codSede, codCentro, codNivel, codTipoGrado, codGrado, codTurno, fechaInicio, fechaTermino, cuotas, tipoSeccion, pensionDes, pensionMonto, pensionVencimiento);
        } catch (Exception e) {
            e.printStackTrace();
        }
	return r;
    }
    
    public int cambiarEstadoAula(int idAula, int estado) {
        int r=0;
        try {
            r = objAulaDAO.cambiarEstadoAula(idAula, estado);
        } catch (Exception e) {
            e.printStackTrace();
        }
	return r;
    }
    
    public int cerrarCiclo(int codCiclo) {
        int r=0;
        try {
            r = objAulaDAO.cerrarCiclo(codCiclo);
        } catch (Exception e) {
            e.printStackTrace();
        }
	return r;
    }
    
    public int agregarSeccion(int codAula, int seccion) {
        int r=0;
        try {
            r = objAulaDAO.insertarSeccion(codAula, seccion);
        } catch (Exception e) {
            e.printStackTrace();
        }
	return r;
    }
    
    public int cambiaeEstadoSeccion(int codseccion,int estado) {
        int r=0;
        try {
            r = objAulaDAO.cambiarEstadoSeccion(codseccion, estado);
        } catch (Exception e) {
            e.printStackTrace();
        }
	return r;
    }
    
    public int obtenerTipoSeccion(int codAula) {
        int r=0;
        try {
            r = objAulaDAO.obtenerTipoSeccion(codAula);
        } catch (Exception e) {
            e.printStackTrace();
        }
	return r;
    }
    public ArrayList<Pension> ListarPensionesxAula(int cod_aula){
        ArrayList<Pension> lista = null;
        try {
            lista = objAulaDAO.ListarAulaporPensiones(cod_aula);
        } catch (Exception e) {
            e.printStackTrace();
        }
	return lista;
    }
    public int contarPensionesPagadas(int cod_aula){
        int cant=0;
        try {
            cant = objAulaDAO.contarPensionesPagadas(cod_aula);
        } catch (Exception e) {
            e.printStackTrace();
        }
	return cant;
    }
    public int insertarPension(int cod_aula,String fecha,String monto) {
        int r=0;
        try {
            r = objAulaDAO.insertarPension(cod_aula,fecha,monto);
        } catch (Exception e) {
            e.printStackTrace();
        }
	return r;
    }
     public int EliminarPension(int cod_pension) {
        int r=0;
        try {
            r = objAulaDAO.EliminarPension(cod_pension);
        } catch (Exception e) {
            e.printStackTrace();
        }
	return r;
    }
     public int EditarAula(int cod_aula,int codSede, int codCentro, int codNivel, int codTipoGrado, int codGrado, int codTurno, String fechaInicio, String fechaTermino, int cuotas, int tipoSeccion, String[] cod_pensiones, String[] pensionDes, String[] pensionMonto, String[] pensionVencimiento) {
        int r=0;
        try {
            r = objAulaDAO.EditarAula(cod_aula, codSede, codCentro, codNivel, codTipoGrado, codGrado, codTurno, fechaInicio, fechaTermino, cuotas, tipoSeccion, cod_pensiones, pensionDes, pensionMonto, pensionVencimiento);
        } catch (Exception e) {
            e.printStackTrace();
        }
	return r;
    }
}
