/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package pe.siso.academia.Services;

import java.util.ArrayList;
import org.json.simple.JSONArray;
import pe.siso.academia.Beans.Descuento;
import pe.siso.academia.DAO.DAOFactory;
import pe.siso.academia.DAO.DescuentoDAO;

/**
 *
 * @author sistem08user
 */
public class DescuentoService {

    DAOFactory fabrica = DAOFactory.getDAOFactory(DAOFactory.MYSQL);
    DescuentoDAO objDsctoDAO = fabrica.getDescuentoDAO();

    public ArrayList<Descuento> listarDescuentoPorNombre(String nombre, int inicio, int cantidad) {
        ArrayList<Descuento> lista = null;
        try {
            lista = objDsctoDAO.listarDescuentosPorNombre(nombre, inicio, cantidad);

        } catch (Exception e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        return lista;
    }

    public int cantidadDescuentoPorNombre(String nombre) {
        int cantidad = 0;
        try {
            cantidad = objDsctoDAO.cantidadDescuentosPorNombre(nombre);

        } catch (Exception e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        return cantidad;
    }

    public int cambiarEstadoDescuento(int id, String nombre) {
        int r = 0;
        try {
            r = objDsctoDAO.cambiarEstado(id, nombre);

        } catch (Exception e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        return r;
    }

    public int editarDescuento(int id, String nombre) {
        int r = 0;
        try {
            r = objDsctoDAO.editarDescuento(id, nombre);

        } catch (Exception e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        return r;
    }

    public int nuevoDescuento(String nombre) {
        int r = 0;
        try {
            r = objDsctoDAO.nuevoDescuento(nombre);

        } catch (Exception e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        return r;
    }

    public ArrayList<Descuento> listarDescuentoPorSede(int sede, String tipoUsuario) {
        ArrayList<Descuento> lista = null;
        try {
            lista = objDsctoDAO.listarDescuentosPorSede(sede, tipoUsuario);

        } catch (Exception e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        return lista;
    }

    public ArrayList<Descuento> listarDescuentoPorSedeSinAsignar(int sede) {
        ArrayList<Descuento> lista = null;
        try {
            lista = objDsctoDAO.listarDescuentosPorSedeSinAsignar(sede);

        } catch (Exception e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        return lista;
    }

    public int agregarDestoSede(int codSede, int codDscto, double monto, int tip_mon) {
        int r = 0;
        try {
            r = objDsctoDAO.agregarDescuentoSede(codSede, codDscto, monto, tip_mon);

        } catch (Exception e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        return r;
    }

    public int eliminarDestoSede(int codDesctoSede) {
        int r = 0;
        try {
            r = objDsctoDAO.eliminarDescuentoSede(codDesctoSede);

        } catch (Exception e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        return r;
    }

    public int cantEnlacesDesc(int id) {
        int r = 0;
        try {
            r = objDsctoDAO.cantEnlacesDscto(id);

        } catch (Exception e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        return r;
    }

    public JSONArray TipoDocumentoxSede(int codSede) {
        JSONArray jsonresultado=new JSONArray();
        try {
            jsonresultado=objDsctoDAO.TipoDocumentoxSede(codSede);
        } catch (Exception e) {
        }
        return jsonresultado;
    }

}
