/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package pe.siso.academia.Services;

import java.util.ArrayList;
import pe.siso.academia.Beans.Documento;
import pe.siso.academia.DAO.DAOFactory;
import pe.siso.academia.DAO.DocumentoDAO;

/**
 *
 * @author sistem08user
 */
public class DocumentoService {
    
    DAOFactory fabrica = DAOFactory.getDAOFactory(DAOFactory.MYSQL);
    DocumentoDAO objDocDAO= fabrica.getDocumentoDAO();
    
    public ArrayList<Documento> listarDocumentoPorSede(int sede){
        ArrayList<Documento> lista = null;
        try {
            lista = objDocDAO.listarDocumentosPorSede(sede);
                    
        } catch (Exception e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        return lista;
    }
    
    public ArrayList<Documento> listarDocumentoPorSedeSinAsignar(int sede){
        ArrayList<Documento> lista = null;
        try {
            lista = objDocDAO.listarDocumentosPorSedeSinAsignar(sede);
                    
        } catch (Exception e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        return lista;
    }
    
    public int agregarDocSede(int codSede, int codDoc){
        int r=0;
        try {
            r = objDocDAO.agregarDocumentoSede(codSede, codDoc);
                    
        } catch (Exception e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        return r;
    }
    
    public int eliminarDocSede(int codDesctoSede){
        int r=0;
        try {
            r = objDocDAO.eliminarDocumentoSede(codDesctoSede);
                    
        } catch (Exception e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        return r;
    }
    
    public ArrayList<Documento> listarDocumentoPorNombre(String nombre,int inicio, int cantidad){
        ArrayList<Documento> lista = null;
        try {
            lista = objDocDAO.listarDocumentosPorNombre(nombre, inicio, cantidad);
                    
        } catch (Exception e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        return lista;
    }
    
    public int cantidadDocumentoPorNombre(String nombre){
        int cantidad=0;
        try {
            cantidad = objDocDAO.cantidadDocumentosPorNombre(nombre);
                    
        } catch (Exception e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        return cantidad;
    }
    
    public int cambiarEstadoDocumento(int id, String nombre){
        int r=0;
        try {
            r = objDocDAO.cambiarEstado(id, nombre);
                    
        } catch (Exception e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        return r;
    }
    
    public int editarDocumento(int id, String nombre){
        int r=0;
        try {
            r = objDocDAO.editarDocumento(id, nombre);
                    
        } catch (Exception e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        return r;
    }
    
    public int nuevoDocumento(String nombre){
        int r=0;
        try {
            r = objDocDAO.nuevoDocumento(nombre);
                    
        } catch (Exception e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        return r;
    }
    
    public int cantEnlacesDoc(int id) {
        int r=0;
        try {
            r = objDocDAO.cantEnlacesDoc(id);
                    
        } catch (Exception e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        return r;
    }
    
    public ArrayList<Documento> obtenerDocumentosMatricula(int codmatri){
        ArrayList<Documento> lista = null;
        try {
            lista = objDocDAO.obtenerDocumentosMatricula(codmatri);
                    
        } catch (Exception e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        return lista;
    }
    
    public int actualizarDocumentosMat(int codMatricula,String codDoc[], String valDoc[]){
        int r = 0;
        try {
            r = objDocDAO.actualizarDocumentosMat(codMatricula, codDoc, valDoc);
                    
        } catch (Exception e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        return r;
    }
}
