
package pe.siso.academia.Services;

import java.util.ArrayList;
import pe.siso.academia.Beans.Aula;
import pe.siso.academia.Beans.Matricula;
import pe.siso.academia.Beans.Pension;
import pe.siso.academia.DAO.DAOFactory;
import pe.siso.academia.DAO.MatriculaDAO;

public class MatriculaService {
    DAOFactory fabrica = DAOFactory.getDAOFactory(DAOFactory.MYSQL);
    MatriculaDAO objMatriculaDAO= fabrica.getMatriculaDAO();
    
    public ArrayList<Matricula> listarMatriculas(int sede, String filtro, int inicio, int cant){
        ArrayList<Matricula> lista = null;
        try {
            lista = objMatriculaDAO.listarMatriculas(sede,filtro,inicio,cant);
        } catch (Exception e) {
            e.printStackTrace();
        }
        return lista;
    }
    public int contarMatriculas(int sede, String filtro) {
        int cantidad = 0;
        try {
            cantidad = objMatriculaDAO.contarMatriculas(sede,filtro);
        } catch (Exception e) {
            e.printStackTrace();
        }
        return cantidad;
    }
    public ArrayList<Matricula> listarCentros(int codSede){
        ArrayList<Matricula> lista = null;
        try {
            lista = objMatriculaDAO.listarCentros(codSede);
        } catch (Exception e) {
            e.printStackTrace();
        }
        return lista;
    }
    public ArrayList<Matricula> listarNiveles(int codSede, int idCentro){
        ArrayList<Matricula> lista = null;
        try {
            lista = objMatriculaDAO.listarNiveles(codSede, idCentro);
        } catch (Exception e) {
            e.printStackTrace();
        }
        return lista;
    }
    public ArrayList<Matricula> listarTiposGrado(int codSede, int idCentro, int idNivel){
        ArrayList<Matricula> lista = null;
        try {
            lista = objMatriculaDAO.listarTiposGrado(codSede, idCentro, idNivel);
        } catch (Exception e) {
            e.printStackTrace();
        }
        return lista;
    }
    public ArrayList<Matricula> listarGrados(int codSede, int idCentro, int idNivel, int idTipo){
        ArrayList<Matricula> lista = null;
        try {
            lista = objMatriculaDAO.listarGrados(codSede, idCentro, idNivel, idTipo);
        } catch (Exception e) {
            e.printStackTrace();
        }
        return lista;
    }
    public ArrayList<Matricula> listarTurnos(int codSede, int idCentro, int idNivel, int idTipo, int idGrado){
        ArrayList<Matricula> lista = null;
        try {
            lista = objMatriculaDAO.listarTurnos(codSede, idCentro, idNivel, idTipo, idGrado);
        } catch (Exception e) {
            e.printStackTrace();
        }
        return lista;
    }
    public ArrayList<Matricula> listarSecciones(int Aula){
        ArrayList<Matricula> lista = null;
        try {
            lista = objMatriculaDAO.listarSecciones(Aula);
        } catch (Exception e) {
            e.printStackTrace();
        }
        return lista;
    }
    
    public Aula obtenerAula(int Aula){
        Aula aula = new Aula();
        try {
            aula = objMatriculaDAO.obtenerAula(Aula);
        } catch (Exception e) {
            e.printStackTrace();
        }
        return aula;
    }
    
    public ArrayList<Pension> obtenerPensionesPorAula(int aula) {
        ArrayList<Pension> lista = null;
        try {
            lista = objMatriculaDAO.obtenerPensionesPorAula(aula);
        } catch (Exception e) {
            e.printStackTrace();
        }
        return lista;
    }
    
    public int matricularAlumno(int cod_estu, String fechaMatricula, int codAula, String seccion, String condicion, String observaciones, String informo, String eligio, String[] codDoc, String[] valDoc, String[] codPen, String[] monPen, String motDes, double monDes,String autorizacion){
        int r = 0;
        try {
            r = objMatriculaDAO.matricularAlumno(cod_estu, fechaMatricula, codAula, seccion, condicion, observaciones, informo, eligio, codDoc, valDoc, codPen, monPen,motDes,monDes,autorizacion);
        } catch (Exception e) {
            e.printStackTrace();
        }
        return r;
    }
    public ArrayList<Matricula> listarMatriculados(int sede, String filtro, int inicio, int cant) {
        ArrayList<Matricula> lista = null;
        try {
            lista = objMatriculaDAO.listarMatriculados(sede, filtro, inicio, cant);
        } catch (Exception e) {
            e.printStackTrace();
        }
        return lista;
    }
    public int contarMatriculados(int sede, String filtro) {
        int cantidad = 0;
        try {
            cantidad = objMatriculaDAO.contarMatriculados(sede, filtro);
        } catch (Exception e) {
            e.printStackTrace();
        }
        return cantidad;
    }
    public int deshabilitarMatricula(int cod_matricula) {
        int cantidad = 0;
        try {
            cantidad = objMatriculaDAO.deshabilitarMatricula(cod_matricula);
        } catch (Exception e) {
            e.printStackTrace();
        }
        return cantidad;
    }
    public Matricula obtenerMatricula(int cod_matricula) {
        Matricula matri = new Matricula();
        try {
            matri = objMatriculaDAO.obtenerMatricula(cod_matricula);
        } catch (Exception e) {
            e.printStackTrace();
        }
        return matri;
    }
    public int actualizarMatricula(int cod_matricula, String obs, int aula, String seccion) {
        int r = 0;
        try {
            r = objMatriculaDAO.actualizarMatricula(cod_matricula, obs, aula, seccion);
        } catch (Exception e) {
            e.printStackTrace();
        }
        return r;
    }
    public int validarMatriculaExistente(int aula, int estudiante) {
        int r = 0;
        try {
            r = objMatriculaDAO.validarMatriculaExistente(aula, estudiante);
        } catch (Exception e) {
            e.printStackTrace();
        }
        return r;
    }
}
