/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package pe.siso.academia.Services;

import java.util.ArrayList;
import pe.siso.academia.Beans.Monto;
import pe.siso.academia.DAO.DAOFactory;
import pe.siso.academia.DAO.MontoDAO;

/**
 *
 * @author sistem08user
 */
public class MontoService {
    DAOFactory fabrica = DAOFactory.getDAOFactory(DAOFactory.MYSQL);
    MontoDAO objMontoDAO= fabrica.getMontoDAO();
    
    public ArrayList<Monto> listarCentros(String nombre, int inicio, int cantidad){
        ArrayList<Monto> lista = null;
        try {
            lista = objMontoDAO.listarCentros(nombre, inicio, cantidad);
        } catch (Exception e) {
            e.printStackTrace();
        }
	return lista;
    }
    
    public ArrayList<Monto> listarNiveles(int sede, String nombre, int inicio, int cantidad){
        ArrayList<Monto> lista = null;
        try {
            lista = objMontoDAO.listarNiveles(sede,nombre,inicio,cantidad);
        } catch (Exception e) {
            e.printStackTrace();
        }
	return lista;
    }
    
    public ArrayList<Monto> listarGrados(int nivel, String nombre, int inicio, int cantidad){
        ArrayList<Monto> lista = null;
        try {
            lista = objMontoDAO.listarGrados(nivel, nombre, inicio, cantidad);
        } catch (Exception e) {
            e.printStackTrace();
        }
	return lista;
    }
    
    public ArrayList<Monto> listarCiclos(int grado, String nombre, int inicio, int cantidad){
        ArrayList<Monto> lista = null;
        try {
            lista = objMontoDAO.listarCiclos(grado, nombre, inicio, cantidad);
        } catch (Exception e) {
            e.printStackTrace();
        }
	return lista;
    }
    
    public ArrayList<Monto> listarTurnos(){
        ArrayList<Monto> lista = null;
        try {
            lista = objMontoDAO.listarTurnos();
        } catch (Exception e) {
            e.printStackTrace();
        }
	return lista;
    }
    
    public int contarCentros(String nombre){
        int cantidad = 0;
        try {
            cantidad = objMontoDAO.contarCentros(nombre);
        } catch (Exception e) {
            e.printStackTrace();
        }
	return cantidad;
    }
    
    public int contarNiveles(int sede, String nombre){
        int cantidad = 0;
        try {
            cantidad = objMontoDAO.contarNiveles(sede, nombre);
        } catch (Exception e) {
            e.printStackTrace();
        }
	return cantidad;
    }
    
    public int contarGrados(int nivel, String nombre){
        int cantidad = 0;
        try {
            cantidad = objMontoDAO.contarGrados(nivel, nombre);
        } catch (Exception e) {
            e.printStackTrace();
        }
	return cantidad;
    }
    
    public int contarCiclos(int grado, String nombre){
        int cantidad = 0;
        try {
            cantidad = objMontoDAO.contarCiclos(grado, nombre);
        } catch (Exception e) {
            e.printStackTrace();
        }
	return cantidad;
    }
    
    public int insertarCentros(String nombre) {
        int r = 0;
        try {
            r = objMontoDAO.insertarCentros(nombre);
        } catch (Exception e) {
            e.printStackTrace();
        }
	return r;
    }

    public int insertarNiveles(int idCentro, String nombre) {
        int r = 0;
        try {
            r = objMontoDAO.insertarNiveles(idCentro, nombre);
        } catch (Exception e) {
            e.printStackTrace();
        }
	return r;
    }

    public int insertarGrados(int idNivel, String nombre) {
        int r = 0;
        try {
            r = objMontoDAO.insertarGrados(idNivel, nombre);
        } catch (Exception e) {
            e.printStackTrace();
        }
	return r;
    }

    public int insertarCiclos(int idGrado, String nombre) {
        int r = 0;
        try {
            r = objMontoDAO.insertarCiclos(idGrado, nombre);
        } catch (Exception e) {
            e.printStackTrace();
        }
	return r;
    }

    public int cambiarEstadoCentros(int codCentro, int estado) {
        int r = 0;
        try {
            r = objMontoDAO.cambiarEstadoCentros(codCentro, estado);
        } catch (Exception e) {
            e.printStackTrace();
        }
	return r;
    }

    public int cambiarEstadoNiveles(int codNivel, int estado) {
        int r = 0;
        try {
            r = objMontoDAO.cambiarEstadoNiveles(codNivel, estado);
        } catch (Exception e) {
            e.printStackTrace();
        }
	return r;
    }

    public int cambiarEstadoGrados(int codGrado, int estado) {
        int r = 0;
        try {
            r = objMontoDAO.cambiarEstadoGrados(codGrado, estado);
        } catch (Exception e) {
            e.printStackTrace();
        }
	return r;
    }

    public int cambiarEstadoCiclos(int codCiclo, int estado) {
        int r = 0;
        try {
            r = objMontoDAO.cambiarEstadoCiclos(codCiclo, estado);
        } catch (Exception e) {
            e.printStackTrace();
        }
	return r;
    }
    
    public int editarCentro(int codCentro, String nombre) {
        int r = 0;
        try {
            r = objMontoDAO.editarCentro(codCentro, nombre);
        } catch (Exception e) {
            e.printStackTrace();
        }
	return r;
    }

    public int editarNivel(int codNivel, String nombre) {
        int r = 0;
        try {
            r = objMontoDAO.editarNivel(codNivel, nombre);
        } catch (Exception e) {
            e.printStackTrace();
        }
	return r;
    }

    public int editarGrado(int codGrado, String nombre) {
        int r = 0;
        try {
            r = objMontoDAO.editarGrado(codGrado, nombre);
        } catch (Exception e) {
            e.printStackTrace();
        }
	return r;
    }

    public int editarCiclo(int codCiclo, String nombre) {
        int r = 0;
        try {
            r = objMontoDAO.editarCiclo(codCiclo, nombre);
        } catch (Exception e) {
            e.printStackTrace();
        }
	return r;
    }
}
