/*
#########################################################
################### INTEGRACIÓN FÁCIL ###################
+++++++++++++++++++++++++++++++++++++++++++++++++++++++++
# ESTE CÓDIGO FUNCIONA PARA LA VERSIÓN ONLINE Y OFFLINE
# Documentación oficial: www.nubefact.com/integracion
+++++++++++++++++++++++++++++++++++++++++++++++++++++++++

#########################################################
#### FORMA DE TRABAJO ####
+++++++++++++++++++++++++++++++++++++++++++++++++++++++
# PASO 1: Conseguir una RUTA y un TOKEN para trabajar con NUBEFACT (Regístrate o ingresa a tu cuenta en www.nubefact.com).
# PASO 2: Generar un archivo en formato .JSON o .TXT con una estructura que se detalla en este documento.
# PASO 3: Enviar el archivo generado a nuestra WEB SERVICE ONLINE u OFFLINE según corresponda usando la RUTA y el TOKEN.
# PASO 4: Generamos el archivo XML y PDF (Según especificaciones de la SUNAT) y te devolveremos INSTANTÁNEAMENTE los datos del documento generado.
# Para ver el documento generado ingresa a www.nubefact.com/login con tus datos de acceso, y luego a la opción "Ver Facturas, Boletas y Notas"
# IMPORTANTE: Enviaremos el XML generado a la SUNAT y lo almacenaremos junto con el PDF, XML y CDR en la NUBE para que tu cliente pueda consultarlo
en cualquier momento, si así lo desea.
+++++++++++++++++++++++++++++++++++++++++++++++++++++++
 */
package pe.siso.academia.Services;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.UnsupportedEncodingException;
import java.text.SimpleDateFormat;
import java.util.Calendar;

import org.apache.http.HttpResponse;
import org.apache.http.client.HttpClient;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.entity.StringEntity;
import org.apache.http.impl.client.DefaultHttpClient;
import org.json.simple.JSONArray;
import org.json.simple.JSONObject;

import org.json.simple.parser.JSONParser;
import org.json.simple.parser.ParseException;

public class NubefactSO {

    /* j2rojasr@gmail.com
  https://www.nubefact.com/api/v1/0e28692c-98b8-4301-854f-b76028b09dda
  24279208f8cb480f815d3113dc9392d98d91153f8cfd4a608083d19aa3a2cca2
     */
 /* j2rojasr.ti@sacooliveros.edu.pe
  https://www.nubefact.com/api/v1/bad1d138-c66c-45e3-bb60-459f4e868424
  0cc75899adf745dba5e8fe364c263a2061ad99f2b7fa4c5793c70c7f39a11cae
     */
// ----------------------------NUBEFACT ORIGINAL------------------------
////  RUTA para enviar documentos
//    private String RUTA = "https://www.nubefact.com/api/v1/bad1d138-c66c-45e3-bb60-459f4e868424";
//  TOKEN para enviar documentos    
//    private String TOKEN = "24279208f8cb480f815d3113dc9392d98d91153f8cfd4a608083d19aa3a2cca2";
//// -------------------------NUBEFACT ORIGINAL-------------------------
//    //// -------------------------NUBEFACT ORIGINAL-------------------------
//////  RUTA para enviar documentos
    private String RUTA = "https://www.nubefact.com/api/v1/0e28692c-98b8-4301-854f-b76028b09dda";
//////  TOKEN para enviar documentos    
//    private String TOKEN = "0cc75899adf745dba5e8fe364c263a2061ad99f2b7fa4c5793c70c7f39a11cae";
//    //// -------------------------JJ-------------------------

    public JSONObject consultarComprobante(JSONObject jsonObject, String TOKEN) {
        JSONObject objectReturn = new JSONObject();

        try {
            HttpClient cliente = new DefaultHttpClient();
            HttpPost post = new HttpPost(RUTA);
            post.addHeader("Authorization", "Token token=" + TOKEN); // Cabecera del token
            post.addHeader("Content-Type", "application/json"); // Cabecera del Content-Type
//"content-type: application/json; charset=utf-8"
            JSONObject objetoCabecera = new JSONObject();

            String tipo_de_comprobante = "";
            String serie = "";
            String numero = "";

            if (jsonObject.containsKey("tipo_de_comprobante")) {
                tipo_de_comprobante = String.valueOf(jsonObject.get("tipo_de_comprobante"));
            } else {
                objectReturn.put("error_so", "Falta campo tipo_de_comprobante");
                objectReturn.put("tipo_de_comprobante", tipo_de_comprobante);
                objectReturn.put("serie", serie);
                objectReturn.put("numero", numero);
                return objectReturn;
            }

            if (jsonObject.containsKey("serie")) {
                serie = String.valueOf(jsonObject.get("serie"));
            } else {
                objectReturn.put("error_so", "Falta campo serie");
                objectReturn.put("tipo_de_comprobante", tipo_de_comprobante);
                objectReturn.put("serie", serie);
                objectReturn.put("numero", numero);
                return objectReturn;
            }

            if (jsonObject.containsKey("numero")) {
                numero = String.valueOf(jsonObject.get("numero"));
            } else {
                objectReturn.put("error_so", "Falta campo numero");
                objectReturn.put("tipo_de_comprobante", tipo_de_comprobante);
                objectReturn.put("serie", serie);
                objectReturn.put("numero", numero);
                return objectReturn;
            }

            /*
      1 = FACTURA
      2 = BOLETA
      3 = NOTA DE CRÉDITO
      4 = NOTA DE DÉBITO
             */
            if (tipo_de_comprobante == null
                    || tipo_de_comprobante.equals("")
                    || Integer.parseInt((String) tipo_de_comprobante) <= 0
                    || Integer.parseInt((String) tipo_de_comprobante) >= 5) {
                objectReturn.put("error_so", "validacion de tipo_de_comprobante");
                objectReturn.put("tipo_de_comprobante", tipo_de_comprobante);
                objectReturn.put("serie", serie);
                objectReturn.put("numero", numero);
                return objectReturn;
            }
            if (serie == null
                    || serie.equals("")) {
                objectReturn.put("error_so", "validacion de serie");
                objectReturn.put("tipo_de_comprobante", tipo_de_comprobante);
                objectReturn.put("serie", serie);
                objectReturn.put("numero", numero);
                return objectReturn;
            }
            if (numero == null
                    || numero.equals("")
                    || Integer.parseInt((String) numero) <= 0) {
                objectReturn.put("error_so", "validacion de numero");
                objectReturn.put("tipo_de_comprobante", tipo_de_comprobante);
                objectReturn.put("serie", serie);
                objectReturn.put("numero", numero);
                return objectReturn;
            }

            objetoCabecera.put("operacion", "consultar_comprobante");
            objetoCabecera.put("tipo_de_comprobante", tipo_de_comprobante);
            objetoCabecera.put("serie", serie);
            objetoCabecera.put("numero", numero);

            StringEntity parametros = new StringEntity(objetoCabecera.toString(), "UTF-8");
            post.setEntity(parametros);
            HttpResponse response = cliente.execute(post);
            BufferedReader rd = new BufferedReader(new InputStreamReader(response.getEntity().getContent()));
            String linea = "";

            if ((linea = rd.readLine()) != null) {
                JSONParser parsearRsptaJson = new JSONParser();
                JSONObject json_rspta = (JSONObject) parsearRsptaJson.parse(linea);

                if (json_rspta.get("errors") != null) {
                    objectReturn = json_rspta;
                    objectReturn.put("error_so", "Error en respuesta de Nubefact");
                } else {
                    JSONParser parsearRsptaDetalleOK = new JSONParser();
                    JSONObject json_rspta_ok = (JSONObject) parsearRsptaDetalleOK.parse(json_rspta.toString());

                    objectReturn.put("tipo_de_comprobante", json_rspta_ok.get("tipo_de_comprobante"));
                    objectReturn.put("serie", json_rspta_ok.get("serie"));
                    objectReturn.put("numero", json_rspta_ok.get("numero"));
                    objectReturn.put("enlace", json_rspta_ok.get("enlace"));
                    objectReturn.put("aceptada_por_sunat", json_rspta_ok.get("aceptada_por_sunat"));
                    objectReturn.put("sunat_description", json_rspta_ok.get("sunat_description"));
                    objectReturn.put("sunat_note", json_rspta_ok.get("sunat_note"));
                    objectReturn.put("sunat_responsecode", json_rspta_ok.get("sunat_responsecode"));
                    objectReturn.put("sunat_soap_error", json_rspta_ok.get("sunat_soap_error"));
                    objectReturn.put("pdf_zip_base64", json_rspta_ok.get("pdf_zip_base64"));
                    objectReturn.put("xml_zip_base64", json_rspta_ok.get("xml_zip_base64"));
                    objectReturn.put("cdr_zip_base64", json_rspta_ok.get("cdr_zip_base64"));
                    objectReturn.put("cadena_para_codigo_qr", json_rspta_ok.get("cadena_para_codigo_qr"));
                    objectReturn.put("codigo_hash", json_rspta_ok.get("codigo_hash"));
                    objectReturn.put("codigo_de_barras", json_rspta_ok.get("codigo_de_barras"));
                    objectReturn.put("key", json_rspta_ok.get("key"));
                    objectReturn.put("digest_value", json_rspta_ok.get("digest_value"));
                    objectReturn.put("enlace_del_pdf", json_rspta_ok.get("enlace_del_pdf"));
                    objectReturn.put("enlace_del_xml", json_rspta_ok.get("enlace_del_xml"));
                    objectReturn.put("enlace_del_cdr", json_rspta_ok.get("enlace_del_cdr"));

                    return objectReturn;
                }
            }
        } catch (UnsupportedEncodingException ex1) {
            System.out.println("Error UnsupportedEncodingException: " + ex1.getMessage());
        } catch (IOException ex2) {
            System.out.println("Error IOException: " + ex2.getMessage());
        } catch (IllegalStateException | NumberFormatException | ParseException ex3) {
            System.out.println("Exepction: " + ex3.getMessage());
        }

        return objectReturn;
    }

    public JSONObject generarComprobante(JSONObject jsonObject, String TOKEN) {
        JSONObject objectReturn = new JSONObject();

        try {
            HttpClient cliente = new DefaultHttpClient();
            HttpPost post = new HttpPost(RUTA);
            post.addHeader("Authorization", "Token token=" + TOKEN); // Cabecera del token
            post.addHeader("Content-Type", "application/json"); // Cabecera del Content-Type

            String tipo_de_comprobante = String.valueOf(jsonObject.get("tipo_de_comprobante"));
            String serie = String.valueOf(jsonObject.get("serie"));
            String numero = String.valueOf(jsonObject.get("numero"));

            String sunat_transaction = String.valueOf(jsonObject.get("sunat_transaction"));
            String cliente_tipo_de_documento = String.valueOf(jsonObject.get("cliente_tipo_de_documento"));
            String cliente_numero_de_documento = String.valueOf(jsonObject.get("cliente_numero_de_documento"));
            String cliente_denominacion = String.valueOf(jsonObject.get("cliente_denominacion"));
            String cliente_direccion = String.valueOf(jsonObject.get("cliente_direccion"));
            String cliente_email = String.valueOf(jsonObject.get("cliente_email"));
            String cliente_email_1 = String.valueOf(jsonObject.get("cliente_email_1")); //opcional
            String cliente_email_2 = String.valueOf(jsonObject.get("cliente_email_2")); //opcional
            String fecha_de_emision = "";
            String fecha_de_vencimiento = String.valueOf(jsonObject.get("fecha_de_vencimiento")); //opcional
            String moneda = String.valueOf(jsonObject.get("moneda"));
            String tipo_de_cambio = String.valueOf(jsonObject.get("tipo_de_cambio")); //opcional
            String porcentaje_de_igv = String.valueOf(jsonObject.get("porcentaje_de_igv"));
            String descuento_global = String.valueOf(jsonObject.get("descuento_global")); //opcional
            String total_descuento = String.valueOf(jsonObject.get("total_descuento")); //opcional
            String total_anticipo = String.valueOf(jsonObject.get("total_anticipo")); //opcional
            String total_gravada = String.valueOf(jsonObject.get("total_gravada"));
            String total_inafecta = String.valueOf(jsonObject.get("total_inafecta")); //opcional
            String total_exonerada = String.valueOf(jsonObject.get("total_exonerada")); //opcional
            String total_igv = String.valueOf(jsonObject.get("total_igv"));
            String total_gratuita = String.valueOf(jsonObject.get("total_gratuita")); //opcional
            String total_otros_cargos = String.valueOf(jsonObject.get("total_otros_cargos")); //opcional
            String total = String.valueOf(jsonObject.get("total"));
            String percepcion_tipo = String.valueOf(jsonObject.get("percepcion_tipo")); //opcional
            String percepcion_base_imponible = String.valueOf(jsonObject.get("percepcion_base_imponible")); //opcional
            String total_percepcion = String.valueOf(jsonObject.get("total_percepcion")); //opcional
            String total_incluido_percepcion = String.valueOf(jsonObject.get("total_incluido_percepcion")); //opcional
            String detraccion = String.valueOf(jsonObject.get("detraccion"));
            String observaciones = String.valueOf(jsonObject.get("observaciones")); //opcional
            String documento_que_se_modifica_tipo = String.valueOf(jsonObject.get("documento_que_se_modifica_tipo")); //opcional
            String documento_que_se_modifica_serie = String.valueOf(jsonObject.get("documento_que_se_modifica_serie")); //opcional
            String documento_que_se_modifica_numero = String.valueOf(jsonObject.get("documento_que_se_modifica_numero")); //opcional
            String tipo_de_nota_de_credito = String.valueOf(jsonObject.get("tipo_de_nota_de_credito")); //opcional
            String tipo_de_nota_de_debito = String.valueOf(jsonObject.get("tipo_de_nota_de_debito")); //opcional
            String enviar_automaticamente_a_la_sunat = String.valueOf(jsonObject.get("enviar_automaticamente_a_la_sunat"));
            String enviar_automaticamente_al_cliente = String.valueOf(jsonObject.get("enviar_automaticamente_al_cliente"));
            String codigo_unico = String.valueOf(jsonObject.get("codigo_unico")); //opcional
            String condiciones_de_pago = String.valueOf(jsonObject.get("condiciones_de_pago")); //opcional
            String medio_de_pago = String.valueOf(jsonObject.get("medio_de_pago")); //opcional
            String placa_vehiculo = String.valueOf(jsonObject.get("placa_vehiculo")); //opcional
            String orden_compra_servicio = String.valueOf(jsonObject.get("orden_compra_servicio")); //opcional
            String tabla_personalizada_codigo = String.valueOf(jsonObject.get("tabla_personalizada_codigo")); //opcional
            String formato_de_pdf = String.valueOf(jsonObject.get("formato_de_pdf")); //opcional

            /*
      1 = FACTURA
      2 = BOLETA
      3 = NOTA DE CRÉDITO
      4 = NOTA DE DÉBITO
             */
//      if (tipo_de_comprobante == null
//              || tipo_de_comprobante.equals("")
//              || Integer.parseInt((String) tipo_de_comprobante) <= 0
//              || Integer.parseInt((String) tipo_de_comprobante) >= 5) {
//        objectReturn.put("error", "");
//        objectReturn.put("tipo_de_comprobante", tipo_de_comprobante);
//        objectReturn.put("serie", serie);
//        objectReturn.put("numero", numero);
//        return objectReturn;
//      }
//      if (serie == null
//              || serie.equals("")) {
//        objectReturn.put("error", "");
//        objectReturn.put("tipo_de_comprobante", tipo_de_comprobante);
//        objectReturn.put("serie", serie);
//        objectReturn.put("numero", numero);
//        return objectReturn;
//      }
//      if (numero == null
//              || numero.equals("")
//              || Integer.parseInt((String) numero) <= 0) {
//        objectReturn.put("error", "");
//        objectReturn.put("tipo_de_comprobante", tipo_de_comprobante);
//        objectReturn.put("serie", serie);
//        objectReturn.put("numero", numero);
//        return objectReturn;
//      }
//      /*
//      1 = VENTA INTERNA
//      2 = EXPORTACIÓN
//      3 = NO DOMICILIADO
//      4 = VENTA INTERNA – ANTICIPOS
//      5 = VENTA ITINERANTE
//      6 = FACTURA GUÍA
//      7 = VENTA ARROZ PILADO
//      8 = FACTURA - COMPROBANTE DE PERCEPCIÓN
//      10 = FACTURA - GUÍA REMITENTE
//      11 = FACTURA - GUÍA TRANSPORTISTA
//      12 = BOLETA DE VENTA – COMPROBANTE DE PERCEPCIÓN
//      13 = GASTO DEDUCIBLE PERSONA NATURAL
//       */
//      if (sunat_transaction == null
//              || Integer.parseInt((String) sunat_transaction) <= 0
//              || Integer.parseInt((String) sunat_transaction) >= 14) {
//        objectReturn.put("error", "");
//        objectReturn.put("tipo_de_comprobante", tipo_de_comprobante);
//        objectReturn.put("serie", serie);
//        objectReturn.put("numero", numero);
//        return objectReturn;
//      }
//      /*
//      6 = RUC - REGISTRO ÚNICO DE CONTRIBUYENTE
//      1 = DNI - DOC. NACIONAL DE IDENTIDAD
//      - = VARIOS - VENTAS MENORES A S/.700.00 Y OTROS
//      4 = CARNET DE EXTRANJERÍA
//      7 = PASAPORTE
//      A = CÉDULA DIPLOMÁTICA DE IDENTIDAD
//      0 = NO DOMICILIADO, SIN RUC (EXPORTACIÓN)
//       */
//      if (cliente_tipo_de_documento.equals("6")
//              || cliente_tipo_de_documento.equals("1")
//              || cliente_tipo_de_documento.equals("-")
//              || cliente_tipo_de_documento.equals("4")
//              || cliente_tipo_de_documento.equals("7")
//              || cliente_tipo_de_documento.equals("A")
//              || cliente_tipo_de_documento.equals("0")) {
//      } else {
//        objectReturn.put("error", "");
//        objectReturn.put("tipo_de_comprobante", tipo_de_comprobante);
//        objectReturn.put("serie", serie);
//        objectReturn.put("numero", numero);
//        return objectReturn;
//      }
//      if (cliente_numero_de_documento == null
//              || cliente_numero_de_documento.length() < 1
//              || cliente_numero_de_documento.length() > 15) {
//        objectReturn.put("error", "");
//        objectReturn.put("tipo_de_comprobante", tipo_de_comprobante);
//        objectReturn.put("serie", serie);
//        objectReturn.put("numero", numero);
//        return objectReturn;
//      }
//      if (cliente_denominacion == null
//              || cliente_denominacion.equals("")) {
//        objectReturn.put("error", "");
//        objectReturn.put("tipo_de_comprobante", tipo_de_comprobante);
//        objectReturn.put("serie", serie);
//        objectReturn.put("numero", numero);
//        return objectReturn;
//      }
//      if (cliente_direccion == null
//              || cliente_direccion.equals("")) {
//        objectReturn.put("error", "");
//        objectReturn.put("tipo_de_comprobante", tipo_de_comprobante);
//        objectReturn.put("serie", serie);
//        objectReturn.put("numero", numero);
//        return objectReturn;
//      }
//      if (cliente_email == null
//              || cliente_email.equals("")) {
//        objectReturn.put("error", "");
//        objectReturn.put("tipo_de_comprobante", tipo_de_comprobante);
//        objectReturn.put("serie", serie);
//        objectReturn.put("numero", numero);
//        return objectReturn;
//      }
//      if (moneda == null
//              || moneda.equals("")) {
//        objectReturn.put("error", "");
//        objectReturn.put("tipo_de_comprobante", tipo_de_comprobante);
//        objectReturn.put("serie", serie);
//        objectReturn.put("numero", numero);
//        return objectReturn;
//      }
//      if (porcentaje_de_igv == null
//              || porcentaje_de_igv.equals("")) {
//        objectReturn.put("error", "");
//        objectReturn.put("tipo_de_comprobante", tipo_de_comprobante);
//        objectReturn.put("serie", serie);
//        objectReturn.put("numero", numero);
//        return objectReturn;
//      }
//      if (total_gravada == null
//              || total_gravada.equals("")) {
//        objectReturn.put("error", "");
//        objectReturn.put("tipo_de_comprobante", tipo_de_comprobante);
//        objectReturn.put("serie", serie);
//        objectReturn.put("numero", numero);
//        return objectReturn;
//      }
//      if (total_igv == null
//              || total_igv.equals("")) {
//        objectReturn.put("error", "");
//        objectReturn.put("tipo_de_comprobante", tipo_de_comprobante);
//        objectReturn.put("serie", serie);
//        objectReturn.put("numero", numero);
//        return objectReturn;
//      }
//      if (total == null
//              || total.equals("")) {
//        objectReturn.put("error", "");
//        objectReturn.put("tipo_de_comprobante", tipo_de_comprobante);
//        objectReturn.put("serie", serie);
//        objectReturn.put("numero", numero);
//        return objectReturn;
//      }
//      if (detraccion == null
//              || detraccion.equals("")) {
//        objectReturn.put("error", "");
//        objectReturn.put("tipo_de_comprobante", tipo_de_comprobante);
//        objectReturn.put("serie", serie);
//        objectReturn.put("numero", numero);
//        return objectReturn;
//      }
//      if (enviar_automaticamente_a_la_sunat == null
//              || enviar_automaticamente_a_la_sunat.equals("")) {
//        objectReturn.put("error", "");
//        objectReturn.put("tipo_de_comprobante", tipo_de_comprobante);
//        objectReturn.put("serie", serie);
//        objectReturn.put("numero", numero);
//        return objectReturn;
//      }
//      if (enviar_automaticamente_al_cliente == null
//              || enviar_automaticamente_al_cliente.equals("")) {
//        objectReturn.put("error", "");
//        objectReturn.put("tipo_de_comprobante", tipo_de_comprobante);
//        objectReturn.put("serie", serie);
//        objectReturn.put("numero", numero);
//        return objectReturn;
//      }
            //FECHA DE EMISIÓN (TIENE QUE SER SIEMPRE EL DÍA DE HOY)
            Calendar cal = Calendar.getInstance();
            SimpleDateFormat sdf = new SimpleDateFormat("dd/MM/yyyy HH:mm:ss.SS");
            sdf = new SimpleDateFormat("dd-MM-yyyy");
            fecha_de_emision = sdf.format(cal.getTime());

            JSONObject objetoCabecera = new JSONObject(); // Instancear el  segundario
            objetoCabecera.put("operacion", "generar_comprobante");
            objetoCabecera.put("tipo_de_comprobante", tipo_de_comprobante);
            objetoCabecera.put("serie", serie);
            objetoCabecera.put("numero", numero);

            objetoCabecera.put("sunat_transaction", sunat_transaction);
            objetoCabecera.put("cliente_tipo_de_documento", cliente_tipo_de_documento);
            objetoCabecera.put("cliente_numero_de_documento", cliente_numero_de_documento);
            objetoCabecera.put("cliente_denominacion", cliente_denominacion);
            objetoCabecera.put("cliente_direccion", cliente_direccion);
            objetoCabecera.put("cliente_email", cliente_email);
            objetoCabecera.put("cliente_email_1", cliente_email_1);
            objetoCabecera.put("cliente_email_2", cliente_email_2);
            objetoCabecera.put("fecha_de_emision", fecha_de_emision);
            objetoCabecera.put("fecha_de_vencimiento", fecha_de_vencimiento);
            objetoCabecera.put("moneda", moneda);
            objetoCabecera.put("tipo_de_cambio", tipo_de_cambio);
            objetoCabecera.put("porcentaje_de_igv", porcentaje_de_igv);
            objetoCabecera.put("descuento_global", descuento_global);
            objetoCabecera.put("total_descuento", total_descuento);
            objetoCabecera.put("total_anticipo", total_anticipo);
            objetoCabecera.put("total_gravada", total_gravada);
            objetoCabecera.put("total_inafecta", total_inafecta);
            objetoCabecera.put("total_exonerada", total_exonerada);
            objetoCabecera.put("total_igv", total_igv);
            objetoCabecera.put("total_gratuita", total_gratuita);
            objetoCabecera.put("total_otros_cargos", total_otros_cargos);
            objetoCabecera.put("total", total);
            objetoCabecera.put("percepcion_tipo", percepcion_tipo);
            objetoCabecera.put("percepcion_base_imponible", percepcion_base_imponible);
            objetoCabecera.put("total_percepcion", total_percepcion);
            objetoCabecera.put("total_incluido_percepcion", total_incluido_percepcion);
            objetoCabecera.put("detraccion", detraccion);
            objetoCabecera.put("observaciones", observaciones);
            objetoCabecera.put("documento_que_se_modifica_tipo", documento_que_se_modifica_tipo);
            objetoCabecera.put("documento_que_se_modifica_serie", documento_que_se_modifica_serie);
            objetoCabecera.put("documento_que_se_modifica_numero", documento_que_se_modifica_numero);
            objetoCabecera.put("tipo_de_nota_de_credito", tipo_de_nota_de_credito);
            objetoCabecera.put("tipo_de_nota_de_debito", tipo_de_nota_de_debito);
            objetoCabecera.put("enviar_automaticamente_a_la_sunat", enviar_automaticamente_a_la_sunat);
            objetoCabecera.put("enviar_automaticamente_al_cliente", enviar_automaticamente_al_cliente);
            objetoCabecera.put("codigo_unico", codigo_unico);
            objetoCabecera.put("condiciones_de_pago", condiciones_de_pago);
            objetoCabecera.put("medio_de_pago", medio_de_pago);
            objetoCabecera.put("placa_vehiculo", placa_vehiculo);
            objetoCabecera.put("orden_compra_servicio", orden_compra_servicio);
            objetoCabecera.put("tabla_personalizada_codigo", tabla_personalizada_codigo);
            objetoCabecera.put("formato_de_pdf", formato_de_pdf);

            JSONArray lista = (JSONArray) jsonObject.get("items");

            if (lista == null) {
                objectReturn.put("error", "");
                objectReturn.put("tipo_de_comprobante", tipo_de_comprobante);
                objectReturn.put("serie", serie);
                objectReturn.put("numero", numero);
                return objectReturn;
            } else {
                for (int i = 0; i < lista.size(); i++) {
                    JSONObject object = (JSONObject) lista.get(i);

                    /*
          {
			"unidad_de_medida": "NIU",
			"codigo": "001",
			"descripcion": "DETALLE DEL PRODUCTO",
			"cantidad": 1,
			"valor_unitario": 500,
			"precio_unitario": 590,
			"descuento": "", //opcional
			"subtotal": 500,
			"tipo_de_igv": 1,
			"igv": 90,
			"total": 590,
			"anticipo_regularizacion": false,
			"anticipo_documento_serie": "", //opcional
			"anticipo_documento_numero": "" //opcional
		}
                     */
                    if (object.get("unidad_de_medida") == null || object.get("unidad_de_medida") == "") {
                        objectReturn.put("error", "");
                        objectReturn.put("tipo_de_comprobante", tipo_de_comprobante);
                        objectReturn.put("serie", serie);
                        objectReturn.put("numero", numero);
                        return objectReturn;
                    }
                    if (object.get("codigo") == null || object.get("codigo") == "") {
                        objectReturn.put("error", "");
                        objectReturn.put("tipo_de_comprobante", tipo_de_comprobante);
                        objectReturn.put("serie", serie);
                        objectReturn.put("numero", numero);
                        return objectReturn;
                    }
                    if (object.get("descripcion") == null || object.get("descripcion") == "") {
                        objectReturn.put("error", "");
                        objectReturn.put("tipo_de_comprobante", tipo_de_comprobante);
                        objectReturn.put("serie", serie);
                        objectReturn.put("numero", numero);
                        return objectReturn;
                    }
                    if (object.get("cantidad") == null || object.get("cantidad") == "") {
                        objectReturn.put("error", "");
                        objectReturn.put("tipo_de_comprobante", tipo_de_comprobante);
                        objectReturn.put("serie", serie);
                        objectReturn.put("numero", numero);
                        return objectReturn;
                    }
                    if (object.get("valor_unitario") == null || object.get("valor_unitario") == "") {
                        objectReturn.put("error", "");
                        objectReturn.put("tipo_de_comprobante", tipo_de_comprobante);
                        objectReturn.put("serie", serie);
                        objectReturn.put("numero", numero);
                        return objectReturn;
                    }
                    if (object.get("precio_unitario") == null || object.get("precio_unitario") == "") {
                        objectReturn.put("error", "");
                        objectReturn.put("tipo_de_comprobante", tipo_de_comprobante);
                        objectReturn.put("serie", serie);
                        objectReturn.put("numero", numero);
                        return objectReturn;
                    }
                    if (object.get("subtotal") == null || object.get("subtotal") == "") {
                        objectReturn.put("error", "");
                        objectReturn.put("tipo_de_comprobante", tipo_de_comprobante);
                        objectReturn.put("serie", serie);
                        objectReturn.put("numero", numero);
                        return objectReturn;
                    }
                    if (object.get("tipo_de_igv") == null || object.get("tipo_de_igv") == "") {
                        objectReturn.put("error", "");
                        objectReturn.put("tipo_de_comprobante", tipo_de_comprobante);
                        objectReturn.put("serie", serie);
                        objectReturn.put("numero", numero);
                        return objectReturn;
                    }
                    if (object.get("igv") == null || object.get("igv") == "") {
                        objectReturn.put("error", "");
                        objectReturn.put("tipo_de_comprobante", tipo_de_comprobante);
                        objectReturn.put("serie", serie);
                        objectReturn.put("numero", numero);
                        return objectReturn;
                    }
                    if (object.get("total") == null || object.get("total") == "") {
                        objectReturn.put("error", "");
                        objectReturn.put("tipo_de_comprobante", tipo_de_comprobante);
                        objectReturn.put("serie", serie);
                        objectReturn.put("numero", numero);
                        return objectReturn;
                    }
                    if (object.get("anticipo_regularizacion") == null || object.get("anticipo_regularizacion") == "") {
                        objectReturn.put("error", "");
                        objectReturn.put("tipo_de_comprobante", tipo_de_comprobante);
                        objectReturn.put("serie", serie);
                        objectReturn.put("numero", numero);
                        return objectReturn;
                    }
                }
            }

            objetoCabecera.put("items", lista);

            //ENVIAR EL ARCHIVO A NUBEFACT
            StringEntity parametros = new StringEntity(objetoCabecera.toString(), "UTF-8");
            post.setEntity(parametros);
            HttpResponse response = cliente.execute(post);
            BufferedReader rd = new BufferedReader(new InputStreamReader(response.getEntity().getContent()));
            String linea = "";
            if ((linea = rd.readLine()) != null) {
                JSONParser parsearRsptaJson = new JSONParser();
                JSONObject json_rspta = (JSONObject) parsearRsptaJson.parse(linea);

                // LEER RESPUESTA DE NUBEFACT
                if (json_rspta.get("errors") != null) {
                    objectReturn = json_rspta;
                } else {
                    JSONParser parsearRsptaDetalleOK = new JSONParser();
                    JSONObject json_rspta_ok = (JSONObject) parsearRsptaDetalleOK.parse(json_rspta.toString());

                    objectReturn.put("tipo_de_comprobante", json_rspta_ok.get("tipo_de_comprobante"));
                    objectReturn.put("serie", json_rspta_ok.get("serie"));
                    objectReturn.put("numero", json_rspta_ok.get("numero"));
                    objectReturn.put("enlace", json_rspta_ok.get("enlace"));
                    objectReturn.put("aceptada_por_sunat", json_rspta_ok.get("aceptada_por_sunat"));
                    objectReturn.put("sunat_description", json_rspta_ok.get("sunat_description"));
                    objectReturn.put("sunat_note", json_rspta_ok.get("sunat_note"));
                    objectReturn.put("sunat_responsecode", json_rspta_ok.get("sunat_responsecode"));
                    objectReturn.put("sunat_soap_error", json_rspta_ok.get("sunat_soap_error"));
                    objectReturn.put("pdf_zip_base64", json_rspta_ok.get("pdf_zip_base64"));
                    objectReturn.put("xml_zip_base64", json_rspta_ok.get("xml_zip_base64"));
                    objectReturn.put("cdr_zip_base64", json_rspta_ok.get("cdr_zip_base64"));
                    objectReturn.put("cadena_para_codigo_qr", json_rspta_ok.get("cadena_para_codigo_qr"));
                    objectReturn.put("codigo_hash", json_rspta_ok.get("codigo_hash"));
                    objectReturn.put("codigo_de_barras", json_rspta_ok.get("codigo_de_barras"));
                    objectReturn.put("key", json_rspta_ok.get("key"));
                    objectReturn.put("digest_value", json_rspta_ok.get("digest_value"));
                    objectReturn.put("enlace_del_pdf", json_rspta_ok.get("enlace_del_pdf"));
                    objectReturn.put("enlace_del_xml", json_rspta_ok.get("enlace_del_xml"));
                    objectReturn.put("enlace_del_cdr", json_rspta_ok.get("enlace_del_cdr"));

                    return objectReturn;
                }
            }
        } catch (UnsupportedEncodingException ex1) {
            System.out.println("Error UnsupportedEncodingException: " + ex1.getMessage());
        } catch (IOException ex2) {
            System.out.println("Error IOException: " + ex2.getMessage());
        } catch (Exception ex3) {
            System.out.println("Exepction: " + ex3.getMessage());
        }

        return objectReturn;
    }

    public JSONArray generarComprobante(JSONArray jsonArray, String TOKEN) {
        JSONArray listReturn = null;

        if (jsonArray.size() > 0) {
            for (int i = 0; i < jsonArray.size(); i++) {
                listReturn.add(generarComprobante((JSONObject) jsonArray.get(i), TOKEN));
            }
        } else {
            return listReturn;
        }

        return listReturn;
    }

    public JSONObject anularComprobante(JSONObject jsonObject, String TOKEN) {
        //////////********************************Anular pago *****************************************

        JSONObject objectReturn = new JSONObject();
        JSONObject jsonEstComp = new JSONObject();
        jsonEstComp.put("operacion", "consultar_comprobante");
        jsonEstComp.put("tipo_de_comprobante", jsonObject.get("tipo_de_comprobante"));
        jsonEstComp.put("serie", jsonObject.get("serie"));
        jsonEstComp.put("numero", jsonObject.get("numero"));

//    {
//  "operacion": "consultar_comprobante",
//  "tipo_de_comprobante": "2",
//  "serie": "B001",
//  "numero": "1"
//}
        JSONObject jsonResultadoEstado = new JSONObject();

        jsonResultadoEstado = consultarComprobante(jsonEstComp, TOKEN);
        System.out.println("jsonResultadoEstado Anuladio  ::::::>>>>" + jsonResultadoEstado);
        try {
            if (jsonResultadoEstado.get("aceptada_por_sunat").equals(false)) {
                try {
                    HttpClient cliente = new DefaultHttpClient();
                    HttpPost post = new HttpPost(RUTA);
                    post.addHeader("Authorization", "Token token=" + TOKEN); // Cabecera del token
                    post.addHeader("Content-Type", "application/json"); // Cabecera del Content-Type

                    JSONObject objetoCabecera = new JSONObject(); // Instancear el  segundario

                    String tipo_de_comprobante = "";
                    String serie = "";
                    String numero = "";
                    String motivo = "";
                    String codigo_unico = "";

                    if (jsonObject.containsKey("tipo_de_comprobante")) {
                        tipo_de_comprobante = String.valueOf(jsonObject.get("tipo_de_comprobante"));
                    } else {
                        objectReturn.put("error_so", "Falta campo tipo_de_comprobante");
                        objectReturn.put("tipo_de_comprobante", tipo_de_comprobante);
                        objectReturn.put("serie", serie);
                        objectReturn.put("numero", numero);
                        return objectReturn;
                    }

                    if (jsonObject.containsKey("serie")) {
                        serie = String.valueOf(jsonObject.get("serie"));
                    } else {
                        objectReturn.put("error_so", "Falta campo serie");
                        objectReturn.put("tipo_de_comprobante", tipo_de_comprobante);
                        objectReturn.put("serie", serie);
                        objectReturn.put("numero", numero);
                        return objectReturn;
                    }

                    if (jsonObject.containsKey("numero")) {
                        numero = String.valueOf(jsonObject.get("numero"));
                    } else {
                        objectReturn.put("error_so", "Falta campo numero");
                        objectReturn.put("tipo_de_comprobante", tipo_de_comprobante);
                        objectReturn.put("serie", serie);
                        objectReturn.put("numero", numero);
                        return objectReturn;
                    }

                    if (jsonObject.containsKey("motivo")) {
                        motivo = String.valueOf(jsonObject.get("motivo"));
                    } else {
                        objectReturn.put("error_so", "Falta campo motivo");
                        objectReturn.put("tipo_de_comprobante", tipo_de_comprobante);
                        objectReturn.put("serie", serie);
                        objectReturn.put("numero", numero);
                        return objectReturn;
                    }

                    codigo_unico = String.valueOf(jsonObject.get("codigo_unico"));

                    /*
      1 = FACTURA
      2 = BOLETA
      3 = NOTA DE CRÉDITO
      4 = NOTA DE DÉBITO
                     */
                    if (tipo_de_comprobante == null
                            || tipo_de_comprobante.equals("")
                            || Integer.parseInt((String) tipo_de_comprobante) <= 0
                            || Integer.parseInt((String) tipo_de_comprobante) >= 5) {
                        objectReturn.put("error_so", "validacion de tipo_de_comprobante");
                        objectReturn.put("tipo_de_comprobante", tipo_de_comprobante);
                        objectReturn.put("serie", serie);
                        objectReturn.put("numero", numero);
                        return objectReturn;
                    }
                    if (serie == null
                            || serie.equals("")) {
                        objectReturn.put("error_so", "validacion de serie");
                        objectReturn.put("tipo_de_comprobante", tipo_de_comprobante);
                        objectReturn.put("serie", serie);
                        objectReturn.put("numero", numero);
                        return objectReturn;
                    }
                    if (numero == null
                            || numero.equals("")
                            || Integer.parseInt((String) numero) <= 0) {
                        objectReturn.put("error_so", "validacion de numero");
                        objectReturn.put("tipo_de_comprobante", tipo_de_comprobante);
                        objectReturn.put("serie", serie);
                        objectReturn.put("numero", numero);
                        return objectReturn;
                    }
                    if (motivo == null
                            || motivo.equals("")) {
                        objectReturn.put("error_so", "validacion de motivo");
                        objectReturn.put("tipo_de_comprobante", tipo_de_comprobante);
                        objectReturn.put("serie", serie);
                        objectReturn.put("numero", numero);
                        return objectReturn;
                    }

                    objetoCabecera.put("operacion", "generar_anulacion");
                    objetoCabecera.put("tipo_de_comprobante", tipo_de_comprobante);
                    objetoCabecera.put("serie", serie);
                    objetoCabecera.put("numero", numero);
                    objetoCabecera.put("motivo", motivo);
                    objetoCabecera.put("codigo_unico", codigo_unico);

                    StringEntity parametros = new StringEntity(objetoCabecera.toString(), "UTF-8");
                    post.setEntity(parametros);
                    HttpResponse response = cliente.execute(post);
                    BufferedReader rd = new BufferedReader(new InputStreamReader(response.getEntity().getContent()));
                    String linea = "";
                    if ((linea = rd.readLine()) != null) {
                        JSONParser parsearRsptaJson = new JSONParser();
                        JSONObject json_rspta = (JSONObject) parsearRsptaJson.parse(linea);

                        if (json_rspta.get("errors") != null) {
                            objectReturn = json_rspta;
                            objectReturn.put("error_so", "Error en respuesta de Nubefact");
                        } else {
                            JSONParser parsearRsptaDetalleOK = new JSONParser();
                            JSONObject json_rspta_ok = (JSONObject) parsearRsptaDetalleOK.parse(json_rspta.toString());

                            objectReturn.put("numero", json_rspta_ok.get("numero"));
                            objectReturn.put("enlace", json_rspta_ok.get("enlace"));
                            objectReturn.put("sunat_ticket_numero", json_rspta_ok.get("sunat_ticket_numero"));
                            objectReturn.put("aceptada_por_sunat", json_rspta_ok.get("aceptada_por_sunat"));
                            objectReturn.put("sunat_description", json_rspta_ok.get("sunat_description"));
                            objectReturn.put("sunat_note", json_rspta_ok.get("sunat_note"));
                            objectReturn.put("sunat_responsecode", json_rspta_ok.get("sunat_responsecode"));
                            objectReturn.put("sunat_soap_error", json_rspta_ok.get("sunat_soap_error"));
                            objectReturn.put("pdf_zip_base64", json_rspta_ok.get("pdf_zip_base64"));
                            objectReturn.put("xml_zip_base64", json_rspta_ok.get("xml_zip_base64"));
                            objectReturn.put("cdr_zip_base64", json_rspta_ok.get("cdr_zip_base64"));
                            objectReturn.put("enlace_del_pdf", json_rspta_ok.get("enlace_del_pdf"));
                            objectReturn.put("enlace_del_xml", json_rspta_ok.get("enlace_del_xml"));
                            objectReturn.put("enlace_del_cdr", json_rspta_ok.get("enlace_del_cdr"));
                            objectReturn.put("key", json_rspta_ok.get("key"));

                            return objectReturn;
                        }
                    }
                } catch (UnsupportedEncodingException ex1) {
                    System.out.println("Error UnsupportedEncodingException: " + ex1.getMessage());
                } catch (IOException ex2) {
                    System.out.println("Error IOException: " + ex2.getMessage());
                } catch (IllegalStateException | NumberFormatException | ParseException ex3) {
                    System.out.println("Exepction: " + ex3.getMessage());
                }

            } else {
                objectReturn.put("error_so", "El comprobante no se puede anular");

            }
        } catch (Exception e) {
            objectReturn = jsonResultadoEstado;
        }

        return objectReturn;

        //////////********************************Anular pago *****************************************
    }

    public JSONObject consultarAnulacionComprobante(JSONObject jsonObject, String TOKEN) {
        JSONObject objectReturn = new JSONObject();

        try {
            HttpClient cliente = new DefaultHttpClient();
            HttpPost post = new HttpPost(RUTA);
            post.addHeader("Authorization", "Token token=" + TOKEN); // Cabecera del token
            post.addHeader("Content-Type", "application/json"); // Cabecera del Content-Type

            JSONObject objetoCabecera = new JSONObject();

            String tipo_de_comprobante = "";
            String serie = "";
            String numero = "";

            if (jsonObject.containsKey("tipo_de_comprobante")) {
                tipo_de_comprobante = String.valueOf(jsonObject.get("tipo_de_comprobante"));
            } else {
                objectReturn.put("error_so", "Falta campo tipo_de_comprobante");
                objectReturn.put("tipo_de_comprobante", tipo_de_comprobante);
                objectReturn.put("serie", serie);
                objectReturn.put("numero", numero);
                return objectReturn;
            }

            if (jsonObject.containsKey("serie")) {
                serie = String.valueOf(jsonObject.get("serie"));
            } else {
                objectReturn.put("error_so", "Falta campo serie");
                objectReturn.put("tipo_de_comprobante", tipo_de_comprobante);
                objectReturn.put("serie", serie);
                objectReturn.put("numero", numero);
                return objectReturn;
            }

            if (jsonObject.containsKey("numero")) {
                numero = String.valueOf(jsonObject.get("numero"));
            } else {
                objectReturn.put("error_so", "Falta campo numero");
                objectReturn.put("tipo_de_comprobante", tipo_de_comprobante);
                objectReturn.put("serie", serie);
                objectReturn.put("numero", numero);
                return objectReturn;
            }

            /*
      1 = FACTURA
      2 = BOLETA
      3 = NOTA DE CRÉDITO
      4 = NOTA DE DÉBITO
             */
            if (tipo_de_comprobante == null
                    || tipo_de_comprobante.equals("")
                    || Integer.parseInt((String) tipo_de_comprobante) <= 0
                    || Integer.parseInt((String) tipo_de_comprobante) >= 5) {
                objectReturn.put("error_so", "validacion de tipo_de_comprobante");
                objectReturn.put("tipo_de_comprobante", tipo_de_comprobante);
                objectReturn.put("serie", serie);
                objectReturn.put("numero", numero);
                return objectReturn;
            }
            if (serie == null
                    || serie.equals("")) {
                objectReturn.put("error_so", "validacion de serie");
                objectReturn.put("tipo_de_comprobante", tipo_de_comprobante);
                objectReturn.put("serie", serie);
                objectReturn.put("numero", numero);
                return objectReturn;
            }
            if (numero == null
                    || numero.equals("")
                    || Integer.parseInt(numero) <= 0) {
                objectReturn.put("error_so", "validacion de numero");
                objectReturn.put("tipo_de_comprobante", tipo_de_comprobante);
                objectReturn.put("serie", serie);
                objectReturn.put("numero", numero);
                return objectReturn;
            }

            objetoCabecera.put("operacion", "consultar_anulacion");
            objetoCabecera.put("tipo_de_comprobante", tipo_de_comprobante);
            objetoCabecera.put("serie", serie);
            objetoCabecera.put("numero", numero);

            StringEntity parametros = new StringEntity(objetoCabecera.toString(), "UTF-8");
            post.setEntity(parametros);
            HttpResponse response = cliente.execute(post);
            BufferedReader rd = new BufferedReader(new InputStreamReader(response.getEntity().getContent()));
            String linea = "";
            if ((linea = rd.readLine()) != null) {
                JSONParser parsearRsptaJson = new JSONParser();
                JSONObject json_rspta = (JSONObject) parsearRsptaJson.parse(linea);

                if (json_rspta.get("errors") != null) {
                    objectReturn = json_rspta;
                    objectReturn.put("error_so", "Error en respuesta de Nubefact");
                } else {
                    JSONParser parsearRsptaDetalleOK = new JSONParser();
                    JSONObject json_rspta_ok = (JSONObject) parsearRsptaDetalleOK.parse(json_rspta.toString());

                    objectReturn.put("numero", json_rspta_ok.get("numero"));
                    objectReturn.put("enlace", json_rspta_ok.get("enlace"));
                    objectReturn.put("sunat_ticket_numero", json_rspta_ok.get("sunat_ticket_numero"));
                    objectReturn.put("aceptada_por_sunat", json_rspta_ok.get("aceptada_por_sunat"));
                    objectReturn.put("sunat_description", json_rspta_ok.get("sunat_description"));
                    objectReturn.put("sunat_note", json_rspta_ok.get("sunat_note"));
                    objectReturn.put("sunat_responsecode", json_rspta_ok.get("sunat_responsecode"));
                    objectReturn.put("sunat_soap_error", json_rspta_ok.get("sunat_soap_error"));
                    objectReturn.put("pdf_zip_base64", json_rspta_ok.get("pdf_zip_base64"));
                    objectReturn.put("xml_zip_base64", json_rspta_ok.get("xml_zip_base64"));
                    objectReturn.put("cdr_zip_base64", json_rspta_ok.get("cdr_zip_base64"));
                    objectReturn.put("enlace_del_pdf", json_rspta_ok.get("enlace_del_pdf"));
                    objectReturn.put("enlace_del_xml", json_rspta_ok.get("enlace_del_xml"));
                    objectReturn.put("enlace_del_cdr", json_rspta_ok.get("enlace_del_cdr"));
                    objectReturn.put("key", json_rspta_ok.get("key"));

                    return objectReturn;
                }
            }
        } catch (UnsupportedEncodingException ex1) {
            System.out.println("Error UnsupportedEncodingException: " + ex1.getMessage());
        } catch (IOException ex2) {
            System.out.println("Error IOException: " + ex2.getMessage());
        } catch (IllegalStateException | NumberFormatException | ParseException ex3) {
            System.out.println("Exepction: " + ex3.getMessage());
        }

        return objectReturn;
    }
}
