/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package pe.siso.academia.Services;

import java.util.ArrayList;
import org.json.simple.JSONArray;
import org.json.simple.JSONObject;
import pe.siso.academia.Beans.Cierre;
import pe.siso.academia.Beans.Pension;
import pe.siso.academia.DAO.DAOFactory;
import pe.siso.academia.DAO.PensionDAO;

/**
 *
 * @author sistem08user
 */
public class PensionService {

    DAOFactory fabrica = DAOFactory.getDAOFactory(DAOFactory.MYSQL);
    PensionDAO objPensionDAO = fabrica.getPension();

    public ArrayList<Pension> listarPensiones(int codMatri) {
        ArrayList<Pension> lista = null;
        try {
            lista = objPensionDAO.listarPensionesPorAlumno(codMatri);
        } catch (Exception e) {
            e.printStackTrace();
        }
        return lista;
    }

    public int activarPension(int codPension) {
        int r = 0;
        try {
            r = objPensionDAO.activarPension(codPension);
        } catch (Exception e) {
            e.printStackTrace();
        }
        return r;
    }

    public int anularPension(int codPension, String motivo, int codUsuario, String fecha_actual) {
        int r = 0;
        try {
            r = objPensionDAO.anularPension(codPension, motivo, codUsuario, fecha_actual);
        } catch (Exception e) {
            e.printStackTrace();
        }
        return r;
    }

    public int pagarPension(int codsede, int codPension, int codigoUsuario, String monto, String nomDscto, String montoDscto, String fechaPago, String formaPago, String tipoDoc, String obs, double regu, int num_serie, int num_doc, String razon_social, String ruc, int cod_enlace_desc) {
        int r = 0;
        try {
            r = objPensionDAO.pagarPension(codsede, codPension, codigoUsuario, monto, nomDscto, montoDscto, fechaPago, formaPago, tipoDoc, obs, regu, num_serie, num_doc, razon_social, ruc, cod_enlace_desc);
        } catch (Exception e) {
            e.printStackTrace();
        }
        return r;
    }

    public int devolverPension(int codPension, double monto, double monto_neto, String tipoDoc, String numSerie, String numDoc, String motivo, String cod_usu, String cod_sede, int tipo_nota_credito) {
        int r = 0;
        try {
            r = objPensionDAO.devolverPension(codPension, monto, monto_neto, tipoDoc, numSerie, numDoc, motivo, cod_usu, cod_sede, tipo_nota_credito);
        } catch (Exception e) {
            e.printStackTrace();
        }
        return r;
    }

    public String generarNumBoleta(int codSede) {
        String r = "";
        try {
            r = objPensionDAO.generarNumBoleta(codSede);
        } catch (Exception e) {
            e.printStackTrace();
        }
        return r;
    }

    public int fraccionarPension(int codPagoCuota, String[] monto, String[] posDescuento) {
        int r = 0;
        try {
            r = objPensionDAO.fraccionarPension(codPagoCuota, monto, posDescuento);
        } catch (Exception e) {
            e.printStackTrace();
        }
        return r;
    }

    public boolean verificarPensionesActualizarMatri(int codmatricula) {
        boolean r = false;
        try {
            r = objPensionDAO.verificarPensionesActualizarMatri(codmatricula);
        } catch (Exception e) {
            e.printStackTrace();
        }
        return r;
    }

    public int actualizarPensiones(int codMatricula, String codPen[], String monPen[], String nom_desc, double mon_desc) {
        int r = 0;
        try {
            r = objPensionDAO.actualizarPensiones(codMatricula, codPen, monPen, nom_desc, mon_desc);
        } catch (Exception e) {
            e.printStackTrace();
        }
        return r;
    }

    public Pension obtenerPension(int codPension) {
        Pension p = new Pension();
        try {
            p = objPensionDAO.obtenerPension(codPension);
        } catch (Exception e) {
            e.printStackTrace();
        }
        return p;
    }

    public int duplicarPensionAnulada(int codPagoCuota) {
        int r = 0;
        try {
            r = objPensionDAO.duplicarPensionAnulada(codPagoCuota);
        } catch (Exception e) {
            e.printStackTrace();
        }
        return r;
    }

    public int anularPensionesPorMatricula(int codMatricula, int valueradio, String observ) {
        int r = 0;
        try {
            r = objPensionDAO.anularPensionesPorMatricula(codMatricula, valueradio, observ);
        } catch (Exception e) {
            e.printStackTrace();
        }
        return r;
    }

    public Pension obtenerDetallePension(int codPension) {
        Pension p = new Pension();
        try {
            p = objPensionDAO.obtenerDetalle(codPension);
        } catch (Exception e) {
            e.printStackTrace();
        }
        return p;
    }

    public String imprimirBoletaPago(int codPension) {
        String b = "";
        try {
            b = objPensionDAO.imprimirBoletaPago(codPension);
        } catch (Exception e) {
            e.printStackTrace();
        }
        return b;
    }

    public JSONObject ComprobanteElectronico(int codPension) {
        JSONObject jsonComp = new JSONObject();
        try {
            jsonComp = objPensionDAO.ComprobanteElectronico(codPension);
        } catch (Exception e) {
        }
        return jsonComp;
    }

    public ArrayList<Cierre> AdvertenciaCierreDiario(int codsede) {
        ArrayList<Cierre> lista = new ArrayList<>();
        try {
            lista = objPensionDAO.AdvertenciaCierreDiario(codsede);
        } catch (Exception e) {
        }
        return lista;
    }

    public int habilitarPensionAnulada(int codPagoCuota) {
        int resultado = 0;
        try {
            resultado = objPensionDAO.habilitarPensionAnulada(codPagoCuota);
        } catch (Exception e) {
        }
        return resultado;
    }

    public int guardarDescuento(int codPagoCuota, String nombreDescuento, double montoDescuento, String motivoDescuento, int cod_enlace_dsc) {
        int resultado = 0;
        try {
            resultado = objPensionDAO.guardarDescuento(codPagoCuota, nombreDescuento, montoDescuento, motivoDescuento, cod_enlace_dsc);
        } catch (Exception e) {
        }
        return resultado;
    }

    public int maxMontoFraccionado(int codPagoCuota) {
        int max = 0;
        try {
            max = objPensionDAO.maxMontoFraccionado(codPagoCuota);
        } catch (Exception e) {
        }
        return max;
    }

    public int GuardarUrl(int codCuotaPago, String url, String TipoDocumento) {
        int rs = 0;
        try {
            rs = objPensionDAO.GuardarUrl(codCuotaPago, url, TipoDocumento);
        } catch (Exception e) {
        }
        return rs;
    }

    public JSONObject ComprobanteElectronicoAnular(int codPagoCuota) {
        JSONObject jsonCompAnulado = new JSONObject();
        try {
            jsonCompAnulado = objPensionDAO.ComprobanteElectronicoAnular(codPagoCuota);
        } catch (Exception e) {
        }
        return jsonCompAnulado;
    }

    public JSONArray tipoNotaDeCredito() {
        JSONArray jsonResultado = new JSONArray();
        try {
            jsonResultado = objPensionDAO.tipoNotaDeCredito();
        } catch (Exception e) {
        }
        return jsonResultado;
    }

    public int GuardarJsonErrorNubeFact(JSONObject jsonNubefact,String motivo, int codPagoCuota, String codsede,String estado_nubefact) {
        int resultado = 0;
        try {
            resultado = objPensionDAO.GuardarJsonErrorNubeFact(jsonNubefact, motivo, codPagoCuota, codsede, estado_nubefact);
        } catch (Exception e) {
        }
        return resultado;
    }
     public JSONArray listarBackupErrorNubeFact(){
         JSONArray jsonResultado=new JSONArray();
         try {
             jsonResultado=objPensionDAO.listarBackupErrorNubeFact();
         } catch (Exception e) {
         }
         return jsonResultado;
     }
}
