
package pe.siso.academia.Servlets;

import java.io.IOException;
import java.io.PrintWriter;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import pe.siso.academia.Beans.Aula;
import pe.siso.academia.Beans.Monto;
import pe.siso.academia.Beans.Pension;
import pe.siso.academia.Beans.Sede;
import pe.siso.academia.Services.AulaService;
import pe.siso.academia.Services.MontoService;
import pe.siso.academia.Services.SedeService;

public class ServletAula extends HttpServlet {

    @Override
     protected void service(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
        String param=request.getParameter("accion");
        if("listarAulas".equals(param)){
            listarAulas(request, response);
        }
        else if("listarAulasFiltradas".equals(param)){
            listarAulasFiltradas(request, response);
        }
        else if("generarFormNuevaAula".equals(param)){
            generarFormNuevaAula(request, response);
        }
        else if("generarFormNuevaSeccion".equals(param)){
            generarFormNuevaSeccion(request, response);
        }
        else if("generarCmbNivel".equals(param)){
            listarCmbNivel(request, response);
        }
        else if("generarCmbTipoGrado".equals(param)){
            listarCmbTipoGrado(request, response);
        }
        else if("generarCmbGrado".equals(param)){
            listarCmbGrado(request, response);
        }
        else if("generarCmbTurno".equals(param)){
            listarCmbTurno(request, response);
        }
        else if("insertarAula".equals(param)){
            insertarAula(request, response);
        }
        else if("insertarSeccion".equals(param)){
            insertarSeccion(request, response);
        }
        else if("cambiarEstadoAula".equals(param)){
            cambiarEstadoAula(request, response);
        }
        else if("cambiarEstadoSeccion".equals(param)){
            cambiarEstadoSeccion(request, response);
        }
        else if("cerrarCiclo".equals(param)){
            cerrarCiclo(request, response);
        }else if("generarFormEditarAula".equals(param)){
            generarFormEditarAula(request, response);
        }else if("Agregar1Pension".equals(param)){
            Agregar1Pension(request,response);
        }else if ("EditarquitarPension".equals(param)){
            EditarquitarPension(request, response);
        }else if("EditarAula".equals(param)){
            EditarAula(request, response);
        }
    }

    private void listarAulas(HttpServletRequest request, HttpServletResponse response) throws IOException {
        Date fechaActual = new Date();
        SimpleDateFormat formateador = new SimpleDateFormat("dd/MM/yyyy");
        Date fechaDate1 = null;
        Date fechaDate2 = null;
        int pagina = Integer.parseInt(request.getParameter("pag"));
        int codsede = Integer.parseInt(request.getParameter("sede"));
        int cantPorPagina = 20;
        int cantidadRegistros = 0;
        int cantidadPaginas = 0;
        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        ArrayList<Aula> lista = null;
        AulaService servicio = new AulaService();
        lista = servicio.listarAulas( codsede, (pagina*cantPorPagina)-cantPorPagina, cantPorPagina );
        cantidadRegistros = servicio.contarAulas(codsede);
        cantidadPaginas = cantidadRegistros/cantPorPagina;
        pw.println("    <div class=\"col-md-12\">\n" +
"                            <div class=\"panel\">\n" +
"                                <div class=\"panel-heading-saco\">\n" +
"                                    <h3 class=\"panel-title pull-left\">Lista de Ciclos</h3>\n" +
"                                    <span class=\"pull-right\" style=\"display: block;\">\n" +
"                                        <button class=\"btn btn-saco\" onclick=\"mostrarAgregar();\">  \n" +
"                                            <i class=\"fa fa-plus-circle\"></i> Agregar Ciclo\n" +
"                                        </button>\n" +
"                                    </span>\n" +
"                                    <div style=\"clear: both;\"></div> \n" +
"                                </div>\n" +
"                                <div class=\"panel-body no-padding\"> \n" +
"                                    <!-- Start sample table -->\n" +
"                                    <div class=\"table rounded mb-20\" id=\"imprimirTablaAula\"> \n" +
"                                        <table class=\"table table-striped table-saco\" style=\"border: 1px solid rgb(198, 198, 198); border-image: none; font-size: 11px;\">\n" +
"                                            <thead>\n" +
"                                                <tr>\n" +
"                                                    <th class=\"text-center border-right\">No.</th>\n" +
"                                                    <th class=\"text-center\">Sede</th>\n" +
"                                                    <th class=\"text-center\">Centro</th>\n" +
"                                                    <th class=\"text-center\">Ciclo</th>\n" +
"                                                    <th class=\"text-center\">Tipo de Grado</th>\n" +
"                                                    <th class=\"text-center\">Universidad</th>\n" +
"                                                    <th class=\"text-center\">Turno</th>\n" +
"                                                    <th class=\"text-center\">Fecha de Inicio</th>\n" +
"                                                    <th class=\"text-center\">Fecha de Cese</th>\n" +
"                                                    <th class=\"text-center\">Sec.</th>\n" +
"                                                    <th class=\"text-center\" width=\"100\">Acciones</th>\n" +
"                                                </tr>\n" +
"                                            </thead>\n" +
"                                            <tbody>\n");
        
        if(lista.size()==0){
            pw.println("<tr><td colspan='7'>No se encontraron registros.</td></tr>");
        }
        for(int i = 0; i<lista.size();i++){
            //Estado
            switch(lista.get(i).getEstado().trim()){
                case "0":
                    lista.get(i).setEstado("DESACTIVADO");
                    break;
                case "1":
                    lista.get(i).setEstado("ACTIVADO");
                    break;
                default:
                    lista.get(i).setEstado("-1");
                    break;
            }
            //FECHAS
            String fechaI[] = lista.get(i).getFechaInicio().split("-");
            lista.get(i).setFechaInicio(fechaI[2] + "/" + fechaI[1] + "/" + fechaI[0]);
            String fechaF[] = lista.get(i).getFechaTermino().split("-");
            lista.get(i).setFechaTermino(fechaF[2] + "/" + fechaF[1] + "/" + fechaF[0]);
            pw.println("<tr>\n");
            pw.println("    <td>" + (((pagina-1)*cantPorPagina)+1+i) + "</td>\n");
            pw.println("    <td>" + lista.get(i).getNomSede() + "</td>\n");
            pw.println("    <td>" + lista.get(i).getNomCentro() + "</td>\n");
            pw.println("    <td>" + lista.get(i).getNomNivel() + "</td>\n");
            pw.println("    <td>" + lista.get(i).getNomTipoGrado() + "</td>\n");
            pw.println("    <td>" + lista.get(i).getNomGrado() + "</td>\n");
            pw.println("    <td>" + lista.get(i).getNomTurno() + "</td>\n");
            pw.println("    <td>" + lista.get(i).getFechaInicio() + "</td>\n");
            pw.println("    <td>" + lista.get(i).getFechaTermino() + "</td>\n");
            pw.println("    <td>" + lista.get(i).getSecciones() + "</td>\n");
            pw.println("    <td>");
            if(lista.get(i).getEstado().trim() != "-1"){
                if(lista.get(i).getEstado().trim() == "ACTIVADO"){
                    pw.println("        <a data-original-title=\"Desactivar\" data-toggle=\"tooltip\" data-placement=\"top\" href=\"javascript:void();\" onclick=\"frmDesactivar(" + lista.get(i).getCodAula() + ");\"><i class=\"fa fa-lightbulb-o bigger-140 green\"></i></a>");
                }
                else{
                    pw.println("        <a data-original-title=\"Activar\" data-toggle=\"tooltip\" data-placement=\"top\" href=\"javascript:void();\" onclick=\"frmActivar(" + lista.get(i).getCodAula() + ");\"><i class=\"fa fa-lightbulb-o bigger-140 red\"></i></a>");
                }
                pw.println("        <a data-original-title=\"Editar\" data-toggle=\"tooltip\" data-placement=\"top\" href=\"javascript:void();\" onclick=\"mostrarEditar(" + lista.get(i).getCodAula()+","+lista.get(i).getCodSede()+","+lista.get(i).getCodCentro()+","+lista.get(i).getCodNivel()+","+lista.get(i).getCodTipoGrado()+","+lista.get(i).getCodGrado()+","+lista.get(i).getCodTurno()+",'"+lista.get(i).getFechaInicio()+"','"+lista.get(i).getFechaTermino()+"','"+lista.get(i).getTipoSeccion()+"',"+lista.get(i).getCantMatriculados()+",'"+lista.get(i).getEstado()+"');\"><i class=\"fa fa-pencil-square-o bigger-140 blue\"></i></a>");
                try {
                    fechaDate1 = formateador.parse(lista.get(i).getFechaTermino());
                    fechaDate2 = formateador.parse(formateador.format(fechaActual));
                } catch (Exception e) {
                    //System.out.println(e.getMessage());
                }
                if ( fechaDate1.before(fechaDate2) ){
                    pw.println("        <a data-original-title=\"Cerrar Ciclo\" data-toggle=\"tooltip\" data-placement=\"top\" href=\"javascript:void();\" onclick=\"frmCerrarCiclo(" + lista.get(i).getCodAula() + ");\"><i class=\"fa fa-times bigger-140 red\"></i></a>");
                }
                pw.println("        <a data-original-title=\"Mantenimiento de Secciones\" data-toggle=\"tooltip\" data-placement=\"top\" href=\"javascript:void();\" onclick=\"frmSecciones(" + lista.get(i).getCodAula() + ");\"><i class=\"fa fa-bars bigger-140 blue\"></i></a>");
            }
            else{
                pw.println("<p class=\"label blue\">Sin acción</p>");
            }
            pw.println("    </td>\n");
            pw.println("</tr>\n");
            
            
            
            
        }

pw.println("                         </tbody>\n" +
"                                        </table>\n" );

pw.println("<div class=\"col-xs-12\" style=\"border-right-color: rgb(198, 198, 198); border-bottom-color: rgb(198, 198, 198); border-left-color: rgb(198, 198, 198); border-right-width: 1px; border-bottom-width: 1px; border-left-width: 1px; border-right-style: solid; border-bottom-style: solid; border-left-style: solid; background-color: rgb(239, 243, 248);\">                                              \n" +
"                                            <div class=\"col-xs-7\">\n" +
"                                                <div class=\"dataTables_paginate paging_simple_numbers\" id=\"datatable-ajax_paginate\">\n" +
"                                                    <ul class=\"pagination\">  \n" );
if(pagina==1){
    pw.println("<li tabindex=\"0\" class=\"paginate_button previous disabled\" id=\"sample-table-2_previous\" aria-controls=\"sample-table-2\"> <a> &lt;&lt; </a></li>\n" );
}
else{
    pw.println("<li tabindex=\"0\" class=\"paginate_button previous\" id=\"sample-table-2_previous\" aria-controls=\"sample-table-2\"> <a href=\"javascript:listarAulas('1');\"> &lt;&lt; </a></li>\n" );
}
if(pagina>1){
    pw.println("<li tabindex=\"0\" class=\"paginate_button previous\" id=\"sample-table-2_previous\" aria-controls=\"sample-table-2\"> <a href=\"javascript:listarAulas('"+(pagina-1)+"');\">Anterior</a></li>\n" );
}
else{
    pw.println("<li tabindex=\"0\" class=\"paginate_button previous disabled\" id=\"sample-table-2_previous\" aria-controls=\"sample-table-2\"> <a>Anterior</a></li>\n" );
}


for(int x=1;x<=(cantidadPaginas+1);x++){
    if(x>=(pagina-0) && x<=(pagina+4)){
        if(pagina==x){
            pw.println("<li tabindex=\"0\" class=\"paginate_button active\" aria-controls=\"sample-table-2\"><a href=\"javascript:void(0);\">"+x+"</a></li>\n" );
        }
        else{
            pw.println("<li tabindex=\"0\" class=\"paginate_button\" aria-controls=\"sample-table-2\"><a href=\"javascript:listarAulas('"+x+"');\">"+x+"</a></li>\n" );
        }
    }
}
if(pagina<(cantidadPaginas+1)){
    pw.println("<li tabindex=\"0\" class=\"paginate_button next\" id=\"sample-table-2_next\" aria-controls=\"sample-table-2\"> <a href=\"javascript:listarAulas('"+(pagina+1)+"');\">Siguiente</a></li>\n" );
    pw.println("<li tabindex=\"0\" class=\"paginate_button next\" id=\"sample-table-2_next\" aria-controls=\"sample-table-2\"> <a href=\"javascript:listarAulas('"+(cantidadPaginas+1)+"');\"> &gt;&gt; </a></li>\n" );
}
else{
    pw.println("<li tabindex=\"0\" class=\"paginate_button next disabled\" id=\"sample-table-2_next\" aria-controls=\"sample-table-2\"> <a>Siguiente</a></li>\n" );
    pw.println("<li tabindex=\"0\" class=\"paginate_button next disabled\" id=\"sample-table-2_next\" aria-controls=\"sample-table-2\"> <a> &gt;&gt; </a></li>\n" );
}

pw.println("                                                    </ul>                                                  \n" +
"                                                </div>                                             \n" +
"                                            </div>                                              \n" +
"                                            <div class=\"col-xs-5\">\n" +
"                                                <table style=\"width: 100%; height: 72px;\" border=\"0\">\n" +
"                                                    <tbody>\n" +
"                                                        <tr>                                                          \n" +
"                                                            <td style=\"text-align: right; vertical-align: middle; background-color: transparent!important;\">Mostrando del "+((pagina*cantPorPagina)-cantPorPagina+1)+" al "+((pagina*cantPorPagina))+" de "+cantidadRegistros+" ciclos</td> \n" +
"                                                        </tr> \n" +
"                                                    </tbody>\n" +
"                                                </table>\n" +
"                                            </div>  \n" +
"                                        </div>");

pw.println("                                    </div><!-- /.table -->\n" +
"                                    <!--/ End sample table -->\n" +
"                                </div>\n" +
"                            </div>\n" +
"                        </div>");
    }
    
    private void listarAulasFiltradas(HttpServletRequest request, HttpServletResponse response) throws IOException {
        /*== OBTENER FILTROS ==*/
        int tipo = Integer.parseInt(request.getParameter("tipo"));
        String fecha1 = request.getParameter("fecha1");
        String fecha2 = request.getParameter("fecha2");
        int codsede = Integer.parseInt(request.getParameter("sede"));
        
        /*== FIN OBTENER FILTROS ==*/
        
        Date fechaActual = new Date();
        SimpleDateFormat formateador = new SimpleDateFormat("dd/MM/yyyy");
        Date fechaDate1 = null;
        Date fechaDate2 = null;
        int pagina = Integer.parseInt(request.getParameter("pag"));
        int cantPorPagina = 20;
        int cantidadRegistros = 0;
        int cantidadPaginas = 0;
        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        ArrayList<Aula> lista = null;
        AulaService servicio = new AulaService();
        switch(tipo){
            case 2:
                lista = servicio.listarAulasPorInicio(codsede,fecha1, fecha2, (pagina*cantPorPagina)-cantPorPagina, cantPorPagina );
                cantidadRegistros = servicio.contarAulasPorInicio(codsede,fecha1, fecha2);
                break;
            case 3:
                lista = servicio.listarAulasPorCese(codsede,fecha1, fecha2, (pagina*cantPorPagina)-cantPorPagina, cantPorPagina );
                cantidadRegistros = servicio.contarAulasPorCese(codsede,fecha1, fecha2);
                break;
            default:
                lista = servicio.listarAulas(codsede, (pagina*cantPorPagina)-cantPorPagina, cantPorPagina );
                cantidadRegistros = servicio.contarAulas(codsede);
                break;
        }
        cantidadPaginas = cantidadRegistros/cantPorPagina;
        pw.println("    <div class=\"col-md-12\">\n" +
"                            <div class=\"panel\">\n" +
"                                <div class=\"panel-heading-saco\">\n" +
"                                    <h3 class=\"panel-title pull-left\">Lista de Ciclos</h3>\n" +
"                                    <span class=\"pull-right\" style=\"display: block;\">\n" +
"                                        <button class=\"btn btn-saco\" onclick=\"mostrarAgregar();\">  \n" +
"                                            <i class=\"fa fa-plus-circle\"></i> Agregar Ciclo\n" +
"                                        </button>\n" +
"                                    </span>\n" +
"                                    <div style=\"clear: both;\"></div> \n" +
"                                </div>\n" +
"                                <div class=\"panel-body no-padding\"> \n" +
"                                    <!-- Start sample table -->\n" +
"                                    <div class=\"table rounded mb-20\" id=\"imprimirTablaAula\"> \n" +
"                                        <table class=\"table table-striped table-saco\" style=\"border: 1px solid rgb(198, 198, 198); border-image: none; font-size: 11px;\">\n" +
"                                            <thead>\n" +
"                                                <tr>\n" +
"                                                    <th class=\"text-center border-right\">No.</th>\n" +
"                                                    <th class=\"text-center\">Sede</th>\n" +
"                                                    <th class=\"text-center\">Centro</th>\n" +
"                                                    <th class=\"text-center\">Nivel</th>\n" +
"                                                    <th class=\"text-center\">Tipo de Grado</th>\n" +
"                                                    <th class=\"text-center\">Grado</th>\n" +
"                                                    <th class=\"text-center\">Turno</th>\n" +
"                                                    <th class=\"text-center\">Fecha de Inicio</th>\n" +
"                                                    <th class=\"text-center\">Fecha de Cese</th>\n" +
"                                                    <th class=\"text-center\">Sec.</th>\n" +
"                                                    <th class=\"text-center\" width=\"100\">Acciones</th>\n" +
"                                                </tr>\n" +
"                                            </thead>\n" +
"                                            <tbody>\n");
        
        if(lista.size()==0){
            pw.println("<tr><td colspan='7'>No se encontraron registros.</td></tr>");
        }
        for(int i = 0; i<lista.size();i++){
            //Estado
            switch(lista.get(i).getEstado().trim()){
                case "0":
                    lista.get(i).setEstado("DESACTIVADO");
                    break;
                case "1":
                    lista.get(i).setEstado("ACTIVADO");
                    break;
                default:
                    lista.get(i).setEstado("-1");
                    break;
            }
            //FECHAS
            String fechaI[] = lista.get(i).getFechaInicio().split("-");
            lista.get(i).setFechaInicio(fechaI[2] + "/" + fechaI[1] + "/" + fechaI[0]);
            String fechaF[] = lista.get(i).getFechaTermino().split("-");
            lista.get(i).setFechaTermino(fechaF[2] + "/" + fechaF[1] + "/" + fechaF[0]);
            pw.println("<tr>\n");
            pw.println("    <td>" + (((pagina-1)*cantPorPagina)+1+i) + "</td>\n");
            pw.println("    <td>" + lista.get(i).getNomSede() + "</td>\n");
            pw.println("    <td>" + lista.get(i).getNomCentro() + "</td>\n");
            pw.println("    <td>" + lista.get(i).getNomNivel() + "</td>\n");
            pw.println("    <td>" + lista.get(i).getNomTipoGrado() + "</td>\n");
            pw.println("    <td>" + lista.get(i).getNomGrado() + "</td>\n");
            pw.println("    <td>" + lista.get(i).getNomTurno() + "</td>\n");
            pw.println("    <td>" + lista.get(i).getFechaInicio() + "</td>\n");
            pw.println("    <td>" + lista.get(i).getFechaTermino() + "</td>\n");
            pw.println("    <td>" + lista.get(i).getSecciones() + "</td>\n");
            pw.println("    <td>");
            if(lista.get(i).getEstado().trim() != "-1"){
                if(lista.get(i).getEstado().trim() == "ACTIVADO"){
                    pw.println("        <a data-original-title=\"Desactivar\" data-toggle=\"tooltip\" data-placement=\"top\" href=\"javascript:void();\" onclick=\"frmDesactivar(" + lista.get(i).getCodAula() + ");\"><i class=\"fa fa-lightbulb-o bigger-140 green\"></i></a>");
                }
                else{
                    pw.println("        <a data-original-title=\"Activar\" data-toggle=\"tooltip\" data-placement=\"top\" href=\"javascript:void();\" onclick=\"frmActivar(" + lista.get(i).getCodAula() + ");\"><i class=\"fa fa-lightbulb-o bigger-140 red\"></i></a>");
                }
                pw.println("        <a data-original-title=\"Editar\" data-toggle=\"tooltip\" data-placement=\"top\" href=\"javascript:void();\" onclick=\"frmEditar(" + lista.get(i).getCodAula() + ");\"><i class=\"fa fa-pencil-square-o bigger-140 blue\"></i></a>");
                try {
                    fechaDate1 = formateador.parse(lista.get(i).getFechaTermino());
                    fechaDate2 = formateador.parse(formateador.format(fechaActual));
                } catch (Exception e) {
                    //System.out.println(e.getMessage());
                }
                if ( fechaDate1.before(fechaDate2) ){
                    pw.println("        <a data-original-title=\"Cerrar Ciclo\" data-toggle=\"tooltip\" data-placement=\"top\" href=\"javascript:void();\" onclick=\"frmCerrarCiclo(" + lista.get(i).getCodAula() + ");\"><i class=\"fa fa-times bigger-140 red\"></i></a>");
                }
                pw.println("        <a data-original-title=\"Mantenimiento de Secciones\" data-toggle=\"tooltip\" data-placement=\"top\" href=\"javascript:void();\" onclick=\"frmSecciones(" + lista.get(i).getCodAula() + ");\"><i class=\"fa fa-bars bigger-140 blue\"></i></a>");
            }
            else{
                pw.println("<p class=\"label blue\">Sin acción</p>");
            }
            pw.println("    </td>\n");
            pw.println("</tr>\n");
            
            
            
            
        }

pw.println("                         </tbody>\n" +
"                                        </table>\n" );

pw.println("<div class=\"col-xs-12\" style=\"border-right-color: rgb(198, 198, 198); border-bottom-color: rgb(198, 198, 198); border-left-color: rgb(198, 198, 198); border-right-width: 1px; border-bottom-width: 1px; border-left-width: 1px; border-right-style: solid; border-bottom-style: solid; border-left-style: solid; background-color: rgb(239, 243, 248);\">                                              \n" +
"                                            <div class=\"col-xs-7\">\n" +
"                                                <div class=\"dataTables_paginate paging_simple_numbers\" id=\"datatable-ajax_paginate\">\n" +
"                                                    <ul class=\"pagination\">  \n" );
if(pagina==1){
    pw.println("<li tabindex=\"0\" class=\"paginate_button previous disabled\" id=\"sample-table-2_previous\" aria-controls=\"sample-table-2\"> <a> &lt;&lt; </a></li>\n" );
}
else{
    pw.println("<li tabindex=\"0\" class=\"paginate_button previous\" id=\"sample-table-2_previous\" aria-controls=\"sample-table-2\"> <a href=\"javascript:listarMatriculas('1');\"> &lt;&lt; </a></li>\n" );
}
if(pagina>1){
    pw.println("<li tabindex=\"0\" class=\"paginate_button previous\" id=\"sample-table-2_previous\" aria-controls=\"sample-table-2\"> <a href=\"javascript:listarMatriculas('"+(pagina-1)+"');\">Anterior</a></li>\n" );
}
else{
    pw.println("<li tabindex=\"0\" class=\"paginate_button previous disabled\" id=\"sample-table-2_previous\" aria-controls=\"sample-table-2\"> <a>Anterior</a></li>\n" );
}


for(int x=1;x<=(cantidadPaginas+1);x++){
    if(x>=(pagina-0) && x<=(pagina+4)){
        if(pagina==x){
            pw.println("<li tabindex=\"0\" class=\"paginate_button active\" aria-controls=\"sample-table-2\"><a href=\"javascript:void(0);\">"+x+"</a></li>\n" );
        }
        else{
            pw.println("<li tabindex=\"0\" class=\"paginate_button\" aria-controls=\"sample-table-2\"><a href=\"javascript:listarMatriculas('"+x+"');\">"+x+"</a></li>\n" );
        }
    }
}
if(pagina<(cantidadPaginas+1)){
    pw.println("<li tabindex=\"0\" class=\"paginate_button next\" id=\"sample-table-2_next\" aria-controls=\"sample-table-2\"> <a href=\"javascript:listarMatriculas('"+(pagina+1)+"');\">Siguiente</a></li>\n" );
    pw.println("<li tabindex=\"0\" class=\"paginate_button next\" id=\"sample-table-2_next\" aria-controls=\"sample-table-2\"> <a href=\"javascript:listarMatriculas('"+(cantidadPaginas+1)+"');\"> &gt;&gt; </a></li>\n" );
}
else{
    pw.println("<li tabindex=\"0\" class=\"paginate_button next disabled\" id=\"sample-table-2_next\" aria-controls=\"sample-table-2\"> <a>Siguiente</a></li>\n" );
    pw.println("<li tabindex=\"0\" class=\"paginate_button next disabled\" id=\"sample-table-2_next\" aria-controls=\"sample-table-2\"> <a> &gt;&gt; </a></li>\n" );
}

pw.println("                                                    </ul>                                                  \n" +
"                                                </div>                                             \n" +
"                                            </div>                                              \n" +
"                                            <div class=\"col-xs-5\">\n" +
"                                                <table style=\"width: 100%; height: 72px;\" border=\"0\">\n" +
"                                                    <tbody>\n" +
"                                                        <tr>                                                          \n" +
"                                                            <td style=\"text-align: right; vertical-align: middle; background-color: transparent!important;\">Mostrando del "+((pagina*cantPorPagina)-cantPorPagina+1)+" al "+((pagina*cantPorPagina))+" de "+cantidadRegistros+" ciclos</td> \n" +
"                                                        </tr> \n" +
"                                                    </tbody>\n" +
"                                                </table>\n" +
"                                            </div>  \n" +
"                                        </div>");

pw.println("                                    </div><!-- /.table -->\n" +
"                                    <!--/ End sample table -->\n" +
"                                </div>\n" +
"                            </div>\n" +
"                        </div>");
    }
    
    private void generarFormNuevaAula(HttpServletRequest request, HttpServletResponse response) throws IOException {
        SedeService servicioSede = new SedeService();
        MontoService servicioMonto = new MontoService();
        ArrayList<Sede> listaSede = new ArrayList<>();
        ArrayList<Monto> listaMonto = new ArrayList<>();
        listaSede = servicioSede.listarSedesActivas();
        listaMonto = servicioMonto.listarCentros("", 0, 1000);
        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        
        pw.println("<form id=\"form-nuevo\"><div class=\"form-body\">\n" +
"                                            <fieldset>\n" +
"                                                \n" +
"                                                <div class=\"form-group col-sm-6\" id=\"txtFiltro\">\n" +
"                                                    <label class=\"control-label\" id=\"etiqueta-busqueda\"><b><span class=\"etiqueta\">Centro</span>: <span class=\"asterisk\">(*)</span></b></label>\n" +
"                                                    <select class=\"form-control validate[required]\" id=\"centro\" onchange=\"listarNiveles();\">\n" );
        pw.println("                                    <option value=\"\">[SELECCIONE]</option>");
        for (int i = 0; i < listaMonto.size(); i++) {
            pw.println("                                <option value=\"" + listaMonto.get(i).getCodCentro() + "\">" + listaMonto.get(i).getNomCentro()+ "</option>");
        }
        pw.println("                                 </select>\n" +
"                                                </div>\n" +
"                                                <div class=\"form-group col-sm-6\" id=\"cmbNivel\">\n" +
"                                                    <label class=\"control-label\" id=\"etiqueta-busqueda\"><b><span class=\"etiqueta\">Nivel</span>: <span class=\"asterisk\">(*)</span></b></label>\n " +
"                                                    <select class=\"form-control validate[required]\" id=\"nivel\" onchange=\"listarTipoGrados();\"><option value=\"\">[SELECCIONE]</option></select> \n" +
"                                                </div>\n" +
"                                                <div class=\"form-group col-sm-6\" id=\"cmbTipoGrado\">\n" +
"                                                    <label class=\"control-label\" id=\"etiqueta-busqueda\"><b><span class=\"etiqueta\">Tipo Grado</span>: <span class=\"asterisk\">(*)</span></b></label>\n" +
"                                                    <select class=\"form-control validate[required]\" id=\"tipoGrado\" onchange=\"listarGrados();\"><option value=\"\">[SELECCIONE]</option></select> \n" +
"                                                </div>\n" +
"                                                <div class=\"form-group col-sm-6\" id=\"cmbGrado\">\n" +
"                                                    <label class=\"control-label\" id=\"etiqueta-busqueda\"><b><span class=\"etiqueta\">Grado</span>: <span class=\"asterisk\">(*)</span></b></label>\n" +
"                                                    <select class=\"form-control validate[required]\" id=\"grado\"><option value=\"\">[SELECCIONE]</option></select> \n" +
"                                                </div>\n" +
"                                                <div class=\"form-group col-sm-6\" id=\"cmbTurno\">\n" +
"                                                    <label class=\"control-label\" id=\"etiqueta-busqueda\"><b><span class=\"etiqueta\">Turno</span>: <span class=\"asterisk\">(*)</span></b></label>\n" +
"                                                    <select class=\"form-control validate[required]\" id=\"turno\"><option value=\"\">[SELECCIONE]</option></select> \n" +
"                                                </div>\n" +
"                                                <div class=\"form-group col-sm-6\" id=\"txtFiltro\">\n" +
"                                                    <label class=\"control-label\" id=\"etiqueta-busqueda\"><b><span class=\"etiqueta\">Fechas de Duración</span>: <span class=\"asterisk\">(*)</span></b></label>\n" +
"                                                    <div id=\"Rfecha\"><input type=\"text\" class=\"form-control date-range-picker-double-Top validate[required]\" id=\"fechaRango\" value=\"\"></div>\n" +
"                                                </div>\n" +
"                                                <div class=\"form-group col-sm-6\" id=\"txtFiltro\">\n" +
"                                                    <label class=\"control-label\" id=\"etiqueta-busqueda\"><b><span class=\"etiqueta\">Tipo Sección</span>: <span class=\"asterisk\">(*)</span></b></label>\n" +
"                                                    <select class=\"form-control validate[required]\" id=\"tiposeccion\"><option value=\"1\">A, B, C, ...</option><option value=\"2\">I, II, III, ...</option><option value=\"3\">1, 2, 3, ...</option></select> \n" +
"                                                </div>"
                + "                                 <div class=\"form-group col-md-12\">       <br>          \n" +
"                                                            <div class=\"text-right\"><b><span class=\"asterisk\">(*)</span> Campo Obligatorio</b>\n" +
"                                                            </div>         \n" +
"                                                        </div>\n" +
"                                                \n" +
"                                                <div class=\"row\" id=\"pensiones\"><div class=\"col-md-12\">\n" +
"                                                   <table id=\"pensiones-table\" class=\"table table-striped table-saco\" style=\"border: 1px solid rgb(198, 198, 198); border-image: none; font-size: 11px;\"><thead><tr><th>Descripcion</th><th>Monto</th><th>Fecha Caducidad</th><th width=\"150\"><button type=\"button\" onclick=\"agregarFila();\" class=\"btn btn-foursquare\">Agregar Pension</button></th></tr></thead><tbody id=\"pensionesRows\">\n" +
"                                                   <tr>\n" +
"                                                   <td><input type=\"text\" class=\"input-oculto validate[required]\"></td>\n" +
"                                                   <td><input id=\"MontoPension\" type=\"number\" class=\"input-oculto validate[required]\"></td>\n" +
"                                                   <td><input id=\"Fecha_i\" type=\"text\" class=\"input-oculto date-range-picker-single-Top validate[required]\"></td>\n" +
"                                                   <td class=\"text-center\"><a class=\"remove\" ><i class=\"fa fa-ban bigger-140 red\"></i></a></td>" +
"                                                   </tr>\n" +
"                                                   </tbody></table> \n" +
"                                                   </div></div>" +
"                                            </fieldset>\n" +
"                                        </div><!-- /.form-body --></form>\n" +
"                                        <div class=\"form-footer\">\n" +
"                                            <div class=\"pull-right\">\n" +
"                                                <button class=\"btn btn-foursquare\" type=\"button\" onclick=\"agregar();\" ><i class=\"fa fa-plus\"></i> AGREGAR</button>\n" +
"                                                <button class=\"btn btn-warning\"  onclick=\"window.location='man_aulas.jsp'\" ><i class=\"fa fa-times\"></i> CANCELAR</button>\n" +
"                                            </div>\n" +
"                                            <div class=\"clearfix\"></div>\n" +
"                                        </div>");
    }
    
    private void generarFormNuevaSeccion(HttpServletRequest request, HttpServletResponse response) throws IOException {
        int contador = 0;
        int codAula = Integer.parseInt(request.getParameter("codaula"));
        int tipoSeccion = 0;
        ArrayList<Aula> lista = new ArrayList<>();
        AulaService servicio = new AulaService();
        tipoSeccion = servicio.obtenerTipoSeccion(codAula);
        lista = servicio.listarSeccionesPorAula(codAula);
        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        
        pw.println("<form id=\"form-nuevo\"><div class=\"form-body\">\n" +
"                                            <fieldset>\n" +
"                                                <div class=\"form-group col-sm-10\">\n" +
"                                                   <table id=\"secciones-table\" class=\"table table-striped table-saco\" style=\"border: 1px solid rgb(198, 198, 198); border-image: none; font-size: 11px;\">" +
"                                                       <thead>" +
"                                                           <tr><th class=\"text-center\">Seccion</th>"
                + "                                             <th class=\"text-center\">Acciones</th>"
                + "                                         </tr>" +
"                                                       </thead>" +
"                                                       <tbody>" );
        for (int i = 0; i < lista.size(); i++) {
            if(Integer.parseInt(lista.get(i).getEstSeccion().trim())==1){
                pw.println("                                    <tr><td class=\"text-center\">" + lista.get(i).getNomSeccion() + "</td>"
                        + "                                         <td class=\"text-center\"><a data-original-title=\"Deshabilitar Sección\" data-toggle=\"tooltip\" data-placement=\"top\" href=\"javascript:void();\" onclick=\"cambiarEstadoSeccion(" + lista.get(i).getCodSeccion() + ",0," + codAula + ");\"><i class=\"fa fa-power-off bigger-140 green\"></i></a></td>"
                        + "                                     </tr>");
            }
            else{
                pw.println("                                    <tr><td class=\"text-center\">" + lista.get(i).getNomSeccion() + "</td>"
                        + "                                         <td class=\"text-center\"><a data-original-title=\"Habilitar Sección\" data-toggle=\"tooltip\" data-placement=\"top\" href=\"javascript:void();\" onclick=\"cambiarEstadoSeccion(" + lista.get(i).getCodSeccion() + ",1," + codAula + ");\"><i class=\"fa fa-power-off bigger-140 red\"></i></a></td>"
                        + "                                     </tr>");
            }
            
        }
        pw.println("                                    </tbody>" +
"                                                   </table>\n" +
"                                               </div>\n" +
""
                + "                             <div class=\"form-group col-sm-2\">\n" +
"                                                   <button type=\"button\" onclick=\"agregarSecciones("+codAula+","+tipoSeccion+");\" class=\"btn btn-foursquare\">Agregar</button>" +
"                                               </div>\n" +
"                                            </fieldset>\n" +
"                                        </div><!-- /.form-body --></form>\n" +
                                        "                                               <div class=\"row\"><div class=\"col-sm-9\"></div><div class=\"col-sm-3\" align=\"left\">\n" +
"                                                    <b><i class=\"fa fa-power-off bigger-140 green\"></i> Estado Activo</b><br> \n" +
                "                                    <b><i class=\"fa fa-power-off bigger-140 red\"></i> Estado Inactivo</b>\n" +
"                                                </div></div>"+
"                                        <div class=\"form-footer\">\n" +
"                                            <div class=\"pull-right\">\n" +
"                                                \n" +
"                                                <button class=\"btn btn-warning\" type=\"reset\" onclick=\"\" data-dismiss=\"modal\"><i class=\"fa fa-times\"></i> CANCELAR</button>\n" +
"                                            </div>\n" +
"                                            <div class=\"clearfix\"></div>\n" +
"                                        </div>");
    }
    
    private void insertarSeccion(HttpServletRequest request, HttpServletResponse response) throws IOException {
        int codAula = Integer.parseInt(request.getParameter("aula"));
        int seccion = Integer.parseInt(request.getParameter("tiposeccion"));
        AulaService servicio = new AulaService();
        int resultado = 0;
        resultado = servicio.agregarSeccion(codAula, seccion);
        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        pw.print(resultado);
    };
    
    private void cambiarEstadoSeccion(HttpServletRequest request, HttpServletResponse response) throws IOException {
        int codSeccion = Integer.parseInt(request.getParameter("seccion"));
        int estado = Integer.parseInt(request.getParameter("estado"));
        AulaService servicio = new AulaService();
        int resultado = 0;
        resultado = servicio.cambiaeEstadoSeccion(codSeccion, estado);
        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        pw.print(resultado);
    };
    
    private void listarCmbNivel(HttpServletRequest request, HttpServletResponse response) throws IOException {
        int codCentro = Integer.parseInt(request.getParameter("codcentro"));
        MontoService servicioMonto = new MontoService();
        ArrayList<Monto> listaMonto = new ArrayList<>();
        listaMonto = servicioMonto.listarNiveles(codCentro, "", 0, 1000);
        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        
        pw.println("<label class=\"control-label\" id=\"etiqueta-busqueda\"><b><span class=\"etiqueta\">Nivel</span>: <span class=\"asterisk\">(*)</span></b></label>\n ");
        pw.println("<select class=\"form-control validate[required]\" id=\"nivel\" onchange=\"listarTipoGrados();\">");
        pw.println("    <option value=\"\">[SELECCIONE]</option>");
        for (int i = 0; i < listaMonto.size(); i++) {
            pw.println("<option value=\"" + listaMonto.get(i).getCodNivel() + "\">" + listaMonto.get(i).getNomNivel() + "</option>");
        }
        pw.println("</select> \n ");
    }
    
    private void listarCmbTipoGrado(HttpServletRequest request, HttpServletResponse response) throws IOException {
        int codNivel = Integer.parseInt(request.getParameter("codnivel"));
        MontoService servicioMonto = new MontoService();
        ArrayList<Monto> listaMonto = new ArrayList<>();
        listaMonto = servicioMonto.listarGrados(codNivel, "", 0, 1000);
        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        
        pw.println("<label class=\"control-label\" id=\"etiqueta-busqueda\"><b><span class=\"etiqueta\">Tipo Grado</span>: <span class=\"asterisk\">(*)</span></b></label>\n ");
        pw.println("<select class=\"form-control validate[required]\" id=\"tipoGrado\" onchange=\"listarGrados();\">");
        pw.println("    <option value=\"\">[SELECCIONE]</option>");
        for (int i = 0; i < listaMonto.size(); i++) {
            pw.println("<option value=\"" + listaMonto.get(i).getCodGrado()+ "\">" + listaMonto.get(i).getNomGrado()+ "</option>");
        }
        pw.println("</select> \n ");
    }
    
    private void listarCmbGrado(HttpServletRequest request, HttpServletResponse response) throws IOException {
        int codTipoGrado = Integer.parseInt(request.getParameter("codtipogrado"));
        MontoService servicioMonto = new MontoService();
        ArrayList<Monto> listaMonto = new ArrayList<>();
        listaMonto = servicioMonto.listarCiclos(codTipoGrado, "", 0, 1000);
        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        
        pw.println("<label class=\"control-label\" id=\"etiqueta-busqueda\"><b><span class=\"etiqueta\">Grado</span>: <span class=\"asterisk\">(*)</span></b></label>\n ");
        pw.println("<select class=\"form-control validate[required]\" id=\"grado\" onchange=\"listarTurnos();\">");
        pw.println("    <option value=\"\">[SELECCIONE]</option>");
        for (int i = 0; i < listaMonto.size(); i++) {
            pw.println("<option value=\"" + listaMonto.get(i).getCodCiclo()+ "\">" + listaMonto.get(i).getNomCiclo()+ "</option>");
        }
        pw.println("</select> \n ");
    }
    
    private void listarCmbTurno(HttpServletRequest request, HttpServletResponse response) throws IOException {
        MontoService servicioMonto = new MontoService();
        ArrayList<Monto> listaMonto = new ArrayList<>();
        listaMonto = servicioMonto.listarTurnos();
        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        
        pw.println("<label class=\"control-label\" id=\"etiqueta-busqueda\"><b><span class=\"etiqueta\">Turno</span>: <span class=\"asterisk\">(*)</span></b></label>\n ");
        pw.println("<select class=\"form-control validate[required]\" id=\"turno\">");
        pw.println("    <option value=\"\">[SELECCIONE]</option>");
        for (int i = 0; i < listaMonto.size(); i++) {
            pw.println("<option value=\"" + listaMonto.get(i).getCodTurno()+ "\">" + listaMonto.get(i).getNomTurno()+ "</option>");
        }
        pw.println("</select> \n ");
    }
    
    private void insertarAula(HttpServletRequest request, HttpServletResponse response) throws IOException {
        int codSede = Integer.parseInt(request.getParameter("sede"));
        int codCentro = Integer.parseInt(request.getParameter("centro"));
        int codNivel = Integer.parseInt(request.getParameter("nivel"));
        int codTipoGrado = Integer.parseInt(request.getParameter("tipogrado"));
        int codGrado = Integer.parseInt(request.getParameter("grado"));
        int codTurno = Integer.parseInt(request.getParameter("turno"));
        String fechaInicio = request.getParameter("fechainicio");
        String fechaTermino = request.getParameter("fechatermino");
        int cuotas = Integer.parseInt(request.getParameter("cuotas"));
        int tipoSeccion = Integer.parseInt(request.getParameter("tseccion"));
        String[] pensionDes = request.getParameter("nompension").split(",");
        String[] pensionMontoCadena = request.getParameter("montopension").split(",");
        String[] pensionVencimiento = request.getParameter("finpension").split(",");
        double[] pensionMonto = new double[pensionMontoCadena.length];
        
        for (int i = 0; i < pensionMontoCadena.length; i++) {
            pensionMonto[i] = Double.parseDouble(pensionMontoCadena[i]);
        }
        AulaService servicio = new AulaService();
        int resultado = 0;
        resultado = servicio.insertarAula(codSede, codCentro, codNivel, codTipoGrado, codGrado, codTurno, fechaInicio, fechaTermino, cuotas, tipoSeccion, pensionDes, pensionMonto, pensionVencimiento);
        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        pw.print(resultado);
    };
    
    private void cambiarEstadoAula(HttpServletRequest request, HttpServletResponse response) throws IOException {
        int codigo = Integer.parseInt(request.getParameter("idaula"));
        int estado = Integer.parseInt(request.getParameter("estado"));
        int resultado = 0;
        AulaService servicio = new AulaService();
        resultado = servicio.cambiarEstadoAula(codigo, estado);
        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        pw.print(resultado);
    } 
    
    private void cerrarCiclo(HttpServletRequest request, HttpServletResponse response) throws IOException {
        int codigo = Integer.parseInt(request.getParameter("codciclo"));
        int resultado = 0;
        AulaService servicio = new AulaService();
        resultado = servicio.cerrarCiclo(codigo);
        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        pw.print(resultado);
    }
      private void generarFormEditarAula(HttpServletRequest request, HttpServletResponse response) throws IOException {
         
        String cod_aula=request.getParameter("cod_aula");
        String cod_sede=request.getParameter("cod_sede");
        String cod_centro=request.getParameter("cod_centro");
        String cod_nivel=request.getParameter("cod_nivel");
        String cod_TipoGr=request.getParameter("cod_TipoGr");
        String cod_Gr=request.getParameter("cod_Gr");
        String cod_Turno=request.getParameter("cod_Turno");
        String fecha_i=request.getParameter("fecha_i");
        String fecha_f=request.getParameter("fecha_f");
        
        
        SedeService servicioSede = new SedeService();
        MontoService servicioMonto = new MontoService();
        AulaService servicioAula =new AulaService(); 
        
        ArrayList<Sede> listaSede = new ArrayList<>();
        ArrayList<Monto> listaMonto = new ArrayList<>();
        ArrayList<Monto> listaNivel = new ArrayList<>();
        ArrayList<Monto> listaTipo_Grado = new ArrayList<>();
        ArrayList<Monto> listaGrado = new ArrayList<>();
        ArrayList<Monto> listaTurno = new ArrayList<>();
        ArrayList<Pension> ListarPensionxAula= new ArrayList<>();
        
        listaSede = servicioSede.listarSedesActivas();
        listaMonto = servicioMonto.listarCentros("", 0, 1000);
        listaNivel=servicioMonto.listarNiveles(Integer.parseInt(cod_centro),"", 0, 999999999);
        listaTipo_Grado=servicioMonto.listarGrados(Integer.parseInt(cod_nivel),"", 0, 9999999);
        listaGrado=servicioMonto.listarCiclos(Integer.parseInt(cod_TipoGr),"", 0, 999999999);
        listaTurno=servicioMonto.listarTurnos();
        ListarPensionxAula=servicioAula.ListarPensionesxAula(Integer.parseInt(cod_aula));
        
        int CantPensionesPagadas=servicioAula.contarPensionesPagadas(Integer.parseInt(cod_aula));
        int ultimo=ListarPensionxAula.size();
        String monto=ListarPensionxAula.get(ultimo-1).getMontoPension();
        String selector ="";
        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        
        pw.println("<form id=\"form-nuevo\"><div class=\"form-body\">\n" +
"                                            <fieldset>\n" +
"                                                \n" +
"                                                <div class=\"form-group col-sm-6\" id=\"txtFiltro\">\n" +
"                                                    <label class=\"control-label\" id=\"etiqueta-busqueda\"><b><span class=\"etiqueta\">Centro</span>: <span class=\"asterisk\">(*)</span></b></label>\n" +
"                                                    <select class=\"form-control validate[required]\" id=\"centro\" onchange=\"listarNiveles();\">\n" );
        pw.println("                                    <option value=\"\">[SELECCIONE]</option>");
        for (int i = 0; i < listaMonto.size(); i++) {
            pw.println("                                <option value=\"" + listaMonto.get(i).getCodCentro() + "\">" + listaMonto.get(i).getNomCentro()+ "</option>");
        }
        pw.println("                                 </select>\n" +
"                                                </div>\n" +
"                                                <div class=\"form-group col-sm-6\" id=\"cmbNivel\">\n" +
"                                                    <label class=\"control-label\" id=\"etiqueta-busqueda\"><b><span class=\"etiqueta\">Nivel</span>: <span class=\"asterisk\">(*)</span></b></label>\n " +
"                                                    <select class=\"form-control validate[required]\" id=\"nivel\" onchange=\"listarTipoGrados();\"><option value=\"\">[SELECCIONE]</option>");
        for (int i = 0; i < listaNivel.size(); i++) {
                                            pw.println("<option value=\"" + listaNivel.get(i).getCodNivel() + "\">" + listaNivel.get(i).getNomNivel()+ "</option>");
        }     
                                         pw.println( "</select> \n" +
"                                                </div>\n" +
"                                                <div class=\"form-group col-sm-6\" id=\"cmbTipoGrado\">\n" +
"                                                    <label class=\"control-label\" id=\"etiqueta-busqueda\"><b><span class=\"etiqueta\">Tipo Grado</span>: <span class=\"asterisk\">(*)</span></b></label>\n" +
"                                                    <select class=\"form-control validate[required]\" id=\"tipoGrado\" onchange=\"listarGrados();\"><option value=\"\">[SELECCIONE]</option>");
        for (int i = 0; i < listaTipo_Grado.size(); i++) {
                                            pw.println("<option value=\"" + listaTipo_Grado.get(i).getCodGrado() + "\">" + listaTipo_Grado.get(i).getNomGrado()+ "</option>");
        }                                    
                                        pw.println( "</select> \n" +
"                                                </div>\n" +
"                                                <div class=\"form-group col-sm-6\" id=\"cmbGrado\">\n" +
"                                                    <label class=\"control-label\" id=\"etiqueta-busqueda\"><b><span class=\"etiqueta\">Grado</span>: <span class=\"asterisk\">(*)</span></b></label>\n" +
"                                                    <select class=\"form-control validate[required]\" id=\"grado\" onchange=\"listarTurnos();\"><option value=\"\">[SELECCIONE]</option>");
        for (int i = 0; i < listaGrado.size(); i++) {
                                            pw.println("<option value=\"" + listaGrado.get(i).getCodCiclo() + "\">" + listaGrado.get(i).getNomCiclo()+ "</option>");
        }
                                        pw.println( "</select> \n" +
"                                                </div>\n" +
"                                                <div class=\"form-group col-sm-6\" id=\"cmbTurno\">\n" +
"                                                    <label class=\"control-label\" id=\"etiqueta-busqueda\"><b><span class=\"etiqueta\">Turno</span>: <span class=\"asterisk\">(*)</span></b></label>\n" +
"                                                    <select class=\"form-control validate[required]\" id=\"turno\"><option value=\"\">[SELECCIONE]</option>");
        for (int i = 0; i < listaTurno.size(); i++) {
                                            pw.println("<option value=\"" + listaTurno.get(i).getCodTurno()+ "\">" + listaTurno.get(i).getNomTurno()+ "</option>");
        }
                                         pw.println( "</select> \n" +
"                                                </div>\n" +
"                                                <div class=\"form-group col-sm-6\" id=\"txtFiltro\">\n" +
"                                                    <label class=\"control-label\" id=\"etiqueta-busqueda\"><b><span class=\"etiqueta\">Fechas de Duración</span>: <span class=\"asterisk\">(*)</span></b></label>\n" +
"                                                    <div id=\"Rfecha\"><input type=\"text\" class=\"form-control date-range-picker-double-Top validate[required]\" id=\"fechaRango\" value=\""+fecha_i+" - "+fecha_f+"\"></div>\n" +
"                                                </div>\n" +
"                                                <div class=\"form-group col-sm-6\" id=\"txtFiltro\">\n" + 
"                                                    <label class=\"control-label\" id=\"etiqueta-busqueda\"><b><span class=\"etiqueta\">Tipo Sección</span>: <span class=\"asterisk\">(*)</span></b></label>\n" +
"                                                    <select class=\"form-control validate[required]\" id=\"tiposeccion\"><option value=\"1\">A, B, C, ...</option><option value=\"2\">I, II, III, ...</option><option value=\"3\">1, 2, 3, ...</option></select> \n" +
"                                                </div>\n" +
"                                                \n" +
"                                                <div class=\"row\" id=\"pensiones\"><div class=\"col-md-12\">\n" +
"                                                   <table id=\"pensiones-table\" class=\"table table-striped table-saco\" style=\"border: 1px solid rgb(198, 198, 198); border-image: none; font-size: 11px;\"><thead><tr><th>Descripcion</th><th>Monto</th><th>Fecha Caducidad</th><th width=\"150\"><button type=\"button\" onclick=\"AgregarPensionEditar("+CantPensionesPagadas+","+cod_aula+",'"+ListarPensionxAula.get(ultimo-1).getFecha_pago()+"',"+monto+");\" class=\"btn btn-foursquare\">Agregar Pension</button></th></tr></thead>"
                                                 + "<tbody id=\"pensionesRows\">\n"); 
        
         for (int i = 0; i < ListarPensionxAula.size(); i++) { 
            
                    
pw.println("                                            <tr>\n" +
"                                                           <td><input type=\"text\" class=\"input-oculto validate[required]\" value=\""+ListarPensionxAula.get(i).getDescPension()+"\"></td>\n" +
"                                                           <td><input id=\"monto\" type=\"number\" class=\"input-oculto validate[required]\" value=\""+ListarPensionxAula.get(i).getMontoPension()+"\"></td>\n" +
"                                                           <td><input id=\"Fecha_i\" type=\"text\" class=\"input-oculto date-range-picker-single-Top validate[required]\" value=\""+ListarPensionxAula.get(i).getFecha_pago()+"\"></td>\n" +
"                                                           <td class=\"text-center\"><input type=\"hidden\" value=\""+ListarPensionxAula.get(i).getCodPension()+"\"><a class=\"remove\" href=\"javascript:EditarquitarPension("+ListarPensionxAula.get(i).getCodPension()+","+cod_aula+","+ultimo+");\"><i class=\"fa fa-trash-o bigger-140 red\"></i></a></td>" +
"                                                       </tr>\n" );
        }
pw.println("                                         </tbody>"
                                                 + "</table> \n" +
"                                                   </div></div>" +
"                                            </fieldset>\n" +
"                                        </div><!-- /.form-body --></form>\n" +
"                                        <div class=\"form-footer\">\n" +
"                                            <div class=\"pull-right\">\n" +
"                                                <button class=\"btn btn-foursquare\" type=\"button\" onclick=\"EditarAula("+cod_aula+");\" ><i class=\"fa fa-pencil-square-o bigger-140 \"></i> ACTUALIZAR</button>\n" +
"                                                <button id=\"BTCerrar\" class=\"btn btn-warning\"  onclick=\"window.location='man_aulas.jsp'\" ><i class=\"fa fa-times\"></i> CANCELAR</button>\n" +
"                                            </div>\n" +
"                                            <div class=\"clearfix\"></div>\n" +
"                                        </div>");
    }
        private void Agregar1Pension(HttpServletRequest request, HttpServletResponse response) throws IOException {
         
        String cod_aula=request.getParameter("cod_aula");
        String fecha_c=request.getParameter("fecha_c");
        String monto_T=request.getParameter("monto");
        AulaService servicioAula =new AulaService(); 
  
        ArrayList<Pension> ListarPensionxAula= new ArrayList<>();
        
        servicioAula.insertarPension(Integer.parseInt(cod_aula),fecha_c,monto_T);
        
        ListarPensionxAula=servicioAula.ListarPensionesxAula(Integer.parseInt(cod_aula));
        int CantPensionesPagadas=servicioAula.contarPensionesPagadas(Integer.parseInt(cod_aula));
        int ultimo =ListarPensionxAula.size();
        String monto=ListarPensionxAula.get(ultimo-1).getMontoPension();
        
        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        
                                    pw.println("<thead><tr><th>Descripcion</th><th>Monto</th><th>Fecha Caducidad</th><th width=\"150\"><button type=\"button\" onclick=\"AgregarPensionEditar("+CantPensionesPagadas+","+cod_aula+",'"+ListarPensionxAula.get(ultimo-1).getFecha_pago()+"',"+monto+");\" class=\"btn btn-foursquare\">Agregar Pension</button></th></tr></thead>"
                                                 + "<tbody id=\"pensionesRows\">\n"); 
        for (int i = 0; i < ListarPensionxAula.size(); i++) {                                 
pw.println("                                            <tr>\n" +
"                                                           <td><input type=\"text\" class=\"input-oculto validate[required]\" value=\""+ListarPensionxAula.get(i).getDescPension()+"\"></td>\n" +
"                                                           <td><input type=\"number\" class=\"input-oculto validate[required]\" value=\""+ListarPensionxAula.get(i).getMontoPension()+"\"></td>\n" +
"                                                           <td><input id=\"Fecha_i\" type=\"text\" class=\"input-oculto date-range-picker-single-Top validate[required]\" value=\""+ListarPensionxAula.get(i).getFecha_pago()+"\"></td>\n" +
"                                                           <td class=\"text-center\"><input type=\"hidden\" value=\""+ListarPensionxAula.get(i).getCodPension()+"\"><a class=\"remove\" href=\"javascript:EditarquitarPension("+ListarPensionxAula.get(i).getCodPension()+","+cod_aula+","+ultimo+");\"><i class=\"fa fa-trash-o bigger-140 red\"></i></a></td>" +
"                                                       </tr>\n" );
        }
pw.println("                                         </tbody>");
                                              
    }
          private void EditarquitarPension(HttpServletRequest request, HttpServletResponse response) throws IOException {
          
              
           String cod_aula=request.getParameter("cod_aula");
           String cod_pension=request.getParameter("cod_pension");
           
            AulaService servicioAula =new AulaService(); 
  
        ArrayList<Pension> ListarPensionxAula= new ArrayList<>();
        servicioAula.EliminarPension(Integer.parseInt(cod_pension));
        ListarPensionxAula=servicioAula.ListarPensionesxAula(Integer.parseInt(cod_aula));
        int CantPensionesPagadas=servicioAula.contarPensionesPagadas(Integer.parseInt(cod_aula));
        int ultimo =ListarPensionxAula.size();
        String monto=ListarPensionxAula.get(ultimo-1).getMontoPension();
        
        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        
                                    pw.println("<thead><tr><th>Descripcion</th><th>Monto</th><th>Fecha Caducidad</th><th width=\"150\"><button type=\"button\" onclick=\"AgregarPensionEditar("+CantPensionesPagadas+","+cod_aula+",'"+ListarPensionxAula.get(ultimo-1).getFecha_pago()+"',"+monto+");\" class=\"btn btn-foursquare\">Agregar Pension</button></th></tr></thead>"
                                                 + "<tbody id=\"pensionesRows\">\n"); 
        for (int i = 0; i < ListarPensionxAula.size(); i++) {                                 
pw.println("                                            <tr>\n" +
"                                                           <td><input type=\"text\" class=\"input-oculto validate[required]\" value=\""+ListarPensionxAula.get(i).getDescPension()+"\"></td>\n" +
"                                                           <td><input type=\"number\" class=\"input-oculto validate[required]\" value=\""+ListarPensionxAula.get(i).getMontoPension()+"\"></td>\n" +
"                                                           <td><input id=\"Fecha_i\" type=\"text\" class=\"input-oculto date-range-picker-single-Top validate[required]\" value=\""+ListarPensionxAula.get(i).getFecha_pago()+"\"></td>\n" +
"                                                           <td class=\"text-center\"><input type=\"hidden\" value=\""+ListarPensionxAula.get(i).getCodPension()+"\"><a class=\"remove\" href=\"javascript:EditarquitarPension("+ListarPensionxAula.get(i).getCodPension()+","+cod_aula+","+ultimo+");\"><i class=\"fa fa-trash-o bigger-140 red\"></i></a></td>" +
"                                                       </tr>\n" );
        }
pw.println("                                         </tbody>");
           
          }
    private void EditarAula(HttpServletRequest request, HttpServletResponse response) throws IOException {
        int cod_Aula=Integer.parseInt(request.getParameter("cod_aula"));
        int codSede = Integer.parseInt(request.getParameter("sede"));
        int codCentro = Integer.parseInt(request.getParameter("centro"));
        int codNivel = Integer.parseInt(request.getParameter("nivel"));
        int codTipoGrado = Integer.parseInt(request.getParameter("tipogrado"));
        int codGrado = Integer.parseInt(request.getParameter("grado"));
        int codTurno = Integer.parseInt(request.getParameter("turno"));
        String fechaInicio = request.getParameter("fechainicio");
        String fechaTermino = request.getParameter("fechatermino");
        int cuotas = Integer.parseInt(request.getParameter("cuotas"));
        int tipoSeccion = Integer.parseInt(request.getParameter("tseccion"));
        String[] cod_pensiones = request.getParameter("cod_pension").split(",");
        String[] pensionDes = request.getParameter("nompension").split(",");
        String[] pensionMontoCadena = request.getParameter("montopension").split(",");
        String[] pensionVencimiento = request.getParameter("finpension").split(",");
        String[] pensionMonto = request.getParameter("montopension").split(",");
        AulaService servicioAula =new AulaService();
        
        servicioAula.EditarAula(cod_Aula, codSede, codCentro, codNivel, codTipoGrado, codGrado, codTurno, fechaInicio, fechaTermino, cuotas, tipoSeccion, cod_pensiones, pensionDes, pensionMonto, pensionVencimiento);
        //colocar el Service
        //'cod_aula='+cod_aula+'&sede='+codSede+'&centro='+codCentro+'&nivel='+codNivel+'&tipogrado='+codTipoGrado+'&grado='+codGrado+'&turno='+codTurno+'&fechainicio='+fechaInicio+'&fechatermino='+fechaTermino+'&cuotas='+cuotas+'&tseccion='+tiposeccion+'&nompension='+pensionDes+'&montopension='+pensionMonto+'&finpension='+pensionVencimiento+'&cod_pension='+cod_pension
    }
          
}
