
package pe.siso.academia.Servlets;

import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import pe.siso.academia.Beans.Carrera;
import pe.siso.academia.Services.CarreraService;

public class ServletCarrera extends HttpServlet {

    @Override
    protected void service(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
        String param=request.getParameter("accion");
        if("listarCarreras".equals(param)){
            listarCarreras(request, response);
        }
        else if("listarCarreraEdicion".equals(param)){
            listarCarreraEdicion(request, response);
        }
    }
    
    private void listarCarreras(HttpServletRequest request, HttpServletResponse response) throws IOException {
        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        ArrayList<Carrera> lista = null;
        String orden = request.getParameter("orden");
        if(orden == null){orden="";}
        CarreraService servicio = new CarreraService();
        lista = servicio.listarCarreras();
        int datoReferencia = Integer.parseInt(request.getParameter("num_referencia"));
        String idInput = request.getParameter("id_control");
        pw.println("                                 <label class=\"control-label\" for=\""+idInput+"\"><b>"+orden+"Facultad / Carrera: </b></label>\n");
        pw.println("                                 <select class=\"form-control chosen-select\" id=\""+idInput+"\" data-referencia=\""+datoReferencia+"\" onchange=\"agregarAlResumen(this);\">");
        pw.println("                                     <option value=\"0\">[SELECCIONE]</option>");
        for(int i=0;i<lista.size();i++){
            pw.println("                                 <option value=\""+lista.get(i).getCodCarrera()+"\">"+lista.get(i).getNomCarrera()+"</option>");
        }
        pw.println("                                 </select>\n");
    }
    
    private void listarCarreraEdicion(HttpServletRequest request, HttpServletResponse response) throws IOException {
        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        ArrayList<Carrera> lista = null;
        String carrera = request.getParameter("carrera");
        String orden = request.getParameter("orden");
        if(orden == null){orden="";}
        CarreraService servicio = new CarreraService();
        lista = servicio.listarCarreras();
        int datoReferencia = Integer.parseInt(request.getParameter("num_referencia"));
        String idInput = request.getParameter("id_control");
        pw.println("                                 <label class=\"control-label\" for=\""+idInput+"\"><b>"+orden+"Facultad / Carrera: </b></label>\n");
        pw.println("                                 <select class=\"form-control chosen-select\" id=\""+idInput+"\" data-referencia=\""+datoReferencia+"\" onchange=\"agregarAlResumen(this);\">");
        pw.println("                                     <option value=\"0\">[SELECCIONE]</option>");
        for(int i=0;i<lista.size();i++){
            if(carrera.trim().equals(lista.get(i).getNomCarrera().trim())){
                pw.println("                                 <option value=\""+lista.get(i).getCodCarrera()+"\" SELECTED=\"true\">"+lista.get(i).getNomCarrera()+"</option>");
            }
            else{
                pw.println("                                 <option value=\""+lista.get(i).getCodCarrera()+"\">"+lista.get(i).getNomCarrera()+"</option>");
            }
        }
        pw.println("                                 </select>\n");
    }
}
