
package pe.siso.academia.Servlets;

import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import pe.siso.academia.Beans.Descuento;
import pe.siso.academia.Services.DescuentoService;


public class ServletDescuento extends HttpServlet {

    @Override
    protected void service(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
        String param=request.getParameter("accion");
        if("listarDescuentosPorNombre".equals(param)){
            listarDescuentosPorNombre(request, response);
        }
        else if("generarFormNuevo".equals(param)){
            generarFormNuevo(request, response);
        }
        else if("generarFormEditar".equals(param)){
            generarFormEditar(request, response);
        }
        else if("cambiarEstadoDescuento".equals(param)){
            cambiarEstadoDescuento(request, response);
        }
        else if("editarDescuento".equals(param)){
            editarDescuento(request, response);
        }
        else if("nuevoDescuento".equals(param)){
            nuevoDescuento(request, response);
        }
        else if("cantAsignados".equals(param)){
            cantAsignados(request, response);
        }
        else if("listarDescuentoPorSede".equals(param)){
            listarDescuentoPorSede(request, response);
        }
    }
    
    private void listarDescuentosPorNombre(HttpServletRequest request, HttpServletResponse response) throws IOException {
        String nombre = request.getParameter("nombre");
        if(nombre == null){nombre = "";}
        int pagina = Integer.parseInt(request.getParameter("pag"));
        int cantPorPagina = 20;
        int cantidadRegistros = 0;
        int cantidadPaginas = 0;
        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        ArrayList<Descuento> lista = null;
        DescuentoService servicio = new DescuentoService();
        lista = servicio.listarDescuentoPorNombre(nombre, (pagina*cantPorPagina)-cantPorPagina, cantPorPagina);
        cantidadRegistros = servicio.cantidadDescuentoPorNombre(nombre);
        cantidadPaginas = cantidadRegistros/cantPorPagina;
        pw.println("<div class=\"col-md-1\"></div>");
        pw.println("<div class=\"col-md-10\">\n" +
"                            <div class=\"panel\">\n" +
"                                <div class=\"panel-heading-saco\">\n" +
"                                    <h3 class=\"panel-title pull-left\">Lista de Descuentos</h3>\n" +
"                                    <span class=\"pull-right\" style=\"display: block;\">\n" +
"                                        <button class=\"btn btn-saco\" onclick=\"mostrarAgregar();\">  \n" +
"                                            <i class=\"fa fa-plus-circle\"></i> Agregar Descuento\n" +
"                                        </button>\n" +
"                                    </span>\n" +
"                                    <div style=\"clear: both;\"></div>\n" +
"                                </div>\n" +
"                                <div class=\"panel-body no-padding\">\n" +
"                                    <!-- Start sample table -->\n" +
"                                    <div class=\"table rounded mb-20\" id=\"imprimirTablaDescuentos\">\n" +
"                                        <table class=\"table table-striped table-saco\" style=\"border: 1px solid rgb(198, 198, 198); border-image: none; font-size: 11px;\">\n" +
"                                            <thead>\n" +
"                                                <tr>\n" +
"                                                    <th class=\"text-center border-right\">No.</th>\n" +
"                                                    <th class=\"text-center\">Concepto</th>\n" +
"                                                    <th class=\"text-center\">Acciones</th>\n" +
"                                                </tr>\n" +
"                                            </thead>\n" +
"                                            <tbody>\n");
        
        if(lista.size()==0){
            pw.println("<tr><td colspan='7'>No se encontraron registros.</td></tr>");
        }
                for(int i = 0; i<lista.size();i++){
pw.println("                                     <tr>\n" +
"                                                    <td class=\"text-center border-right\">"+(((pagina-1)*cantPorPagina)+1+i)+"</td>\n" +
"                                                    <td class=\"text-left\">"+lista.get(i).getNomDescuento()+"</td>\n" +
"                                                    <td class=\"text-center\">\n" +
"                                                        <a data-original-title=\"Editar Descuento\" data-toggle=\"tooltip\" data-placement=\"top\" href=\"javascript:mostrarEditar('"+lista.get(i).getCodDescuento()+"','"+lista.get(i).getNomDescuento()+"','"+(((pagina-1)*cantPorPagina)+1+i)+"');\">\n" +
"                                                            <i class=\"fa fa-edit bigger-140 blue\"></i>\n" +
"                                                        </a>&nbsp;&nbsp;\n");
if("1".equals(lista.get(i).getEstDescuento().trim())){
    pw.println("                                         <a data-original-title=\"Desactivar Descuento\" data-toggle=\"tooltip\" data-placement=\"top\" href=\"javascript:mostrarDesactivar('"+lista.get(i).getCodDescuento()+"');\">\n" +
"                                                            <i class=\"fa fa-lightbulb-o bigger-140 green\"></i>\n" +
"                                                        </a>\n");
}
else{
    pw.println("                                         <a data-original-title=\"Activar Descuento\" data-toggle=\"tooltip\" data-placement=\"top\" href=\"javascript:mostrarActivar('"+lista.get(i).getCodDescuento()+"');\">\n" +
"                                                            <i class=\"fa fa-lightbulb-o bigger-140 red\"></i>\n" +
"                                                        </a>\n");
}

pw.println("                                         </td>\n" +
"                                                </tr>\n" );
                }

pw.println("                         </tbody>\n" +
"                                        </table>\n" );

pw.println("<div class=\"col-xs-12\" style=\"border-right-color: rgb(198, 198, 198); border-bottom-color: rgb(198, 198, 198); border-left-color: rgb(198, 198, 198); border-right-width: 1px; border-bottom-width: 1px; border-left-width: 1px; border-right-style: solid; border-bottom-style: solid; border-left-style: solid; background-color: rgb(239, 243, 248);\">                                              \n" +
"                                            <div class=\"col-xs-7\">\n" +
"                                                <div class=\"dataTables_paginate paging_simple_numbers\" id=\"datatable-ajax_paginate\">\n" +
"                                                    <ul class=\"pagination\">  \n" );
if(pagina==1){
    pw.println("<li tabindex=\"0\" class=\"paginate_button previous disabled\" id=\"sample-table-2_previous\" aria-controls=\"sample-table-2\"> <a> &lt;&lt; </a></li>\n" );
}
else{
    pw.println("<li tabindex=\"0\" class=\"paginate_button previous\" id=\"sample-table-2_previous\" aria-controls=\"sample-table-2\"> <a href=\"javascript:listarDescuentos('1');\"> &lt;&lt; </a></li>\n" );
}
if(pagina>1){
    pw.println("<li tabindex=\"0\" class=\"paginate_button previous\" id=\"sample-table-2_previous\" aria-controls=\"sample-table-2\"> <a href=\"javascript:listarDescuentos('"+(pagina-1)+"');\">Anterior</a></li>\n" );
}
else{
    pw.println("<li tabindex=\"0\" class=\"paginate_button previous disabled\" id=\"sample-table-2_previous\" aria-controls=\"sample-table-2\"> <a>Anterior</a></li>\n" );
}


for(int x=1;x<=(cantidadPaginas+1);x++){
    if(x>=(pagina-0) && x<=(pagina+4)){
    if(pagina==x){
        pw.println("<li tabindex=\"0\" class=\"paginate_button active\" aria-controls=\"sample-table-2\"><a href=\"javascript:void(0);\">"+x+"</a></li>\n" );
    }
    else{
        pw.println("<li tabindex=\"0\" class=\"paginate_button\" aria-controls=\"sample-table-2\"><a href=\"javascript:listarDescuentos('"+x+"');\">"+x+"</a></li>\n" );
    }}
}
if(pagina<(cantidadPaginas+1)){
    pw.println("<li tabindex=\"0\" class=\"paginate_button next\" id=\"sample-table-2_next\" aria-controls=\"sample-table-2\"> <a href=\"javascript:listarDescuentos('"+(pagina+1)+"');\">Siguiente</a></li>\n" );
    pw.println("<li tabindex=\"0\" class=\"paginate_button next\" id=\"sample-table-2_next\" aria-controls=\"sample-table-2\"> <a href=\"javascript:listarDescuentos('"+(cantidadPaginas+1)+"');\"> &gt;&gt; </a></li>\n" );
}
else{
    pw.println("<li tabindex=\"0\" class=\"paginate_button next disabled\" id=\"sample-table-2_next\" aria-controls=\"sample-table-2\"> <a>Siguiente</a></li>\n" );
    pw.println("<li tabindex=\"0\" class=\"paginate_button next disabled\" id=\"sample-table-2_next\" aria-controls=\"sample-table-2\"> <a> &gt;&gt; </a></li>\n" );
}

pw.println("                                                    </ul>                                                  \n" +
"                                                </div>                                             \n" +
"                                            </div>                                              \n" +
"                                            <div class=\"col-xs-5\">\n" +
"                                                <table style=\"width: 100%; height: 72px;\" border=\"0\">\n" +
"                                                    <tbody>\n" +
"                                                        <tr>                                                          \n" +
"                                                            <td style=\"text-align: right; vertical-align: middle; background-color: transparent!important;\">Mostrando del "+((pagina*cantPorPagina)-cantPorPagina+1)+" al "+((pagina*cantPorPagina))+" de "+cantidadRegistros+" Descuentos</td> \n" +
"                                                        </tr> \n" +
"                                                    </tbody>\n" +
"                                                </table>\n" +
"                                            </div>  \n" +
"                                        </div>");

pw.println("                                    </div><!-- /.table -->\n" +
"                                    <!--/ End sample table -->\n" +
"                                </div>\n" +
"                            </div>\n" +
"                        </div>");
pw.println("<div class=\"col-md-1\"></div>");
    }
    
    private void generarFormNuevo(HttpServletRequest request, HttpServletResponse response) throws IOException {
        
        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        
        pw.println("<form id=\"form-validate\"><div class=\"form-body\">\n" +
"                                            <fieldset>\n" +
"                                                <div class=\"col-sm-12\" id=\"txtFiltro\">\n" +
"                                                    <label class=\"control-label\" id=\"etiqueta-busqueda\"><b><span class=\"etiqueta\">Concepto</span> <span class=\"asterisk\">(*)</span></b></label>\n" +
"                                                    <input type=\"text\" class=\"form-control validate[required]\" id=\"nuevoNombre\">\n" +
"                                                </div>\n" +
"                                                \n" +
"                                                \n" +
"                                            </fieldset>\n" +
"                                        </div><!-- /.form-body -->\n" +
"                                        <div class=\"form-footer\">\n" +
"                                            <div class=\"pull-right\">\n" +
"                                                <button class=\"btn btn-foursquare  \" type=\"button\" onclick=\"agregarNuevo();\" ><i class=\"fa fa-save\"></i> GUADAR</button>\n" +
"                                                <button class=\"btn btn-warning \" type=\"reset\" onclick=\"\" data-dismiss=\"modal\"><i class=\"fa fa-refresh\"></i> CANCELAR</button>\n" +
"                                            </div>\n" +
"                                            <div class=\"clearfix\"></div>\n" +
"                                        </div></form>");
    }
    
    private void generarFormEditar(HttpServletRequest request, HttpServletResponse response) throws IOException {
        
        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        String id = request.getParameter("idDescuento");
        String valor = request.getParameter("valor");
        String etiqueta = request.getParameter("etiqueta");
        
        pw.println("<div class=\"form-body\">\n" +
"                                            <fieldset>\n" +
"                                                <div class=\"col-sm-12\" id=\"txtFiltro\">\n" +
"                                                    <label class=\"control-label\" id=\"etiqueta-busqueda\"><b><span class=\"etiqueta\">Concepto</span> <span class=\"asterisk\">(*)</span></b></label>\n" +
"                                                    <div class=\"input-group\"><span class=\"input-group-addon\">"+etiqueta+"</span>" +
"                                                    <input type=\"text\" class=\"form-control\" id=\"nuevoNombre\" value=\""+valor+"\"></div>\n" +
"                                                </div>\n" +
"                                                \n" +
"                                                \n" +
"                                            </fieldset>\n" +
"                                        </div><!-- /.form-body -->\n" +
"                                        <div class=\"form-footer\">\n" +
"                                            <div class=\"pull-right\">\n" +
"                                                <button class=\"btn btn-foursquare  \" type=\"button\" onclick=\"editarDescuento('"+id+"');\" data-dismiss=\"modal\"><i class=\"fa fa-refresh\"></i> ACTUALIZAR</button>\n" +
"                                                <button class=\"btn btn-warning \" type=\"reset\" onclick=\"\" data-dismiss=\"modal\"><i class=\"fa fa-times\"></i> CANCELAR</button>\n" +
"                                            </div>\n" +
"                                            <div class=\"clearfix\"></div>\n" +
"                                        </div>");
    }
    
    private void cambiarEstadoDescuento(HttpServletRequest request, HttpServletResponse response) throws IOException {
        int r = 0;
        response.setContentType("text/html");
        int id = Integer.parseInt(request.getParameter("id"));
        String estado = request.getParameter("estado");
        PrintWriter pw = response.getWriter();
        DescuentoService servicio = new DescuentoService();
        int cantidadEnlaces = servicio.cantEnlacesDesc(id);
        if(cantidadEnlaces==0){
            r = servicio.cambiarEstadoDescuento(id, estado);
        }
        else{
            r = 2;
        }
        pw.println(r);
    }
    
    private void editarDescuento(HttpServletRequest request, HttpServletResponse response) throws IOException {
        
        response.setContentType("text/html");
        int id = Integer.parseInt(request.getParameter("id"));
        String nombre = request.getParameter("nombre");
        PrintWriter pw = response.getWriter();
        DescuentoService servicio = new DescuentoService();
        int r = servicio.editarDescuento(id, nombre);
        pw.println(r);
    }
    
    private void nuevoDescuento(HttpServletRequest request, HttpServletResponse response) throws IOException {
        
        response.setContentType("text/html");
        String nombre = request.getParameter("nombre");
        PrintWriter pw = response.getWriter();
        DescuentoService servicio = new DescuentoService();
        int r = servicio.nuevoDescuento(nombre);
        pw.println(r);
    }
    
    private void cantAsignados(HttpServletRequest request, HttpServletResponse response) throws IOException {
        response.setContentType("text/html");
        int id = Integer.parseInt(request.getParameter("id"));
        PrintWriter pw = response.getWriter();
        DescuentoService servicio = new DescuentoService();
        int r = servicio.cantEnlacesDesc(id);
        pw.println(r);
    }
    private void listarDescuentoPorSede(HttpServletRequest request, HttpServletResponse response) throws IOException {
        response.setContentType("text/html");
        //int id = Integer.parseInt(request.getParameter("id"));
        PrintWriter pw = response.getWriter();
        DescuentoService servicio = new DescuentoService();
        //int r = servicio.cantEnlacesDesc(id);
        
    }
}
