package pe.siso.academia.Servlets;

import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import pe.siso.academia.Beans.Descuento;
import pe.siso.academia.Beans.Usuario;
import pe.siso.academia.Services.DescuentoService;

public class ServletDescuentoEnlace extends HttpServlet {

    @Override
    protected void service(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
        String param = request.getParameter("accion");
        if ("generarFormDescuentos".equals(param)) {
            generarFormDescuentos(request, response);
        } else if ("agregarDsctoSede".equals(param)) {
            agregarDsctoSede(request, response);
        } else if ("eliminarDsctoSede".equals(param)) {
            eliminarDsctoSede(request, response);
        }
    }

    private void generarFormDescuentos(HttpServletRequest request, HttpServletResponse response) throws IOException {

        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        DescuentoService servicio = new DescuentoService();
        ArrayList<Descuento> listaTable = new ArrayList<>();
        ArrayList<Descuento> listaCmb = new ArrayList<>();
        int sede = Integer.parseInt(request.getParameter("sede"));
        HttpSession session_actual = request.getSession(true);
        Usuario usuario = new Usuario();
        usuario = (Usuario) session_actual.getAttribute("usuario");
        listaTable = servicio.listarDescuentoPorSede(sede, usuario.getCodigoTipoUsuario());
        listaCmb = servicio.listarDescuentoPorSedeSinAsignar(sede);
        pw.println("<div class=\"form-body\" style=\"height:300px;overflow-y:scroll;\">\n"
                + "                        <fieldset>\n"
                + "                            <div class=\"col-sm-6 form-group\">\n"
                + "                                <div class=\"table rounded mb-20 border\">\n"
                + "                                    <table class=\"table table-saco\">\n"
                + "                                        <thead>\n"
                + "                                            <tr>\n"
                + "                                                <th class=\"text-center\">Descuentos</th>\n"
                + "                                                <th class=\"text-center\">Monto</th>\n"
                + "                                                <th class=\"text-center\"></th>\n"
                + "                                            </tr>\n"
                + "                                        </thead>\n"
                + "                                        <tbody>\n");
        if (listaTable.size() == 0) {
            pw.println("<tr><td colspan=\"2\">No hay descuentos registrados.</td></tr>");
        }

        for (int i = 0; i < listaTable.size(); i++) {
            String tip = "";
            String por = "";
            if (listaTable.get(i).getTip_mon() == 0) {
                tip = "S/.";
            } else {
                por = "%";
            }
            pw.println("                     <tr>\n"
                    + "                                                <td>" + listaTable.get(i).getNomDescuento() + "</td>\n"
                    + "                                                <td>" + tip + "" + listaTable.get(i).getMonto() + "" + por + "</td>\n"
                    + "                                                <td class=\"text-center\"><a href=\"javascript:void();\" onclick=\"mostrarEliminarDscto('" + listaTable.get(i).getCodEnlace() + "','" + sede + "')\"><i class=\"fa fa-times red\"></i></a></td>\n"
                    + "                                            </tr>\n");
        }

        pw.println("                     </tbody>\n"
                + "                                    </table>\n"
                + "                                </div>\n"
                + "                            </div>\n"
                + "                        \n"
                + "                            <div class=\"col-sm-6\">\n"
                + "                                <div class=\"form-group\">\n"
                + "                                    <label class=\"control-label\" id=\"etiqueta-busqueda\">\n"
                + "                                        <b>\n"
                + "                                            Descuento <span class=\"asterisk\">(*)</span>\n"
                + "                                        </b>\n"
                + "                                    </label>\n"
                + "                                    <select class=\"form-control chosen-select\" id=\"dscto\">\n");
        for (int i = 0; i < listaCmb.size(); i++) {
            pw.println("                 <option value=\"" + listaCmb.get(i).getCodDescuento() + "\">" + listaCmb.get(i).getNomDescuento() + "</option>\n");
        }
        pw.println("                 </select>\n"
                + "                                </div>\n"
                + "                              <div class=\"form-group\"> <div class=\"ckbox ckbox-theme square\"><input id=\"chkTipoMonto\" type=\"checkbox\" onclick=\"cambiarLblTipo();\" value=\"0\"><label for=\"chkTipoMonto\"> <b> Porcentaje</b></label> </div></div>"
                + "                                <div class=\"form-group\">\n"
                + "                                    <label class=\"control-label\" id=\"etiqueta-busqueda1\">\n"
                + "                                        <b>\n"
                + "                                            Monto (S/.) <span class=\"asterisk\">(*)</span>\n"
                + "                                        </b>\n"
                + "                                    </label>\n"
                + "                                    <input type=\"text\" class=\"form-control\" maxlength=\"9\" id=\"monto\">\n"
                + "                                </div>\n"
                + "                                <div class=\"form-group text-center\">\n"
                + "                                    <button class=\"btn btn-foursquare\" type=\"button\" onclick=\"agregarDsctoSede('" + sede + "');\">\n"
                + "                                        <i class=\"fa fa-save\"></i> AGREGAR\n"
                + "                                    </button>\n"
                + "                                </div>\n"
                + "                            </div>\n"
                + "                        </fieldset>\n"
                + "                    </div>\n"
                + "                    <div class=\"form-footer\">\n"
                + "                        <div class=\"pull-right\">\n"
                + "                            <button class=\"btn btn-warning\" data-dismiss=\"modal\">\n"
                + "                                <i class=\"fa fa-times\"></i> CERRAR\n"
                + "                            </button>\n"
                + "                        </div>\n"
                + "                        <div class=\"clearfix\"></div>\n"
                + "                    </div>");
    }

    private void agregarDsctoSede(HttpServletRequest request, HttpServletResponse response) throws IOException {
        int sede = Integer.parseInt(request.getParameter("sede"));
        int dcto = Integer.parseInt(request.getParameter("dcto"));
        double mont = Double.parseDouble(request.getParameter("mont"));
        int tip_mon = Integer.parseInt(request.getParameter("tip_mon"));
        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        DescuentoService servicio = new DescuentoService();
        int r = servicio.agregarDestoSede(sede, dcto, mont, tip_mon);
        pw.println(r);
    }

    private void eliminarDsctoSede(HttpServletRequest request, HttpServletResponse response) throws IOException {
        int enlaceDscto = Integer.parseInt(request.getParameter("enlace"));
        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        DescuentoService servicio = new DescuentoService();
        int r = servicio.eliminarDestoSede(enlaceDscto);
        pw.println(r);
    }
}
