
package pe.siso.academia.Servlets;

import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import pe.siso.academia.Beans.Descuento;
import pe.siso.academia.Beans.Documento;
import pe.siso.academia.Beans.Usuario;
import pe.siso.academia.Services.DescuentoService;
import pe.siso.academia.Services.DocumentoService;

public class ServletDocumentoEnlace extends HttpServlet {

    @Override
    protected void service(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
        String param=request.getParameter("accion");
        if("generarFormDocumentos".equals(param)){
            generarFormDocumentos(request, response);
        }
        else if("agregarDocSede".equals(param)){
            agregarDocSede(request, response);
        }
        else if("eliminarDocSede".equals(param)){
            eliminarDocSede(request, response);
        }
        else if("llenarCmbDocSede".equals(param)){
            llenarCmbDocSede(request, response);
        }
        else if("llenarDescuentosPorSede".equals(param)){
            llenarDescuentosPorSede(request, response);
        }
    }
    
    private void generarFormDocumentos(HttpServletRequest request, HttpServletResponse response) throws IOException {
        
        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        DocumentoService servicio = new DocumentoService();
        ArrayList<Documento> listaTable = new ArrayList<>();
        ArrayList<Documento> listaCmb = new ArrayList<>();
        int sede = Integer.parseInt(request.getParameter("sede"));
        listaTable = servicio.listarDocumentoPorSede(sede);
        listaCmb = servicio.listarDocumentoPorSedeSinAsignar(sede);
        pw.println("<div class=\"form-body\" style=\"height:300px;overflow-y:scroll;\">\n" +
"                        <fieldset>\n" +
"                            <div class=\"col-sm-6 form-group\">\n" +
"                                <div class=\"table rounded mb-20 border\">\n" +
"                                    <table class=\"table table-saco\">\n" +
"                                        <thead>\n" +
"                                            <tr>\n" +
"                                                <th class=\"text-center\">Documentos</th>\n" +
"                                                <th class=\"text-center\"></th>\n" +
"                                            </tr>\n" +
"                                        </thead>\n" +
"                                        <tbody>\n" );
        if(listaTable.size()== 0){
            pw.println("<tr><td colspan=\"2\">No hay descuentos registrados.</td></tr>");
        }
        for(int i=0;i<listaTable.size();i++){
            pw.println("                     <tr>\n" +
"                                                <td>"+listaTable.get(i).getNomDocumento()+"</td>\n" +
"                                                <td class=\"text-center\"><a href=\"javascript:void();\" onclick=\"mostrarEliminarDoc('"+listaTable.get(i).getCodEnlace()+"','"+sede+"')\"><i class=\"fa fa-times red\"></i></a></td>\n" +
"                                            </tr>\n" );
        }
pw.println("                             </tbody>\n" +
"                                    </table>\n" +
"                                </div>\n" +
"                            </div>\n" +
"                        \n" +
"                            <div class=\"col-sm-6\">\n" +
"                                <div class=\"form-group\">\n" +
"                                    <label class=\"control-label\" id=\"etiqueta-busqueda\">\n" +
"                                        <b>\n" +
"                                            Documentos <span class=\"asterisk\">(*)</span>\n" +
"                                        </b>\n" +
"                                    </label>\n" +
"                                    <select class=\"form-control chosen-select\" id=\"doc\">\n" );
        for(int i=0;i<listaCmb.size();i++){
            pw.println("                 <option value=\""+listaCmb.get(i).getCodDocumento()+"\">"+listaCmb.get(i).getNomDocumento()+"</option>\n" );
        }
pw.println("                         </select>\n" +
"                                </div>\n" +
"                                <div class=\"form-group text-center\">\n" +
"                                    <button class=\"btn btn-foursquare\" type=\"button\" onclick=\"agregarDocSede("+sede+");\">\n" +
"                                        <i class=\"fa fa-save\"></i> AGREGAR\n" +
"                                    </button>\n" +
"                                </div>\n" +
"                            </div>\n" +
"                        </fieldset>\n" +
"                    </div>\n" +
"                    <div class=\"form-footer\">\n" +
"                        <div class=\"pull-right\">\n" +
"                            <button class=\"btn btn-warning\" data-dismiss=\"modal\">\n" +
"                                <i class=\"fa fa-times\"></i> CERRAR\n" +
"                            </button>\n" +
"                        </div>\n" +
"                        <div class=\"clearfix\"></div>\n" +
"                    </div>");
    }
    
    private void agregarDocSede(HttpServletRequest request, HttpServletResponse response) throws IOException {
        int sede = Integer.parseInt(request.getParameter("sede"));
        int doc = Integer.parseInt(request.getParameter("doc"));
        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        DocumentoService servicio = new DocumentoService();
        int r = servicio.agregarDocSede(sede, doc);
        pw.println(r);
    }
    
    private void eliminarDocSede(HttpServletRequest request, HttpServletResponse response) throws IOException {
        int enlaceDoc = Integer.parseInt(request.getParameter("enlace"));
        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        DocumentoService servicio = new DocumentoService();
        int r = servicio.eliminarDocSede(enlaceDoc);
        pw.println(r);
    }
    
    private void llenarCmbDocSede(HttpServletRequest request, HttpServletResponse response) throws IOException {
        int sede = Integer.parseInt(request.getParameter("sede"));
        ArrayList<Documento> lista = new ArrayList<>();
        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        DocumentoService servicio = new DocumentoService();
        lista = servicio.listarDocumentoPorSede(sede);
        pw.println("<div class=\"col-md-12\">");
        pw.println("<div class=\"panel rounded shadow panel-blueDark panelborder\">"
                + "<div class=\"panel-heading blue2\">\n" 
                + "<div class=\"pull-left\">\n" 
                + "<h3 class=\"panel-title\">\n" 
                + "<i class=\"fa fa-file-o\"></i>\n" 
                + "Documentos Obligatorios\n" 
                + "</h3>\n" 
                + "</div>\n" 
                + "<div class=\"clearfix\"></div>\n" 
                + "</div>"
                + "<div class=\"panel-body\">");
        for (int i = 0; i < lista.size(); i++) {
            pw.println("<div class=\"ckbox ckbox-primary\">\n" +
                "<input class=\"validate[minCheckbox[1]] cmb_requisito\" id=\"cmb" + i + "\" type=\"checkbox\" name=\"Documentos[]\" value=\"" + lista.get(i).getCodDocumento()+ "\">\n" +
                "<label for=\"cmb" + i + "\">\n" +
                "" + lista.get(i).getNomDocumento() + "\n" +
                "</label></div>");
        }
        pw.println("</div></div>");
    }
    
    private void llenarDescuentosPorSede(HttpServletRequest request, HttpServletResponse response) throws IOException {
        
        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        int codSede = Integer.parseInt(request.getParameter("codsede"));
        HttpSession session_actual = request.getSession(true);
        Usuario usuario = new Usuario();
        usuario = (Usuario) session_actual.getAttribute("usuario");
        ArrayList<Descuento> lista = new ArrayList<>();
        DescuentoService servicioDesc = new DescuentoService();
        lista = servicioDesc.listarDescuentoPorSede(codSede,usuario.getCodigoTipoUsuario());
        pw.println("                                <label class=\"control-label\" id=\"etiqueta-busqueda\" for=\"descuento\"><b><span class=\"etiqueta\">Descuento</span> <span class=\"asterisk\">(*)</span></b></label>\n");
        pw.println("                                <select class=\"form-control validate[required]\" id=\"descuento\" onchange=\"obtenerMontoDscto();\">");
        pw.println("                                   <option value=\"0\" data-monto=\"0.00\">[SELECCIONE]</option>");
        for (int i = 0; i < lista.size(); i++) {
                                            pw.println("<option data-tip=\""+lista.get(i).getTip_mon()+"\" value=\"" + lista.get(i).getCodDescuento() + "\" data-monto=\"" + lista.get(i).getMonto() + "\">" + lista.get(i).getNomDescuento() + "</option>");
        }
        pw.println("                                </select>");
    }
}
