package pe.siso.academia.Servlets;

import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import pe.siso.academia.Beans.Estudiante;
import pe.siso.academia.Services.EstudianteService;
import pe.siso.academia.Services.MatriculadosService;

public class ServletEstudiante extends HttpServlet {

    @Override
    protected void service(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
        String param = request.getParameter("accion");
        if ("listarEstudiantePorApellido".equals(param)) {
            listarEstudiantePorApellido(request, response);
        } else if ("listarEstudiantePorDoc".equals(param)) {
            listarEstudiantePorDoc(request, response);
        } else if ("listarEstudiantePorSede".equals(param)) {
            listarEstudiantePorSede(request, response);
        } else if ("insertarEstudiante".equals(param)) {
            insertarEstudiante(request, response);
        } else if ("validarCod".equals(param)) {
            validarCod(request, response);
        } else if ("cambiarEstadoEstudiante".equals(param)) {
            cambiarEstadoEstudiante(request, response);
        } else if ("imprimirEstudiante".equals(param)) {
            imprimirEstudiante(request, response);
        } else if ("obtenerDatosEstudianteSession".equals(param)) {
            obtenerDatosEstudianteSession(request, response);
        } else if ("editarEstudiante".equals(param)) {
            editarEstudiante(request, response);
        }else if("ValidarEstudianteExitente".equals(param)){
            ValidarEstudianteExitente(request, response);
        }else if("ListarEstudianteSinActualizar".contains(param)){
            ListarEstudianteSinActualizar(request, response);
        }else if ("validarDNI".equals(param)) {
                validarDNI(request, response);
        }else if ("obtenerDatosEstudianteMatricula".equals(param)) {
            obtenerDatosEstudianteMatricula(request, response);
        }
    }

    private void listarEstudiantePorApellido(HttpServletRequest request, HttpServletResponse response) throws IOException {
        String apellido = request.getParameter("nombre");
        int pagina = Integer.parseInt(request.getParameter("pag"));
        String codsede=request.getParameter("codsede");
        int cantPorPagina = 20;
        int cantidadRegistros = 0;
        int cantidadPaginas = 0;
        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        ArrayList<Estudiante> lista = null;
        EstudianteService servicio = new EstudianteService();
        lista = servicio.listarEstudiantePorApellido(apellido,codsede, (pagina * cantPorPagina) - cantPorPagina, cantPorPagina);
        cantidadRegistros = servicio.cantidadEstudiantePorApellido(apellido,codsede );
        cantidadPaginas = cantidadRegistros / cantPorPagina;
        pw.println("<div class=\"col-md-12\">\n"
                + "                            <div class=\"panel\">\n"
                + "                                <div class=\"panel-heading-saco\">\n"
                + "                                    <h3 class=\"panel-title pull-left\">Lista de Estudiantes</h3>\n"
                + "                                    <span class=\"pull-right\" style=\"display: block;\">\n"
                + "                                        <button class=\"btn btn-saco\" onclick=\"location='frm_estudiante.jsp';\">  \n"
                + "                                            <i class=\"fa fa-plus-circle\"></i> Agregar Estudiante\n"
                + "                                        </button>\n"
                + "                                    </span>\n"
                + "                                    <div style=\"clear: both;\"></div>\n"
                + "                                </div>\n"
                + "                                <div class=\"panel-body no-padding\">\n"
                + "                                    <!-- Start sample table -->\n"
                + "                                    <div class=\"table-responsive table rounded mb-20\" id=\"imprimirTablaEstudiantes\">\n"
                + "                                        <table class=\"table table-striped table-saco\" style=\"border: 1px solid rgb(198, 198, 198); border-image: none; font-size: 11px;\">\n"
                + "                                            <thead>\n"
                + "                                                <tr>\n"
                + "                                                    <th class=\"text-center border-right\">No.</th>\n"
                + "                                                    <th class=\"text-center\">Tipo Doc</th>\n"
                + "                                                    <th class=\"text-center\">N° Documento</th>\n"
                + "                                                    <th class=\"text-center\">Nombres Completos</th>\n"
                + "                                                    <th class=\"text-center\">Acciones</th>\n"
                + "                                                </tr>\n"
                + "                                            </thead>\n"
                + "                                            <tbody>\n");
        if (lista.size() == 0) {
            pw.println("<tr><td colspan='7'>No se encontraron registros.</td></tr>");
        }
        for (int i = 0; i < lista.size(); i++) {
            switch (lista.get(i).getTipodoc().trim()) {
                case "0":
                    lista.get(i).setTipodoc("Ninguno");
                    break;
                case "1":
                    lista.get(i).setTipodoc("DNI");
                    break;
                case "2":
                    lista.get(i).setTipodoc("CARNÉ DE EXTRANJERIA");
                    break;
                case "3":
                    lista.get(i).setTipodoc("PASAPORTE");
                    break;
                case "4":
                    lista.get(i).setTipodoc("PARTIDA DE NACIMIENTO");
                    break;
                default:
                    break;
            }
            pw.println("                                     <tr>\n"
                    + "                                                    <td class=\"text-center border-right\">" + (((pagina - 1) * cantPorPagina) + 1 + i) + "</td>\n"
                    + "                                                    <td class=\"text-center border-right\">" + lista.get(i).getTipodoc() + "</td>\n"
                    + "                                                    <td class=\"text-center border-right\">" + lista.get(i).getDni() + "</td>\n"
                    + "                                                    <td class=\"text-left border-right\">" + lista.get(i).getNombres() + "</td>\n"
                    + "                                                    <td class=\"text-center border-right\">\n"
                    + "                                                        <a data-original-title=\"Editar Estudiante\" data-toggle=\"tooltip\" data-placement=\"top\" href=\"javascript:frmEditarEstudiante('" + lista.get(i).getCodestudiante() + "');\">\n"
                    + "                                                            <i class=\"fa fa-edit bigger-140 blue\"></i>\n"
                    + "                                                        </a>\n");
            if (Integer.parseInt(lista.get(i).getEstado()) == 1) {
                pw.println("                    <a data-original-title=\"Desactivar Estudiante\" data-toggle=\"tooltip\" data-placement=\"top\" href=\"javascript:frmCambiarEstado(" + lista.get(i).getCodestudiante() + ",0);\">\n"
                        + "                                                            <i class=\"fa fa-lightbulb-o bigger-140 green\"></i>\n"
                        + "                                                        </a>");
            } else {
                pw.println("                    <a data-original-title=\"Activar Estudiante\" data-toggle=\"tooltip\" data-placement=\"top\" href=\"javascript:frmCambiarEstado(" + lista.get(i).getCodestudiante() + ",1);\">\n"
                        + "                                                            <i class=\"fa fa-lightbulb-o bigger-140 red\"></i>\n"
                        + "                                                        </a>");
            }
            pw.println("                                             <a data-original-title=\"Imprimir Ficha\" data-toggle=\"tooltip\" data-placement=\"top\" href=\"javascript:frmImprimirEstudiante('" + lista.get(i).getCodestudiante() + "');\">\n"
                    + "                                                            <i class=\"fa fa-print bigger-140 green\"></i>\n"
                    + "                                                        </a>\n"
                    + "                                                       <a data-original-title=\"Matricular\" data-toggle=\"tooltip\" data-placement=\"top\" href=\"javascript:matricular(" + lista.get(i).getCodestudiante() + ");\">"
                    + "                                                           <i class=\"fa fa-pencil bigger-140 blue\"></i>"
                    + "                                                       </a>"
                    + "                                                    </td>\n"
                    + "                                                </tr>\n");
        }

        pw.println("                         </tbody>\n"
                + "                                        </table>\n");

// ------------------ paginacion

        pw.println("<div class=\"col-xs-12\" style=\"border-right-color: rgb(198, 198, 198); border-bottom-color: rgb(198, 198, 198); border-left-color: rgb(198, 198, 198); border-right-width: 1px; border-bottom-width: 1px; border-left-width: 1px; border-right-style: solid; border-bottom-style: solid; border-left-style: solid; background-color: rgb(239, 243, 248);\">                                              \n"
                + "                                            <div class=\"col-xs-7\">\n"
                + "                                                <div class=\"dataTables_paginate paging_simple_numbers\" id=\"datatable-ajax_paginate\">\n"
                + "                                                    <ul class=\"pagination\">  \n");
        if (pagina == 1) {
            pw.println("<li tabindex=\"0\" class=\"paginate_button previous disabled\" id=\"sample-table-2_previous\" aria-controls=\"sample-table-2\"> <a> &lt;&lt; </a></li>\n");
        } else {
            pw.println("<li tabindex=\"0\" class=\"paginate_button previous\" id=\"sample-table-2_previous\" aria-controls=\"sample-table-2\"> <a href=\"javascript:listarEstudiantes('1');\"> &lt;&lt; </a></li>\n");
        }
        if (pagina > 1) {
            pw.println("<li tabindex=\"0\" class=\"paginate_button previous\" id=\"sample-table-2_previous\" aria-controls=\"sample-table-2\"> <a href=\"javascript:listarEstudiantes('" + (pagina - 1) + "');\">Anterior</a></li>\n");
        } else {
            pw.println("<li tabindex=\"0\" class=\"paginate_button previous disabled\" id=\"sample-table-2_previous\" aria-controls=\"sample-table-2\"> <a>Anterior</a></li>\n");
        }

        for (int x = 1; x <= (cantidadPaginas + 1); x++) {
            if (x >= (pagina - 0) && x <= (pagina + 4)) {
                if (pagina == x) {
                    pw.println("<li tabindex=\"0\" class=\"paginate_button active\" aria-controls=\"sample-table-2\"><a href=\"javascript:void(0);\">" + x + "</a></li>\n");
                } else {
                    pw.println("<li tabindex=\"0\" class=\"paginate_button\" aria-controls=\"sample-table-2\"><a href=\"javascript:listarEstudiantes('" + x + "');\">" + x + "</a></li>\n");
                }
            }
        }
        if (pagina < (cantidadPaginas + 1)) {
            pw.println("<li tabindex=\"0\" class=\"paginate_button next\" id=\"sample-table-2_next\" aria-controls=\"sample-table-2\"> <a href=\"javascript:listarEstudiantes('" + (pagina + 1) + "');\">Siguiente</a></li>\n");
            pw.println("<li tabindex=\"0\" class=\"paginate_button next\" id=\"sample-table-2_next\" aria-controls=\"sample-table-2\"> <a href=\"javascript:listarEstudiantes('" + (cantidadPaginas + 1) + "');\"> &gt;&gt; </a></li>\n");
        } else {
            pw.println("<li tabindex=\"0\" class=\"paginate_button next disabled\" id=\"sample-table-2_next\" aria-controls=\"sample-table-2\"> <a>Siguiente</a></li>\n");
            pw.println("<li tabindex=\"0\" class=\"paginate_button next disabled\" id=\"sample-table-2_next\" aria-controls=\"sample-table-2\"> <a> &gt;&gt; </a></li>\n");
        }

        pw.println("                                                    </ul>                                                  \n"
                + "                                                </div>                                             \n"
                + "                                            </div>                                              \n"
                + "                                            <div class=\"col-xs-5\">\n"
                + "                                                <table style=\"width: 100%; height: 72px;\" border=\"0\">\n"
                + "                                                    <tbody>\n"
                + "                                                        <tr>                                                          \n"
                + "                                                            <td style=\"text-align: right; vertical-align: middle; background-color: transparent!important;\">Mostrando del " + ((pagina * cantPorPagina) - cantPorPagina + 1) + " al " + ((pagina * cantPorPagina)) + " de " + cantidadRegistros + " Estudiantes</td> \n"
                + "                                                        </tr> \n"
                + "                                                    </tbody>\n"
                + "                                                </table>\n"
                + "                                            </div>  \n"
                + "                                        </div>");

        pw.println("                                    </div><!-- /.table -->\n"
                + "                                    <!--/ End sample table -->\n"
                + "                                </div>\n"
                + "                            </div>\n"
                + "                        </div>");

    }

    private void listarEstudiantePorDoc(HttpServletRequest request, HttpServletResponse response) throws IOException {
        String documento = request.getParameter("documento");
        String tipo = request.getParameter("tipo");
        int pagina = Integer.parseInt(request.getParameter("pag"));
         String codsede=request.getParameter("codsede");
        int cantPorPagina = 20;
        int cantidadRegistros = 0;
        int cantidadPaginas = 0;
        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        ArrayList<Estudiante> lista = null;
        EstudianteService servicio = new EstudianteService();
        lista = servicio.listarEstudiantePorDocumento(documento,codsede, tipo, (pagina * cantPorPagina) - cantPorPagina, cantPorPagina);
        cantidadRegistros = servicio.cantidadEstudiantePorDocumento(documento, tipo,codsede);
        cantidadPaginas = cantidadRegistros / cantPorPagina;
        pw.println("<div class=\"col-md-12\">\n"
                + "                            <div class=\"panel\">\n"
                + "                                <div class=\"panel-heading-saco\">\n"
                + "                                    <h3 class=\"panel-title pull-left\">Lista de Estudiantes</h3>\n"
                + "                                    <span class=\"pull-right\" style=\"display: block;\">\n"
                + "                                        <button class=\"btn btn-saco\" onclick=\"location='frm_estudiante.jsp';\">  \n"
                + "                                            <i class=\"fa fa-plus-circle\"></i> Agregar Estudiante\n"
                + "                                        </button>\n"
                + "                                    </span>\n"
                + "                                    <div style=\"clear: both;\"></div>\n"
                + "                                </div>\n"
                + "                                <div class=\"panel-body no-padding\">\n"
                + "                                    <!-- Start sample table -->\n"
                + "                                    <div class=\"table-responsive table rounded mb-20\" id=\"imprimirTablaEstudiantes\">\n"
                + "                                        <table class=\"table table-striped table-saco\" style=\"border: 1px solid rgb(198, 198, 198); border-image: none; font-size: 11px;\">\n"
                + "                                            <thead>\n"
                + "                                                <tr>\n"
                + "                                                    <th class=\"text-center border-right\">No.</th>\n"
                + "                                                    <th class=\"text-center\">Tipo Doc</th>\n"
                + "                                                    <th class=\"text-center\">N° Documento</th>\n"
                + "                                                    <th class=\"text-center\">Nombres Completos</th>\n"
                + "                                                    <th class=\"text-center\">Acciones</th>\n"
                + "                                                </tr>\n"
                + "                                            </thead>\n"
                + "                                            <tbody>\n");
        if (lista.size() == 0) {
            pw.println("<tr><td colspan='7'>No se encontraron registros.</td></tr>");
        }
        for (int i = 0; i < lista.size(); i++) {
            switch (lista.get(i).getTipodoc().trim()) {
                case "0":
                    lista.get(i).setTipodoc("Ninguno");
                    break;
                case "1":
                    lista.get(i).setTipodoc("DNI");
                    break;
                case "2":
                    lista.get(i).setTipodoc("CARNÉ DE EXTRANJERIA");
                    break;
                case "3":
                    lista.get(i).setTipodoc("PASAPORTE");
                    break;
                case "4":
                    lista.get(i).setTipodoc("PARTIDA DE NACIMIENTO");
                    break;
                default:
                    break;
            }
            pw.println("                                     <tr>\n"
                    + "                                                    <td class=\"text-center border-right\">" + (((pagina - 1) * cantPorPagina) + 1 + i) + "</td>\n"
                    + "                                                    <td class=\"text-center border-right\">" + lista.get(i).getTipodoc() + "</td>\n"
                    + "                                                    <td class=\"text-center border-right\">" + lista.get(i).getDni() + "</td>\n"
                    + "                                                    <td class=\"text-left border-right\">" + lista.get(i).getNombres() + "</td>\n"
                    + "                                                    <td class=\"text-center border-right\">\n"
                    + "                                                        <a data-original-title=\"Editar Estudiante\" data-toggle=\"tooltip\" data-placement=\"top\" href=\"javascript:frmEditarEstudiante('" + lista.get(i).getCodestudiante() + "');\">\n"
                    + "                                                            <i class=\"fa fa-edit bigger-140 blue\"></i>\n"
                    + "                                                        </a>\n");
            if (Integer.parseInt(lista.get(i).getEstado()) == 1) {
                pw.println("                    <a data-original-title=\"Desactivar Estudiante\" data-toggle=\"tooltip\" data-placement=\"top\" href=\"javascript:frmCambiarEstado(" + lista.get(i).getCodestudiante() + ",0);\">\n"
                        + "                                                            <i class=\"fa fa-lightbulb-o bigger-140 green\"></i>\n"
                        + "                                                        </a>");
            } else {
                pw.println("                    <a data-original-title=\"Activar Estudiante\" data-toggle=\"tooltip\" data-placement=\"top\" href=\"javascript:frmCambiarEstado(" + lista.get(i).getCodestudiante() + ",1);\">\n"
                        + "                                                            <i class=\"fa fa-lightbulb-o bigger-140 red\"></i>\n"
                        + "                                                        </a>");
            }
            pw.println("                                             <a data-original-title=\"Imprimir Ficha\" data-toggle=\"tooltip\" data-placement=\"top\" href=\"javascript:frmImprimirEstudiante('" + lista.get(i).getCodestudiante() + "');\">\n"
                    + "                                                            <i class=\"fa fa-print bigger-140 green\"></i>\n"
                    + "                                                        </a>\n"
                    + "                                                        <a data-original-title=\"Matricular\" data-toggle=\"tooltip\" data-placement=\"top\" href=\"javascript:matricular(" + lista.get(i).getCodestudiante() + ");\">"
                    + "                                                           <i class=\"fa fa-pencil bigger-140 blue\"></i>"
                    + "                                                       </a>"
                    + "                                                    </td>\n"
                    + "                                                </tr>\n");
        }

        pw.println("                         </tbody>\n"
                + "                                        </table>\n");

        pw.println("<div class=\"col-xs-12\" style=\"border-right-color: rgb(198, 198, 198); border-bottom-color: rgb(198, 198, 198); border-left-color: rgb(198, 198, 198); border-right-width: 1px; border-bottom-width: 1px; border-left-width: 1px; border-right-style: solid; border-bottom-style: solid; border-left-style: solid; background-color: rgb(239, 243, 248);\">                                              \n"
                + "                                            <div class=\"col-xs-7\">\n"
                + "                                                <div class=\"dataTables_paginate paging_simple_numbers\" id=\"datatable-ajax_paginate\">\n"
                + "                                                    <ul class=\"pagination\">  \n");
        if (pagina == 1) {
            pw.println("<li tabindex=\"0\" class=\"paginate_button previous disabled\" id=\"sample-table-2_previous\" aria-controls=\"sample-table-2\"> <a> &lt;&lt; </a></li>\n");
        } else {
            pw.println("<li tabindex=\"0\" class=\"paginate_button previous\" id=\"sample-table-2_previous\" aria-controls=\"sample-table-2\"> <a href=\"javascript:listarEstudiantes('1');\"> &lt;&lt; </a></li>\n");
        }
        if (pagina > 1) {
            pw.println("<li tabindex=\"0\" class=\"paginate_button previous\" id=\"sample-table-2_previous\" aria-controls=\"sample-table-2\"> <a href=\"javascript:listarEstudiantes('" + (pagina - 1) + "');\">Anterior</a></li>\n");
        } else {
            pw.println("<li tabindex=\"0\" class=\"paginate_button previous disabled\" id=\"sample-table-2_previous\" aria-controls=\"sample-table-2\"> <a>Anterior</a></li>\n");
        }

        for (int x = 1; x <= (cantidadPaginas + 1); x++) {
            if (x >= (pagina - 0) && x <= (pagina + 4)) {
                if (pagina == x) {
                    pw.println("<li tabindex=\"0\" class=\"paginate_button active\" aria-controls=\"sample-table-2\"><a href=\"javascript:void(0);\">" + x + "</a></li>\n");
                } else {
                    pw.println("<li tabindex=\"0\" class=\"paginate_button\" aria-controls=\"sample-table-2\"><a href=\"javascript:listarEstudiantes('" + x + "');\">" + x + "</a></li>\n");
                }
            }
        }
        if (pagina < (cantidadPaginas + 1)) {
            pw.println("<li tabindex=\"0\" class=\"paginate_button next\" id=\"sample-table-2_next\" aria-controls=\"sample-table-2\"> <a href=\"javascript:listarEstudiantes('" + (pagina + 1) + "');\">Siguiente</a></li>\n");
            pw.println("<li tabindex=\"0\" class=\"paginate_button next\" id=\"sample-table-2_next\" aria-controls=\"sample-table-2\"> <a href=\"javascript:listarEstudiantes('" + (cantidadPaginas + 1) + "');\"> &gt;&gt; </a></li>\n");
        } else {
            pw.println("<li tabindex=\"0\" class=\"paginate_button next disabled\" id=\"sample-table-2_next\" aria-controls=\"sample-table-2\"> <a>Siguiente</a></li>\n");
            pw.println("<li tabindex=\"0\" class=\"paginate_button next disabled\" id=\"sample-table-2_next\" aria-controls=\"sample-table-2\"> <a> &gt;&gt; </a></li>\n");
        }

        pw.println("                                                    </ul>                                                  \n"
                + "                                                </div>                                             \n"
                + "                                            </div>                                              \n"
                + "                                            <div class=\"col-xs-5\">\n"
                + "                                                <table style=\"width: 100%; height: 72px;\" border=\"0\">\n"
                + "                                                    <tbody>\n"
                + "                                                        <tr>                                                          \n"
                + "                                                            <td style=\"text-align: right; vertical-align: middle; background-color: transparent!important;\">Mostrando del " + ((pagina * cantPorPagina) - cantPorPagina + 1) + " al " + ((pagina * cantPorPagina)) + " de " + cantidadRegistros + " Estudiantes</td> \n"
                + "                                                        </tr> \n"
                + "                                                    </tbody>\n"
                + "                                                </table>\n"
                + "                                            </div>  \n"
                + "                                        </div>");

        pw.println("                                    </div><!-- /.table -->\n"
                + "                                    <!--/ End sample table -->\n"
                + "                                </div>\n"
                + "                            </div>\n"
                + "                        </div>");
    }

    private void listarEstudiantePorSede(HttpServletRequest request, HttpServletResponse response) throws IOException {
        int codSede = Integer.parseInt(request.getParameter("codsede"));
        int pagina = Integer.parseInt(request.getParameter("pag"));
        int cantPorPagina = 20;
        int cantidadRegistros = 0;
        int cantidadPaginas = 0;
        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        ArrayList<Estudiante> lista = null;
        EstudianteService servicio = new EstudianteService();
        //lista = servicio.listarEstudiante(filtro,((pagina*cantPorPagina)-cantPorPagina),cantPorPagina);
        lista = servicio.listarEstudiantePorSede(codSede, (pagina * cantPorPagina) - cantPorPagina, cantPorPagina);
        cantidadRegistros = servicio.cantidadEstudiantePorSede(codSede);
        cantidadPaginas = cantidadRegistros / cantPorPagina;
        pw.println("<div class=\"col-md-12\">\n"
                + "                            <div class=\"panel\">\n"
                + "                                <div class=\"panel-heading-saco\">\n"
                + "                                    <h3 class=\"panel-title pull-left\">Lista de Estudiantes</h3>\n"
                + "                                    <span class=\"pull-right\" style=\"display: block;\">\n"
                + "                                        <button class=\"btn btn-saco\" onclick=\"AdvertenciaCierreD()\">  \n"
                + "                                            <i class=\"fa fa-plus-circle\"></i> Agregar Estudiante\n"
                + "                                        </button>\n"
                + "                                    </span>\n"
                + "                                    <div style=\"clear: both;\"></div>\n"
                + "                                </div>\n"
                + "                                <div class=\"panel-body no-padding\">\n"
                + "                                    <!-- Start sample table -->\n"
                + "                                    <div class=\"table-responsive table rounded mb-20\" id=\"imprimirTablaEstudiantes\">\n"
                + "                                        <table class=\"table table-striped table-saco\" style=\"border: 1px solid rgb(198, 198, 198); border-image: none; font-size: 11px;\">\n"
                + "                                            <thead>\n"
                + "                                                <tr>\n"
                + "                                                    <th class=\"text-center border-right\">No.</th>\n"
                + "                                                    <th class=\"text-center\">Tipo Doc</th>\n"
                + "                                                    <th class=\"text-center\">N° Documento</th>\n"
                + "                                                    <th class=\"text-center\">Nombres Completos</th>\n"
                + "                                                    <th class=\"text-center\">Acciones</th>\n"
                + "                                                </tr>\n"
                + "                                            </thead>\n"
                + "                                            <tbody>\n");
        if (lista.size() == 0) {
            pw.println("<tr><td colspan='7'>No se encontraron registros.</td></tr>");
        }
        for (int i = 0; i < lista.size(); i++) {
            switch (lista.get(i).getTipodoc().trim()) {
                case "0":
                    lista.get(i).setTipodoc("Ninguno");
                    break;
                case "1":
                    lista.get(i).setTipodoc("DNI");
                    break;
                case "2":
                    lista.get(i).setTipodoc("CARNÉ DE EXTRANJERIA");
                    break;
                case "3":
                    lista.get(i).setTipodoc("PASAPORTE");
                    break;
                case "4":
                    lista.get(i).setTipodoc("PARTIDA DE NACIMIENTO");
                    break;
                default:
                    break;
            }
            pw.println("                                     <tr>\n"
                    + "                                                    <td class=\"text-center border-right\">" + (((pagina - 1) * cantPorPagina) + 1 + i) + "</td>\n"
                    + "                                                    <td class=\"text-center border-right\">" + lista.get(i).getTipodoc() + "</td>\n"
                    + "                                                    <td class=\"text-center border-right\">" + lista.get(i).getDni() + "</td>\n"
                    + "                                                    <td class=\"text-left border-right\">" + lista.get(i).getNombres() + "</td>\n"
                    + "                                                    <td class=\"text-center border-right\">\n"
                    + "                                                        <a data-original-title=\"Editar Estudiante\" data-toggle=\"tooltip\" data-placement=\"top\" href=\"javascript:frmEditarEstudiante('" + lista.get(i).getCodestudiante() + "');\">\n"
                    + "                                                            <i class=\"fa fa-edit bigger-140 blue\"></i>\n"
                    + "                                                        </a>\n");
            if (Integer.parseInt(lista.get(i).getEstado()) == 1) {
                pw.println("                    <a data-original-title=\"Desactivar Estudiante\" data-toggle=\"tooltip\" data-placement=\"top\" href=\"javascript:frmCambiarEstado(" + lista.get(i).getCodestudiante() + ",0);\">\n"
                        + "                                                            <i class=\"fa fa-lightbulb-o bigger-140 green\"></i>\n"
                        + "                                                        </a>");
            } else {
                pw.println("                    <a data-original-title=\"Activar Estudiante\" data-toggle=\"tooltip\" data-placement=\"top\" href=\"javascript:frmCambiarEstado(" + lista.get(i).getCodestudiante() + ",1);\">\n"
                        + "                                                            <i class=\"fa fa-lightbulb-o bigger-140 red\"></i>\n"
                        + "                                                        </a>");
            }
            pw.println("                                             <a data-original-title=\"Imprimir Ficha\" data-toggle=\"tooltip\" data-placement=\"top\" href=\"javascript:frmImprimirEstudiante('" + lista.get(i).getCodestudiante() + "');\">\n"
                    + "                                                            <i class=\"fa fa-print bigger-140 green\"></i>\n"
                    + "                                                        </a>\n"
                    + "                                                        <a data-original-title=\"Matricular\" data-toggle=\"tooltip\" data-placement=\"top\" href=\"javascript:matricular(" + lista.get(i).getCodestudiante() + ");\">"
                    + "                                                           <i class=\"fa fa-pencil bigger-140 blue\"></i>"
                    + "                                                        </a>"
                    + "                                                    </td>\n"
                    + "                                                </tr>\n");
        }

        pw.println("                         </tbody>\n"
                + "                                        </table>\n");

        pw.println("<div class=\"col-xs-12\" style=\"border-right-color: rgb(198, 198, 198); border-bottom-color: rgb(198, 198, 198); border-left-color: rgb(198, 198, 198); border-right-width: 1px; border-bottom-width: 1px; border-left-width: 1px; border-right-style: solid; border-bottom-style: solid; border-left-style: solid; background-color: rgb(239, 243, 248);\">                                              \n"
                + "                                            <div class=\"col-xs-7\">\n"
                + "                                                <div class=\"dataTables_paginate paging_simple_numbers\" id=\"datatable-ajax_paginate\">\n"
                + "                                                    <ul class=\"pagination\">  \n");
        if (pagina == 1) {
            pw.println("<li tabindex=\"0\" class=\"paginate_button previous disabled\" id=\"sample-table-2_previous\" aria-controls=\"sample-table-2\"> <a> &lt;&lt; </a></li>\n");
        } else {
            pw.println("<li tabindex=\"0\" class=\"paginate_button previous\" id=\"sample-table-2_previous\" aria-controls=\"sample-table-2\"> <a href=\"javascript:listarEstudiantes('1');\"> &lt;&lt; </a></li>\n");
        }
        if (pagina > 1) {
            pw.println("<li tabindex=\"0\" class=\"paginate_button previous\" id=\"sample-table-2_previous\" aria-controls=\"sample-table-2\"> <a href=\"javascript:listarEstudiantes('" + (pagina - 1) + "');\">Anterior</a></li>\n");
        } else {
            pw.println("<li tabindex=\"0\" class=\"paginate_button previous disabled\" id=\"sample-table-2_previous\" aria-controls=\"sample-table-2\"> <a>Anterior</a></li>\n");
        }

        for (int x = 1; x <= (cantidadPaginas + 1); x++) {
            if (x >= (pagina - 0) && x <= (pagina + 4)) {
                if (pagina == x) {
                    pw.println("<li tabindex=\"0\" class=\"paginate_button active\" aria-controls=\"sample-table-2\"><a href=\"javascript:void(0);\">" + x + "</a></li>\n");
                } else {
                    pw.println("<li tabindex=\"0\" class=\"paginate_button\" aria-controls=\"sample-table-2\"><a href=\"javascript:listarEstudiantes('" + x + "');\">" + x + "</a></li>\n");
                }
            }
        }
        if (pagina < (cantidadPaginas + 1)) {
            pw.println("<li tabindex=\"0\" class=\"paginate_button next\" id=\"sample-table-2_next\" aria-controls=\"sample-table-2\"> <a href=\"javascript:listarEstudiantes('" + (pagina + 1) + "');\">Siguiente</a></li>\n");
            pw.println("<li tabindex=\"0\" class=\"paginate_button next\" id=\"sample-table-2_next\" aria-controls=\"sample-table-2\"> <a href=\"javascript:listarEstudiantes('" + (cantidadPaginas + 1) + "');\"> &gt;&gt; </a></li>\n");
        } else {
            pw.println("<li tabindex=\"0\" class=\"paginate_button next disabled\" id=\"sample-table-2_next\" aria-controls=\"sample-table-2\"> <a>Siguiente</a></li>\n");
            pw.println("<li tabindex=\"0\" class=\"paginate_button next disabled\" id=\"sample-table-2_next\" aria-controls=\"sample-table-2\"> <a> &gt;&gt; </a></li>\n");
        }

        pw.println("                                                    </ul>                                                  \n"
                + "                                                </div>                                             \n"
                + "                                            </div>                                              \n"
                + "                                            <div class=\"col-xs-5\">\n"
                + "                                                <table style=\"width: 100%; height: 72px;\" border=\"0\">\n"
                + "                                                    <tbody>\n"
                + "                                                        <tr>                                                          \n"
                + "                                                            <td style=\"text-align: right; vertical-align: middle; background-color: transparent!important;\">Mostrando del " + ((pagina * cantPorPagina) - cantPorPagina + 1) + " al " + ((pagina * cantPorPagina)) + " de " + cantidadRegistros + " Estudiantes</td> \n"
                + "                                                        </tr> \n"
                + "                                                    </tbody>\n"
                + "                                                </table>\n"
                + "                                            </div>  \n"
                + "                                        </div>");

        pw.println("                                    </div><!-- /.table -->\n"
                + "                                    <!--/ End sample table -->\n"
                + "                                </div>\n"
                + "                            </div>\n"
                + "                        </div>");
    }

    private void insertarEstudiante(HttpServletRequest request, HttpServletResponse response) throws IOException {
        int r = 0;
        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        EstudianteService servicio = new EstudianteService();
        r = servicio.agregarEstudiante(request.getParameter("1"),
                request.getParameter("2"), request.getParameter("3"),
                request.getParameter("4"), request.getParameter("5"),
                request.getParameter("6"), request.getParameter("7"),
                request.getParameter("8"), request.getParameter("9"),
                request.getParameter("10"), request.getParameter("11"),
                request.getParameter("14"), request.getParameter("15"),
                request.getParameter("16"), request.getParameter("17"),
                request.getParameter("18"), request.getParameter("19"),
                request.getParameter("20"), request.getParameter("21"),
                request.getParameter("22"),
                request.getParameter("23"), request.getParameter("24"),
                request.getParameter("25"),
                request.getParameter("26"), request.getParameter("27"),
                request.getParameter("28"), request.getParameter("29"),
                request.getParameter("30"), request.getParameter("31"),
                request.getParameter("32"), request.getParameter("33"),
                request.getParameter("34"),
                request.getParameter("35"), request.getParameter("36"),
                request.getParameter("37"), request.getParameter("38"),
                request.getParameter("39"), request.getParameter("codsede"));
        pw.println(r);
    }

    private void validarCod(HttpServletRequest request, HttpServletResponse response) throws IOException {
        int r = 0;
        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        String app=request.getParameter("app");
        String apm=request.getParameter("apm");
        String nombres=request.getParameter("nombres");
        String fecha= request.getParameter("fecha_n");
        EstudianteService servicio = new EstudianteService();
        r = servicio.validarCod(app, apm, nombres, fecha);
        
        pw.print(r);
    }

    private void cambiarEstadoEstudiante(HttpServletRequest request, HttpServletResponse response) throws IOException {
        int r = 0;
        int codigo = Integer.parseInt(request.getParameter("id"));
        int estado = Integer.parseInt(request.getParameter("estado"));
        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        EstudianteService servicio = new EstudianteService();
        r = servicio.cambiarEstadoEstudiante(codigo, estado);
        pw.println(r);
    }

    private void imprimirEstudiante(HttpServletRequest request, HttpServletResponse response) throws IOException {
        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        String fechaTemp = "";
        int identificador = Integer.parseInt(request.getParameter("estudiante"));
        Estudiante estu = new Estudiante();
        EstudianteService servicio = new EstudianteService();
        estu = servicio.obtenerEstudiante(identificador);
        pw.println("<div style=\"text-align: center;width: 100%;\">"
                + "            <h2 style=\"font-weight: bold;\">FICHA DE ESTUDIANTE</h2></div>"
                + "            <div style=\"clear: both;\"></div>\n"
                + "            <div><br /><br /></div>\n"
                + "            <div style=\"clear: both;\"></div>\n"
                + "            <div id=\"contenido-imprimible\" style=\"width: 100%;\">\n"
                + "                <div style=\"clear: both;\"></div>\n"
                + "                <div style=\"width: 50%;float: left;padding-left: 5%;padding-right: 5%;\">\n"
                + "                    <h4 style=\"font-weight: bold;\">Datos de Estudiante</h4>"
                + "                    <p>\n"
                + "                        <b>Tipo de Documento: </b>");
        switch (estu.getTipodoc().trim()) {
            case "1":
                pw.println("DNI");
                break;
            case "2":
                pw.println("CARNÉ DE EXTRANJERIA");
                break;
            case "3":
                pw.println("PASAPORTE");
                break;
            case "4":
                pw.println("PARTIDA DE NACIMIENTO");
                break;
            default:
                break;
        }
        fechaTemp = estu.getNacimiento();
        fechaTemp = fechaTemp.split("-")[2] + "/" + fechaTemp.split("-")[1] + "/" + fechaTemp.split("-")[0];

        pw.println("             <br>\n"
                + "                        <b>Número de Documento: </b>" + estu.getDni() + "<br>\n"
                + "                        <b>Apellido Paterno: </b>" + estu.getPaterno() + "<br>\n"
                + "                        <b>Apellido Materno: </b>" + estu.getMaterno() + "<br>\n"
                + "                        <b>Nombres: </b>" + estu.getNombres() + "<br>\n"
                + "                        <b>Fecha Nacimiento: </b>" + fechaTemp + "<br>\n"
                + "                        <b>Edad: </b>" + estu.getEdad() + "<br>\n"
                + "                        <b>Teléfono Fijo: </b>" + estu.getFijo() + "<br>\n"
                + "                        <b>Celular: </b>" + estu.getCelular() + "<br>\n"
                + "                        <b>Correo: </b>" + estu.getCorreo() + "<br>\n"
                + "                        <b>Dirección: </b>" + estu.getDireccion() + "<br>\n"
                + "                        <b>Departamento: </b>" + estu.getDepartamento() + "<br>\n"
                + "                        <b>Provincia: </b>" + estu.getProvincia() + "<br>\n"
                + "                        <b>Distrito: </b>" + estu.getDistrito() + "<br>\n"
                + "                    </p>\n"
                + "                </div>\n"
                + "                <div style=\"width: 50%;float: right;padding-right: 5%;padding-left: 5%;\">\n"
                + "                    <h4 style=\"font-weight: bold;\">Referencia de Estudiante</h4>"
                + "                    <p>\n"
                + "                        <b>Colegio de Procedencia: </b>" + estu.getProcedencia() + "<br>\n"
                + "                        <b>Tipo de Colegio: </b>" + estu.getTipo_colegio() + "<br>\n"
                + "                        <b>Tipo de Estudiante: </b>" + estu.getTipo_estudiante() + "<br>\n"
                + "                        <b>Año de Egreso: </b>" + estu.getEgreso() + "<br>\n"
                + "                        <b>Academia anterior de Preparación: </b>" + estu.getAcademia() + "<br>\n"
                + "                        <b>Universidad a la que postula: </b>" + estu.getCoduniversidad1() + "<br>\n"
                + "                        <b>Proceso de Admisión: </b>" + estu.getProceso1() + "<br>\n"
                + "                        <b>Facultad / Carrera: </b>" + estu.getCodcarrera1() + "<br>\n"
                + "                        <b>Universidad a la que postula: </b>" + estu.getCoduniversidad2() + "<br>\n"
                + "                        <b>Proceso de Admisión: </b>" + estu.getProceso2() + "<br>\n"
                + "                        <b>Facultad / Carrera: </b>" + estu.getCodcarrera2() + "<br>\n"
                + "                        <b>Universidad a la que postula: </b>" + estu.getCoduniversidad3() + "<br>\n"
                + "                        <b>Proceso de Admisión: </b>" + estu.getProceso3() + "<br>\n"
                + "                        <b>Facultad / Carrera: </b>" + estu.getCodcarrera3() + "<br>\n"
                + "                    </p>\n"
                + "                </div>\n"
                + "                <div style=\"clear: both;\"></div>\n"
                + "                <div><br /><br /></div>\n"
                + "                <div style=\"clear: both;\"></div>\n"
                + "                <div style=\"width: 50%;float: left;padding-left: 5%;padding-right: 5%;\">\n"
                + "                    <h4 style=\"font-weight: bold;\">Datos de Apoderado</h4>"
                + "                    <p>\n"
                + "                        <b>DNI: </b>" + estu.getDni_apo() + "<br>\n"
                + "                        <b>Apellido Paterno: </b>" + estu.getPaterno_apo() + "<br>\n"
                + "                        <b>Apellido Materno: </b>" + estu.getMaterno_apo() + "<br>\n"
                + "                        <b>Nombres: </b>" + estu.getNombre_apo() + "<br>\n"
                + "                        <b>Lugar de Trabajo: </b>" + estu.getTrabajo_apo() + "<br>\n"
                + "                        <b>Grado de Instrucción: </b>" + estu.getCodinstruccion() + "<br>\n"
                + "                        <b>Ocupacion: </b>" + estu.getCodprofesion() + "<br>\n"
                + "                        <b>Domicilio: </b>" + estu.getDomicilio_apo() + "<br>\n"
                + "                        <b>Correo: </b>" + estu.getCorreo_apo() + "<br>\n"
                + "                        <b>Teléfono Fijo: </b>" + estu.getFijo_apo() + "<br>\n"
                + "                        <b>Celular: </b>" + estu.getCelular_apo() + "<br>\n"
                + "                    </p>\n"
                + "                </div>\n"
                + "            </div>");
    }

    private void obtenerDatosEstudianteSession(HttpServletRequest request, HttpServletResponse response) throws IOException {

        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        int identificador = Integer.parseInt(request.getParameter("estudiante"));
        Estudiante estu = new Estudiante();
        EstudianteService servicio = new EstudianteService();
        estu = servicio.obtenerEstudiante(identificador);

        //------------------------Crear la sesiones-------------------------
        HttpSession session_actual = request.getSession(true);

        session_actual.setAttribute("estudiante", estu);

        session_actual.setMaxInactiveInterval(10 * 60 * 60); // 10 horas

        //------------------------------------------------------------------
    }

    private void editarEstudiante(HttpServletRequest request, HttpServletResponse response) throws IOException {

        int r = 0;
        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        EstudianteService servicio = new EstudianteService();
        r = servicio.editarEstudiante(request.getParameter("0"),request.getParameter("1"),
                request.getParameter("2"), request.getParameter("3"),
                request.getParameter("4"), request.getParameter("5"),
                request.getParameter("6"), request.getParameter("7"),
                request.getParameter("8"), request.getParameter("9"),
                request.getParameter("10"), request.getParameter("11"),
                request.getParameter("14"), request.getParameter("15"),
                request.getParameter("16"), request.getParameter("17"),
                request.getParameter("18"), request.getParameter("19"),
                request.getParameter("20"), request.getParameter("21"),
                request.getParameter("22"),
                request.getParameter("23"), request.getParameter("24"),
                request.getParameter("25"),
                request.getParameter("26"), request.getParameter("27"),
                request.getParameter("28"), request.getParameter("29"),
                request.getParameter("30"), request.getParameter("31"),
                request.getParameter("32"), request.getParameter("33"),
                request.getParameter("34"),
                request.getParameter("35"), request.getParameter("36"),
                request.getParameter("37"), request.getParameter("38"),
                request.getParameter("39"), request.getParameter("id"));
        pw.println(r);
    }

    private void obtenerDatosEstudianteMatricula(HttpServletRequest request , HttpServletResponse response) throws IOException {
        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
                
        System.out.println("cod estudiante :"+request.getParameter("estudiante"));
        
         int ident = Integer.parseInt(request.getParameter("estudiante").trim());
         int cod_mat=0;
         try {
             cod_mat=Integer.parseInt(request.getParameter("cod_mat"));
        } catch (Exception e) {
        }
         
         
        Estudiante estu = new Estudiante();
        String ficha="";
        EstudianteService servicio = new EstudianteService();
        estu = servicio.obtenerEstudiante(ident);
        try {
            ficha=servicio.FichaMatricula(cod_mat);
        } catch (Exception e) {
        }
        
        
        switch (estu.getTipodoc().trim()) {
            case "1":
                estu.setTipodoc("DNI");
                break;
            case "2":
                estu.setTipodoc("CARNÉ DE EXTRANJERIA");
                break;
            case "3":
                estu.setTipodoc("PASAPORTE");
                break;
            case "4":
                estu.setTipodoc("PARTIDA DE NACIMIENTO");
                break;
            default:
                break;
        }
        pw.print(estu.getCorrelativo() + ",");//0
        pw.print(estu.getTipodoc() + ",");//2
        pw.print(estu.getDni() + ",");//3
        pw.print(estu.getPaterno() + ",");//4
        pw.print(estu.getMaterno() + ",");//5
        pw.print(estu.getNombres() + ",");//6
        pw.print(estu.getCodestudiante()+",");//7
        pw.print(ficha);//8 9
    }
    private void ValidarEstudianteExitente(HttpServletRequest request, HttpServletResponse response) throws IOException {
        int r = 0;
        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        String paterno=request.getParameter("paternoE");
        String materno=request.getParameter("maternoE");
        String nombre=request.getParameter("nombreE");
        
        EstudianteService servicio = new EstudianteService();
        r = servicio.ValidarEstudianteExitente(paterno, materno, nombre);
        pw.print(r);
    }
    
   private void ListarEstudianteSinActualizar(HttpServletRequest request, HttpServletResponse response) throws IOException {


        int pagina = Integer.parseInt(request.getParameter("pag"));
        String codsede=request.getParameter("cod_sede");
        int cantPorPagina = 20;
        int cantidadRegistros = 0;
        int cantidadPaginas = 0;
        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        ArrayList<Estudiante> lista = null;
        EstudianteService servicio = new EstudianteService();
        MatriculadosService serviciom=new MatriculadosService();
        lista = servicio.listarEstudianteSinActualizar(codsede, (pagina * cantPorPagina) - cantPorPagina, cantPorPagina);
               
        cantidadRegistros = serviciom.CantASindatos(Integer.parseInt(codsede));
        cantidadPaginas = cantidadRegistros / cantPorPagina;
        pw.println("<div class=\"col-md-12\">\n"
                + "                            <div class=\"panel\">\n"
                + "                                <div class=\"panel-heading-saco\">\n"
                + "                                    <h3 class=\"panel-title pull-left\">Lista de Estudiantes</h3>\n"
                + "                                    <span class=\"pull-right\" style=\"display: block;\">\n"
                + "                                    "
                + "                                    </span>\n"
                + "                                    <div style=\"clear: both;\"></div>\n"
                + "                                </div>\n"
                + "                                <div class=\"panel-body no-padding\">\n"
                + "                                    <!-- Start sample table -->\n"
                + "                                    <div class=\"table-responsive table rounded mb-20\" id=\"imprimirTablaEstudiantes\">\n"
                + "                                        <table class=\"table table-striped table-saco\" style=\"border: 1px solid rgb(198, 198, 198); border-image: none; font-size: 11px;\">\n"
                + "                                            <thead>\n"
                + "                                                <tr>\n"
                + "                                                    <th class=\"text-center border-right\">No.</th>\n"
                + "                                                    <th class=\"text-center\">Tipo Doc</th>\n"
                + "                                                    <th class=\"text-center\">Nombres Completos</th>\n"
                + "                                                    <th class=\"text-center\">Fecha de matricula</th>\n"
                + "                                                    <th class=\"text-center\">Acciones</th>\n"
                + "                                                </tr>\n"
                + "                                            </thead>\n"
                + "                                            <tbody>\n");
        if (lista.size() == 0) {
            pw.println("<tr><td colspan='7'>No se encontraron registros.</td></tr>");
        }
        for (int i = 0; i < lista.size(); i++) {
          
            pw.println("                                     <tr>\n"
                    + "                                                    <td class=\"text-center border-right\">" + (((pagina - 1) * cantPorPagina) + 1 + i) + "</td>\n"
                    + "                                                    <td class=\"text-center border-right\">" + lista.get(i).getTipodoc() + "</td>\n"
                    + "                                                    <td class=\"text-left border-right\">" + lista.get(i).getNombres() + "</td>\n"
                    + "                                                    <td class=\"text-left border-right\">" + lista.get(i).getFecha_edicion()+ "</td>\n"
                    + "                                                    <td class=\"text-center border-right\">\n"
                    + "                                                        <a data-original-title=\"Editar Estudiante\" data-toggle=\"tooltip\" data-placement=\"top\" href=\"javascript:frmEditarEstudiante('" + lista.get(i).getCodestudiante() + "');\">\n"
                    + "                                                            <i class=\"fa fa-edit bigger-140 blue\"></i>\n"
                    + "                                                        </a>\n");

            pw.println(" "
                    + "                                                    </td>\n"
                    + "                                                </tr>\n");
        }

        pw.println("                         </tbody>\n"
                + "                                        </table>\n");

// ------------------ paginacion

        pw.println("<div class=\"col-xs-12\" style=\"border-right-color: rgb(198, 198, 198); border-bottom-color: rgb(198, 198, 198); border-left-color: rgb(198, 198, 198); border-right-width: 1px; border-bottom-width: 1px; border-left-width: 1px; border-right-style: solid; border-bottom-style: solid; border-left-style: solid; background-color: rgb(239, 243, 248);\">                                              \n"
                + "                                            <div class=\"col-xs-7\">\n"
                + "                                                <div class=\"dataTables_paginate paging_simple_numbers\" id=\"datatable-ajax_paginate\">\n"
                + "                                                    <ul class=\"pagination\">  \n");
        if (pagina == 1) {
            pw.println("<li tabindex=\"0\" class=\"paginate_button previous disabled\" id=\"sample-table-2_previous\" aria-controls=\"sample-table-2\"> <a> &lt;&lt; </a></li>\n");
        } else {
            pw.println("<li tabindex=\"0\" class=\"paginate_button previous\" id=\"sample-table-2_previous\" aria-controls=\"sample-table-2\"> <a href=\"javascript:ListarEstudianteSinActualizar('1');\"> &lt;&lt; </a></li>\n");
        }
        if (pagina > 1) {
            pw.println("<li tabindex=\"0\" class=\"paginate_button previous\" id=\"sample-table-2_previous\" aria-controls=\"sample-table-2\"> <a href=\"javascript:ListarEstudianteSinActualizar('" + (pagina - 1) + "');\">Anterior</a></li>\n");
        } else {
            pw.println("<li tabindex=\"0\" class=\"paginate_button previous disabled\" id=\"sample-table-2_previous\" aria-controls=\"sample-table-2\"> <a>Anterior</a></li>\n");
        }

        for (int x = 1; x <= (cantidadPaginas + 1); x++) {
            if (x >= (pagina - 0) && x <= (pagina + 4)) {
                if (pagina == x) {
                    pw.println("<li tabindex=\"0\" class=\"paginate_button active\" aria-controls=\"sample-table-2\"><a href=\"javascript:void(0);\">" + x + "</a></li>\n");
                } else {
                    pw.println("<li tabindex=\"0\" class=\"paginate_button\" aria-controls=\"sample-table-2\"><a href=\"javascript:ListarEstudianteSinActualizar('" + x + "');\">" + x + "</a></li>\n");
                }
            }
        }
        if (pagina < (cantidadPaginas + 1)) {
            pw.println("<li tabindex=\"0\" class=\"paginate_button next\" id=\"sample-table-2_next\" aria-controls=\"sample-table-2\"> <a href=\"javascript:ListarEstudianteSinActualizar('" + (pagina + 1) + "');\">Siguiente</a></li>\n");
            pw.println("<li tabindex=\"0\" class=\"paginate_button next\" id=\"sample-table-2_next\" aria-controls=\"sample-table-2\"> <a href=\"javascript:ListarEstudianteSinActualizar('" + (cantidadPaginas + 1) + "');\"> &gt;&gt; </a></li>\n");
        } else {
            pw.println("<li tabindex=\"0\" class=\"paginate_button next disabled\" id=\"sample-table-2_next\" aria-controls=\"sample-table-2\"> <a>Siguiente</a></li>\n");
            pw.println("<li tabindex=\"0\" class=\"paginate_button next disabled\" id=\"sample-table-2_next\" aria-controls=\"sample-table-2\"> <a> &gt;&gt; </a></li>\n");
        }

        pw.println("                                                    </ul>                                                  \n"
                + "                                                </div>                                             \n"
                + "                                            </div>                                              \n"
                + "                                            <div class=\"col-xs-5\">\n"
                + "                                                <table style=\"width: 100%; height: 72px;\" border=\"0\">\n"
                + "                                                    <tbody>\n"
                + "                                                        <tr>                                                          \n"
                + "                                                            <td style=\"text-align: right; vertical-align: middle; background-color: transparent!important;\">Mostrando del " + ((pagina * cantPorPagina) - cantPorPagina + 1) + " al " + ((pagina * cantPorPagina)) + " de " + cantidadRegistros + " Estudiantes</td> \n"
                + "                                                        </tr> \n"
                + "                                                    </tbody>\n"
                + "                                                </table>\n"
                + "                                            </div>  \n"
                + "                                        </div>");

        pw.println("                                    </div><!-- /.table -->\n"
                + "                                    <!--/ End sample table -->\n"
                + "                                </div>\n"
                + "                            </div>\n"
                + "                        </div>");
    }
   public  void validarDNI(HttpServletRequest request,HttpServletResponse response)throws IOException{
      String Dni=request.getParameter("doc");
//      response.setContentType("text/html");
      PrintWriter pw=response.getWriter();
       EstudianteService est=new EstudianteService();
       int cod=0;
       cod=est.validarDNI(Dni);
       System.out.println(cod+"d");
      pw.println(cod);
       
   }
}
