package pe.siso.academia.Servlets;

import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import pe.siso.academia.Beans.Aula;
import pe.siso.academia.Beans.Documento;
import pe.siso.academia.Beans.Estudiante;
import pe.siso.academia.Beans.Matricula;
import pe.siso.academia.Beans.Pension;
import pe.siso.academia.Services.DocumentoService;
import pe.siso.academia.Services.EstudianteService;
import pe.siso.academia.Services.MatriculaService;

public class ServletMatricula extends HttpServlet {

    @Override
    protected void service(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
        String param=request.getParameter("accion");
        if("listarMatriculas".equals(param)){
            listarMatriculas(request, response);
        }
        else if("listarCmbCentros".equals(param)){
            listarCmbCentros(request, response);
        }
        else if("listarCmbNivel".equals(param)){
            listarCmbNivel(request, response);
        }
        else if("listarCmbTipoGrado".equals(param)){
            listarCmbTipoGrado(request, response);
        }
        else if("listarCmbGrado".equals(param)){
            listarCmbGrado(request, response);
        }
        else if("listarCmbTurno".equals(param)){
            listarCmbTurno(request, response);
        }
        else if("listarCmbSeccion".equals(param)){
            listarCmbSeccion(request, response);
        }
        else if("obtenerAula".equals(param)){
            obtenerAula(request, response);
        }
        else if("llenarPensiones".equals(param)){
            llenarPensiones(request, response);
        }
        else if("insertarMatricula".equals(param)){
            insertarMatricula(request, response);
        }
        else if("listarMatriculados".equals(param)){
            listarMatriculados(request, response);
        }
        else if("deshabilitarMatricula".equals(param)){
            deshabilitarMatricula(request, response);
        }
        else if("imprimirMatricula".equals(param)){
            imprimirMatricula(request, response);
        }
        else if("obtenerMatricula".equals(param)){
            obtenerMatricula(request, response);
        }
        else if("actualizarMatricula".equals(param)){
            actualizarMatricula(request, response);
        }
        else if("validarMatriculaExistente".equals(param)){
            validarMatriculaExistente(request, response);
        }
    }
    
    private void listarMatriculas(HttpServletRequest request, HttpServletResponse response) throws IOException {
        int sede = Integer.parseInt(request.getParameter("codsede"));
        String filtro = request.getParameter("filtro");
        if(filtro == null){filtro = "";}
        int pagina = Integer.parseInt(request.getParameter("pag"));
        int cantPorPagina = 20;
        int cantidadRegistros = 0;
        int cantidadPaginas = 0;
        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        ArrayList<Matricula> lista = null;
        MatriculaService servicio = new MatriculaService();
        lista = servicio.listarMatriculas(sede,filtro,  (pagina*cantPorPagina)-cantPorPagina, cantPorPagina);
        cantidadRegistros = servicio.contarMatriculas(sede,filtro);
        cantidadPaginas = cantidadRegistros/cantPorPagina;
        pw.println("<div class=\"col-md-12\">\n" +
"                            <div class=\"panel\">\n" +
"                                <div class=\"panel-heading-saco\">\n" +
"                                    <h3 class=\"panel-title pull-left\">Lista de Estudiantes / Matriculas</h3>\n" +
"                                    <span class=\"pull-right\" style=\"display: block;\">\n" + 
"                                    </span>\n" +
"                                    <div style=\"clear: both;\"></div>\n" +
"                                </div>\n" +
"                                <div class=\"panel-body no-padding\">\n" +
"                                    <!-- Start sample table -->\n" +
"                                    <div class=\"table rounded mb-20\" id=\"imprimirTablaDocumentos\">\n" +
"                                        <table class=\"table table-striped table-saco\" style=\"border: 1px solid rgb(198, 198, 198); border-image: none; font-size: 11px;\">\n" +
"                                            <thead>\n" +
"                                                <tr>\n" +
"                                                    <th class=\"text-center border-right\">No.</th>\n" +
"                                                    <th class=\"text-center\">Documento</th>\n" +
"                                                    <th class=\"text-center\">Alumno</th>\n" +
//"                                                    <th class=\"text-center\">Sede</th>\n" +
"                                                    <th class=\"text-center\">Ciclo</th>\n" +
"                                                    <th class=\"text-center\">Tipo Grado</th>\n" +
"                                                    <th class=\"text-center\">Universidad</th>\n" +
"                                                    <th class=\"text-center\">Turno</th>\n" +
"                                                    <th class=\"text-center\">Fecha</th>\n" +
"                                                    <th class=\"text-center\">Estado</th>\n" +
"                                                    <th class=\"text-center\" style=\"width:100px;\">Acciones</th>\n" +
"                                                </tr>\n" +
"                                            </thead>\n" +
"                                            <tbody>\n");
        
        if(lista.size()==0){
            pw.println("<tr><td colspan='10'><center>No se encontraron registros.</center></td></tr>");
        }
                for(int i = 0; i<lista.size();i++){
                    pw.println("<tr>\n");
                    pw.println("<td class=\"text-center border-right\">"+(((pagina-1)*cantPorPagina)+1+i)+"</td>\n");
                    pw.println("<td class=\"text-center\">" + (lista.get(i).getDocEstudiante() == null ? "" : lista.get(i).getDocEstudiante()) + "</td>\n");
                    pw.println("<td class=\"\">" + (lista.get(i).getNombres_est() == null ? "" : lista.get(i).getNombres_est()) + "</td>\n");
 //                   pw.println("<td class=\"text-center\">" + (lista.get(i).getNom_Sede() == null ? "" : lista.get(i).getNom_Sede()) + "</td>\n");
                    pw.println("<td class=\"text-center\">" + (lista.get(i).getNom_nivel() == null ? "" : lista.get(i).getNom_nivel()) + "</td>\n");
                    pw.println("<td class=\"text-center\">" + (lista.get(i).getNom_grado() == null ? "" : lista.get(i).getNom_grado()) + "</td>\n");
                    pw.println("<td class=\"text-center\">" + (lista.get(i).getNom_Ciclo() == null ? "" : lista.get(i).getNom_Ciclo()) + "</td>\n");
                    pw.println("<td class=\"text-center\">" + (lista.get(i).getNom_Turno() == null ? "" : lista.get(i).getNom_Turno()) + "</td>\n");
                    pw.println("<td class=\"text-center\">" + (lista.get(i).getFecha_matri() == null ? "" : lista.get(i).getFecha_matri().split("-")[2]+"/"+lista.get(i).getFecha_matri().split("-")[1]+"/"+lista.get(i).getFecha_matri().split("-")[0]) + "</td>\n");
                    if(lista.get(i).getEstado() == null){lista.get(i).setEstado("-1");}
                    switch(lista.get(i).getEstado()){
                        case "0":
                            lista.get(i).setEstado("<span class=\"label label-danger\">INACTIVO</span>");
                            break;
                        case "1":
                            lista.get(i).setEstado("<span class=\"label label-success\">ACTIVO</span>");
                            break;
                        default:
                            lista.get(i).setEstado("<span class=\"label label-warning\">PENDIENTE</span>");
                            break;
                    }
                    pw.println("<td class=\"text-center\">" + (lista.get(i).getEstado() == null ? "" : lista.get(i).getEstado()) + "</td>\n");
                    pw.println("<td class=\"text-center\">");
                    switch(lista.get(i).getEstado()){
                        case "<span class=\"label label-success\">ACTIVO</span>":
                            //pw.println("<a data-original-title=\"Matricular\" data-toggle=\"tooltip\" data-placement=\"top\" href=\"javascript:matricular(" + lista.get(i).getCodEstudiante() + ");\"><i class=\"fa fa-pencil-square-o bigger-140 blue\"></i></a>");
                            pw.println("<a data-original-title=\"Editar Matricula\" data-toggle=\"tooltip\" data-placement=\"top\" href=\"javascript:editarmatricula(" + lista.get(i).getCodEstudiante() + "," + lista.get(i).getCodMatricula() + ");\"><i class=\"fa fa-pencil-square-o bigger-140 blue\"></i></a>");
                            if(lista.get(i).getCantPensionesEditadas()>0){
                                pw.println("<a data-original-title=\"Trasladar Estudiante\" data-toggle=\"tooltip\" data-placement=\"top\" href=\"javascript:trasladoMatricula(" + lista.get(i).getCodEstudiante() + "," + lista.get(i).getCodMatricula() + ");\"><i class=\"fa fa-refresh bigger-140 pink2\"></i></a>");
                            }
                            else{
                                pw.println("<a href=\"javascript:void(0);\"><i class=\"fa fa-refresh bigger-140\"></i></a>");
                            }
                            pw.println("<a data-original-title=\"Cancelar Matricula\" data-toggle=\"tooltip\" data-placement=\"top\" href=\"javascript:mostrareliminar(" + lista.get(i).getCodMatricula() + ");\"><i class=\"fa fa-times bigger-140 red\"></i></a>");
                            pw.println("<a data-original-title=\"Imprimir Matricula\" data-toggle=\"tooltip\" data-placement=\"top\" href=\"javascript:imprimir(" + lista.get(i).getCodMatricula() + ");\"><i class=\"fa fa-print bigger-140 green\"></i></a>");
                            break;
                        case "<span class=\"label label-danger\">INACTIVO</span>":
                            //pw.println("<a data-original-title=\"Matricular\" data-toggle=\"tooltip\" data-placement=\"top\" href=\"javascript:matricular(" + lista.get(i).getCodEstudiante() + ");\"><i class=\"fa fa-pencil-square-o bigger-140 blue\"></i></a>");
                            pw.println("<a data-original-title=\"Imprimir Matricula\" data-toggle=\"tooltip\" data-placement=\"top\" href=\"javascript:imprimir(" + lista.get(i).getCodMatricula() + ");\"><i class=\"fa fa-print bigger-140 green\"></i></a>");
                            break;
                        case "<span class=\"label label-warning\">PENDIENTE</span>":
                            //pw.println("<a data-original-title=\"Matricular\" data-toggle=\"tooltip\" data-placement=\"top\" href=\"javascript:matricular(" + lista.get(i).getCodEstudiante() + ");\"><i class=\"fa fa-pencil-square-o bigger-140 blue\"></i></a>");
                            break;
                    }
                    pw.println("</td>\n");
                    pw.println("</tr>\n");
                    pw.println();
                }

pw.println("                         </tbody>\n" +
"                                        </table>\n" );

pw.println("<div class=\"col-xs-12\" style=\"border-right-color: rgb(198, 198, 198); border-bottom-color: rgb(198, 198, 198); border-left-color: rgb(198, 198, 198); border-right-width: 1px; border-bottom-width: 1px; border-left-width: 1px; border-right-style: solid; border-bottom-style: solid; border-left-style: solid; background-color: rgb(239, 243, 248);\">                                              \n" +
"                                            <div class=\"col-xs-7\">\n" +
"                                                <div class=\"dataTables_paginate paging_simple_numbers\" id=\"datatable-ajax_paginate\">\n" +
"                                                    <ul class=\"pagination\">  \n" );
if(pagina==1){
    pw.println("<li tabindex=\"0\" class=\"paginate_button previous disabled\" id=\"sample-table-2_previous\" aria-controls=\"sample-table-2\"> <a> &lt;&lt; </a></li>\n" );
}
else{
    pw.println("<li tabindex=\"0\" class=\"paginate_button previous\" id=\"sample-table-2_previous\" aria-controls=\"sample-table-2\"> <a href=\"javascript:listarMatriculas('1');\"> &lt;&lt; </a></li>\n" );
}
if(pagina>1){
    pw.println("<li tabindex=\"0\" class=\"paginate_button previous\" id=\"sample-table-2_previous\" aria-controls=\"sample-table-2\"> <a href=\"javascript:listarMatriculas('"+(pagina-1)+"');\">Anterior</a></li>\n" );
}
else{
    pw.println("<li tabindex=\"0\" class=\"paginate_button previous disabled\" id=\"sample-table-2_previous\" aria-controls=\"sample-table-2\"> <a>Anterior</a></li>\n" );
}


for(int x=1;x<=(cantidadPaginas+1);x++){
    if(x>=(pagina-0) && x<=(pagina+4)){
        if(pagina==x){
            pw.println("<li tabindex=\"0\" class=\"paginate_button active\" aria-controls=\"sample-table-2\"><a href=\"javascript:void(0);\">"+x+"</a></li>\n" );
        }
        else{
            pw.println("<li tabindex=\"0\" class=\"paginate_button\" aria-controls=\"sample-table-2\"><a href=\"javascript:listarMatriculas('"+x+"');\">"+x+"</a></li>\n" );
        }
    }
}
if(pagina<(cantidadPaginas+1)){
    pw.println("<li tabindex=\"0\" class=\"paginate_button next\" id=\"sample-table-2_next\" aria-controls=\"sample-table-2\"> <a href=\"javascript:listarMatriculas('"+(pagina+1)+"');\">Siguiente</a></li>\n" );
    pw.println("<li tabindex=\"0\" class=\"paginate_button next\" id=\"sample-table-2_next\" aria-controls=\"sample-table-2\"> <a href=\"javascript:listarMatriculas('"+(cantidadPaginas+1)+"');\"> &gt;&gt; </a></li>\n" );
}
else{
    pw.println("<li tabindex=\"0\" class=\"paginate_button next disabled\" id=\"sample-table-2_next\" aria-controls=\"sample-table-2\"> <a>Siguiente</a></li>\n" );
    pw.println("<li tabindex=\"0\" class=\"paginate_button next disabled\" id=\"sample-table-2_next\" aria-controls=\"sample-table-2\"> <a> &gt;&gt; </a></li>\n" );
}

pw.println("                                                    </ul>                                                  \n" +
"                                                </div>                                             \n" +
"                                            </div>                                              \n" +
"                                            <div class=\"col-xs-5\">\n" +
"                                                <table style=\"width: 100%; height: 72px;\" border=\"0\">\n" +
"                                                    <tbody>\n" +
"                                                        <tr>                                                          \n" +
"                                                            <td style=\"text-align: right; vertical-align: middle; background-color: transparent!important;\">Mostrando del "+((pagina*cantPorPagina)-cantPorPagina+1)+" al "+((pagina*cantPorPagina))+" de "+cantidadRegistros+" Matriculas</td> \n" +
"                                                        </tr> \n" +
"                                                    </tbody>\n" +
"                                                </table>\n" +
"                                            </div>  \n" +
"                                        </div>");

pw.println("                                    </div><!-- /.table -->\n" +
"                                    <!--/ End sample table -->\n" +
"                                </div>\n" +
"                            </div>\n" +
"                        </div>");

    }
    
    private void listarMatriculados(HttpServletRequest request, HttpServletResponse response) throws IOException {
        String filtro = request.getParameter("filtro");
        int sede = Integer.parseInt(request.getParameter("codsede"));
        if(filtro == null){filtro = "";}
        int pagina = Integer.parseInt(request.getParameter("pag"));
        int cantPorPagina = 20;
        int cantidadRegistros = 0;
        int cantidadPaginas = 0;
        
        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        ArrayList<Matricula> lista = null;
        MatriculaService servicio = new MatriculaService();
        lista = servicio.listarMatriculados(sede, filtro,  (pagina*cantPorPagina)-cantPorPagina, cantPorPagina);
        cantidadRegistros = servicio.contarMatriculados(sede, filtro);
        cantidadPaginas = cantidadRegistros/cantPorPagina;
        pw.println("<div class=\"col-md-12\">\n" +
"                            <div class=\"panel\">\n" +
"                                <div class=\"panel-heading-saco\">\n" +
"                                    <h3 class=\"panel-title pull-left\">Lista de Estudiantes / Matriculas</h3>\n" +
"                                    <span class=\"pull-right\" style=\"display: block;\">\n" + 
"                                    </span>\n" +
"                                    <div style=\"clear: both;\"></div>\n" +
"                                </div>\n" +
"                                <div class=\"panel-body no-padding\">\n" +
"                                    <!-- Start sample table -->\n" +
"                                    <div class=\"table rounded mb-20\" id=\"imprimirTablaDocumentos\">\n" +
"                                        <table class=\"table table-striped table-saco\" style=\"border: 1px solid rgb(198, 198, 198); border-image: none; font-size: 11px;\">\n" +
"                                            <thead>\n" +
"                                                <tr>\n" +
"                                                    <th class=\"text-center border-right\">No.</th>\n" +
"                                                    <th class=\"text-center\">Documento</th>\n" +
"                                                    <th class=\"text-center\">Alumno</th>\n" +
// "                                                    <th class=\"text-center\">Sede</th>\n" +
"                                                    <th class=\"text-center\">Ciclo</th>\n" +
"                                                    <th class=\"text-center\">Tipo Grado</th>\n" +
"                                                    <th class=\"text-center\">Universidad</th>\n" +
"                                                    <th class=\"text-center\">Turno</th>\n" +
"                                                    <th class=\"text-center\">Fecha</th>\n" +
"                                                    <th class=\"text-center\">Estado</th>\n" +
"                                                    <th class=\"text-center\" style=\"width:100px;\">Acciones</th>\n" +
"                                                </tr>\n" +
"                                            </thead>\n" +
"                                            <tbody>\n");
        
        if(lista.size()==0){
            pw.println("<tr><td colspan='10'><center>No se encontraron registros.</center></td></tr>");
        }
                for(int i = 0; i<lista.size();i++){
                    pw.println("<tr>\n");
                    pw.println("<td class=\"text-center border-right\">"+(((pagina-1)*cantPorPagina)+1+i)+"</td>\n");
                    pw.println("<td class=\"text-center\">" + (lista.get(i).getDocEstudiante() == null ? "" : lista.get(i).getDocEstudiante()) + "</td>\n");
                    pw.println("<td class=\"\">" + (lista.get(i).getNombres_est() == null ? "" : lista.get(i).getNombres_est()) + "</td>\n");
 //                   pw.println("<td class=\"text-center\">" + (lista.get(i).getNom_Sede() == null ? "" : lista.get(i).getNom_Sede()) + "</td>\n");
                    pw.println("<td class=\"text-center\">" + (lista.get(i).getNom_nivel() == null ? "" : lista.get(i).getNom_nivel()) + "</td>\n");
                    pw.println("<td class=\"text-center\">" + (lista.get(i).getNom_grado() == null ? "" : lista.get(i).getNom_grado()) + "</td>\n");
                    pw.println("<td class=\"text-center\">" + (lista.get(i).getNom_Ciclo() == null ? "" : lista.get(i).getNom_Ciclo()) + "</td>\n");
                    pw.println("<td class=\"text-center\">" + (lista.get(i).getNom_Turno() == null ? "" : lista.get(i).getNom_Turno()) + "</td>\n");
                    pw.println("<td class=\"text-center\">" + (lista.get(i).getFecha_matri() == null ? "" : lista.get(i).getFecha_matri().split("-")[2]+"/"+lista.get(i).getFecha_matri().split("-")[1]+"/"+lista.get(i).getFecha_matri().split("-")[0]) + "</td>\n");
                    if(lista.get(i).getEstado() == null){lista.get(i).setEstado("-1");}
                    switch(lista.get(i).getEstado()){
                        case "0":
                            lista.get(i).setEstado("<span class=\"label label-danger\">ANULADO</span>");
                            break;
                        case "1":
                            if(lista.get(i).getCant()==0){
                                lista.get(i).setEstado("<span class=\"label label-success\">CANCELADO</span>");
                            }else{
                                lista.get(i).setEstado("<span class=\"label label-warning\">ACTIVO</span>");
                            }
                            break;
                        case "2":
                                lista.get(i).setEstado("<span class=\"label label-lilac\">TRASLADO</span>");
                            break;
                        default:
                            lista.get(i).setEstado("Pendiente");
                            break;
                    }
                    pw.println("<td class=\"text-center\">" + (lista.get(i).getEstado() == null ? "" : lista.get(i).getEstado()) + "</td>\n");
                    pw.println("<td class=\"text-center\">");
                    if(lista.get(i).getCant()==0){
                        pw.println("<a data-original-title=\"Ver Pensiones Canceladas\" data-toggle=\"tooltip\" data-placement=\"top\" href=\"javascript:verPensiones('" + lista.get(i).getCodEstudiante() + "," + lista.get(i).getCodMatricula()+ "');\"><i class=\"fa fa-times fa-2x red\"></i></a>");
                    }else{
                       pw.println("<a data-original-title=\"Ver Pensiones Activas\" data-toggle=\"tooltip\" data-placement=\"top\" href=\"javascript:verPensiones('" + lista.get(i).getCodEstudiante() + "," + lista.get(i).getCodMatricula()+ "');\"><i class=\"fa fa-money fa-2x green\"></i></a>"); 
                    }
                    pw.println("</td>\n");
                    
                    pw.println("</tr>\n");
                    pw.println();
                }

pw.println("                         </tbody>\n" +
"                                        </table>\n" );

pw.println("<div class=\"col-xs-12\" style=\"border-right-color: rgb(198, 198, 198); border-bottom-color: rgb(198, 198, 198); border-left-color: rgb(198, 198, 198); border-right-width: 1px; border-bottom-width: 1px; border-left-width: 1px; border-right-style: solid; border-bottom-style: solid; border-left-style: solid; background-color: rgb(239, 243, 248);\">                                              \n" +
"                                            <div class=\"col-xs-7\">\n" +
"                                                <div class=\"dataTables_paginate paging_simple_numbers\" id=\"datatable-ajax_paginate\">\n" +
"                                                    <ul class=\"pagination\">  \n" );
if(pagina==1){
    pw.println("<li tabindex=\"0\" class=\"paginate_button previous disabled\" id=\"sample-table-2_previous\" aria-controls=\"sample-table-2\"> <a> &lt;&lt; </a></li>\n" );
}
else{
    pw.println("<li tabindex=\"0\" class=\"paginate_button previous\" id=\"sample-table-2_previous\" aria-controls=\"sample-table-2\"> <a href=\"javascript:listarMatriculas('1');\"> &lt;&lt; </a></li>\n" );
}
if(pagina>1){
    pw.println("<li tabindex=\"0\" class=\"paginate_button previous\" id=\"sample-table-2_previous\" aria-controls=\"sample-table-2\"> <a href=\"javascript:listarMatriculas('"+(pagina-1)+"');\">Anterior</a></li>\n" );
}
else{
    pw.println("<li tabindex=\"0\" class=\"paginate_button previous disabled\" id=\"sample-table-2_previous\" aria-controls=\"sample-table-2\"> <a>Anterior</a></li>\n" );
}


for(int x=1;x<=(cantidadPaginas+1);x++){
    if(x>=(pagina-0) && x<=(pagina+4)){
        if(pagina==x){
            pw.println("<li tabindex=\"0\" class=\"paginate_button active\" aria-controls=\"sample-table-2\"><a href=\"javascript:void(0);\">"+x+"</a></li>\n" );
        }
        else{
            pw.println("<li tabindex=\"0\" class=\"paginate_button\" aria-controls=\"sample-table-2\"><a href=\"javascript:listarMatriculas('"+x+"');\">"+x+"</a></li>\n" );
        }
    }
}
if(pagina<(cantidadPaginas+1)){
    pw.println("<li tabindex=\"0\" class=\"paginate_button next\" id=\"sample-table-2_next\" aria-controls=\"sample-table-2\"> <a href=\"javascript:listarMatriculas('"+(pagina+1)+"');\">Siguiente</a></li>\n" );
    pw.println("<li tabindex=\"0\" class=\"paginate_button next\" id=\"sample-table-2_next\" aria-controls=\"sample-table-2\"> <a href=\"javascript:listarMatriculas('"+(cantidadPaginas+1)+"');\"> &gt;&gt; </a></li>\n" );
}
else{
    pw.println("<li tabindex=\"0\" class=\"paginate_button next disabled\" id=\"sample-table-2_next\" aria-controls=\"sample-table-2\"> <a>Siguiente</a></li>\n" );
    pw.println("<li tabindex=\"0\" class=\"paginate_button next disabled\" id=\"sample-table-2_next\" aria-controls=\"sample-table-2\"> <a> &gt;&gt; </a></li>\n" );
}

pw.println("                                                    </ul>                                                  \n" +
"                                                </div>                                             \n" +
"                                            </div>                                              \n" +
"                                            <div class=\"col-xs-5\">\n" +
"                                                <table style=\"width: 100%; height: 72px;\" border=\"0\">\n" +
"                                                    <tbody>\n" +
"                                                        <tr>                                                          \n" +
"                                                            <td style=\"text-align: right; vertical-align: middle; background-color: transparent!important;\">Mostrando del "+((pagina*cantPorPagina)-cantPorPagina+1)+" al "+((pagina*cantPorPagina))+" de "+cantidadRegistros+" Matriculas</td> \n" +
"                                                        </tr> \n" +
"                                                    </tbody>\n" +
"                                                </table>\n" +
"                                            </div>  \n" +
"                                        </div>");

pw.println("                                    </div><!-- /.table -->\n" +
"                                    <!--/ End sample table -->\n" +
"                                </div>\n" +
"                            </div>\n" +
"                        </div>");

    }
    
    private void listarCmbCentros(HttpServletRequest request, HttpServletResponse response) throws IOException {
        int codSede = 0;
        if(request.getParameter("sede").length() > 0){
            codSede = Integer.parseInt(request.getParameter("sede"));
        }
        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        ArrayList<Matricula> lista = null;
        MatriculaService servicio = new MatriculaService();
        lista = servicio.listarCentros(codSede);
        pw.println("<select class=\"form-control validate[required]\" onchange=\"llenarCmbNivel();\">");
        pw.println("    <option value=\"\">[SELECCIONE OPCION]</option>");
        for (int i = 0; i < lista.size(); i++) {
            pw.println("    <option value=\"" + lista.get(i).getCod_Centro() + "\">" + lista.get(i).getNom_Centro() + "</option>");
        }
        pw.println("</select>");
    }
    
    private void listarCmbNivel(HttpServletRequest request, HttpServletResponse response) throws IOException {
        int codSede = 0;
        int codCentro = 0;
        if(request.getParameter("sede").length() > 0 && request.getParameter("centro").length() > 0){
            codSede = Integer.parseInt(request.getParameter("sede"));
            codCentro = Integer.parseInt(request.getParameter("centro"));
        }
        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        ArrayList<Matricula> lista = null;
        MatriculaService servicio = new MatriculaService();
        lista = servicio.listarNiveles(codSede, codCentro);
        pw.println("<select class=\"form-control validate[required]\" onchange=\"llenarCmbGrado();\">");
        pw.println("    <option value=\"\">[SELECCIONE OPCION]</option>");
        for (int i = 0; i < lista.size(); i++) {
            pw.println("    <option data-grado='"+lista.get(i).getCod_grado()+"' value=\"" + lista.get(i).getCod_nivel()+ "\">" + lista.get(i).getNom_nivel()+ "</option>");
        }
        pw.println("</select>");
    }
    
    private void listarCmbTipoGrado(HttpServletRequest request, HttpServletResponse response) throws IOException {
        int codSede = 0;
        int codCentro = 0;
        int codNivel = 0;
        if(request.getParameter("sede").length() > 0 && request.getParameter("centro").length() > 0 && request.getParameter("nivel").length() > 0){
            codSede = Integer.parseInt(request.getParameter("sede"));
            codCentro = Integer.parseInt(request.getParameter("centro"));
            codNivel = Integer.parseInt(request.getParameter("nivel"));
        }
        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        ArrayList<Matricula> lista = null;
        MatriculaService servicio = new MatriculaService();
        lista = servicio.listarTiposGrado(codSede, codCentro, codNivel);
        pw.println("<select class=\"form-control validate[required]\" onchange=\"llenarCmbGrado();\">");
        pw.println("    <option value=\"\">[SELECCIONE OPCION]</option>");
        for (int i = 0; i < lista.size(); i++) {
            pw.println("    <option value=\"" + lista.get(i).getCod_grado()+ "\">" + lista.get(i).getNom_grado()+ "</option>");
        }
        pw.println("</select>");
    }
    
    private void listarCmbGrado(HttpServletRequest request, HttpServletResponse response) throws IOException {
        int codSede = 0;
        int codCentro = 0;
        int codNivel = 0;
        int codTipGrado = 0;
        if(request.getParameter("sede").length() > 0 && request.getParameter("centro").length() > 0 && request.getParameter("nivel").length() > 0 && request.getParameter("tipo").length() > 0){
            codSede = Integer.parseInt(request.getParameter("sede"));
            codCentro = Integer.parseInt(request.getParameter("centro"));
            codNivel = Integer.parseInt(request.getParameter("nivel"));
            codTipGrado = Integer.parseInt(request.getParameter("tipo"));
        }
        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        ArrayList<Matricula> lista = null;
        MatriculaService servicio = new MatriculaService();
        lista = servicio.listarGrados(codSede, codCentro, codNivel, codTipGrado);
        pw.println("<select class=\"form-control validate[required]\" onchange=\"llenarCmbTurno();\">");
        pw.println("    <option value=\"\">[SELECCIONE OPCION]</option>");
        for (int i = 0; i < lista.size(); i++) {
            pw.println("    <option value=\"" + lista.get(i).getCod_Ciclo()+ "\">" + lista.get(i).getNom_Ciclo()+ "</option>");
        }
        pw.println("</select>");
    }
    
    private void listarCmbTurno(HttpServletRequest request, HttpServletResponse response) throws IOException {
        int codSede = 0;
        int codCentro = 0;
        int codNivel = 0;
        int codTipGrado = 0;
        int codGrado = 0;
        if(request.getParameter("sede").length() > 0 && request.getParameter("centro").length() > 0 && request.getParameter("nivel").length() > 0 && request.getParameter("tipo").length() > 0 && request.getParameter("grado").length() > 0){
            codSede = Integer.parseInt(request.getParameter("sede"));
            codCentro = Integer.parseInt(request.getParameter("centro"));
            codNivel = Integer.parseInt(request.getParameter("nivel"));
            codTipGrado = Integer.parseInt(request.getParameter("tipo"));
            codGrado = Integer.parseInt(request.getParameter("grado"));
        }
        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        ArrayList<Matricula> lista = null;
        MatriculaService servicio = new MatriculaService();
        lista = servicio.listarTurnos(codSede, codCentro, codNivel, codTipGrado, codGrado);
        pw.println("<select class=\"form-control validate[required]\" onchange=\"llenarCmbSeccion();obtenerAula();verificarAulaModificar();\">");
        pw.println("    <option value=\"\">[SELECCIONE OPCION]</option>");
        for (int i = 0; i < lista.size(); i++) {
            pw.println("    <option value=\"" + lista.get(i).getCod_Turno()+ "\" data-aula=\"" + lista.get(i).getCod_aula()+ "\">" + lista.get(i).getNom_Turno()+ "</option>");
        }
        pw.println("</select>");
    }
    
    private void listarCmbSeccion(HttpServletRequest request, HttpServletResponse response) throws IOException {
        int aula = 0;
        if(request.getParameter("aula").length() > 0){
            aula = Integer.parseInt(request.getParameter("aula"));
        }
        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        ArrayList<Matricula> lista = null;
        MatriculaService servicio = new MatriculaService();
        lista = servicio.listarSecciones(aula);
        pw.println("<select class=\"form-control validate[required]\">");
       
        for (int i = 0; i < lista.size(); i++) {
            pw.println("    <option value=\"" + lista.get(i).getNom_Seccion()+ "\">" + lista.get(i).getNom_Seccion()+ "</option>");
        }
        pw.println("</select>");
    }
    
    private void obtenerAula(HttpServletRequest request, HttpServletResponse response) throws IOException {
        int codaula = 0;
        if(request.getParameter("aula").length() > 0){
            codaula = Integer.parseInt(request.getParameter("aula"));
        }
        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        Aula aula = null;
        MatriculaService servicio = new MatriculaService();
        aula = servicio.obtenerAula(codaula);
        pw.print(aula.getFechaInicio() + ",");
        pw.print(aula.getFechaTermino() + ",");
        pw.print(aula.getCuotas());
    }
    
    private void llenarPensiones(HttpServletRequest request, HttpServletResponse response) throws IOException {
        int codaula = 0;
        if(request.getParameter("aula").length() > 0){
            codaula = Integer.parseInt(request.getParameter("aula"));
        }
        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        ArrayList<Pension> lista = new ArrayList<>();
        MatriculaService servicio = new MatriculaService();
        lista = servicio.obtenerPensionesPorAula(codaula);
        pw.println("<input type=\"hidden\" value=\""+lista.get(0).getMontoPension()+"\" id=\"monto-max\" ><div class=\"col-md-12\">");
        pw.println("<div class=\"panel rounded shadow panel-blueDark panelborder\">"
                + "<div class=\"panel-heading blue2\">\n" 
                + "<div class=\"pull-left\">\n" 
                + "<h3 class=\"panel-title\">\n" 
                + "<i class=\"fa fa-money\"></i>\n" 
                + "Pensiones\n" 
                + "</h3>\n" 
                + "</div>\n" 
                + "<div class=\"clearfix\"></div>\n" 
                + "</div>"
                + "<div class=\"panel-body\">"
                + "<table class=\"table table-striped table-saco\">"
                + "<thead>"
                + "<tr>"
                + "<th>N°</th>"
                + "<th>Descripcion</th>"
                + "<th>Monto</th>"
                + "<th>Fecha Caducidad</th>"
                + "</tr>"
                + "</thead>"
                + "<tbody>");
        for (int i = 0; i < lista.size(); i++) {
            pw.println("<tr>");
            pw.println("<td data-id=\"" + lista.get(i).getCodPension() + "\">" + (i+1) + "</td>");
            pw.println("<td>" + lista.get(i).getDescPension() + "</td>");
            pw.println("<td> S/." + lista.get(i).getMontoPension()+ "</td>");
            pw.println("<td>" + lista.get(i).getCaducidadPension().split("-")[2]+"/"+lista.get(i).getCaducidadPension().split("-")[1]+"/"+lista.get(i).getCaducidadPension().split("-")[0] + "</td>");
            pw.println("</tr>");
        }
        
        pw.println("</tbody></table></div></div>");
    }
    private void insertarMatricula(HttpServletRequest request, HttpServletResponse response) throws IOException {
        String cadena;
        cadena = request.getParameter("codigoDoc");
        String[] codDoc = cadena.split(",");
        cadena = request.getParameter("valorDoc");
        String[] valDoc = cadena.split(",");
        cadena = request.getParameter("codigoPension");
        String[] codPen = cadena.split(",");
        cadena = request.getParameter("montoPension");
        String[] monPen = cadena.split(",");
        String cod_estu = request.getParameter("cod_estu");
        String fechaMatricula = request.getParameter("fechaMatricula");
        String codAula = request.getParameter("codAula");
        String seccion = request.getParameter("seccion");
        String condicion = request.getParameter("condicion");
        String observaciones = request.getParameter("observaciones");
        String informo = request.getParameter("informo");
        String eligio = request.getParameter("eligio");
        String motivoDes = request.getParameter("mot");
        double montoDes = Double.parseDouble( request.getParameter("desc"));
        String autorizacion=request.getParameter("autorizacion");
  
       
        
        MatriculaService servicio = new MatriculaService();
        int rpta = servicio.matricularAlumno(Integer.parseInt(cod_estu), fechaMatricula, Integer.parseInt(codAula), seccion, condicion, observaciones, informo, eligio, codDoc, valDoc, codPen, monPen, motivoDes, montoDes,autorizacion);
        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        pw.println(rpta);
    }
    private void deshabilitarMatricula(HttpServletRequest request, HttpServletResponse response) throws IOException {
        int r;
        int cod_matri = Integer.parseInt(request.getParameter("codmatricula"));
        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        MatriculaService servicio = new MatriculaService();
        r = servicio.deshabilitarMatricula(cod_matri);
        pw.println(r);
    }
    private void imprimirMatricula(HttpServletRequest request, HttpServletResponse response) throws IOException {
        
        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        int codMatri = Integer.parseInt(request.getParameter("codmatricula"));
        Matricula matri = new Matricula();
        MatriculaService servMatri = new MatriculaService();
        matri = servMatri.obtenerMatricula(codMatri);
        Estudiante estu = new Estudiante();
        EstudianteService servEstu = new EstudianteService();
        estu = servEstu.obtenerEstudiante(Integer.parseInt(matri.getCodEstudiante()));
        ArrayList<Documento> doc = new ArrayList<>();
        DocumentoService servDoc = new DocumentoService();
        doc = servDoc.listarDocumentoPorSede(Integer.parseInt(matri.getCod_Sede()));
        
        
        pw.println("<div style=\"text-align: center;width: 100%;\">" +
"            <h2 style=\"font-weight: bold;\">FICHA DE MATRICULA</h2></div>" +
"            <div style=\"clear: both;\"></div>\n" +
"            <div><br /><br /></div>\n" +
"            <div style=\"clear: both;\"></div>\n" +
"            <div id=\"contenido-imprimible\" style=\"width: 100%;\">\n" +
"                <div style=\"clear: both;\"></div>\n" +
"                <div style=\"width: 50%;float: left;padding-left: 5%;padding-right: 5%;\">\n" +
"                    <h4 style=\"font-weight: bold;\">Datos de Estudiante</h4>" +
"                    <p>\n" +
"                        <b>Tipo de Documento: </b>");
                switch(estu.getTipodoc().trim()){
                    case "1":
                        pw.println("DNI");
                        break;
                    case "2":
                        pw.println("CARNÉ DE EXTRANJERIA");
                        break;
                    case "3":
                        pw.println("PASAPORTE");
                        break;
                    case "4":
                        pw.println("PARTIDA DE NACIMIENTO");
                        break;
                    default:
                        break;   
                }
                    
pw.println("             <br>\n" +
"                        <b>Número de Documento: </b>"+estu.getDni()+"<br>\n" +
"                        <b>Apellido Paterno: </b>"+estu.getPaterno()+"<br>\n" +
"                        <b>Apellido Materno: </b>"+estu.getMaterno()+"<br>\n" +
"                        <b>Nombres: </b>"+estu.getNombres()+"<br>\n" +
"                        <b>Fecha Nacimiento: </b>"+estu.getNacimiento().split("-")[2]+"/"+estu.getNacimiento().split("-")[1]+"/"+estu.getNacimiento().split("-")[0]+"<br>\n" +
"                        <b>Edad: </b>"+estu.getEdad()+"<br>\n" +
"                        <b>Teléfono Fijo: </b>"+estu.getFijo()+"<br>\n" +
"                        <b>Celular: </b>"+estu.getCelular()+"<br>\n" +
"                        <b>Correo: </b>"+estu.getCorreo()+"<br>\n" +
"                        <b>Dirección: </b>"+estu.getDireccion()+"<br>\n" +
"                        <b>Departamento: </b>"+estu.getDepartamento()+"<br>\n" +
"                        <b>Provincia: </b>"+estu.getProvincia()+"<br>\n" +
"                        <b>Distrito: </b>"+estu.getDistrito()+"<br>\n" +
"                    </p>\n" +
"                </div>\n" +
"                <div style=\"width: 50%;float: right;padding-right: 5%;padding-left: 5%;\">\n" +
"                    <h4 style=\"font-weight: bold;\">Referencia de Estudiante</h4>" +
"                    <p>\n" +
"                        <b>Colegio de Procedencia: </b>"+estu.getProcedencia()+"<br>\n" +
"                        <b>Tipo de Colegio: </b>"+estu.getTipo_colegio()+"<br>\n" +
"                        <b>Tipo de Estudiante: </b>"+estu.getTipo_estudiante()+"<br>\n" +
"                        <b>Año de Egreso: </b>"+estu.getEgreso()+"<br>\n" +
"                        <b>Academia anterior de Preparación: </b>"+estu.getAcademia()+"<br>\n" +
"                        <b>Universidad a la que postula: </b>"+estu.getCoduniversidad1()+"<br>\n" +
"                        <b>Proceso de Admisión: </b>"+estu.getProceso1()+"<br>\n" +
"                        <b>Facultad / Carrera: </b>"+estu.getCodcarrera1()+"<br>\n" +
"                        <b>Universidad a la que postula: </b>"+estu.getCoduniversidad2()+"<br>\n" +
"                        <b>Proceso de Admisión: </b>"+estu.getProceso2()+"<br>\n" +
"                        <b>Facultad / Carrera: </b>"+estu.getCodcarrera2()+"<br>\n" +
"                        <b>Universidad a la que postula: </b>"+estu.getCoduniversidad3()+"<br>\n" +
"                        <b>Proceso de Admisión: </b>"+estu.getProceso3()+"<br>\n" +
"                        <b>Facultad / Carrera: </b>"+estu.getCodcarrera3()+"<br>\n" +
"                    </p>\n" +
"                </div>\n" +
"                <div style=\"clear: both;\"></div>\n" +
"                <div style=\"width: 50%;float: left;padding-left: 5%;padding-right: 5%;\">\n" +
"                    <h4 style=\"font-weight: bold;\">Datos de Apoderado</h4>" +
"                    <p>\n" +
"                        <b>DNI: </b>"+estu.getDni_apo()+"<br>\n" +
"                        <b>Apellido Paterno: </b>"+estu.getPaterno_apo()+"<br>\n" +
"                        <b>Apellido Materno: </b>"+estu.getMaterno_apo()+"<br>\n" +
"                        <b>Nombres: </b>"+estu.getNombre_apo()+"<br>\n" +
"                        <b>Lugar de Trabajo: </b>"+estu.getTrabajo_apo()+"<br>\n" +
"                        <b>Grado de Instrucción: </b>"+estu.getCodinstruccion()+"<br>\n" +
"                        <b>Ocupacion: </b>"+estu.getCodprofesion()+"<br>\n" +
"                        <b>Domicilio: </b>"+estu.getDomicilio_apo()+"<br>\n" +
"                        <b>Correo: </b>"+estu.getCorreo_apo()+"<br>\n" +
"                        <b>Teléfono Fijo: </b>"+estu.getFijo_apo()+"<br>\n" +
"                        <b>Celular: </b>"+estu.getCelular_apo()+"<br>\n" +
"                    </p>\n" +
"                </div>\n" +
"                <div style=\"width: 50%;float: left;padding-left: 5%;padding-right: 5%;\">\n" +
"                    <h4 style=\"font-weight: bold;\">Datos de Matricula</h4>" +
"                    <p>\n" +
"                        <b>Fecha de Matricula: </b>"+matri.getFecha_matri().split("-")[2]+"/"+matri.getFecha_matri().split("-")[1]+"/"+matri.getFecha_matri().split("-")[0]+"<br>\n" +
"                        <b>Sede: </b>"+matri.getNom_Sede()+"<br>\n" +
"                        <b>Centro: </b>"+matri.getNom_Centro()+"<br>\n" +
"                        <b>Nivel: </b>"+matri.getNom_nivel()+"<br>\n" +
"                        <b>Tipo Grado: </b>"+matri.getNom_grado()+"<br>\n" +
"                        <b>Ciclo / Grado: </b>"+matri.getNom_Ciclo()+"<br>\n" +
"                        <b>Turno: </b>"+matri.getNom_Turno()+"<br>\n" +
"                        <b>Sección: </b>"+matri.getNom_Seccion()+"<br>\n" +
"                        <b>Fecha Inicio: </b>"+matri.getfInicio().split("-")[2]+"/"+matri.getfInicio().split("-")[1]+"/"+matri.getfInicio().split("-")[0]+"<br>\n" +
"                        <b>Fecha Termino: </b>"+matri.getfFinal().split("-")[2]+"/"+matri.getfFinal().split("-")[1]+"/"+matri.getfFinal().split("-")[0]+"<br>\n" +
"                    </p>\n" +
"                </div>\n" +
"                <div style=\"clear: both;\"></div>\n" +
"                <div style=\"width: 50%;float: left;padding-left: 5%;padding-right: 5%;\">\n" +
"                    <h4 style=\"font-weight: bold;\">Requisitos de Matricula</h4>" +
"                    <p>\n");
        for (int i = 0; i < doc.size(); i++) {
            pw.println(doc.get(i).getNomDocumento());
            if(i!=doc.size()-1){
                pw.println(",");
            }
        }
pw.println("         </p>\n" +
"                </div>\n" +
"                <div style=\"width: 50%;float: left;padding-left: 5%;padding-right: 5%;\">\n" +
"                    <h4 style=\"font-weight: bold;\">Datos Adicionales</h4>" +
"                    <p>\n" +
"                       <b>¿Como se informo? </b>"+matri.getInformo()+"<br>\n" +
"                       <b>¿Por qué eligio? </b>"+matri.getEligio()+"<br>\n" +
"                    </p>\n" +
"                </div>\n" +
"            </div>");
    }
    
    private void obtenerMatricula(HttpServletRequest request, HttpServletResponse response) throws IOException {
        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        int codMatri = Integer.parseInt(request.getParameter("codmat"));
        Matricula matri = new Matricula();
        MatriculaService servMatri = new MatriculaService();
        matri = servMatri.obtenerMatricula(codMatri);

        pw.print(matri.getFecha_matri()+"\\|/");
        pw.print(matri.getCod_Centro()+"\\|/");
        pw.print(matri.getCod_nivel()+"\\|/");
        pw.print(matri.getCod_Ciclo()+"\\|/");
        pw.print(matri.getCod_grado()+"\\|/");
        pw.print(matri.getCod_Turno()+"\\|/");
        pw.print(matri.getNom_Seccion()+"\\|/");
        pw.print(matri.getfInicio()+"\\|/");
        pw.print(matri.getfFinal()+"\\|/");
        pw.print(matri.getNropensiones()+"\\|/");
        pw.print(matri.getCondicion()+"\\|/");
        pw.print(matri.getObservacion()+"\\|/");
        pw.print(matri.getInformo()+"\\|/");
        pw.print(matri.getEligio()+"\\|/");
        
    }
    
    private void actualizarMatricula(HttpServletRequest request, HttpServletResponse response) throws IOException {
        int r;
        int cod_matri = Integer.parseInt(request.getParameter("mat"));
        String obs = request.getParameter("obs");
        int aula = Integer.parseInt(request.getParameter("aula"));
        String seccion = request.getParameter("seccion");
        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        MatriculaService servicio = new MatriculaService();
        r = servicio.actualizarMatricula(cod_matri, obs, aula, seccion);
        pw.println(r);
    }
    
    private void validarMatriculaExistente(HttpServletRequest request, HttpServletResponse response) throws IOException {
        int r=0;
        int cod_estu = Integer.parseInt(request.getParameter("estudiante"));
        int cod_aula = Integer.parseInt(request.getParameter("aula"));
        
        PrintWriter pw = response.getWriter();
        MatriculaService servicio = new MatriculaService();
        r = servicio.validarMatriculaExistente(cod_aula, cod_estu);
        pw.print(r);
    }
   
}
