
package pe.siso.academia.Servlets;

import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import pe.siso.academia.Beans.Menu;
import pe.siso.academia.Services.MenuServices;

public class ServletMenuAcademia extends HttpServlet {

    @Override
    protected void service(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
        String param=request.getParameter("accion");
        if("listarMenu".equals(param)){
            listarMenu(request,response);
        }else if("paginaMenuSession".equals(param)){
            paginaMenuSession(request,response);
        }
    }

    private void listarMenu(HttpServletRequest request, HttpServletResponse response) throws IOException {
        String codTipoUsuario = request.getParameter("codTipoUsuario");
        String codTitulo = request.getParameter("codTitulo");
        String codModulo = request.getParameter("codModulo");
        String codCategoria = request.getParameter("codCategoria");
        String codSubCategoria = request.getParameter("codSubCategoria");
        String seleccion = "";
        MenuServices servicios = new MenuServices();
        ArrayList<Menu> lista = null;
        lista = servicios.listarTitulo(codTipoUsuario);
        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        
        for(int i=0; i<lista.size(); i++){
            String codigoTitulo = lista.get(i).getCodigoTitulo();
            pw.println( "<li  class='sidebar-category' ><a href=\"principal.jsp\">" +
                    
                            "<span style=\" color: #ffffff;\">"+lista.get(i).getNombreTitulo()+"</span>" +
                            "<span class='pull-right'><i class='fa "+lista.get(i).getIconoTitulo()+"'></i></span>"
                    + "    </a> " +
                        "</li>");
            /* LISTAR MÓDULOS */
            ArrayList<Menu> listaModulo = null;
            listaModulo = servicios.listarModulo(codTipoUsuario,codigoTitulo);
            for (int m = 0; m < listaModulo.size(); m++) {
                String codigoModulo = listaModulo.get(m).getCodigoModulo();
                String tipoModulo = listaModulo.get(m).getTipoModulo();
                seleccion = "";
                if(codigoModulo.equals(codModulo)){
                    seleccion="active";
                }
                if(tipoModulo.equals("1")){ /* TIPO 1 = SIN CATEGORÍA */
                    pw.println( "<li class='"+seleccion+" '>" +
                                    "<a style='cursor: pointer;' onclick='javascript:paginaMenuSession("+codigoTitulo+","+codigoModulo+",0,0,\""+listaModulo.get(m).getUrlModulo()+"\",5)'>" +
                                        "<span class='icon'><i class='fa "+listaModulo.get(m).getIconoModulo()+"'></i></span>" +
                                        "<span class='text'>"+listaModulo.get(m).getNombreModulo()+"</span>" +
                                    "</a>\n" +
                                "</li>");
                }else{ /* TIPO 2 = CON CATEGORÍA */
                    pw.println( "<li class='submenu "+seleccion+" '>\n" +
                                    "<a style='cursor: pointer;' onclick='"+listaModulo.get(m).getUrlModulo()+"'>\n" +
                                        "<span class='icon'><i class='fa "+listaModulo.get(m).getIconoModulo()+"'></i></span>\n" +
                                        "<span class='text'>"+listaModulo.get(m).getNombreModulo()+"</span>\n" +
                                        "<span class='arrow'></span>\n" +
                                    "</a>\n" +
                                    "<ul>\n");
                        /* LISTAR CATEGORÍA */
                        ArrayList<Menu> listaCategoria = null;
                        listaCategoria = servicios.listarCategoria(codTipoUsuario,codigoModulo);
                        for(int c=0;c<listaCategoria.size();c++){
                            /* LISTAR CATEGORÍA */
                            String codigoCategoria = listaCategoria.get(c).getCodigoCategoria();
                            String tipoCategoria = listaCategoria.get(c).getTipoCategoria();
                            seleccion = "";
                            if(codigoCategoria.equals(codCategoria)){
                                seleccion="active";
                            }
                            if(tipoCategoria.equals("1")){ /* TIPO 1 = SIN SUB-CATEGORÍA */
                                pw.println("<li class='"+seleccion+"'><a  style='cursor: pointer;' onclick='javascript:paginaMenuSession("+codigoTitulo+","+codigoModulo+","+codigoCategoria+",0,\""+listaCategoria.get(c).getUrlCategoria()+"\","+listaCategoria.get(i).getEstadoCategoria()+")'>"+listaCategoria.get(c).getNombreCategoria()+"</a></li>");
                            }else{ /* TIPO 2 = CON SUB-CATEGORÍA */
                                
                                pw.println( "<li class='submenu "+seleccion+" '>\n" +
                                                "<a  style='cursor: pointer;' onclick='"+listaCategoria.get(c).getUrlCategoria()+"' >"+listaCategoria.get(c).getNombreCategoria()+"<span class='arrow'></span></a>\n" +
                                                "<ul>"); 
                                
                                /* LISTAR SUB-CATEGORÍA */
                                ArrayList<Menu> listaSubCategoria = null;
                                listaSubCategoria = servicios.listarSubCategoria(codTipoUsuario,codigoCategoria);
                                for(int s=0; s<listaSubCategoria.size(); s++){
                                    String codigoSubCategoria = listaSubCategoria.get(s).getCodigoSubCategoria();
                                    seleccion = "";
                                    if(codigoSubCategoria.equals(codSubCategoria)){
                                        seleccion="active";
                                    }
                                    pw.println("<li class='"+seleccion+"'>" +
                                                    "<a  style='cursor: pointer;' onclick='javascript:paginaMenuSession("+codigoTitulo+","+codigoModulo+","+codigoCategoria+","+codigoSubCategoria+",\""+listaSubCategoria.get(s).getUrlSubCategoria()+"\",5)'>"+listaSubCategoria.get(s).getNombreSubCategoria()+"</a>" +
                                                "</li>");
                                }
                                pw.println("</ul>\n" +
                                            "</li>");
                            }
                        }   
                                pw.println(     "</ul>" +
                                            "</li>");
                }
            }
            
        }
        
     
        
    }

    private void paginaMenuSession(HttpServletRequest request, HttpServletResponse response) {
        String codTitulo = request.getParameter("codTit");
        String codModulo = request.getParameter("codMod");
        String codCategoria = request.getParameter("codCat");
        String codSubCategoria = request.getParameter("codSub");
        String CategoriaEstado = request.getParameter("estado");
        HttpSession session_actual = request.getSession(true);
        
        Menu menu = new Menu();
        menu.setCodigoTitulo(codTitulo);
        menu.setCodigoModulo(codModulo);
        menu.setCodigoCategoria(codCategoria);
        menu.setCodigoSubCategoria(codSubCategoria);
        menu.setEstadoCategoria(CategoriaEstado);
        
        session_actual.setAttribute("menu",menu);
    }

}
