
package pe.siso.academia.Servlets;

import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import pe.siso.academia.Beans.Monto;
import pe.siso.academia.Services.MontoService;

public class ServletMonto extends HttpServlet {

    @Override
    protected void service(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
        String param=request.getParameter("accion");
        if("listarCentros".equals(param)){
            listarCentros(request, response);
        }
        else if("listarNiveles".equals(param)){
            listarNiveles(request, response);
        }
        else if("listarGrados".equals(param)){
            listarGrados(request, response);
        }
        else if("listarCiclos".equals(param)){
            listarCiclos(request, response);
        }
        else if("generarFormNuevoCentro".equals(param)){
            generarFormNuevoCentro(request, response);
        }
        else if("generarFormNuevoNivel".equals(param)){
            generarFormNuevoNivel(request, response);
        }
        else if("generarFormNuevoGrado".equals(param)){
            generarFormNuevoGrado(request, response);
        }
        else if("generarFormNuevoCiclo".equals(param)){
            generarFormNuevoCiclo(request, response);
        }
        else if("insertarCentro".equals(param)){
            insertarCentro(request, response);
        }
        else if("insertarNivel".equals(param)){
            insertarNivel(request, response);
        }
        else if("insertarGrado".equals(param)){
            insertarGrado(request, response);
        }
        else if("insertarCiclo".equals(param)){
            insertarCiclo(request, response);
        }
        else if("cambiarEstadoCentro".equals(param)){
            cambiarEstadoCentro(request, response);
        }
        else if("cambiarEstadoNivel".equals(param)){
            cambiarEstadoNivel(request, response);
        }
        else if("cambiarEstadoGrado".equals(param)){
            cambiarEstadoGrado(request, response);
        }
        else if("cambiarEstadoCiclo".equals(param)){
            cambiarEstadoCiclo(request, response);
        }
        else if("generarFormEditarCentro".equals(param)){
            generarFormEditarCentro(request, response);
        }
        else if("generarFormEditarNivel".equals(param)){
            generarFormEditarNivel(request, response);
        }
        else if("generarFormEditarGrado".equals(param)){
            generarFormEditarGrado(request, response);
        }
        else if("generarFormEditarCiclo".equals(param)){
            generarFormEditarCiclo(request, response);
        }
        else if("editarCentro".equals(param)){
            editarCentro(request, response);
        }
        else if("editarNivel".equals(param)){
            editarNivel(request, response);
        }
        else if("editarGrado".equals(param)){
            editarGrado(request, response);
        }
        else if("editarCiclo".equals(param)){
            editarCiclo(request, response);
        }
    }
    
    //LISTAR
    private void listarCentros(HttpServletRequest request, HttpServletResponse response) throws IOException {
        String nivel = request.getParameter("nombre");
        int pagina = Integer.parseInt(request.getParameter("pag"));
        int cantPorPagina = 20;
        int cantidadRegistros = 0;
        int cantidadPaginas = 0;
        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        ArrayList<Monto> lista = null;
        MontoService servicio = new MontoService();
        lista = servicio.listarCentros(nivel, (pagina*cantPorPagina)-cantPorPagina, cantPorPagina);
        cantidadRegistros = servicio.contarCentros(nivel);
        cantidadPaginas = cantidadRegistros/cantPorPagina;
        pw.println("<div class=\"col-md-12\">\n" +
"                            <div class=\"panel\">\n" +
"                                <div class=\"panel-heading-saco\">\n" +
"                                    <h3 class=\"panel-title pull-left\">Lista de Centros</h3>\n" +
"                                    <span class=\"pull-right\" style=\"display: block;\">\n" +
"                                        <button class=\"btn btn-saco\" onclick=\"agregarCentro();\">  \n" +
"                                            <i class=\"fa fa-plus-circle\"></i> Agregar Centro\n" +
"                                        </button>\n" +
"                                    </span>\n" +
"                                    <div style=\"clear: both;\"></div>\n" +
"                                </div>\n" +
"                                <div class=\"panel-body no-padding\">\n" +
"                                    <!-- Start sample table -->\n" +
"                                    <div class=\"table rounded mb-20\" id=\"imprimirTabla\">\n" +
"                                        <table class=\"table table-striped table-saco\" style=\"border: 1px solid rgb(198, 198, 198); border-image: none; font-size: 11px;\">\n" +
"                                            <thead>\n" +
"                                                <tr>\n" +
"                                                    <th class=\"text-center border-right\">No.</th>\n" +
"                                                    <th class=\"text-center\">Centro</th>\n" +
"                                                    <th class=\"text-center\">Acciones</th>\n" +
"                                                </tr>\n" +
"                                            </thead>\n" +
"                                            <tbody>\n");
        if(lista.size()==0){
            pw.println("<tr><td colspan='7'>No se encontraron registros.</td></tr>");
        }
                for(int i = 0; i<lista.size();i++){
pw.println("                                     <tr>\n" +
"                                                    <td class=\"text-center border-right\">"+(((pagina-1)*cantPorPagina)+1+i)+"</td>\n" +
"                                                    <td class=\"text-center\">"+lista.get(i).getNomCentro()+"</td>\n" +
"                                                    <td class=\"text-center\">\n" );
if("1".equals(lista.get(i).getEstCentro())){
    pw.printf("                                          <a data-original-title=\"Desactivar Centro\" data-toggle=\"tooltip\" data-placement=\"top\" href=\"javascript:frmDesactivar('"+lista.get(i).getCodCentro()+"');\">\n" +
"                                                            <i class=\"fa fa-lightbulb-o bigger-140 green\"></i>\n" +
"                                                        </a>\n" );
}
else{
    pw.printf("                                          <a data-original-title=\"Activar Centro\" data-toggle=\"tooltip\" data-placement=\"top\" href=\"javascript:frmActivar("+lista.get(i).getCodCentro()+");\">\n" +
"                                                            <i class=\"fa fa-lightbulb-o bigger-140 red\"></i>\n" +
"                                                        </a>\n" );
}
pw.printf("                                              <a data-original-title=\"Editar Centro\" data-toggle=\"tooltip\" data-placement=\"top\" href=\"javascript:frmEditarCentro('"+lista.get(i).getCodCentro()+"','"+lista.get(i).getNomCentro()+"');\">\n" +
"                                                            <i class=\"fa fa-edit bigger-140 blue\"></i>\n" +
"                                                        </a>\n" +
"                                                        <a data-original-title=\"Mantenimiento de Niveles\" data-toggle=\"tooltip\" data-placement=\"top\" href=\"javascript:verNiveles("+lista.get(i).getCodCentro()+",'"+lista.get(i).getNomCentro()+"');\">\n" +
"                                                            <i class=\"fa fa-bars bigger-140 blue\"></i>\n" +
"                                                        </a>\n" +
"                                                    </td>\n" +
"                                                </tr>\n" );
                }

pw.println("                         </tbody>\n" +
"                                        </table>\n" );

pw.println("<div class=\"col-xs-12\" style=\"border-right-color: rgb(198, 198, 198); border-bottom-color: rgb(198, 198, 198); border-left-color: rgb(198, 198, 198); border-right-width: 1px; border-bottom-width: 1px; border-left-width: 1px; border-right-style: solid; border-bottom-style: solid; border-left-style: solid; background-color: rgb(239, 243, 248);\">                                              \n" +
"                                            <div class=\"col-xs-7\">\n" +
"                                                <div class=\"dataTables_paginate paging_simple_numbers\" id=\"datatable-ajax_paginate\">\n" +
"                                                    <ul class=\"pagination\">  \n" );
if(pagina==1){
    pw.println("<li tabindex=\"0\" class=\"paginate_button previous disabled\" id=\"sample-table-2_previous\" aria-controls=\"sample-table-2\"> <a> &lt;&lt; </a></li>\n" );
}
else{
    pw.println("<li tabindex=\"0\" class=\"paginate_button previous\" id=\"sample-table-2_previous\" aria-controls=\"sample-table-2\"> <a href=\"javascript:listarCentros('1');\"> &lt;&lt; </a></li>\n" );
}
if(pagina>1){
    pw.println("<li tabindex=\"0\" class=\"paginate_button previous\" id=\"sample-table-2_previous\" aria-controls=\"sample-table-2\"> <a href=\"javascript:listarCentros('"+(pagina-1)+"');\">Anterior</a></li>\n" );
}
else{
    pw.println("<li tabindex=\"0\" class=\"paginate_button previous disabled\" id=\"sample-table-2_previous\" aria-controls=\"sample-table-2\"> <a>Anterior</a></li>\n" );
}


for(int x=1;x<=(cantidadPaginas+1);x++){
    if(x>=(pagina-0) && x<=(pagina+4)){
        if(pagina==x){
            pw.println("<li tabindex=\"0\" class=\"paginate_button active\" aria-controls=\"sample-table-2\"><a href=\"javascript:void(0);\">"+x+"</a></li>\n" );
        }
        else{
            pw.println("<li tabindex=\"0\" class=\"paginate_button\" aria-controls=\"sample-table-2\"><a href=\"javascript:listarCentros('"+x+"');\">"+x+"</a></li>\n" );
        }
    }
}
if(pagina<(cantidadPaginas+1)){
    pw.println("<li tabindex=\"0\" class=\"paginate_button next\" id=\"sample-table-2_next\" aria-controls=\"sample-table-2\"> <a href=\"javascript:listarCentros('"+(pagina+1)+"');\">Siguiente</a></li>\n" );
    pw.println("<li tabindex=\"0\" class=\"paginate_button next\" id=\"sample-table-2_next\" aria-controls=\"sample-table-2\"> <a href=\"javascript:listarCentros('"+(cantidadPaginas+1)+"');\"> &gt;&gt; </a></li>\n" );
}
else{
    pw.println("<li tabindex=\"0\" class=\"paginate_button next disabled\" id=\"sample-table-2_next\" aria-controls=\"sample-table-2\"> <a>Siguiente</a></li>\n" );
    pw.println("<li tabindex=\"0\" class=\"paginate_button next disabled\" id=\"sample-table-2_next\" aria-controls=\"sample-table-2\"> <a> &gt;&gt; </a></li>\n" );
}

pw.println("                                                    </ul>                                                  \n" +
"                                                </div>                                             \n" +
"                                            </div>                                              \n" +
"                                            <div class=\"col-xs-5\">\n" +
"                                                <table style=\"width: 100%; height: 72px;\" border=\"0\">\n" +
"                                                    <tbody>\n" +
"                                                        <tr>                                                          \n" +
"                                                            <td style=\"text-align: right; vertical-align: middle; background-color: transparent!important;\">Mostrando del "+((pagina*cantPorPagina)-cantPorPagina+1)+" al "+((pagina*cantPorPagina))+" de "+cantidadRegistros+" Niveles</td> \n" +
"                                                        </tr> \n" +
"                                                    </tbody>\n" +
"                                                </table>\n" +
"                                            </div>  \n" +
"                                        </div>");

pw.println("                                    </div><!-- /.table -->\n" +
"                                    <!--/ End sample table -->\n" +
"                                </div>\n" +
"                            </div>\n" +
"                        </div>");
    }
    
    private void listarNiveles(HttpServletRequest request, HttpServletResponse response) throws IOException {
        int idSede = Integer.parseInt(request.getParameter("sede"));
        String nivel = request.getParameter("nombre");
        int pagina = Integer.parseInt(request.getParameter("pag"));
        int cantPorPagina = 20;
        int cantidadRegistros = 0;
        int cantidadPaginas = 0;
        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        ArrayList<Monto> lista = null;
        MontoService servicio = new MontoService();
        lista = servicio.listarNiveles(idSede, nivel,(pagina*cantPorPagina)-cantPorPagina, cantPorPagina);
        cantidadRegistros = servicio.contarNiveles(idSede, nivel);
        cantidadPaginas = cantidadRegistros/cantPorPagina;
        pw.println("<div class=\"col-md-12\">\n" +
"                            <div class=\"panel\">\n" +
"                                <div class=\"panel-heading-saco\">\n" +
"                                    <h3 class=\"panel-title pull-left\">Lista de Niveles</h3>\n" +
"                                    <span class=\"pull-right\" style=\"display: block;\">\n" +
"                                        <button class=\"btn btn-saco\" onclick=\"location.href='man_centros.jsp'\">  \n" +
"                                            <i class=\"fa fa-reply\"></i> Volver\n" +
"                                        </button>\n" +
"                                        <button class=\"btn btn-saco\" onclick=\"agregarNivel();\">  \n" +
"                                            <i class=\"fa fa-plus-circle\"></i> Agregar Nivel\n" +
"                                        </button>\n" +
"                                    </span>\n" +
"                                    <div style=\"clear: both;\"></div>\n" +
"                                </div>\n" +
"                                <div class=\"panel-body no-padding\">\n" +
"                                    <!-- Start sample table -->\n" +
"                                    <div class=\"table rounded mb-20\" id=\"imprimirTabla\">\n" +
"                                        <table class=\"table table-striped table-saco\" style=\"border: 1px solid rgb(198, 198, 198); border-image: none; font-size: 11px;\">\n" +
"                                            <thead>\n" +
"                                                <tr>\n" +
"                                                    <th class=\"text-center border-right\">No.</th>\n" +
"                                                    <th class=\"text-center\">Nivel</th>\n" +
"                                                    <th class=\"text-center\">Acciones</th>\n" +
"                                                </tr>\n" +
"                                            </thead>\n" +
"                                            <tbody>\n");
        if(lista.size()==0){
            pw.println("<tr><td colspan='7'>No se encontraron registros.</td></tr>");
        }
                for(int i = 0; i<lista.size();i++){
pw.println("                                     <tr>\n" +
"                                                    <td class=\"text-center border-right\">"+(((pagina-1)*cantPorPagina)+1+i)+"</td>\n" +
"                                                    <td class=\"text-center\">"+lista.get(i).getNomNivel()+"</td>\n" +
"                                                    <td class=\"text-center\">\n" );
if("1".equals(lista.get(i).getEstNivel())){
    pw.printf("                                          <a data-original-title=\"Desactivar Nivel\" data-toggle=\"tooltip\" data-placement=\"top\" href=\"javascript:frmDesactivar('"+lista.get(i).getCodNivel()+"');\">\n" +
"                                                            <i class=\"fa fa-lightbulb-o bigger-140 green\"></i>\n" +
"                                                        </a>\n" );
}
else{
    pw.printf("                                          <a data-original-title=\"Activar Nivel\" data-toggle=\"tooltip\" data-placement=\"top\" href=\"javascript:frmActivar('"+lista.get(i).getCodNivel()+"');\">\n" +
"                                                            <i class=\"fa fa-lightbulb-o bigger-140 red\"></i>\n" +
"                                                        </a>\n" );
}
pw.printf("                                              <a data-original-title=\"Editar Nivel\" data-toggle=\"tooltip\" data-placement=\"top\" href=\"javascript:frmEditarNivel('" + lista.get(i).getCodNivel() + "','" + lista.get(i).getNomNivel() + "');\">\n" +
"                                                            <i class=\"fa fa-edit bigger-140 blue\"></i>\n" +
"                                                        </a>\n" +
"                                                        <a data-original-title=\"Mantenimiento de Tipo de Grados\" data-toggle=\"tooltip\" data-placement=\"top\" href=\"javascript:verGrados("+lista.get(i).getCodNivel()+",'"+lista.get(i).getNomNivel()+"');\">\n" +
"                                                            <i class=\"fa fa-bars bigger-140 blue\"></i>\n" +
"                                                        </a>\n" +
"                                                    </td>\n" +
"                                                </tr>\n" );
                }

pw.println("                         </tbody>\n" +
"                                        </table>\n" );

pw.println("<div class=\"col-xs-12\" style=\"border-right-color: rgb(198, 198, 198); border-bottom-color: rgb(198, 198, 198); border-left-color: rgb(198, 198, 198); border-right-width: 1px; border-bottom-width: 1px; border-left-width: 1px; border-right-style: solid; border-bottom-style: solid; border-left-style: solid; background-color: rgb(239, 243, 248);\">                                              \n" +
"                                            <div class=\"col-xs-7\">\n" +
"                                                <div class=\"dataTables_paginate paging_simple_numbers\" id=\"datatable-ajax_paginate\">\n" +
"                                                    <ul class=\"pagination\">  \n" );
if(pagina==1){
    pw.println("<li tabindex=\"0\" class=\"paginate_button previous disabled\" id=\"sample-table-2_previous\" aria-controls=\"sample-table-2\"> <a> &lt;&lt; </a></li>\n" );
}
else{
    pw.println("<li tabindex=\"0\" class=\"paginate_button previous\" id=\"sample-table-2_previous\" aria-controls=\"sample-table-2\"> <a href=\"javascript:listarNiveles('1');\"> &lt;&lt; </a></li>\n" );
}
if(pagina>1){
    pw.println("<li tabindex=\"0\" class=\"paginate_button previous\" id=\"sample-table-2_previous\" aria-controls=\"sample-table-2\"> <a href=\"javascript:listarNiveles('"+(pagina-1)+"');\">Anterior</a></li>\n" );
}
else{
    pw.println("<li tabindex=\"0\" class=\"paginate_button previous disabled\" id=\"sample-table-2_previous\" aria-controls=\"sample-table-2\"> <a>Anterior</a></li>\n" );
}


for(int x=1;x<=(cantidadPaginas+1);x++){
    if(x>=(pagina-0) && x<=(pagina+4)){
        if(pagina==x){
            pw.println("<li tabindex=\"0\" class=\"paginate_button active\" aria-controls=\"sample-table-2\"><a href=\"javascript:void(0);\">"+x+"</a></li>\n" );
        }
        else{
            pw.println("<li tabindex=\"0\" class=\"paginate_button\" aria-controls=\"sample-table-2\"><a href=\"javascript:listarNiveles('"+x+"');\">"+x+"</a></li>\n" );
        }
    }
}
if(pagina<(cantidadPaginas+1)){
    pw.println("<li tabindex=\"0\" class=\"paginate_button next\" id=\"sample-table-2_next\" aria-controls=\"sample-table-2\"> <a href=\"javascript:listarNiveles('"+(pagina+1)+"');\">Siguiente</a></li>\n" );
    pw.println("<li tabindex=\"0\" class=\"paginate_button next\" id=\"sample-table-2_next\" aria-controls=\"sample-table-2\"> <a href=\"javascript:listarNiveles('"+(cantidadPaginas+1)+"');\"> &gt;&gt; </a></li>\n" );
}
else{
    pw.println("<li tabindex=\"0\" class=\"paginate_button next disabled\" id=\"sample-table-2_next\" aria-controls=\"sample-table-2\"> <a>Siguiente</a></li>\n" );
    pw.println("<li tabindex=\"0\" class=\"paginate_button next disabled\" id=\"sample-table-2_next\" aria-controls=\"sample-table-2\"> <a> &gt;&gt; </a></li>\n" );
}

pw.println("                                                    </ul>                                                  \n" +
"                                                </div>                                             \n" +
"                                            </div>                                              \n" +
"                                            <div class=\"col-xs-5\">\n" +
"                                                <table style=\"width: 100%; height: 72px;\" border=\"0\">\n" +
"                                                    <tbody>\n" +
"                                                        <tr>                                                          \n" +
"                                                            <td style=\"text-align: right; vertical-align: middle; background-color: transparent!important;\">Mostrando del "+((pagina*cantPorPagina)-cantPorPagina+1)+" al "+((pagina*cantPorPagina))+" de "+cantidadRegistros+" Niveles</td> \n" +
"                                                        </tr> \n" +
"                                                    </tbody>\n" +
"                                                </table>\n" +
"                                            </div>  \n" +
"                                        </div>");

pw.println("                                    </div><!-- /.table -->\n" +
"                                    <!--/ End sample table -->\n" +
"                                </div>\n" +
"                            </div>\n" +
"                        </div>");
    }
    
    private void listarGrados(HttpServletRequest request, HttpServletResponse response) throws IOException {
        int idNivel = Integer.parseInt(request.getParameter("nivel"));
        String grado = request.getParameter("nombre");
        int pagina = Integer.parseInt(request.getParameter("pag"));
        int cantPorPagina = 20;
        int cantidadRegistros = 0;
        int cantidadPaginas = 0;
        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        ArrayList<Monto> lista = null;
        MontoService servicio = new MontoService();
        lista = servicio.listarGrados(idNivel, grado,(pagina*cantPorPagina)-cantPorPagina, cantPorPagina);
        cantidadRegistros = servicio.contarNiveles(idNivel, grado);
        cantidadPaginas = cantidadRegistros/cantPorPagina;
        pw.println("<div class=\"col-md-12\">\n" +
"                            <div class=\"panel\">\n" +
"                                <div class=\"panel-heading-saco\">\n" +
"                                    <h3 class=\"panel-title pull-left\">Lista de Tipos de Grado</h3>\n" +
"                                    <span class=\"pull-right\" style=\"display: block;\">\n" +
"                                        <button class=\"btn btn-saco\" onclick=\"location.href='man_niveles.jsp'\">  \n" +
"                                            <i class=\"fa fa-reply\"></i> Volver\n" +
"                                        </button>\n" +
"                                        <button class=\"btn btn-saco\" onclick=\"agregarGrado();\">  \n" +
"                                            <i class=\"fa fa-plus-circle\"></i> Agregar Tipo de Grado\n" +
"                                        </button>\n" +
"                                    </span>\n" +
"                                    <div style=\"clear: both;\"></div>\n" +
"                                </div>\n" +
"                                <div class=\"panel-body no-padding\">\n" +
"                                    <!-- Start sample table -->\n" +
"                                    <div class=\"table rounded mb-20\" id=\"imprimirTabla\">\n" +
"                                        <table class=\"table table-striped table-saco\" style=\"border: 1px solid rgb(198, 198, 198); border-image: none; font-size: 11px;\">\n" +
"                                            <thead>\n" +
"                                                <tr>\n" +
"                                                    <th class=\"text-center border-right\">No.</th>\n" +
"                                                    <th class=\"text-center\">Tipo de Grado</th>\n" +
"                                                    <th class=\"text-center\">Acciones</th>\n" +
"                                                </tr>\n" +
"                                            </thead>\n" +
"                                            <tbody>\n");
        if(lista.size()==0){
            pw.println("<tr><td colspan='7'>No se encontraron registros.</td></tr>");
        }
                for(int i = 0; i<lista.size();i++){
pw.println("                                     <tr>\n" +
"                                                    <td class=\"text-center border-right\">"+(((pagina-1)*cantPorPagina)+1+i)+"</td>\n" +
"                                                    <td class=\"text-center\">"+lista.get(i).getNomGrado()+"</td>\n" +
"                                                    <td class=\"text-center\">\n" );
if("1".equals(lista.get(i).getEstGrado())){
    pw.printf("                                          <a data-original-title=\"Desactivar Tipo de Grado\" data-toggle=\"tooltip\" data-placement=\"top\" href=\"javascript:frmDesactivar('"+lista.get(i).getCodGrado()+"',0);\">\n" +
"                                                            <i class=\"fa fa-lightbulb-o bigger-140 green\"></i>\n" +
"                                                        </a>\n" );
}
else{
    pw.printf("                                          <a data-original-title=\"Activar Tipo de Grado\" data-toggle=\"tooltip\" data-placement=\"top\" href=\"javascript:frmActivar('"+lista.get(i).getCodGrado()+"',1);\">\n" +
"                                                            <i class=\"fa fa-lightbulb-o bigger-140 red\"></i>\n" +
"                                                        </a>\n" );
}
pw.printf("                                              <a data-original-title=\"Editar Tipo de Grado\" data-toggle=\"tooltip\" data-placement=\"top\" href=\"javascript:frmEditarGrados('"+lista.get(i).getCodGrado()+"','"+lista.get(i).getNomGrado()+"');\">\n" +
"                                                            <i class=\"fa fa-edit bigger-140 blue\"></i>\n" +
"                                                        </a>\n" +
"                                                        <a data-original-title=\"Mantenimiento de Grados/Ciclos\" data-toggle=\"tooltip\" data-placement=\"top\" href=\"javascript:verCiclos("+lista.get(i).getCodGrado()+",'"+lista.get(i).getNomGrado()+"');\">\n" +
"                                                            <i class=\"fa fa-bars bigger-140 blue\"></i>\n" +
"                                                        </a>\n" +
"                                                    </td>\n" +
"                                                </tr>\n" );
                }

pw.println("                         </tbody>\n" +
"                                        </table>\n" );

pw.println("<div class=\"col-xs-12\" style=\"border-right-color: rgb(198, 198, 198); border-bottom-color: rgb(198, 198, 198); border-left-color: rgb(198, 198, 198); border-right-width: 1px; border-bottom-width: 1px; border-left-width: 1px; border-right-style: solid; border-bottom-style: solid; border-left-style: solid; background-color: rgb(239, 243, 248);\">                                              \n" +
"                                            <div class=\"col-xs-7\">\n" +
"                                                <div class=\"dataTables_paginate paging_simple_numbers\" id=\"datatable-ajax_paginate\">\n" +
"                                                    <ul class=\"pagination\">  \n" );
if(pagina==1){
    pw.println("<li tabindex=\"0\" class=\"paginate_button previous disabled\" id=\"sample-table-2_previous\" aria-controls=\"sample-table-2\"> <a> &lt;&lt; </a></li>\n" );
}
else{
    pw.println("<li tabindex=\"0\" class=\"paginate_button previous\" id=\"sample-table-2_previous\" aria-controls=\"sample-table-2\"> <a href=\"javascript:listarGrados('1');\"> &lt;&lt; </a></li>\n" );
}
if(pagina>1){
    pw.println("<li tabindex=\"0\" class=\"paginate_button previous\" id=\"sample-table-2_previous\" aria-controls=\"sample-table-2\"> <a href=\"javascript:listarGrados('"+(pagina-1)+"');\">Anterior</a></li>\n" );
}
else{
    pw.println("<li tabindex=\"0\" class=\"paginate_button previous disabled\" id=\"sample-table-2_previous\" aria-controls=\"sample-table-2\"> <a>Anterior</a></li>\n" );
}


for(int x=1;x<=(cantidadPaginas+1);x++){
    if(x>=(pagina-0) && x<=(pagina+4)){
        if(pagina==x){
            pw.println("<li tabindex=\"0\" class=\"paginate_button active\" aria-controls=\"sample-table-2\"><a href=\"javascript:void(0);\">"+x+"</a></li>\n" );
        }
        else{
            pw.println("<li tabindex=\"0\" class=\"paginate_button\" aria-controls=\"sample-table-2\"><a href=\"javascript:listarGrados('"+x+"');\">"+x+"</a></li>\n" );
        }
    }
}
if(pagina<(cantidadPaginas+1)){
    pw.println("<li tabindex=\"0\" class=\"paginate_button next\" id=\"sample-table-2_next\" aria-controls=\"sample-table-2\"> <a href=\"javascript:listarNiveles('"+(pagina+1)+"');\">Siguiente</a></li>\n" );
    pw.println("<li tabindex=\"0\" class=\"paginate_button next\" id=\"sample-table-2_next\" aria-controls=\"sample-table-2\"> <a href=\"javascript:listarNiveles('"+(cantidadPaginas+1)+"');\"> &gt;&gt; </a></li>\n" );
}
else{
    pw.println("<li tabindex=\"0\" class=\"paginate_button next disabled\" id=\"sample-table-2_next\" aria-controls=\"sample-table-2\"> <a>Siguiente</a></li>\n" );
    pw.println("<li tabindex=\"0\" class=\"paginate_button next disabled\" id=\"sample-table-2_next\" aria-controls=\"sample-table-2\"> <a> &gt;&gt; </a></li>\n" );
}

pw.println("                                                    </ul>                                                  \n" +
"                                                </div>                                             \n" +
"                                            </div>                                              \n" +
"                                            <div class=\"col-xs-5\">\n" +
"                                                <table style=\"width: 100%; height: 72px;\" border=\"0\">\n" +
"                                                    <tbody>\n" +
"                                                        <tr>                                                          \n" +
"                                                            <td style=\"text-align: right; vertical-align: middle; background-color: transparent!important;\">Mostrando del "+((pagina*cantPorPagina)-cantPorPagina+1)+" al "+((pagina*cantPorPagina))+" de "+cantidadRegistros+" Grados</td> \n" +
"                                                        </tr> \n" +
"                                                    </tbody>\n" +
"                                                </table>\n" +
"                                            </div>  \n" +
"                                        </div>");

pw.println("                                    </div><!-- /.table -->\n" +
"                                    <!--/ End sample table -->\n" +
"                                </div>\n" +
"                            </div>\n" +
"                        </div>");
    }
    
    private void listarCiclos(HttpServletRequest request, HttpServletResponse response) throws IOException {
        int idGrado = Integer.parseInt(request.getParameter("grado"));
        String ciclo = request.getParameter("nombre");
        int pagina = Integer.parseInt(request.getParameter("pag"));
        int cantPorPagina = 20;
        int cantidadRegistros = 0;
        int cantidadPaginas = 0;
        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        ArrayList<Monto> lista = null;
        MontoService servicio = new MontoService();
        lista = servicio.listarCiclos(idGrado, ciclo,(pagina*cantPorPagina)-cantPorPagina, cantPorPagina);
        cantidadRegistros = servicio.contarCiclos(idGrado, ciclo);
        cantidadPaginas = cantidadRegistros/cantPorPagina;
        pw.println("<div class=\"col-md-12\">\n" +
"                            <div class=\"panel\">\n" +
"                                <div class=\"panel-heading-saco\">\n" +
"                                    <h3 class=\"panel-title pull-left\">Lista de Grados/Ciclos</h3>\n" +
"                                    <span class=\"pull-right\" style=\"display: block;\">\n" +
"                                        <button class=\"btn btn-saco\" onclick=\"location.href='man_grados.jsp'\">  \n" +
"                                            <i class=\"fa fa-reply\"></i> Volver\n" +
"                                        </button>\n" +
"                                        <button class=\"btn btn-saco\" onclick=\"agregarCiclo();\">  \n" +
"                                            <i class=\"fa fa-plus-circle\"></i> Agregar Grado/Ciclo\n" +
"                                        </button>\n" +
"                                    </span>\n" +
"                                    <div style=\"clear: both;\"></div>\n" +
"                                </div>\n" +
"                                <div class=\"panel-body no-padding\">\n" +
"                                    <!-- Start sample table -->\n" +
"                                    <div class=\"table rounded mb-20\" id=\"imprimirTabla\">\n" +
"                                        <table class=\"table table-striped table-saco\" style=\"border: 1px solid rgb(198, 198, 198); border-image: none; font-size: 11px;\">\n" +
"                                            <thead>\n" +
"                                                <tr>\n" +
"                                                    <th class=\"text-center border-right\">No.</th>\n" +
"                                                    <th class=\"text-center\">Grado/Ciclo</th>\n" +
"                                                    <th class=\"text-center\">Acciones</th>\n" +
"                                                </tr>\n" +
"                                            </thead>\n" +
"                                            <tbody>\n");
        if(lista.size()==0){
            pw.println("<tr><td colspan='7'>No se encontraron registros.</td></tr>");
        }
                for(int i = 0; i<lista.size();i++){
pw.println("                                     <tr>\n" +
"                                                    <td class=\"text-center border-right\">"+(((pagina-1)*cantPorPagina)+1+i)+"</td>\n" +
"                                                    <td class=\"text-center\">"+lista.get(i).getNomCiclo()+"</td>\n" +
"                                                    <td class=\"text-center\">\n" );
if("1".equals(lista.get(i).getEstCiclo())){
    pw.printf("                                          <a data-original-title=\"Desactivar Grado/Ciclo\" data-toggle=\"tooltip\" data-placement=\"top\" href=\"javascript:frmDesactivar('"+lista.get(i).getCodCiclo()+"');\">\n" +
"                                                            <i class=\"fa fa-lightbulb-o bigger-140 green\"></i>\n" +
"                                                        </a>\n" );
}
else{
    pw.printf("                                          <a data-original-title=\"Activar Grado/Ciclo\" data-toggle=\"tooltip\" data-placement=\"top\" href=\"javascript:frmActivar('"+lista.get(i).getCodCiclo()+"');\">\n" +
"                                                            <i class=\"fa fa-lightbulb-o bigger-140 red\"></i>\n" +
"                                                        </a>\n" );
}
pw.printf("                                              <a data-original-title=\"Editar Grado/Ciclo\" data-toggle=\"tooltip\" data-placement=\"top\" href=\"javascript:frmEditarCiclo('"+lista.get(i).getCodCiclo()+"','"+lista.get(i).getNomCiclo()+"');\">\n" +
"                                                            <i class=\"fa fa-edit bigger-140 blue\"></i>\n" +
"                                                        </a>\n" +
"                                                    </td>\n" +
"                                                </tr>\n" );
                }

pw.println("                         </tbody>\n" +
"                                        </table>\n" );

pw.println("<div class=\"col-xs-12\" style=\"border-right-color: rgb(198, 198, 198); border-bottom-color: rgb(198, 198, 198); border-left-color: rgb(198, 198, 198); border-right-width: 1px; border-bottom-width: 1px; border-left-width: 1px; border-right-style: solid; border-bottom-style: solid; border-left-style: solid; background-color: rgb(239, 243, 248);\">                                              \n" +
"                                            <div class=\"col-xs-7\">\n" +
"                                                <div class=\"dataTables_paginate paging_simple_numbers\" id=\"datatable-ajax_paginate\">\n" +
"                                                    <ul class=\"pagination\">  \n" );
if(pagina==1){
    pw.println("<li tabindex=\"0\" class=\"paginate_button previous disabled\" id=\"sample-table-2_previous\" aria-controls=\"sample-table-2\"> <a> &lt;&lt; </a></li>\n" );
}
else{
    pw.println("<li tabindex=\"0\" class=\"paginate_button previous\" id=\"sample-table-2_previous\" aria-controls=\"sample-table-2\"> <a href=\"javascript:listarCiclos('1');\"> &lt;&lt; </a></li>\n" );
}
if(pagina>1){
    pw.println("<li tabindex=\"0\" class=\"paginate_button previous\" id=\"sample-table-2_previous\" aria-controls=\"sample-table-2\"> <a href=\"javascript:listarCiclos('"+(pagina-1)+"');\">Anterior</a></li>\n" );
}
else{
    pw.println("<li tabindex=\"0\" class=\"paginate_button previous disabled\" id=\"sample-table-2_previous\" aria-controls=\"sample-table-2\"> <a>Anterior</a></li>\n" );
}


for(int x=1;x<=(cantidadPaginas+1);x++){
    if(x>=(pagina-0) && x<=(pagina+4)){
        if(pagina==x){
            pw.println("<li tabindex=\"0\" class=\"paginate_button active\" aria-controls=\"sample-table-2\"><a href=\"javascript:void(0);\">"+x+"</a></li>\n" );
        }
        else{
            pw.println("<li tabindex=\"0\" class=\"paginate_button\" aria-controls=\"sample-table-2\"><a href=\"javascript:listarCiclos('"+x+"');\">"+x+"</a></li>\n" );
        }
    }
}
if(pagina<(cantidadPaginas+1)){
    pw.println("<li tabindex=\"0\" class=\"paginate_button next\" id=\"sample-table-2_next\" aria-controls=\"sample-table-2\"> <a href=\"javascript:listarCiclos('"+(pagina+1)+"');\">Siguiente</a></li>\n" );
    pw.println("<li tabindex=\"0\" class=\"paginate_button next\" id=\"sample-table-2_next\" aria-controls=\"sample-table-2\"> <a href=\"javascript:listarCiclos('"+(cantidadPaginas+1)+"');\"> &gt;&gt; </a></li>\n" );
}
else{
    pw.println("<li tabindex=\"0\" class=\"paginate_button next disabled\" id=\"sample-table-2_next\" aria-controls=\"sample-table-2\"> <a>Siguiente</a></li>\n" );
    pw.println("<li tabindex=\"0\" class=\"paginate_button next disabled\" id=\"sample-table-2_next\" aria-controls=\"sample-table-2\"> <a> &gt;&gt; </a></li>\n" );
}

pw.println("                                                    </ul>                                                  \n" +
"                                                </div>                                             \n" +
"                                            </div>                                              \n" +
"                                            <div class=\"col-xs-5\">\n" +
"                                                <table style=\"width: 100%; height: 72px;\" border=\"0\">\n" +
"                                                    <tbody>\n" +
"                                                        <tr>                                                          \n" +
"                                                            <td style=\"text-align: right; vertical-align: middle; background-color: transparent!important;\">Mostrando del "+((pagina*cantPorPagina)-cantPorPagina+1)+" al "+((pagina*cantPorPagina))+" de "+cantidadRegistros+" Grados/Ciclos</td> \n" +
"                                                        </tr> \n" +
"                                                    </tbody>\n" +
"                                                </table>\n" +
"                                            </div>  \n" +
"                                        </div>");

pw.println("                                    </div><!-- /.table -->\n" +
"                                    <!--/ End sample table -->\n" +
"                                </div>\n" +
"                            </div>\n" +
"                        </div>");
    }
    
    private void generarFormNuevoCentro(HttpServletRequest request, HttpServletResponse response) throws IOException {
        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        
        pw.println("<form id=\"form-validate\"><div class=\"form-body\">\n" +
"                                            <fieldset>\n" +
"                                                <div class=\"form-group col-sm-12\" id=\"txtFiltro\">\n" +
"                                                    <label class=\"control-label\" id=\"etiqueta-busqueda\"><b><span class=\"etiqueta\">Centro</span> <span class=\"asterisk\">(*)</span></b></label>\n" +
"                                                    <input type=\"text\" class=\"form-control validate[required]\" id=\"nuevoNombre\">\n" +
"                                                </div>\n" +
"                                                \n" +
"                                                \n" +
"                                            </fieldset>"
                + "                             <div class=\"form-group col-md-12\">                 \n" +
"                                                            <div class=\"text-right\"><b><span class=\"asterisk\">(*)</span> Campo Obligatorio</b>\n" +
"                                                            </div>         \n" +
"                                                        </div>\n" +
"                                        </div><!-- /.form-body -->\n" +
"                                        <div class=\"form-footer\">\n" +
"                                            <div class=\"pull-right\">\n" +
"                                                <button class=\"btn btn-foursquare  \" type=\"button\" onclick=\"agregarNuevo();\" ><i class=\"fa fa-save\"></i> GUADAR</button>\n" +
"                                                <button class=\"btn btn-warning \" type=\"reset\" onclick=\"\" data-dismiss=\"modal\"><i class=\"fa fa-refresh\"></i> CANCELAR</button>\n" +
"                                            </div>\n" +
"                                            <div class=\"clearfix\"></div>\n" +
"                                        </div></form>");
    }
    
    private void generarFormNuevoNivel(HttpServletRequest request, HttpServletResponse response) throws IOException {
        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        
        pw.println("<form id=\"form-validate\"><div class=\"form-body\">\n" +
"                                            <fieldset>\n" +
"                                                <div class=\"form-group col-sm-12\" id=\"txtFiltro\">\n" +
"                                                    <label class=\"control-label\" id=\"etiqueta-busqueda\"><b><span class=\"etiqueta\">Concepto</span> <span class=\"asterisk\">(*)</span></b></label>\n" +
"                                                    <input type=\"text\" class=\"form-control validate[required]\" id=\"nuevoNombre\">\n" +
"                                                </div>\n" +
"                                                \n" +
"                                                \n" +
"                                            </fieldset>"
                + "                          <div class=\"form-group col-md-12\">                 \n" +
"                                                            <div class=\"text-right\"><b><span class=\"asterisk\">(*)</span> Campo Obligatorio</b>\n" +
"                                                            </div>         \n" +
"                                                        </div>\n" +
"                                        </div><!-- /.form-body -->\n" +
"                                        <div class=\"form-footer\">\n" +
"                                            <div class=\"pull-right\">\n" +
"                                                <button class=\"btn btn-foursquare  \" type=\"button\" onclick=\"agregarNuevo();\" ><i class=\"fa fa-save\"></i> GUADAR</button>\n" +
"                                                <button class=\"btn btn-warning \" type=\"reset\" onclick=\"\" data-dismiss=\"modal\"><i class=\"fa fa-refresh\"></i> CANCELAR</button>\n" +
"                                            </div>\n" +
"                                            <div class=\"clearfix\"></div>\n" +
"                                        </div></form>");
    }
    
    private void generarFormNuevoGrado(HttpServletRequest request, HttpServletResponse response) throws IOException {
        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        
        pw.println("<form id=\"form-validate\"><div class=\"form-body\">\n" +
"                                            <fieldset>\n" +
"                                                <div class=\"form-group col-sm-12\" id=\"txtFiltro\">\n" +
"                                                    <label class=\"control-label\" id=\"etiqueta-busqueda\"><b><span class=\"etiqueta\">Concepto</span> <span class=\"asterisk\">(*)</span></b></label>\n" +
"                                                    <input type=\"text\" class=\"form-control validate[required]\" id=\"nuevoNombre\">\n" +
"                                                </div>\n" +
"                                                \n" +
"                                                \n" +
"                                            </fieldset>"
                + "                             <div class=\"form-group col-md-12\">                 \n" +
"                                                            <div class=\"text-right\"><b><span class=\"asterisk\">(*)</span> Campo Obligatorio</b>\n" +
"                                                            </div>         \n" +
"                                                        </div>\n" +
"                                        </div><!-- /.form-body -->\n" +
"                                        <div class=\"form-footer\">\n" +
"                                            <div class=\"pull-right\">\n" +
"                                                <button class=\"btn btn-foursquare  \" type=\"button\" onclick=\"agregarNuevo();\" ><i class=\"fa fa-save\"></i> GUADAR</button>\n" +
"                                                <button class=\"btn btn-warning \" type=\"reset\" onclick=\"\" data-dismiss=\"modal\"><i class=\"fa fa-refresh\"></i> CANCELAR</button>\n" +
"                                            </div>\n" +
"                                            <div class=\"clearfix\"></div>\n" +
"                                        </div></form>");
    }
    
    private void generarFormNuevoCiclo(HttpServletRequest request, HttpServletResponse response) throws IOException {
        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        
        pw.println("<form id=\"form-validate\"><div class=\"form-body\">\n" +
"                                            <fieldset>\n" +
"                                                <div class=\"form-group col-sm-12\" id=\"txtFiltro\">\n" +
"                                                    <label class=\"control-label\" id=\"etiqueta-busqueda\"><b><span class=\"etiqueta\">Concepto</span> <span class=\"asterisk\">(*)</span></b></label>\n" +
"                                                    <input type=\"text\" class=\"form-control validate[required]\" id=\"nuevoNombre\">\n" +
"                                                </div>\n" +
"                                                \n" +
"                                                \n" +
"                                            </fieldset>"
                + "                             <div class=\"form-group col-md-12\">                 \n" +
"                                                            <div class=\"text-right\"><b><span class=\"asterisk\">(*)</span> Campo Obligatorio</b>\n" +
"                                                            </div>         \n" +
"                                                        </div>\n" +
"                                        </div><!-- /.form-body -->\n" +
"                                        <div class=\"form-footer\">\n" +
"                                            <div class=\"pull-right\">\n" +
"                                                <button class=\"btn btn-foursquare  \" type=\"button\" onclick=\"agregarNuevo();\" ><i class=\"fa fa-save\"></i> GUADAR</button>\n" +
"                                                <button class=\"btn btn-warning \" type=\"reset\" onclick=\"\" data-dismiss=\"modal\"><i class=\"fa fa-refresh\"></i> CANCELAR</button>\n" +
"                                            </div>\n" +
"                                            <div class=\"clearfix\"></div>\n" +
"                                        </div></form>");
    }
    
    private void insertarCentro(HttpServletRequest request, HttpServletResponse response) throws IOException {
        response.setContentType("text/html");
        String centro = request.getParameter("centro");
        PrintWriter pw = response.getWriter();
        MontoService servicio = new MontoService();
        int r = servicio.insertarCentros(centro);
        pw.println(r);
    }
    
    private void insertarNivel(HttpServletRequest request, HttpServletResponse response) throws IOException {
        response.setContentType("text/html");
        int idCentro = Integer.parseInt(request.getParameter("codcentro"));
        String nivel = request.getParameter("nivel");
        PrintWriter pw = response.getWriter();
        MontoService servicio = new MontoService();
        int r = servicio.insertarNiveles(idCentro, nivel);
        pw.println(r);
    }
    
    private void insertarGrado(HttpServletRequest request, HttpServletResponse response) throws IOException {
        response.setContentType("text/html");
        int idNivel = Integer.parseInt(request.getParameter("codnivel"));
        String grado = request.getParameter("grado");
        PrintWriter pw = response.getWriter();
        MontoService servicio = new MontoService();
        int r = servicio.insertarGrados(idNivel, grado);
        pw.println(r);
    }
    
    private void insertarCiclo(HttpServletRequest request, HttpServletResponse response) throws IOException {
        response.setContentType("text/html");
        int idGrado = Integer.parseInt(request.getParameter("codgrado"));
        String ciclo = request.getParameter("ciclo");
        PrintWriter pw = response.getWriter();
        MontoService servicio = new MontoService();
        int r = servicio.insertarCiclos(idGrado, ciclo);
        pw.println(r);
    }
    
    private void cambiarEstadoCentro(HttpServletRequest request, HttpServletResponse response) throws IOException {
        response.setContentType("text/html");
        int id = Integer.parseInt(request.getParameter("centro"));
        int estado = Integer.parseInt(request.getParameter("estado"));
        PrintWriter pw = response.getWriter();
        MontoService servicio = new MontoService();
        int r = servicio.cambiarEstadoCentros(id, estado);
        pw.println(r);
    }
    
    private void cambiarEstadoNivel(HttpServletRequest request, HttpServletResponse response) throws IOException {
        response.setContentType("text/html");
        int id = Integer.parseInt(request.getParameter("nivel"));
        int estado = Integer.parseInt(request.getParameter("estado"));
        PrintWriter pw = response.getWriter();
        MontoService servicio = new MontoService();
        int r = servicio.cambiarEstadoNiveles(id, estado);
        pw.println(r);
    }
    
    private void cambiarEstadoGrado(HttpServletRequest request, HttpServletResponse response) throws IOException {
        response.setContentType("text/html");
        int id = Integer.parseInt(request.getParameter("grado"));
        int estado = Integer.parseInt(request.getParameter("estado"));
        PrintWriter pw = response.getWriter();
        MontoService servicio = new MontoService();
        int r = servicio.cambiarEstadoGrados(id, estado);
        pw.println(r);
    }
    
    private void cambiarEstadoCiclo(HttpServletRequest request, HttpServletResponse response) throws IOException {
        response.setContentType("text/html");
        int id = Integer.parseInt(request.getParameter("ciclo"));
        int estado = Integer.parseInt(request.getParameter("estado"));
        PrintWriter pw = response.getWriter();
        MontoService servicio = new MontoService();
        int r = servicio.cambiarEstadoCiclos(id, estado);
        pw.println(r);
    }
    
    private void generarFormEditarCentro(HttpServletRequest request, HttpServletResponse response) throws IOException {
        int codigo = Integer.parseInt(request.getParameter("id"));
        String centro = request.getParameter("nombre");
        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        
        pw.println("<form id=\"form-validate-editar\"><div class=\"form-body\">\n" +
"                                            <fieldset>\n" +
"                                                <div class=\"col-sm-12\" id=\"txtFiltro\">\n" +
"                                                    <label class=\"control-label\" id=\"etiqueta-busqueda\"><b><span class=\"etiqueta\">Concepto</span> <span class=\"asterisk\">(*)</span></b></label>\n" +
"                                                    <input type=\"text\" class=\"form-control validate[required]\" data-id=\"" + codigo + "\" id=\"nuevoNombre\" value=\"" + centro + "\">\n" +
"                                                </div>\n" +
"                                                \n" +
"                                                \n" +
"                                            </fieldset>\n" +
"                                        </div><!-- /.form-body -->\n" +
"                                        <div class=\"form-footer\">\n" +
"                                            <div class=\"pull-right\">\n" +
"                                                <button class=\"btn btn-foursquare  \" type=\"button\" onclick=\"editarCentro();\" ><i class=\"fa fa-save\"></i> GUADAR</button>\n" +
"                                                <button class=\"btn btn-warning \" type=\"reset\" onclick=\"\" data-dismiss=\"modal\"><i class=\"fa fa-refresh\"></i> CANCELAR</button>\n" +
"                                            </div>\n" +
"                                            <div class=\"clearfix\"></div>\n" +
"                                        </div></form>");
    }
    
    private void generarFormEditarNivel(HttpServletRequest request, HttpServletResponse response) throws IOException {
        int codigo = Integer.parseInt(request.getParameter("id"));
        String nombre = request.getParameter("nombre");
        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        
        pw.println("<form id=\"form-validate-editar\"><div class=\"form-body\">\n" +
"                                            <fieldset>\n" +
"                                                <div class=\"col-sm-12\" id=\"txtFiltro\">\n" +
"                                                    <label class=\"control-label\" id=\"etiqueta-busqueda\"><b><span class=\"etiqueta\">Concepto</span> <span class=\"asterisk\">(*)</span></b></label>\n" +
"                                                    <input type=\"text\" class=\"form-control validate[required]\" data-id=\"" + codigo + "\" id=\"nuevoNombre\" value=\"" + nombre + "\">\n" +
"                                                </div>\n" +
"                                                \n" +
"                                                \n" +
"                                            </fieldset>\n" +
"                                        </div><!-- /.form-body -->\n" +
"                                        <div class=\"form-footer\">\n" +
"                                            <div class=\"pull-right\">\n" +
"                                                <button class=\"btn btn-foursquare  \" type=\"button\" onclick=\"editarNivel();\" ><i class=\"fa fa-save\"></i> GUADAR</button>\n" +
"                                                <button class=\"btn btn-warning \" type=\"reset\" onclick=\"\" data-dismiss=\"modal\"><i class=\"fa fa-refresh\"></i> CANCELAR</button>\n" +
"                                            </div>\n" +
"                                            <div class=\"clearfix\"></div>\n" +
"                                        </div></form>");
    }
    
    private void generarFormEditarGrado(HttpServletRequest request, HttpServletResponse response) throws IOException {
        int codigo = Integer.parseInt(request.getParameter("id"));
        String nombre = request.getParameter("nombre");
        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        
        pw.println("<form id=\"form-validate-editar\"><div class=\"form-body\">\n" +
"                                            <fieldset>\n" +
"                                                <div class=\"col-sm-12\" id=\"txtFiltro\">\n" +
"                                                    <label class=\"control-label\" id=\"etiqueta-busqueda\"><b><span class=\"etiqueta\">Concepto</span> <span class=\"asterisk\">(*)</span></b></label>\n" +
"                                                    <input type=\"text\" class=\"form-control validate[required]\" data-id=\"" + codigo + "\" id=\"nuevoNombre\" value=\"" + nombre + "\">\n" +
"                                                </div>\n" +
"                                                \n" +
"                                                \n" +
"                                            </fieldset>\n" +
"                                        </div><!-- /.form-body -->\n" +
"                                        <div class=\"form-footer\">\n" +
"                                            <div class=\"pull-right\">\n" +
"                                                <button class=\"btn btn-foursquare  \" type=\"button\" onclick=\"editarGrado();\"><i class=\"fa fa-save\"></i> GUADAR</button>\n" +
"                                                <button class=\"btn btn-warning \" type=\"reset\" onclick=\"\" data-dismiss=\"modal\"><i class=\"fa fa-refresh\"></i> CANCELAR</button>\n" +
"                                            </div>\n" +
"                                            <div class=\"clearfix\"></div>\n" +
"                                        </div></form>");
    }
    
    private void generarFormEditarCiclo(HttpServletRequest request, HttpServletResponse response) throws IOException {
        int codigo = Integer.parseInt(request.getParameter("id"));
        String nombre = request.getParameter("nombre");
        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        
        pw.println("<form id=\"form-validate-editar\"><div class=\"form-body\">\n" +
"                                            <fieldset>\n" +
"                                                <div class=\"col-sm-12\" id=\"txtFiltro\">\n" +
"                                                    <label class=\"control-label\" id=\"etiqueta-busqueda\"><b><span class=\"etiqueta\">Concepto</span> <span class=\"asterisk\">(*)</span></b></label>\n" +
"                                                    <input type=\"text\" class=\"form-control validate[required]\" data-id=\"" + codigo + "\" id=\"nuevoNombre\" value=\"" + nombre + "\">\n" +
"                                                </div>\n" +
"                                                \n" +
"                                                \n" +
"                                            </fieldset>\n" +
"                                        </div><!-- /.form-body -->\n" +
"                                        <div class=\"form-footer\">\n" +
"                                            <div class=\"pull-right\">\n" +
"                                                <button class=\"btn btn-foursquare  \" type=\"button\" onclick=\"editarCiclo('" + codigo + "','" + nombre + "');\" ><i class=\"fa fa-save\"></i> GUADAR</button>\n" +
"                                                <button class=\"btn btn-warning \" type=\"reset\" onclick=\"\" data-dismiss=\"modal\"><i class=\"fa fa-refresh\"></i> CANCELAR</button>\n" +
"                                            </div>\n" +
"                                            <div class=\"clearfix\"></div>\n" +
"                                        </div></form>");
    }
    
    private void editarCentro(HttpServletRequest request, HttpServletResponse response) throws IOException {
        response.setContentType("text/html");
        int id = Integer.parseInt(request.getParameter("id"));
        String centro = request.getParameter("centro");
        PrintWriter pw = response.getWriter();
        MontoService servicio = new MontoService();
        int r = servicio.editarCentro(id, centro);
        pw.println(r);
    }
    
    private void editarNivel(HttpServletRequest request, HttpServletResponse response) throws IOException {
        response.setContentType("text/html");
        int id = Integer.parseInt(request.getParameter("id"));
        String nombre = request.getParameter("nombre");
        PrintWriter pw = response.getWriter();
        MontoService servicio = new MontoService();
        int r = servicio.editarNivel(id, nombre);
        pw.println(r);
    }
    
    private void editarGrado(HttpServletRequest request, HttpServletResponse response) throws IOException {
        response.setContentType("text/html");
        int id = Integer.parseInt(request.getParameter("id"));
        String nombre = request.getParameter("nombre");
        PrintWriter pw = response.getWriter();
        MontoService servicio = new MontoService();
        int r = servicio.editarGrado(id, nombre);
        pw.println(r);
    }
    
    private void editarCiclo(HttpServletRequest request, HttpServletResponse response) throws IOException {
        response.setContentType("text/html");
        int id = Integer.parseInt(request.getParameter("id"));
        String nombre = request.getParameter("nombre");
        PrintWriter pw = response.getWriter();
        MontoService servicio = new MontoService();
        int r = servicio.editarCiclo(id, nombre);
        pw.println(r);
    }
}


