package pe.siso.academia.Servlets;

import java.io.IOException;
import java.io.PrintWriter;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import org.json.simple.JSONArray;
import org.json.simple.JSONObject;
import org.json.simple.parser.JSONParser;
import pe.siso.academia.Beans.Cierre;
import pe.siso.academia.Beans.Descuento;
import pe.siso.academia.Beans.Pension;
import pe.siso.academia.Beans.Usuario;
import pe.siso.academia.Services.DescuentoService;
import pe.siso.academia.Services.DocumentoService;
import pe.siso.academia.Services.NubefactSO;
import pe.siso.academia.Services.PensionService;

public class ServletPension extends HttpServlet {

    @Override
    protected void service(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
        String param = request.getParameter("accion");
        if ("listarPensionesPorMatricula".equals(param)) {
            listarPensionesPorMatricula(request, response);
        } else if ("generarFormPagarPension".equals(param)) {
            generarFormPagarPension(request, response);
        } else if ("generarFormAnularPension".equals(param)) {
            generarFormAnularPension(request, response);
        } else if ("generarFormDevolverPension".equals(param)) {
            generarFormDevolverPension(request, response);
        } else if ("activarPension".equals(param)) {
            activarPension(request, response);
        } else if ("anularPension".equals(param)) {
            anularPension(request, response);
        } else if ("pagarPension".equals(param)) {
            pagarPension(request, response);
        } else if ("devolverPension".equals(param)) {
            devolverPension(request, response);
        } else if ("generarFormFraccionarPension".equals(param)) {
            generarFormFraccionarPension(request, response);
        } else if ("fraccionarPension".equals(param)) {
            fraccionarPension(request, response);
        } else if ("verificarPensionesActualizarMatri".equals(param)) {
            verificarPensionesActualizarMatri(request, response);
        } else if ("actualizarPensiones".equals(param)) {
            actualizarPensiones(request, response);
        } else if ("duplicarPensionesAnulada".equals(param)) {
            duplicarPensionesAnulada(request, response);
        } else if ("anularPensionesPorMatricula".equals(param)) {
            anularPensionesPorMatricula(request, response);
        } else if ("generarFormInformación".equals(param)) {
            generarFormInformación(request, response);
        } else if ("imprimirBoletaPago".equals(param)) {
            imprimirBoletaPago(request, response);
        } else if ("AdvertenciaCierreDiario".equals(param)) {
            AdvertenciaCierreDiario(request, response);
        } else if ("frmAnularPension".equals(param)) {
            frmAnularPension(request, response);
        } else if ("habilitarPensionesAnulada".equals(param)) {
            habilitarPensionesAnulada(request, response);
        } else if ("frmAgregarDescuento".equals(param)) {
            frmAgregarDescuento(request, response);
        } else if ("guardarDescuento".equals(param)) {
            guardarDescuento(request, response);
        } else if ("listarBackupErrorNubeFact".equals(param)) {
            listarBackupErrorNubeFact(request, response);
        } else if ("cargarNubeFact".equals(param)) {
            try {
                cargarNubeFact(request, response);
            } catch (org.json.simple.parser.ParseException ex) {
                Logger.getLogger(ServletPension.class.getName()).log(Level.SEVERE, null, ex);
            }
        }
    }

    private void listarPensionesPorMatricula(HttpServletRequest request, HttpServletResponse response) throws IOException {
        int codMatri = Integer.parseInt(request.getParameter("codmatri"));
        int TipUsu = Integer.parseInt(request.getParameter("tipusu"));
        PensionService servicio = new PensionService();
        ArrayList<Pension> lista = new ArrayList<>();
        lista = servicio.listarPensiones(codMatri);
        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        pw.println("<div class=\"col-md-12\">\n"
                + "                            <div class=\"panel\">\n"
                + "                                <div class=\"panel-heading-saco\">\n"
                + "                                    <h3 class=\"panel-title pull-left\">Pensiones</h3>\n"
                + "                                    <span class=\"pull-right\" style=\"display: block;\">");

        if (TipUsu == 1) {
            pw.println("                                        <button class=\"btn btn-danger\" onclick=\"frmAnularPensiones(" + codMatri + ")\">  \n"
                    + "                                            <i class=\"fa fa-ban\"></i> Anular Pensiones\n"
                    + "                                        </button>");
            pw.println("                                        <button class=\"btn btn-primary\" onclick=\"frmAgregarDescuento()\">  \n"
                    + "                                            <i class=\"fa fa-plus-square\"></i> Agregar Descuento\n"
                    + "                                        </button>");
            pw.println("                                        <a id=\"seleccionTodo\" class=\"ckbox ckbox-primary\">\n"
                    + "                                            <input id=\"pago-anual\" type=\"checkbox\">\n"
                    + "                                            <label for=\"pago-anual\">Seleccionar Todo</label>                                                 \n"
                    + "                                         </a>");
        }
        pw.println("                                        <a id=\"verAnulado\" class=\"ckbox ckbox-danger\">\n"
                + "                                            <input id=\"ver-anulado\" type=\"checkbox\">\n"
                + "                                            <label for=\"ver-anulado\">Ver Eliminados</label>                                                 \n"
                + "                                         </a>");
        pw.println("                                    </span>\n"
                + "                                    <div style=\"clear: both;\"></div>\n"
                + "                                </div>\n"
                + "                                <div class=\"panel-body no-padding\">\n"
                + "                                    <!-- Start sample table -->\n"
                + "                                    <div class=\"table rounded mb-20\">\n"
                + "                                        <table id=\"listarCuotas\" class=\"table table-striped table-saco\" style=\"border: 1px solid rgb(198, 198, 198); border-image: none; font-size: 11px;\">\n"
                + "                                            <thead>\n"
                + "                                                <tr>\n"
                + "                                                    <th class=\"text-center border-right\">No.</th>\n"
                + "                                                    <th class=\"text-center\">Fec. Venc.</th>\n"
                + "                                                    <th class=\"text-center\">Concepto</th>\n"
                + "                                                    <th class=\"text-center\">Fec. Pago</th>\n"
                + "                                                    <th class=\"text-center\">Monto</th>\n"
                //                + "                                                    <th class=\"text-center\">Nom. Dscto.</th>\n"
                + "                                                    <th class=\"text-center\">Monto Dscto.</th>\n"
                + "                                                    <th class=\"text-center\">Total</th>\n"
                + "                                                    <th class=\"text-center\">Nro. Doc.</th>"
                + "                                                     <th class=\"text-center\">Estado</th>\n"
                + "                                                     <th class=\"text-center\">Tipo documento</th>\n"
                + "                                                    \n"
                + "                                                    <th style=\"width: 126px\" class=\"text-center\">Acciones</th>\n"
                + "                                                </tr>\n"
                + "                                            </thead>\n"
                + "                                            <tbody>\n");
        for (int i = 0; i < lista.size(); i++) {
            /* CONVERTIR FECHA */
            if (lista.get(i).getFecha_pago() == null) {
                lista.get(i).setFecha_pago("");
            }
            String[] fecha_max_anulacion = lista.get(i).getFecha_pago().split(" ");

            Date Hoy = new Date();
            SimpleDateFormat formateador = new SimpleDateFormat("dd/MM/yyyy");
            String fecha_actual = formateador.format(Hoy);
            System.out.println("fecha actual " + fecha_actual + " \n");
            System.out.println("fecha max " + fecha_max_anulacion[0] + " \n");

            String montoTotal = String.format("%.2f", (Double.parseDouble(lista.get(i).getMontoPension()) - Double.parseDouble(lista.get(i).getMonto_dscto())));
            switch (Integer.parseInt(lista.get(i).getEstadoPension().trim())) {
                case 0:
                    if (!lista.get(i).getFraccion().equals("")) {
                        try {
                            if (!lista.get(i).getCodPension().equals(lista.get(i + 1).getCodPension())) {
                                pw.println("<tr class=\"pendiente \" >");
                            }
                        } catch (Exception e) {
                            pw.println("<tr class=\"pendiente \" >");
                        }
                    } else {
                        pw.println("<tr class=\"pendiente\" >");
                    }
                    break;
                case 2:
                    pw.println("<tr class=\"hide\" >");
                    break;
                default:
                    pw.println("<tr>");
                    break;
            }

            pw.println("<td class=\"hide\">" + lista.get(i).getCodpagocuota() + "</td>");
            pw.println("<td>" + (i + 1) + "</td>");
            pw.println("<td>" + lista.get(i).getCaducidadPension() + "</td>");
            pw.println("<td>" + lista.get(i).getDescPension() + " " + lista.get(i).getFraccion() + "</td>");
            pw.println("<td>" + lista.get(i).getFecha_pago() + "</td>");
            pw.println("<td>" + lista.get(i).getMontoPension() + "</td>");
//            pw.println("<td>" + lista.get(i).getNom_dscto() + "</td>");
            pw.println("<td>" + lista.get(i).getMonto_dscto() + "</td>");
            switch (Integer.parseInt(lista.get(i).getEstadoPension().trim())) {
                case 0:
                    pw.println("<td>" + montoTotal.replace(",", ".") + "</td>");
                    break;
                default:
                    pw.println("<td>" + lista.get(i).getPagado() + "</td>");
                    break;
            }
            pw.println("<td >" + lista.get(i).getNum_serie() + "-" + lista.get(i).getNum_docu() + "</td>");

            switch (Integer.parseInt(lista.get(i).getEstadoPension().trim())) {
                case 0:
                    pw.println("<td><span class=\"label label-warning\">PENDIENTE</span></td>");
                    break;
                case 1:
                    pw.println("<td><span class=\"label label-success\">CANCELADO</span></td>");
                    break;
                case 2:
                    pw.println("<td><span class=\"label label-eliminado\">ELIMINADO</span></td>");
                    break;
                case 3:
                    pw.println("<td><span class=\"label label-inverse\">DEVOLUCIÓN</span></td>");
                    break;
                case 5:
                    pw.println("<td><span class=\"label label-success\">CANCELADO</span></td>");
                    break;
                default:
                    pw.println("<td><span class=\"label label-danger\">ANULADO</span></td>");
                    break;
            }
            pw.println("<td class=\"text-center\" >" + lista.get(i).getTipoDocumento() + "</td>");
            pw.println("<td  class=\"text-center border\"><div style=\"width: 126px\">");
            switch (Integer.parseInt(lista.get(i).getEstadoPension().trim())) {
                case 0:
                    if (lista.get(i).getFraccion().equals("")) {
                        try { //try para el error si no encuenta i-1
                            if (Integer.parseInt(lista.get(i - 1).getEstadoPension()) == 0) {
                                pw.println("<i class=\"fa fa-money fa-2x\"></i>");
                                pw.println("<a data-original-title=\"Eliminar Pensión\" data-toggle=\"tooltip\" data-placement=\"top\" href=\"javascript:frmAnularPension(" + lista.get(i).getCodpagocuota() + ",0);\"><span class=\"fa-stack fa-lg\"><i class=\"fa fa-times bigger-140 red\"></i></span></a>");
                                //      pw.println("<a data-original-title=\"Fraccionar Pensión\" data-toggle=\"tooltip\" data-placement=\"top\" href=\"javascript:frmFraccionarPension(" + lista.get(i).getCodpagocuota() + "," + codMatri + "," + lista.get(i).getCodPension()+ "," + lista.get(i).getMontoPension()+ ");\"><i class=\"fa fa-code-fork red bigger-140\"></i></a>");    
                            } else {
                                pw.println("<a data-original-title=\"Registrar Pago\" data-toggle=\"tooltip\" data-placement=\"top\" href=\"javascript:frmPagarPension(" + lista.get(i).getCodpagocuota() + "," + lista.get(i).getMontoPension() + ");\"><i class=\"fa fa-money fa-2x green\"></i></a>");
                                if (TipUsu == 1) {
                                    pw.println("<a data-original-title=\"Eliminar Pensión\" data-toggle=\"tooltip\" data-placement=\"top\" href=\"javascript:frmAnularPension(" + lista.get(i).getCodpagocuota() + ",0);\"><span class=\"fa-stack fa-lg\"><i class=\"fa fa-times bigger-140 red\"></i></span></a>");
                                    pw.println("<a data-original-title=\"Fraccionar Pensión\" data-toggle=\"tooltip\" data-placement=\"top\" href=\"javascript:frmFraccionarPension(" + lista.get(i).getCodpagocuota() + "," + codMatri + "," + lista.get(i).getCodPension() + "," + lista.get(i).getMontoPension() + ");\"><i class=\"fa fa-code-fork red bigger-140\"></i></a>");
                                }
                            }
                        } catch (Exception e) {
                            pw.println("<a data-original-title=\"Registrar Pago\" data-toggle=\"tooltip\" data-placement=\"top\" href=\"javascript:frmPagarPension(" + lista.get(i).getCodpagocuota() + "," + lista.get(i).getMontoPension() + ");\"><i class=\"fa fa-money fa-2x green\"></i></a>");
                            if (TipUsu == 1) {
                                pw.println("<a data-original-title=\"Eliminar Pensión\" data-toggle=\"tooltip\" data-placement=\"top\" href=\"javascript:frmAnularPension(" + lista.get(i).getCodpagocuota() + ",0);\"><span class=\"fa-stack fa-lg\"><i class=\"fa fa-times bigger-140 red\"></i></span></a>");
                                pw.println("<a data-original-title=\"Fraccionar Pensión\" data-toggle=\"tooltip\" data-placement=\"top\" href=\"javascript:frmFraccionarPension(" + lista.get(i).getCodpagocuota() + "," + codMatri + "," + lista.get(i).getCodPension() + "," + lista.get(i).getMontoPension() + ");\"><i class=\"fa fa-code-fork red bigger-140\"></i></a>");
                            }
                        }
                    } else {
                        pw.println("<a data-original-title=\"Registrar Pago\" data-toggle=\"tooltip\" data-placement=\"top\" href=\"javascript:frmPagarPension(" + lista.get(i).getCodpagocuota() + "," + lista.get(i).getMontoPension() + ");\"><i class=\"fa fa-money fa-2x green\"></i></a>");
                        if (TipUsu == 1) {
                            pw.println("<a data-original-title=\"Eliminar Pensión\" data-toggle=\"tooltip\" data-placement=\"top\" href=\"javascript:frmAnularPension(" + lista.get(i).getCodpagocuota() + ",0);\"><span class=\"fa-stack fa-lg\"><i class=\"fa fa-times bigger-140 red\"></i></span></a>");
                            pw.println("<a data-original-title=\"Fraccionar Pensión\" data-toggle=\"tooltip\" data-placement=\"top\" href=\"javascript:frmFraccionarPension(" + lista.get(i).getCodpagocuota() + "," + codMatri + "," + lista.get(i).getCodPension() + "," + lista.get(i).getMontoPension() + ");\"><i class=\"fa fa-code-fork red bigger-140\"></i></a>");
                        }
                    }
                    break;
                case 1:
//                    if (TipUsu == 1) {
//                        pw.println("<a data-original-title=\"Devolver Pensión\" data-toggle=\"tooltip\" data-placement=\"top\" href=\"javascript:frmdevolverPension(" + lista.get(i).getCodpagocuota() + "," + lista.get(i).getPagado() + "," + lista.get(i).getNum_docu() + "," + lista.get(i).getNum_serie() + ");\"><i class=\"fa fa-reply red bigger-140\"></i></a>");
//                    }
                    if (lista.get(i).getDevol_NumDoc().equals("0") && lista.get(i).getDevol_NumSer().equals("0")) {
                        if (TipUsu == 1) {
                            pw.println("<a data-original-title=\"Devolver Pensión\" data-toggle=\"tooltip\" data-placement=\"top\" href=\"javascript:frmdevolverPension(" + lista.get(i).getCodpagocuota() + "," + lista.get(i).getPagado() + "," + lista.get(i).getNum_docu() + "," + lista.get(i).getNum_serie() + ");\"><i class=\"fa fa-reply red bigger-140\"></i></a>");
                        }
                        if (fecha_max_anulacion[0].equals(fecha_actual)) {
                            pw.println("<a data-original-title=\"Anular Pensión\" data-toggle=\"tooltip\" data-placement=\"top\" href=\"javascript:frmAnularPension(" + lista.get(i).getCodpagocuota() + ",1);\"><span class=\"fa-stack fa-lg red\"><i class=\"fa fa-times bigger-140 red\"></i></span></a>");
                        } else {
                            pw.println("<a data-original-title=\"Anulacion no Disponible\" data-toggle=\"tooltip\" data-placement=\"top\" ><span class=\"fa-stack fa-lg plomo\"><i class=\"fa fa-times bigger-140\"></i></span></a>");
                        }

                    }
                    if (lista.get(i).getUrl_nubefac() == null) {
                        pw.println("<a data-original-title=\"Imprimir\" data-toggle=\"tooltip\" data-placement=\"top\" href=\"javascript:imprimirboleta(" + lista.get(i).getCodpagocuota() + ",1);\"><i class=\"fa fa-print blue bigger-140\" aria-hidden=\"true\" ></i></a>");
                    } else {
                        pw.println("<a data-original-title=\"Imprimir\" data-toggle=\"tooltip\" data-placement=\"top\" href=\"javascript:imprimirConprobanteElectrico('" + lista.get(i).getUrl_nubefac() + "');\"><i class=\"fa fa-print blue bigger-140\" aria-hidden=\"true\" ></i></a>");

                    }

                    pw.println("<a data-original-title=\"Ver Información\" data-toggle=\"tooltip\" data-placement=\"top\" href=\"javascript:frmInformacion(" + lista.get(i).getCodpagocuota() + ");\"><span class=\"fa-stack fa-lg\"><i class=\"fa fa-info-circle blue bigger-140\"><span></i></a>");

                    break;
                case 2:
//                  if(TipUsu==1){
//                    pw.println("<a data-original-title=\"Duplicar Pensión\" data-toggle=\"tooltip\" data-placement=\"top\" href=\"javascript:frmDuplicarPension(" + lista.get(i).getCodpagocuota() + ");\"><i class=\"fa fa-level-down fa-2x green\"></i></a>");
                    if (Integer.parseInt(lista.get(i).getNum_docu()) != 0) {

                        if (lista.get(i).getUrl_nubefac_anulado() == null) {
                            pw.println("<a data-original-title=\"Imprimir\" data-toggle=\"tooltip\" data-placement=\"top\" href=\"javascript:imprimirboleta(" + lista.get(i).getCodpagocuota() + ",3);\"><i class=\"fa fa-print blue bigger-140\" aria-hidden=\"true\" ></i></a>");
                        } else {
                            pw.println("<a data-original-title=\"Imprimir\" data-toggle=\"tooltip\" data-placement=\"top\" href=\"javascript:imprimirConprobanteElectrico('" + lista.get(i).getUrl_nubefac_anulado() + "');\"><i class=\"fa fa-print blue bigger-140\" aria-hidden=\"true\" ></i></a>");

                        }
//                        pw.println("<a data-original-title=\"Imprimir\" data-toggle=\"tooltip\" data-placement=\"top\" href=\"javascript:imprimirboleta(" + lista.get(i).getCodpagocuota() + ",3);\"><i class=\"fa fa-print blue bigger-140\" aria-hidden=\"true\" ></i></a>");

                        pw.println("<a data-original-title=\"Ver Información\" data-toggle=\"tooltip\" data-placement=\"top\" href=\"javascript:frmInformacion(" + lista.get(i).getCodpagocuota() + ");\"><span class=\"fa-stack fa-lg\"><i class=\"fa fa-info-circle blue bigger-140\"><span></i></a>");
                        pw.println("<a data-original-title=\"Duplicar Pensión\" data-toggle=\"tooltip\" data-placement=\"top\" href=\"javascript:frmDuplicarPension(" + lista.get(i).getCodpagocuota() + ");\"><i class=\"fa fa-level-down fa-2x green\"></i></a>");

                    } else {
                        if (TipUsu == 1) {
                            pw.println("<a data-original-title=\"Habilitar Pension\" data-toggle=\"tooltip\" data-placement=\"top\" href=\"javascript:frmHabilidadesPension(" + lista.get(i).getCodpagocuota() + ",1);\"><span class=\"fa-stack fa-lg\"><i class=\"fa fa-check green\"></i></span></a>");
                        }
                        pw.println("<a data-original-title=\"Ver Información\" data-toggle=\"tooltip\" data-placement=\"top\" href=\"javascript:frmInformacion(" + lista.get(i).getCodpagocuota() + ");\"><span class=\"fa-stack fa-lg\"><i class=\"fa fa-info-circle blue bigger-140\"><span></i></a>");

                    }

//                  }
                    break;
                case 3:
//                    pw.println("<a data-original-title=\"Anular Pensión\" data-toggle=\"tooltip\" data-placement=\"top\" href=\"javascript:frmAnularPension(" + lista.get(i).getCodpagocuota() + ",1);\"><span class=\"fa-stack fa-lg\"><i class=\"fa fa-times bigger-140 red\"></i></span></a>");

//                    pw.println("<a data-original-title=\"Imprimir\" data-toggle=\"tooltip\" data-placement=\"top\" href=\"javascript:imprimirboleta(" + lista.get(i).getCodpagocuota() + ",5);\"><i class=\"fa fa-print blue bigger-140\" aria-hidden=\"true\" ></i></a>");
                    if (lista.get(i).getUrl_nubefac_anulado() == null) {
                        pw.println("<a data-original-title=\"Imprimir\" data-toggle=\"tooltip\" data-placement=\"top\" href=\"javascript:imprimirboleta(" + lista.get(i).getCodpagocuota() + ",5);\"><i class=\"fa fa-print blue bigger-140\" aria-hidden=\"true\" ></i></a>");
                    } else {
                        pw.println("<a data-original-title=\"Imprimir\" data-toggle=\"tooltip\" data-placement=\"top\" href=\"javascript:imprimirConprobanteElectrico('" + lista.get(i).getUrl_nubefac_anulado() + "');\"><i class=\"fa fa-print blue bigger-140\" aria-hidden=\"true\" ></i></a>");

                    }

                    pw.println("<a data-original-title=\"Ver Información\" data-toggle=\"tooltip\" data-placement=\"top\" href=\"javascript:frmInformacion(" + lista.get(i).getCodpagocuota() + ");\"><span class=\"fa-stack fa-lg\"><i class=\"fa fa-info-circle blue bigger-140\"><span></i></a>");

                    break;
                default:
                    pw.println("<a data-original-title=\"Ver Información\" data-toggle=\"tooltip\" data-placement=\"top\" href=\"javascript:frmInformacion(" + lista.get(i).getCodpagocuota() + ");\"><span class=\"fa-stack fa-lg\"><i class=\"fa fa-info-circle blue bigger-140\"><span></i></a>");
//                    pw.println("<a data-original-title=\"Imprimir\" data-toggle=\"tooltip\" data-placement=\"top\" href=\"javascript:imprimirboleta(" + lista.get(i).getCodpagocuota() + ",5);\"><i class=\"fa fa-print blue bigger-140\" aria-hidden=\"true\" ></i></a>");
                    if (lista.get(i).getUrl_nubefac_anulado() == null) {
                        pw.println("<a data-original-title=\"Imprimir\" data-toggle=\"tooltip\" data-placement=\"top\" href=\"javascript:imprimirboleta(" + lista.get(i).getCodpagocuota() + ",5);\"><i class=\"fa fa-print blue bigger-140\" aria-hidden=\"true\" ></i></a>");
                    } else {
                        pw.println("<a data-original-title=\"Imprimir\" data-toggle=\"tooltip\" data-placement=\"top\" href=\"javascript:imprimirConprobanteElectrico('" + lista.get(i).getUrl_nubefac_anulado() + "');\"><i class=\"fa fa-print blue bigger-140\" aria-hidden=\"true\" ></i></a>");

                    }
                    break;
            }

            pw.println("</td></div>");
            pw.println("</tr>");
        }

        pw.println("                                 </tbody>\n"
                + "                                        </table>\n");
        pw.println("                         </div><!-- /.table -->\n"
                + "                                    <!--/ End sample table -->\n"
                + "                                </div>\n"
                + "                            </div>\n"
                + "                        </div>");

    }

    private void generarFormPagarPension(HttpServletRequest request, HttpServletResponse response) throws IOException {

        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        HttpSession session_actual = request.getSession(true);
        Usuario usuario = new Usuario();
        usuario = (Usuario) session_actual.getAttribute("usuario");
        int codPension = Integer.parseInt(request.getParameter("codPension"));
        int codSede = Integer.parseInt(request.getParameter("codsede"));
        String montoPago = request.getParameter("monto");
        ArrayList<Descuento> lista = new ArrayList<>();
        DescuentoService servicioDesc = new DescuentoService();
        PensionService servicioPens = new PensionService();
        //String numBoleta = servicioPens.generarNumBoleta(codSede);
        Pension pen = servicioPens.obtenerPension(codPension);
        lista = servicioDesc.listarDescuentoPorSede(codSede, usuario.getCodigoTipoUsuario());
        JSONArray jsontipodocumento = new JSONArray();
        jsontipodocumento = servicioDesc.TipoDocumentoxSede(codSede);
        pw.println("<form id=\"pagar\"><div class=\"form-body\">\n"
                + "                                            <fieldset>\n"
                + "                                                <div class=\"col-sm-6 form-group\" >\n"
                + "                                                    <label class=\"control-label\" for=\"monto\"><b><span class=\"etiqueta\">Monto</span> <span class=\"asterisk\">(*)</span></b></label>\n"
                + "                                                    <input type=\"number\" class=\"form-control validate[required]\" id=\"monto\" step=\"any\" min=\"0\" value=\"" + pen.getMontoPension() + "\" max=\"" + montoPago + "\" onchange=\"obtenerMontoDscto();\" readonly=\"true\"></div>\n"
                + "                                                <div class=\"col-sm-6 form-group\" >\n"
                + "                                                   <label class=\"control-label\"  for=\"descuento\"><b><span class=\"etiqueta\">Descuento</span> <span class=\"asterisk\">(*)</span></b></label>\n");
        pw.println("                                <select class=\"form-control\" id=\"descuento\" onchange=\"obtenerMontoDscto();\">");
        pw.println("                                    <option value=\"\" data-monto=\"\">[SELECCIONE]</option>");
        for (int i = 0; i < lista.size(); i++) {
            if (lista.get(i).getNomDescuento().trim().equals(pen.getNom_dscto().trim())) {
                pw.println("<option value=\"" + lista.get(i).getCodEnlace() + "\" data-monto=\"" + lista.get(i).getMonto() + "\" SELECTED=\"true\" data-tip=\"" + lista.get(i).getTip_mon() + "\">" + lista.get(i).getNomDescuento() + "</option>");
            } else {
                pw.println("<option value=\"" + lista.get(i).getCodEnlace() + "\" data-monto=\"" + lista.get(i).getMonto() + "\" data-tip=\"" + lista.get(i).getTip_mon() + "\">" + lista.get(i).getNomDescuento() + "</option>");
            }
        }
        pw.println("                                </select>");
        pw.println("                             </div>");
        pw.println("                             <div class=\"col-sm-6 form-group\" >\n"
                + "                                                    <label class=\"control-label\" for=\"montoDescuento\"><b><span class=\"etiqueta\">Monto de Descuento</span> <span class=\"asterisk\">(*)</span></b></label>\n"
                + "                                                    <input type=\"text\" class=\"form-control\" id=\"montoDescuento\" value=\"" + pen.getMonto_dscto() + "\" readonly=\"true\"></div>\n"
                + "                                                <div class=\"col-sm-6 form-group\" >\n"
                + "                                                    <label class=\"control-label\"  for=\"fechaPago\"><b><span class=\"etiqueta\">Fecha de Pago</span> <span class=\"asterisk\">(*)</span></b></label>\n"
                + "                                                    <input type=\"text\" class=\"form-control date-range-picker-single validate[required]\" id=\"fechaPago\"></div>\n"
                + "                                                <div class=\"col-sm-6 form-group\" >\n"
                + "                                                    <label class=\"control-label\"  for=\"formaPago\"><b><span class=\"etiqueta\">Forma de Pago</span> <span class=\"asterisk\">(*)</span></b></label>\n");
        pw.println("                                <select class=\"form-control\" id=\"formaPago\">");
        pw.println("                                    <option value=\"1\">CAJA EFECTIVO</option>");
        pw.println("                                    <option value=\"2\">DESC. POR PLANILLA</option>");

        pw.println("                                </select>");
        pw.println("                             </div>");
        pw.println("                             <div class=\"col-sm-6 form-group\" >\n"
                + "                                                   <label class=\"control-label\"  for=\"tipoDocPago\"><b><span class=\"etiqueta\">Tipo de Documento</span> <span class=\"asterisk\">(*)</span></b></label>\n");
        pw.println("                                <select class=\"form-control\" id=\"tipoDocPago\">");
        for (int i = 0; i < jsontipodocumento.size(); i++) {
            if (((JSONObject) jsontipodocumento.get(i)).get("codTipoUsuario").equals("0")) {
                if (((JSONObject) jsontipodocumento.get(i)).get("selectedTipoDocumento").equals("1")) {
                    pw.println("<option selected=\"selected\" value=\"" + ((JSONObject) jsontipodocumento.get(i)).get("nomTipoDocumento") + "\">" + ((JSONObject) jsontipodocumento.get(i)).get("nomTipoDocumento") + "</option>");
                } else {
                    pw.println("<option value=\"" + ((JSONObject) jsontipodocumento.get(i)).get("nomTipoDocumento") + "\">" + ((JSONObject) jsontipodocumento.get(i)).get("nomTipoDocumento") + "</option>");
                }
//                pw.println("<option value=\"" + ((JSONObject) jsontipodocumento.get(i)).get("nomTipoDocumento") + "\">" + ((JSONObject) jsontipodocumento.get(i)).get("nomTipoDocumento") + "</option>");
            }
            if (((JSONObject) jsontipodocumento.get(i)).get("codTipoUsuario").equals(usuario.getCodigoTipoUsuario())) {
                pw.println("<option value=\"" + ((JSONObject) jsontipodocumento.get(i)).get("nomTipoDocumento") + "\">" + ((JSONObject) jsontipodocumento.get(i)).get("nomTipoDocumento") + "</option>");
            }
        }

//        pw.println("                                    <option value=\"CPE BOLETA\">CPE BOLETA</option>"
//                + "                                     <option value=\"BOLETA\">BOLETA</option>");
//        if (usuario.getCodigoTipoUsuario().equals("1")) {
//            pw.println("                                    <option value=\"CPE FACTURA\">CPE FACTURA</option>"
//                    + "                                     <option value=\"FACTURA\">FACTURA</option>");
//        }
        pw.println("                                </select>");
        pw.println("                             </div>");

        pw.println("                                               <div class=\"col-sm-6 form-group hide\" style=\"\">\n"
                + "                                                    <label class=\"control-label\"  for=\"ruc\"><b><span class=\"etiqueta\">RUC</span> <span class=\"asterisk\">(*)</span></b></label>\n"
                + "                                                    <input maxlength=\"11\" onkeypress=\"return soloNumeros(event)\" type=\"text\" class=\"form-control validate[required,custom[number]]\" id=\"ruc\" value=\"\"></div>"
                + "                                                <div class=\"col-sm-6 form-group hide\" style=\"\">\n"
                + "                                                    <label class=\"control-label\" for=\"razonSocial\"><b><span class=\"etiqueta\">Razón Social</span> <span class=\"asterisk\">(*)</span></b></label>\n"
                + "                                                    <input type=\"text\"  class=\"form-control validate[required]\" id=\"razonSocial\" value=\"\"></div>"
                + "                                                <div class=\"col-sm-6 form-group hide\" style=\"\">\n"//hide por el ticket
                + "                                                    <label class=\"control-label\" for=\"numSerie\"><b><span class=\"etiqueta\">Número de Serie</span> <span class=\"asterisk\">(*)</span></b></label>\n"
                + "                                                    <input onkeypress=\"return soloNumeros(event)\" type=\"text\" class=\"form-control validate[required,custom[number]]\" id=\"numSerie\" value=\"\"></div>\n"
                + "                                                <div class=\"col-sm-6 form-group hide\"  style=\"\">\n"//hide por el ticket
                + "                                                    <label class=\"control-label\" for=\"numDocPago\"><b><span class=\"etiqueta\">Número de Documento</span> <span class=\"asterisk\">(*)</span></b></label>\n"
                + "                                                    <input onkeypress=\"return soloNumeros(event)\" type=\"number\" class=\"form-control validate[required,custom[number]]\" id=\"numDocPago\" value=\"\"></div>\n"
                + "                                                <div class=\"col-sm-12 form-group\" >\n"
                + "                                                    <label class=\"control-label\" for=\"observaciones\"><b><span class=\"etiqueta\">Observaciones</span></b></label>\n"
                + "                                                    <input type=\"text\" class=\"form-control\" id=\"observaciones\">"
                + "                                                 </div>\n"
                + //"                                                <div class=\"col-sm-6 form-group\" id=\"txtFiltro\" style=\"\">\n" +
                //"                                                    <label class=\"control-label\" id=\"etiqueta-busqueda\" for=\"numSerie\"><b><span class=\"etiqueta\">Número de Serie</span> <span class=\"asterisk\">(*)</span></b></label>\n" +
                //"                                                    <input type=\"text\" class=\"form-control\" id=\"numSerie\" value=\"" + numBoleta.split("-")[0] + "\" readonly=\"true\"></div>\n" +
                //"                                                <div class=\"col-sm-6 form-group\" id=\"txtFiltro\" style=\"\">\n" +
                //"                                                    <label class=\"control-label\" id=\"etiqueta-busqueda\" for=\"numDocPago\"><b><span class=\"etiqueta\">Número de Documento</span> <span class=\"asterisk\">(*)</span></b></label>\n" +
                //"                                                    <input type=\"number\" class=\"form-control\" id=\"numDocPago\" value=\"" + numBoleta.split("-")[1] + "\" readonly=\"true\"></div>\n" +
                "                                               <div class=\"hide col-sm-6 form-group\" >\n"
                + "                                                    <label class=\"control-label\"  for=\"regula\"><b><span class=\"etiqueta\">Regularización</span> <span class=\"asterisk\">(*)</span></b></label>\n"
                + "                                                    <input onkeypress=\"return soloNumeros(event)\" type=\"text\" class=\"form-control validate[required,custom[number]]\" id=\"regula\" value=\"0.00\" onchange=\"obtenerMontoDscto();\"></div><div class=\"col-sm-6 form-group\" id=\"txtFiltro\">\n"
                //                + "                                                    <label class=\"control-label\"  for=\"efectivo\"><b><span class=\"etiqueta\">Monto Efectivo</span> <span class=\"asterisk\">(*)</span></b></label>\n"
                //                + "                                                    <input onkeypress=\"return soloNumeros(event)\" type=\"text\" class=\"form-control validate[required,custom[number]]\" id=\"efectivo\" value=\"\" onchange=\"verificarMontoPago(),obtenerMontoDscto();\">"
                //                + "                                                     <br><b>Vuelto: </b><label id=\"vuelto\"><b></b></label "
                //                + "                                                     </div><div><b style=\"color:red; \" id=\"mensa\"></b></div>\n"
                + "                                                \n"
                + "                                                </div>\n"
                + "                                                \n"
                + "                                                \n"
                + "                                            </fieldset>\n"
                + "                                        </div><!-- /.form-body -->\n"
                + "                                        <div class=\"form-footer\">\n"
                + "                                            <div class=\"pull-right\">\n"
                + "                                                <button class=\"btn btn-foursquare\" id=\"enviar\" type=\"button\" onclick=\"PagarPension('" + codPension + "');\"><i class=\"fa fa-money\"></i> Registrar Pago</button>\n"
                + "                                                <button class=\"btn btn-warning \" type=\"reset\" onclick=\"\" data-dismiss=\"modal\"><i class=\"fa fa-times\"></i> CANCELAR</button>\n"
                + "                                            </div>\n"
                + "                                            <div class=\"clearfix\"></div>\n"
                + "                                        </div></form>");
    }

    private void generarFormAnularPension(HttpServletRequest request, HttpServletResponse response) throws IOException {

        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        String codPension = request.getParameter("codPension");
        String estAnulacion = request.getParameter("estAnulacion");

        pw.println("<form id=\"motivoAnulacion\"><div class=\"form-body\">\n"
                + "                                            <fieldset>\n"
                + "                                                <div class=\"col-sm-12 form-group\" id=\"txtFiltro\">\n"
                + "                                                    <label class=\"control-label\" id=\"etiqueta-busqueda\" for=\"motivo\"><b><span class=\"etiqueta\">Motivo</span> <span class=\"asterisk\">(*)</span></b></label>\n"
                + "                                                    <input type=\"text\" class=\"form-control validate[required]\" id=\"motivo\" ></div>\n"
                + "                                                </div>\n"
                + "                                                \n"
                + "                                                \n"
                + "                                            </fieldset>\n"
                + "                                        </div><!-- /.form-body -->\n"
                + "                                        <div class=\"form-footer\">\n"
                + "                                            <div class=\"pull-right\">\n"
                + "                                                <button class=\"btn btn-foursquare \" id=\"btnAnularPension\" type=\"button\" onclick=\"AnularPension('" + codPension + "'," + estAnulacion + ");\"><i class=\"fa fa-money\"></i> Anular Pensión</button>\n"
                + "                                                <button class=\"btn btn-warning \"  onclick=\"\" data-dismiss=\"modal\"><i class=\"fa fa-times\"></i> CANCELAR</button>\n"
                + "                                            </div>\n"
                + "                                            <div class=\"clearfix\"></div>\n"
                + "                                        </div></form>");
    }

    private void generarFormDevolverPension(HttpServletRequest request, HttpServletResponse response) throws IOException {

        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        String codPension = request.getParameter("codPension");
        String montoPagado = request.getParameter("montoPagado");
        String numdoc = request.getParameter("numdoc");
        String numser = request.getParameter("numser");
        PensionService servicio = new PensionService();
        JSONArray jsonTipNtCredito = new JSONArray();
        jsonTipNtCredito = servicio.tipoNotaDeCredito();
        pw.println("<form id=\"form-validate\"><div class=\"form-body\">\n"
                + "                                            <fieldset>\n"
                + "                                                <div class=\"col-sm-6 form-group\" id=\"txtFiltro\">\n"
                + "                                                   <label class=\"control-label\" id=\"etiqueta-busqueda\" for=\"formaPago\"><b><span class=\"etiqueta\">Monto Devuelto</span> <span class=\"asterisk\">(*)</span></b></label>\n");
        pw.println("                                <input onkeypress=\"return soloNumeros(event)\" type=\"text\" class=\"form-control\" id=\"montoDevolucion\" step=\"any\" value=\"" + montoPagado + "\" min=\"0\" max=\"" + montoPagado + "\" onchange=\"validarMontoDevolucion();\"></div>");
        pw.println("                             <div class=\"col-sm-6 form-group hide\" id=\"txtFiltro\">\n"
                + "                                                   <label class=\"control-label\" id=\"etiqueta-busqueda\" for=\"tipoDocPago\"><b><span class=\"etiqueta\">Tipo de Documento</span> <span class=\"asterisk\">(*)</span></b></label>\n");
        pw.println("                                <select class=\"form-control\" id=\"tipoDocPago\">");
        pw.println("                                    <option value=\"AUTORIZACIÓN DE GASTO (AG)\">AUTORIZACIÓN DE GASTO (AG)</option>");
        pw.println("                                </select>");
        pw.println("                             </div>");
        pw.println("                             <div class=\"col-sm-6 form-group\" id=\"txtFiltro\">\n"
                + "                                                    <label class=\"control-label\" id=\"etiqueta-busqueda\" for=\"numeroDocPago\"><b><span class=\"etiqueta\">Número de Documento</span> <span class=\"asterisk\">(*)</span></b></label>\n"
                + "                                                    <input value=\"" + numdoc + "\" type=\"text\" class=\"form-control validate[required]\" id=\"numeroDocPago\"></div>\n"
                + "                                                <div class=\"col-sm-6 form-group\" id=\"txtFiltro\">\n"
                + "                                                    <label class=\"control-label\" id=\"etiqueta-busqueda\" for=\"numeroSerie\"><b><span class=\"etiqueta\">Número de Serie</span> <span class=\"asterisk\">(*)</span></b></label>\n"
                + "                                                    <input value=\"" + numser + "\" type=\"text\" class=\"form-control validate[required]\" id=\"numeroSerie\"></div>\n"
                + "                                                <div class=\"col-sm-6 form-group\" id=\"txtFiltro\">\n"
                + "                                                    <label class=\"control-label\" id=\"etiqueta-busqueda\" for=\"numeroSerie\"><b><span class=\"etiqueta\">Tipo Nota de Crédito</span> <span class=\"asterisk\">(*)</span></b></label>\n"
                + "                                                    <select   class=\"form-control validate[required]\" id=\"tipo_nota_credito\">"
                + "                                                     <option value value=\"\">SELECCIONE</option>");
        for (int i = 0; i < jsonTipNtCredito.size(); i++) {

            pw.println("<option value=\"" + ((JSONObject) jsonTipNtCredito.get(i)).get("codNotaCredito") + "\"  >" + ((JSONObject) jsonTipNtCredito.get(i)).get("nomNotaCredito") + "</option>");
        }

        pw.println("                                                    </select></div>\n"
                + "                                                <div class=\"col-sm-12 form-group\" id=\"txtFiltro\">\n"
                + "                                                    <label class=\"control-label\" id=\"etiqueta-busqueda\" for=\"obs\"><b><span class=\"etiqueta\">Observaciones</span> <span class=\"asterisk\">(*)</span></b></label>\n"
                + "                                                    <input type=\"text\" class=\"form-control validate[required]\" id=\"obs\"></div>\n"
                + "                                                </div>\n"
                + "                                                \n"
                + "                                                \n"
                + "                                            </fieldset>\n"
                + "                                        </div><!-- /.form-body -->\n"
                + "                                        <div class=\"form-footer\">\n"
                + "                                            <div class=\"pull-right\">\n"
                + "                                                <button class=\"btn btn-foursquare\" id=\"notaCredito\" type=\"button\" onclick=\"DevolverPension('" + codPension + "','" + montoPagado + "');\"><i class=\"fa fa-money\"></i> Devolver Pensión</button>\n"
                + "                                                <button class=\"btn btn-warning \" type=\"reset\" onclick=\"javascript:n=0;\" data-dismiss=\"modal\"><i class=\"fa fa-times\"></i> CANCELAR</button>\n"
                + "                                            </div>\n"
                + "                                            <div class=\"clearfix\"></div>\n"
                + "                                        </div></form>");
    }

    private void activarPension(HttpServletRequest request, HttpServletResponse response) throws IOException {

        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        int codPension = Integer.parseInt(request.getParameter("codpension"));

        PensionService servicio = new PensionService();
        int resultado = servicio.activarPension(codPension);
        pw.print(resultado);
    }

    private void anularPension(HttpServletRequest request, HttpServletResponse response) throws IOException {

        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        int codPension = Integer.parseInt(request.getParameter("codpension"));
        String motivo = request.getParameter("motivo");
        int codusu = Integer.parseInt(request.getParameter("usuario"));
        String codsede = request.getParameter("codsede");

        Date Hoy = new Date();
        SimpleDateFormat formateador = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss ");
        String fecha_actual = formateador.format(Hoy);

        PensionService servicio = new PensionService();
        int resultado = 0;
        JSONObject jsoncompAnulado = new JSONObject();
        servicio.anularPension(codPension, motivo, codusu, fecha_actual);
        JSONObject jsonResultado = new JSONObject();
        try {
            jsoncompAnulado = servicio.ComprobanteElectronicoAnular(codPension);
            NubefactSO nubfact = new NubefactSO();
            JSONObject jsonNubeFact = new JSONObject();
            System.out.println("jsoncompAnulado--->>>" + jsoncompAnulado);

//        if (jsoncompAnulado.size() != 0) {
            jsonNubeFact = nubfact.anularComprobante((JSONObject) jsoncompAnulado.get("jsonNubeFact"), jsoncompAnulado.get("TOKEN") + "");
            System.out.println("jsonNUBEFACT--->>>" + jsonNubeFact);
            if (jsonNubeFact.get("error_so") == null) {
//                servicio.anularPension(codPension, motivo, codusu, fecha_actual);
                resultado = servicio.GuardarUrl(codPension, jsonNubeFact.get("enlace_del_pdf") + "", "ANULADO");
            } else {
                resultado = servicio.GuardarJsonErrorNubeFact(jsoncompAnulado, jsonNubeFact.get("errors").toString(), codPension, codsede, "anularPension");
            }

            jsonResultado.put("urlComprobante", jsonNubeFact.get("enlace_del_pdf"));
//        } else {
//        servicio.anularPension(codPension, motivo, codusu, fecha_actual);
            jsonResultado.put("resultado", resultado);
//        }
        } catch (Exception e) {
            servicio.GuardarJsonErrorNubeFact(jsoncompAnulado, "Error Desconocido", codPension, "", "anularPension");
            jsonResultado.put("resultado", 2);
        }

        pw.print(jsonResultado);
    }

    private void devolverPension(HttpServletRequest request, HttpServletResponse response) throws IOException {

        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        int codPension = Integer.parseInt(request.getParameter("codpension"));
        double monto_devol = Double.parseDouble(request.getParameter("montoDevolucion"));
        String tipoDoc = request.getParameter("tipoDocPago");
        String obs = request.getParameter("observaciones");
        String num_doc = request.getParameter("numDocPago");
        String num_serie = request.getParameter("numSerie");
        double montopagado = Double.parseDouble(request.getParameter("montopagado"));
        String cod_usu = request.getParameter("cod_usu");
        String cod_sede = request.getParameter("cod_sede");
        int tipo_nota_credito = Integer.parseInt(request.getParameter("tipo_nota_credito"));
        double monto_neto = montopagado - monto_devol;
        PensionService servicio = new PensionService();
        int resultado = servicio.devolverPension(codPension, monto_devol, monto_neto, tipoDoc, num_serie, num_doc, obs, cod_usu, cod_sede, tipo_nota_credito);
        JSONObject jsonComNC = servicio.ComprobanteElectronico(resultado);
        NubefactSO servicioNubeFac = new NubefactSO();
        JSONObject jsonNubeFact = new JSONObject();
        System.out.println("jsonComNC +++++++>>>>" + jsonComNC);
        jsonNubeFact = servicioNubeFac.generarComprobante((JSONObject) jsonComNC.get("jsonNubeFact"), jsonComNC.get("TOKEN") + "");
        System.out.println("URLLLLLLLLLLLLLLLLL->>>>" + jsonNubeFact.get("enlace_del_pdf"));
        if (jsonNubeFact.get("error_so") == null) {
            resultado = servicio.GuardarUrl(resultado, jsonNubeFact.get("enlace_del_pdf") + "", "NOTACREDITO");
        } else {
            resultado = servicio.GuardarJsonErrorNubeFact(jsonNubeFact, "", codPension, cod_sede, "devolverPension");
        }
        JSONObject jsonResultado = new JSONObject();
        jsonResultado.put("resultado", resultado);
        jsonResultado.put("urldevolverPension", jsonNubeFact.get("enlace_del_pdf"));
        pw.print(jsonResultado);
    }

    private void pagarPension(HttpServletRequest request, HttpServletResponse response) throws IOException {

        response.setContentType("Content-type: application/json");
        PrintWriter pw = response.getWriter();
        int codPension = Integer.parseInt(request.getParameter("codpension"));
        String monto = request.getParameter("monto");
        String nom_descuento = request.getParameter("descuento");
        String val_descuento = request.getParameter("montoDescuento");
        String fecha_pago = request.getParameter("fechaPago");
        String forma_pago = request.getParameter("formaPago");
        String obs = request.getParameter("observaciones");
        int cod_enlace_desc = 0;
        if (!nom_descuento.equals("[SELECCIONE]")) {
            cod_enlace_desc = Integer.parseInt(request.getParameter("cod_enlace_desc"));
        } else {
            cod_enlace_desc = 0;
        }
        int num_doc = 0;
        int num_serie = 0;
        String tipoDoc = request.getParameter("tipoDocPago");
        try {
            num_doc = Integer.parseInt(request.getParameter("numDocPago"));
            num_serie = Integer.parseInt(request.getParameter("numSerie"));
        } catch (Exception e) {
            num_doc = 0;
            num_serie = 0;
        }

//        numSerie="+num_serie+"&numDocPago=
//        Double efectivo = Double.parseDouble(request.getParameter("efectivo"));
        Double regulari = Double.parseDouble(request.getParameter("regula"));
        int codigoUsuario = Integer.parseInt(request.getParameter("cod_usu"));
        int codsede = Integer.parseInt(request.getParameter("codsede"));
        String ruc = request.getParameter("ruc");
        String razonSocial = request.getParameter("razonSocial");
//        &ruc="+ruc+"&razonSocial="+razonSocial
        /* CONVERTIR FECHA */
        String hora = fecha_pago.trim().split(" ")[1];
        fecha_pago = fecha_pago.trim().split(" ")[0];
        fecha_pago = fecha_pago.split("/")[2] + "-" + fecha_pago.split("/")[1] + "-" + fecha_pago.split("/")[0];
        fecha_pago = fecha_pago + " " + hora;

        PensionService servicio = new PensionService();
        int resultado = servicio.pagarPension(codsede, codPension, codigoUsuario, monto, nom_descuento, val_descuento, fecha_pago, forma_pago, tipoDoc, obs, regulari, num_serie, num_doc, razonSocial, ruc, cod_enlace_desc);

        JSONObject jsonresultado = new JSONObject();

        if (tipoDoc.equals("CPE BOLETA") || tipoDoc.equals("CPE FACTURA")) {
            JSONObject jsoncomp = new JSONObject();
            JSONObject jsonresultadoURL = new JSONObject();
            jsoncomp = servicio.ComprobanteElectronico(codPension);
            System.out.println("json Datos Del pago -------->>>>>>>>>>>" + jsoncomp.get("jsonNubeFact"));
            System.out.println("TOKEN -------->>>>>>>>>>>" + jsoncomp.get("TOKEN"));
            NubefactSO nubefact = new NubefactSO();
            jsonresultadoURL = nubefact.generarComprobante((JSONObject) jsoncomp.get("jsonNubeFact"), jsoncomp.get("TOKEN") + "");
            System.out.println("JSONNUBEFACT-------->>>>>>>>>>>" + jsonresultadoURL);
            if (jsonresultadoURL.get("errors") == null /*|| jsonresultadoURL.get("error_so") == null*/) {
                servicio.GuardarUrl(codPension, jsonresultadoURL.get("enlace_del_pdf") + "", "CANCELADO");
            } else {
                servicio.GuardarJsonErrorNubeFact(jsoncomp, jsonresultadoURL.get("errors").toString(), codPension, codsede + "", "pagarPension");
                resultado = 0;
                jsonresultado.put("mensaje", jsonresultadoURL.get("errors").toString());
            }

            System.out.println("URL-------->>>>>>>>>>>" + jsonresultadoURL.get("enlace_del_pdf"));

            jsonresultado.put("comprobante_url", jsonresultadoURL.get("enlace_del_pdf"));
        }

        jsonresultado.put("resultado", resultado);

        pw.print(jsonresultado);
    }

    private void generarFormFraccionarPension(HttpServletRequest request, HttpServletResponse response) throws IOException {

        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        int codPagoCuota = Integer.parseInt(request.getParameter("codPagoCuota"));
        int codMatricula = Integer.parseInt(request.getParameter("codMatricula"));
        int codPension = Integer.parseInt(request.getParameter("codPension"));
        String monto = request.getParameter("monto");
        pw.println("                                        <div class=\"form-body\">\n"
                + "                                            <fieldset>\n"
                + "                                                <div class=\"col-sm-12 form-group\" id=\"txtFiltro\">\n"
                + "                                                    <label class=\"control-label\"><b><span class=\"etiqueta\">Montos por fracción:  </span></b> <label id=\"numero\">2</label></label>\n"
                + "                                                </div>\n"
                + "                                                <div class=\"col-sm-10 form-group\" id=\"txtFiltro\">\n"
                + "                                                    <input onkeypress=\"return soloNumeros(event)\"  class=\"form-control monto\" id=\"monto\" step=\"any\" min=\"0\" value=\"" + (Double.parseDouble(monto) / 2) + "\" max=\"" + monto + "\" onchange=\"verificarMonto(1);\"></div>\n"
                + "                                                <div class=\"col-sm-2 form-group\" id=\"txtFiltro\">\n"
                + "                                                    <button class=\"btn btn-primary\" onclick=\"agregarFraccion();\">Agregar</button></div>\n"
                + "                                                <div id=\"duplicate\"><div class=\"col-sm-10 form-group\" id=\"txtFiltro\">\n"
                + "                                                    <input onkeypress=\"return soloNumeros(event)\" class=\"form-control monto\" id=\"monto2\" step=\"any\" min=\"0\" value=\"" + (Double.parseDouble(monto) / 2) + "\" max=\"" + monto + "\" onchange=\"verificarMonto(2);\"></div></div>\n"
                + "                                                <div id=\"duplicados\"></div>\n"
                + "                                                </div>\n"
                + "                                                \n"
                + "                                                \n"
                + "                                            </fieldset>\n"
                + "                                        </div><!-- /.form-body -->\n"
                + "                                        <div class=\"form-footer\">\n"
                + "                                            <div class=\"pull-right\">\n"
                + "                                                <button class=\"btn btn-foursquare\" type=\"button\" onclick=\"fraccionarPension(" + codPagoCuota + "," + codMatricula + "," + codPension + ");\" ><i class=\"fa fa-money\"></i> Fraccionar Cuota</button>\n"
                + "                                                <button class=\"btn btn-warning\" type=\"reset\" onclick=\"javascript: a=2;\" data-dismiss=\"modal\"><i class=\"fa fa-times\"></i> CANCELAR</button>\n"
                + "                                            </div>\n"
                + "                                            <div class=\"clearfix\"></div>\n"
                + "                                        </div>");
    }

    private void fraccionarPension(HttpServletRequest request, HttpServletResponse response) throws IOException {

        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        int codPagoCuota = Integer.parseInt(request.getParameter("codPagoCuota"));
//        int codMatricula = Integer.parseInt(request.getParameter("codMatricula"));  
//        int codPension = Integer.parseInt(request.getParameter("codPension"));  
        String monto[];
        String posDescuento[];
        monto = request.getParameter("monto").split(",");
        posDescuento = null;

        PensionService servicio = new PensionService();
        int resultado = servicio.fraccionarPension(codPagoCuota, monto, posDescuento);
        pw.print(resultado);
    }

    private void verificarPensionesActualizarMatri(HttpServletRequest request, HttpServletResponse response) throws IOException {

        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        int codMatricula = Integer.parseInt(request.getParameter("codMatricula"));

        PensionService servicio = new PensionService();
        if (servicio.verificarPensionesActualizarMatri(codMatricula)) {
            pw.print("1");
        } else {
            pw.print("0");
        }
    }

    private void actualizarPensiones(HttpServletRequest request, HttpServletResponse response) throws IOException {
        String cadena = "";
        cadena = request.getParameter("codPen");
        String[] codPen = cadena.split(",");
        cadena = request.getParameter("monPen");
        String[] monPen = cadena.split(",");
        int matri = Integer.parseInt(request.getParameter("codmat"));
        String nom_desc = request.getParameter("nom_desc");
        double mon_des = 0;
        try {
            mon_des = Double.parseDouble(request.getParameter("mon_desc"));
        } catch (Exception e) {
            mon_des = 0;
        }
        int r = 0;
        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        PensionService servicio = new PensionService();
        r = servicio.actualizarPensiones(matri, codPen, monPen, nom_desc, mon_des);
        pw.print(r);
    }

    private void duplicarPensionesAnulada(HttpServletRequest request, HttpServletResponse response) throws IOException {
        int codpension = Integer.parseInt(request.getParameter("codpen"));
        int r = 0;
        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        PensionService servicio = new PensionService();
        r = servicio.duplicarPensionAnulada(codpension);
        pw.print(r);
    }

    private void anularPensionesPorMatricula(HttpServletRequest request, HttpServletResponse response) throws IOException {
        int codmatri = Integer.parseInt(request.getParameter("codmatri"));
        int valueradio = 0;
        try {
            valueradio = Integer.parseInt(request.getParameter("valueradio"));
        } catch (Exception e) {

        }
        String observacion = "";
        try {
            observacion = request.getParameter("observacion");
        } catch (Exception e) {
            observacion = "Traslado del alumano";
        }

        int r = 0;
        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        PensionService servicio = new PensionService();

        r = servicio.anularPensionesPorMatricula(codmatri, valueradio, observacion);

        pw.print(r);
    }

    private void generarFormInformación(HttpServletRequest request, HttpServletResponse response) throws IOException {

        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        int codPension = Integer.parseInt(request.getParameter("codPension"));
        PensionService servicio = new PensionService();
        Pension p = servicio.obtenerDetallePension(codPension);
        if (Integer.parseInt(p.getNum_serie()) > 0) {

        }
        pw.println("<div class=\"form-body\">\n"
                + "                                            <fieldset>\n"
                + "                                                       <div class=\"col-sm-12 form-group\">\n"
                + "                                                               <b>Tipo documento: </b> " + p.getTipoDocumento() + "<br>\n"
                + "                                                       </div>");
        if (p.getTipoDocumento().equals("FACTURA")) {
            pw.println("                                                  <div class=\"col-sm-6 form-group\">\n"
                    + "                                                               <b>RUC: </b> " + p.getRuc() + "<br>\n"
                    + "                                                       </div>"
                    + "                                                       <div class=\"col-sm-6 form-group\">\n"
                    + "                                                               <b>Razón Social: </b> " + p.getRazon_social() + "<br>\n"
                    + "                                                       </div>");
        }

        pw.println("                                                       <div class=\"col-sm-6 form-group\">\n"
                + "                                                               <b>Descripción: </b> " + p.getDescPension() + " " + p.getFraccion() + "<br>\n"
                + "                                                       </div>\n"
                + "                                                       <div class=\"col-sm-6 form-group\">\n"
                + "                                                               <b>Núm. Documento: </b> " + p.getNum_serie() + " - " + p.getNum_docu() + "<br>\n"
                + "                                                       </div>\n"
                + "                                                       <div class=\"col-sm-6 form-group\">\n"
                + "                                                               <b>Fecha Caducidad: </b> " + p.getCaducidadPension().split("-")[2] + "/" + p.getCaducidadPension().split("-")[1] + "/" + p.getCaducidadPension().split("-")[0] + "<br>\n"
                + "                                                       </div>\n"
                + "                                                       <div class=\"col-sm-6 form-group\">\n"
                + "                                                               <b>Fecha Pago: </b> " + p.getFecha_pago() + "<br>\n"
                + "                                                       </div>\n"
                + "                                                       <div class=\"col-sm-6 form-group\">\n"
                + "                                                               <b>Monto Regularización: </b> S/." + p.getRegularizacion() + "<br>\n"
                + "                                                       </div>\n"
                + "                                                       <div class=\"col-sm-6 form-group\">\n"
                + "                                                               <b>Descuento: </b> S/." + p.getMonto_dscto() + "<br>\n"
                + "                                                       </div>\n"
                + "                                                       <div class=\"col-sm-6 form-group\">\n"
                + "                                                               <b>Motivo Dscto.: </b> " + p.getNom_dscto() + "<br>\n"
                + "                                                       </div>\n"
                + "                                                       <div class=\"col-sm-6 form-group\">\n"
                + "                                                               <b>Devolución: </b> S/." + p.getDevol_monto() + "<br>\n"
                + "                                                       </div>\n"
                + "                                                       <div class=\"col-sm-6 form-group\">\n"
                + "                                                               <b>Monto Pensión: </b> S/." + p.getMontoMensual() + "<br>\n"
                + "                                                       </div>\n"
                + "                                                       <div class=\"col-sm-6 form-group\">\n"
                + "                                                               <b>Monto Cancelado: </b> S/." + p.getPagado() + "<br>\n"
                + "                                                       </div>\n"
                + "                                                       <div class=\"col-sm-12 form-group\">\n"
                + "                                                               <b>Observación: </b> " + p.getObs() + "<br>\n"
                + "                                                       </div>\n"
                + "                                                    </fieldset>\n"
                + "                                                </div><!-- /.form-body -->\n"
                + "                                                <div class=\"form-footer\">\n"
                + "                                                    <div class=\"pull-right\">\n"
                + "                                                        <button class=\"btn btn-danger  \" type=\"button\" data-dismiss=\"modal\"><i class=\"fa fa-times\"></i> Cerrar</button>\n"
                + "                                                    </div>\n"
                + "                                                    <div class=\"clearfix\"></div>\n"
                + "                                                </div>");
    }

    private void imprimirBoletaPago(HttpServletRequest request, HttpServletResponse response) throws IOException {

        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        try {
            int codPension = Integer.parseInt(request.getParameter("codpension"));
            PensionService servicio = new PensionService();
            String resultado = servicio.imprimirBoletaPago(codPension);
            pw.print(resultado);
        } catch (Exception e) {
            pw.println(0);
        }

    }

    private void ComprobanteElectronico(HttpServletRequest request, HttpServletResponse response) throws IOException {
        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        int codPension = Integer.parseInt(request.getParameter("codpension"));
        PensionService servicio = new PensionService();
        JSONObject resultado = servicio.ComprobanteElectronico(codPension);
        pw.print(resultado);

    }

    private void AdvertenciaCierreDiario(HttpServletRequest request, HttpServletResponse response) throws IOException {
        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        ArrayList<Cierre> lista = new ArrayList<>();
        int cant_ticket = 0;
        Date fecha_ultimo_pago;
        Date fecha_max_pago;
        Date hoy = new Date();
        int codsede = Integer.parseInt(request.getParameter("codsede"));

        PensionService servicio = new PensionService();
        lista = servicio.AdvertenciaCierreDiario(codsede);
        SimpleDateFormat formateador = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        for (int i = 0; i < lista.size(); i++) {
            try {
                cant_ticket = Integer.parseInt(lista.get(i).getCantidad());
                fecha_ultimo_pago = formateador.parse(lista.get(i).getFecha_pago());
                fecha_max_pago = formateador.parse(lista.get(i).getFecha_max());
                if (cant_ticket > 0) {
                    if (hoy.after(fecha_max_pago)) {
                        pw.println("-1");
                    } else {
                        pw.println("1");
                    }
                }
                if (cant_ticket == 0) {
                    pw.println("1");
                }
            } //        pw.println(result);
            catch (ParseException ex) {
//             Logger.getLogger(ServletPension.class.getName()).log(Level.SEVERE, null, ex);
            }
        }

    }

    private void frmAnularPension(HttpServletRequest request, HttpServletResponse response) throws IOException {
        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        int codigo = Integer.parseInt(request.getParameter("codigo"));
        pw.println("<div class=\"form-body\">\n"
                + "                                            <fieldset>\n"
                + "                                           ¿Esta seguro de anular todas las Pensiones?<div class=\"container\"><div id=\"grupoinput\" class=\"form-group\"><div class=\"rdio rdio-primary\"><input checked value=\"1\" id=\"radio-primary\" type=\"radio\" name=\"radio1\"><label for=\"radio-primary\">Pensiones Anterior al Mes Actual</label></div><div class=\"rdio rdio-primary\"><input value=\"2\" id=\"radio-primary1\" type=\"radio\" name=\"radio1\"><label for=\"radio-primary1\">Todas las Pensiones Pendientes</label></div></div><div class=\"col-sm-3 form-group\" id=\"txtFiltro\"><label class=\"control-label\" id=\"etiqueta-busqueda\" for=\"motivo\"><b><span class=\"etiqueta\">Observación :</span> <span class=\"asterisk\">(*)</span></b></label><input type=\"text\" class=\"form-control validate[required]\" id=\"observ_anulacion\"><div><b style=\"color:red; \" id=\"mensaje_anula\" class=\"hide\">El campo es obligatorio.</b></div></div></div>"
                + "                                            </fieldset>\n"
                + "                                        </div><!-- /.form-body -->\n"
                + "                                        <div class=\"form-footer\">\n"
                + "                                            <div class=\"pull-right\">\n"
                + "                                                <button class=\"btn btn-foursquare\" type=\"button\" onclick=\"AnularPensiones(" + codigo + ")\"  data-dismiss=\"\"><i class=\"fa fa-money\"></i> ANULAR PENSIONES</button>\n"
                + "                                                <button class=\"btn btn-warning\" type=\"reset\" onclick=\"javascript: a=2;\" data-dismiss=\"modal\"><i class=\"fa fa-times\"></i> CANCELAR</button>\n"
                + "                                            </div>\n"
                + "                                            <div class=\"clearfix\"></div>\n"
                + "                                        </div>");
    }

    private void habilitarPensionesAnulada(HttpServletRequest request, HttpServletResponse response) throws IOException {
        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        int codpension = Integer.parseInt(request.getParameter("codpension"));
        int r = 0;
        PensionService servicio = new PensionService();
        r = servicio.habilitarPensionAnulada(codpension);
        pw.print(r);

    }

    private void frmAgregarDescuento(HttpServletRequest request, HttpServletResponse response) throws IOException {
        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        HttpSession session_actual = request.getSession(true);
        Usuario usuario = new Usuario();
        usuario = (Usuario) session_actual.getAttribute("usuario");

        int codSede = Integer.parseInt(request.getParameter("codsede"));
        String[] codPension = request.getParameter("codPension").split(",");

//        int codigo = Integer.parseInt(request.getParameter("codigo"));
        ArrayList<Descuento> lista = new ArrayList<>();
        DescuentoService servicioDesc = new DescuentoService();
        PensionService servicioPens = new PensionService();

        lista = servicioDesc.listarDescuentoPorSede(codSede, usuario.getCodigoTipoUsuario());
        Pension pen = servicioPens.obtenerPension(Integer.parseInt(codPension[0]));
        int max = servicioPens.maxMontoFraccionado(Integer.parseInt(codPension[0]));
        pw.println("<div class=\"form-body\">"
                + "<form id=\"formDescuento\"  >\n"
                + "   <fieldset>\n"
                + "                                                <div class=\"col-sm-12 form-group\" >\n"
                + "                                                   <label class=\"control-label\"  for=\"descuento\"><b><span class=\"etiqueta\">Descuento</span> <span class=\"asterisk\">(*)</span></b></label>\n");
        pw.println("                                <select class=\"form-control validate[required] \" id=\"descuento\" onchange=\"obtenerMontoDscto();\">");
        pw.println("                                    <option value=\"\" data-monto=\"\">[SELECCIONE]</option>");
        for (int i = 0; i < lista.size(); i++) {
//            if (lista.get(i).getNomDescuento().trim().equals(pen.getNom_dscto().trim())) {
//                pw.println("<option value=\"" + lista.get(i).getCodDescuento() + "\" data-monto=\"" + lista.get(i).getMonto() + "\" SELECTED=\"true\" data-tip=\"" + lista.get(i).getTip_mon() + "\">" + lista.get(i).getNomDescuento() + "</option>");
//            } else {
            pw.println("<option value=\"" + lista.get(i).getCodEnlace() + "\" data-monto=\"" + lista.get(i).getMonto() + "\" data-tip=\"" + lista.get(i).getTip_mon() + "\">" + lista.get(i).getNomDescuento() + "</option>");
//            }
        }
        pw.println("                                    <option value=\"0\" data-monto=\"\">Por Regularización</option>");
        pw.println("                                </select>");
        pw.println("                             </div>"
                + "                                                <div class=\"col-sm-6 form-group\" >\n"
                + "                                                    <label class=\"control-label\" for=\"monto\"><b><span class=\"etiqueta\">Monto</span> <span class=\"asterisk\">(*)</span></b></label>\n"
                + "                                                    <input type=\"number\" class=\"form-control validate[required]\" id=\"monto\" step=\"any\" min=\"0\" value=\"" + pen.getMontoPension() + "\" max=\"" + max + "\" onchange=\"obtenerMontoDscto();\" readonly=\"true\"></div>\n"
                + "                             <div class=\"col-sm-6 form-group\" >\n"
                + "                                                    <label class=\"control-label\" for=\"montoDescuento\"><b><span class=\"etiqueta\">Monto de Descuento</span> <span class=\"asterisk\">(*)</span></b></label>\n"
                + "                                                    <input type=\"text\" onkeypress=\"return soloNumeros(event)\" class=\"form-control validate[required] \" id=\"montoDescuento\" value=\"" + pen.getMonto_dscto() + "\" readonly=\"true\"></div>\n"
                + "                                               <div class=\"hide col-sm-6 form-group\" >\n"
                + "                                                    <label class=\"control-label\"  for=\"regula\"><b><span class=\"etiqueta\">Regularización</span> <span class=\"asterisk\">(*)</span></b></label>\n"
                + "                                                    <input onkeypress=\"return soloNumeros(event)\" type=\"text\" class=\"form-control validate[required,custom[number]]\" id=\"regula\" value=\"0.00\" onchange=\"obtenerMontoDscto();\"></div><div class=\"col-sm-6 form-group\" id=\"txtFiltro\">\n"
                //                + "                                                    <label class=\"control-label\"  for=\"efectivo\"><b><span class=\"etiqueta\">Monto Efectivo</span> <span class=\"asterisk\">(*)</span></b></label>\n"
                //                + "                                                    <input onkeypress=\"return soloNumeros(event)\" type=\"text\" class=\"form-control validate[required,custom[number]]\" id=\"efectivo\" value=\"\" onchange=\"verificarMontoPago(),obtenerMontoDscto();\">"
                //                + "                                                     <br><b>Vuelto: </b><label id=\"vuelto\"><b></b></label "
                //                + "                                                     </div><div><b style=\"color:red; \" id=\"mensa\"></b></div>\n"
                + "                                                \n"
                + "                                                </div>\n"
                + "                                                <div class=\"col-sm-12 form-group\" >\n"
                + "                                                    <label class=\"control-label\" for=\"observaciones\"><b><span class=\"etiqueta\">Motivo</span> <span class=\"asterisk\">(*)</span></b></label>\n"
                + "                                                    <input type=\"text\" class=\"form-control validate[required]\" id=\"motivo\">"
                + "                                                 </div>\n"
                + "   </fieldset>\n"
                + "</div>"
                + "                                         <div class=\"form-footer\">\n"
                + "                                            <div class=\"pull-right\">\n"
                + "                                                <button class=\"btn btn-foursquare\" id=\"enviar\" type=\"button\" onclick=\"guardarDescuento()\"><i class=\"fa fa-money\"></i> GUARDAR</button>\n"
                + "                                                <button class=\"btn btn-warning \" type=\"reset\" onclick=\"\" data-dismiss=\"modal\"><i class=\"fa fa-times\"></i> CANCELAR</button>\n"
                + "                                            </div>\n"
                + "                                            <div class=\"clearfix\"></div>\n"
                + "                                        </div> "
        );
    }

    private void guardarDescuento(HttpServletRequest request, HttpServletResponse response) throws IOException {
        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        String nomDescuento = request.getParameter("nom_descuento");
        double valDescuento = Double.parseDouble(request.getParameter("val_descuento"));
        String motivoDescuento = request.getParameter("motivo");
        String[] codPagoCuota = request.getParameter("codPagoCuota").split(",");
        int cod_enlace_dsc = Integer.parseInt(request.getParameter("cod_enlace_dsc"));
        PensionService servicio = new PensionService();
        int Resultado = 0;
        for (int i = 0; i < codPagoCuota.length; i++) {
            Resultado = servicio.guardarDescuento(Integer.parseInt(codPagoCuota[i]), nomDescuento, valDescuento, motivoDescuento, cod_enlace_dsc);
        }
        pw.println(Resultado);
    }

    private void listarBackupErrorNubeFact(HttpServletRequest request, HttpServletResponse response) throws IOException {
        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
//        int vdraw = Integer.parseInt(request.getParameter("draw"));
        JSONArray jsonResultado = new JSONArray();
        PensionService servicio = new PensionService();
        jsonResultado = servicio.listarBackupErrorNubeFact();
        JSONObject jsonReturn = new JSONObject();
        jsonReturn.put("data", jsonResultado);
        jsonReturn.put("recordsFiltered", jsonResultado.size());
        jsonReturn.put("recordsTotal", jsonResultado.size());
//        jsonReturn.put("draw", vdraw);
        System.out.println("listarBackupErrorNubeFact-->>" + jsonResultado);
        pw.println(jsonReturn);
    }

    private void cargarNubeFact(HttpServletRequest request, HttpServletResponse response) throws IOException, org.json.simple.parser.ParseException {
        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        JSONObject jsonCargarJSONubeFact = new JSONObject();
        JSONParser parse = new JSONParser();
        Object obj = parse.parse(request.getParameter("jsonBackupNubeFact"));
        String token = request.getParameter("token");
        String accion = request.getParameter("accionNubefact");
        jsonCargarJSONubeFact.put("jsonBackupNubeFact", obj);
        jsonCargarJSONubeFact.put("token", token);
        NubefactSO servicioNubeFact = new NubefactSO();
        JSONObject jsonResultadoNub = new JSONObject();
        if (accion.equals("pagarPension")) {
            jsonResultadoNub = servicioNubeFact.generarComprobante((JSONObject)obj, token);
        } else if (accion.equals("anularPension")) {
            jsonResultadoNub = servicioNubeFact.anularComprobante((JSONObject)obj, token);
        } else {

        }

        System.out.println("--->>>>" + jsonResultadoNub);
        pw.println(jsonResultadoNub);
//            'jsonBackupNubeFact': JSON.stringify(json_editor.getValue()),
//                    'token': JSON.stringify(JSON.parse(data.jsonNubeFact).TOKEN)
    }
}
