
package pe.siso.academia.Servlets;

import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import pe.siso.academia.Beans.Boleta;
import pe.siso.academia.Beans.Sede;
import pe.siso.academia.Beans.Usuario;
import pe.siso.academia.Services.BoletaService;
import pe.siso.academia.Services.SedeService;

public class ServletSede extends HttpServlet {

    @Override
    protected void service(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
        String param=request.getParameter("accion");
        if("CambiarSessionSede".equals(param)){
            CambiarSessionSede(request, response);
        }
        else if("listarCmbSedes".equals(param)){
            listarCmbSedes(request, response);
        }
        else if("listarCmbSedesSession".equals(param)){
            listarCmbSedesSession(request, response);
        }
        else if("listarCmbSedesMatricula".equals(param)){
            listarCmbSedesMatricula(request, response);
        }
        else if("listarSedesPorNombre".equals(param)){
            listarSedesPorNombre(request, response);
        }
        else if("cambiarEstadoSede".equals(param)){
            cambiarEstadoSede(request, response);
        }
        else if("generarFormNuevo".equals(param)){
            generarFormNuevo(request, response);
        }
        else if("generarFormEditar".equals(param)){
            generarFormEditar(request, response);
        }
        else if("generarFormAsignarBoleta".equals(param)){
            generarFormAsignarBoleta(request, response);
        }
        else if("agregarSede".equals(param)){
            agregarSede(request, response);
        }
        else if("editarSede".equals(param)){
            editarSede(request, response);
        }
        else if("guardarSessionesSede".equals(param)){
            guardarSessionesSede(request, response);
        }
        else if("agregarBoleta".equals(param)){
            agregarBoleta(request, response);
        }
    }
    
    //MENU
    private void listarCmbSedesSession(HttpServletRequest request, HttpServletResponse response) throws IOException {
        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        ArrayList<Sede> lista = null;
        SedeService servicio = new SedeService();
        lista = servicio.listarSedes();
        pw.println("<select id=\"session_sede\" class=\"combo_sede\" style=\"width: 100%; margin-left: 5%; border-color: rgb(85, 85, 85); background-color: transparent;\" onchange=\"cambiarSedeSession();\">\n" );
        for(int i = 0; i<lista.size();i++){
            pw.println("<option value=\""+lista.get(i).getIdLocal()+"\">"+lista.get(i).getDesLocal()+"</option>");
        }
        pw.println("</select>");
    }
    
    private void CambiarSessionSede(HttpServletRequest request, HttpServletResponse response) throws IOException {
        String codsede = request.getParameter("codsede");
        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        //------------------------Crear la sesiones-------------------------
        HttpSession session_actual = request.getSession(true);
        Usuario usuario=(Usuario)session_actual.getAttribute("usuario");
        usuario.setCodigoSede(codsede);
        session_actual.setAttribute("usuario",usuario);
        session_actual.setMaxInactiveInterval(10 * 60 * 60); // 10 horas
        //------------------------------------------------------------------
        pw.println("1");
    }
    //LISTAR
    private void listarCmbSedes(HttpServletRequest request, HttpServletResponse response) throws IOException {
        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        ArrayList<Sede> lista = null;
        SedeService servicio = new SedeService();
        lista = servicio.listarSedes();
        pw.println("<label class=\"control-label\"><b>Sede: <span class=\"asterisk\">(*)</span></b></label>\n" +
"                       <select class=\"form-control chosen-select\" id=\"sedeFiltro\">\n" );
        pw.println("        <option value=\"0\">SIN SEDE</option>");
        
        for(int i = 0; i<lista.size();i++){
            pw.println("<option value=\""+lista.get(i).getIdLocal()+"\">"+lista.get(i).getDesLocal()+"</option>");
        }
        pw.println("        <option value=\"-1\">TODAS LAS SEDES</option>");
        pw.println("    </select>");
    }
    
    private void listarCmbSedesMatricula(HttpServletRequest request, HttpServletResponse response) throws IOException {
        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        ArrayList<Sede> lista = null;
        SedeService servicio = new SedeService();
        lista = servicio.listarSedes();
        pw.println("<div class=\"col-sm-12 form-group\">");
        pw.println("<label class=\"control-label\"><b>Sede: <span class=\"asterisk\">(*)</span></b></label>\n" +
"                       <select class=\"form-control chosen-select\" id=\"sedeFiltro\" onchange=\"llenarCmbCentro();\">\n" );
        
        for(int i = 0; i<lista.size();i++){
            pw.println("<option value=\""+lista.get(i).getIdLocal()+"\">"+lista.get(i).getDesLocal()+"</option>");
        }
        pw.println("    </select>");
        pw.println("</div>");
    }
    
    private void listarSedesPorNombre(HttpServletRequest request, HttpServletResponse response) throws IOException {
        String nombre = request.getParameter("nombre");
        int pagina = Integer.parseInt(request.getParameter("pag"));
        int cantPorPagina = 20;
        int cantidadRegistros = 0;
        int cantidadPaginas = 0;
        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        ArrayList<Sede> lista = null;
        SedeService servicio = new SedeService();
        cantidadRegistros = servicio.cantidadSedesPorNombre(nombre);
        lista = servicio.listarSedesPorNombre(nombre,(pagina*cantPorPagina)-cantPorPagina, cantPorPagina);
        cantidadPaginas = cantidadRegistros/cantPorPagina;
        pw.println("<div class=\"col-md-1\"></div>\n");
        pw.println("<div class=\"col-md-10\">\n" +
"                            <div class=\"panel\">\n" +
"                                <div class=\"panel-heading-saco\">\n" +
"                                    <h3 class=\"panel-title pull-left\">Lista de Sedes</h3>\n" +
"                                    <span class=\"pull-right\" style=\"display: block;\">\n" +
"                                        <button class=\"btn btn-saco\" onclick=\"frmAgregarSede();\"';\">  \n" +
"                                            <i class=\"fa fa-plus-circle\"></i> Agregar Sede\n" +
"                                        </button>\n" +
"                                    </span>\n" +
"                                    <div style=\"clear: both;\"></div>\n" +
"                                </div>\n" +
"                                <div class=\"panel-body no-padding\">\n" +
"                                    <!-- Start sample table -->\n" +
"                                    <div class=\"table rounded mb-20\" id=\"imprimirTablaSedes\">\n" +
"                                        <table class=\"table table-striped table-saco\" style=\"border: 1px solid rgb(198, 198, 198); border-image: none; font-size: 11px;\">\n" +
"                                            <thead>\n" +
"                                                <tr>\n" +
"                                                    <th class=\"text-center border-right\">No.</th>\n" +
"                                                    <th class=\"text-center\">Sede</th>\n" +
"                                                    <th class=\"text-center\">Acciones</th>\n" +
"                                                </tr>\n" +
"                                            </thead>\n" +
"                                            <tbody>\n");
        if(lista.size()==0){
            pw.println("<tr><td colspan='7'>No se encontraron registros.</td></tr>");
        }
                for(int i = 0; i<lista.size();i++){
                    
pw.println("                                     <tr>\n" +
"                                                    <td class=\"text-center border-right\">"+(((pagina-1)*cantPorPagina)+1+i)+"</td>\n" +
"                                                    <td class=\"text-center\">"+lista.get(i).getDesLocal()+"</td>\n" +
"                                                    <td class=\"text-center\">\n" +
"                                                        <a data-original-title=\"Registrar Descuento\" data-toggle=\"tooltip\" data-placement=\"top\" href=\"javascript:frmRegistrarDescuento('"+lista.get(i).getIdLocal()+"');\">\n" +
"                                                            <i class=\"fa fa-arrow-circle-down bigger-140 pink\"></i>\n" +
"                                                        </a> &nbsp;\n" +
"                                                        <a data-original-title=\"Registrar Documento\" data-toggle=\"tooltip\" data-placement=\"top\" href=\"javascript:frmRegistrarDocumento('"+lista.get(i).getIdLocal()+"');\">\n" +
"                                                            <i class=\"fa fa-plus-circle bigger-140 grey\"></i>\n" +
"                                                        </a> &nbsp;\n" );
if(lista.get(i).getActivo()==1){
    pw.println("                                             <a data-original-title=\"Desactivar Sede\" data-toggle=\"tooltip\" data-placement=\"top\" href=\"javascript:DesactivarSede('"+lista.get(i).getIdLocal()+"');\">\n" +
    "                                                            <i class=\"fa fa-lightbulb-o bigger-140 green\"></i>\n" +
    "                                                        </a> &nbsp;\n");
}
else{
    pw.println("                                             <a data-original-title=\"Activar Sede\" data-toggle=\"tooltip\" data-placement=\"top\" href=\"javascript:ActivarSede('"+lista.get(i).getIdLocal()+"');\">\n" +
    "                                                            <i class=\"fa fa-lightbulb-o bigger-140 red\"></i>\n" +
    "                                                        </a> &nbsp;\n");
}

pw.println("                                             <a data-original-title=\"Editar Sede\" data-toggle=\"tooltip\" data-placement=\"top\" href=\"javascript:frmEditarSede('"+lista.get(i).getIdLocal()+"');\">\n" +
"                                                            <i class=\"fa fa-edit bigger-140 blue\"></i>\n" +
"                                                        </a>\n" +
"                                                        <a data-original-title=\"Asignar Boleta\" data-toggle=\"tooltip\" data-placement=\"top\" href=\"javascript:frmAsignarBoleta('"+lista.get(i).getIdLocal()+"');\">\n" +
"                                                            <i class=\"fa fa-calendar-plus-o bigger-140 green\"></i>\n" +
"                                                        </a>\n" +
"                                                    </td>\n" +
"                                                </tr>\n" );
                }

pw.println("                         </tbody>\n" +
"                                        </table>\n" );

pw.println("<div class=\"col-xs-12\" style=\"border-right-color: rgb(198, 198, 198); border-bottom-color: rgb(198, 198, 198); border-left-color: rgb(198, 198, 198); border-right-width: 1px; border-bottom-width: 1px; border-left-width: 1px; border-right-style: solid; border-bottom-style: solid; border-left-style: solid; background-color: rgb(239, 243, 248);\">                                              \n" +
"                                            <div class=\"col-xs-7\">\n" +
"                                                <div class=\"dataTables_paginate paging_simple_numbers\" id=\"datatable-ajax_paginate\">\n" +
"                                                    <ul class=\"pagination\">  \n" );
if(pagina==1){
    pw.println("<li tabindex=\"0\" class=\"paginate_button previous disabled\" id=\"sample-table-2_previous\" aria-controls=\"sample-table-2\"> <a> &lt;&lt; </a></li>\n" );
}
else{
    pw.println("<li tabindex=\"0\" class=\"paginate_button previous\" id=\"sample-table-2_previous\" aria-controls=\"sample-table-2\"> <a href=\"javascript:listarSedes('1');\"> &lt;&lt; </a></li>\n" );
}
if(pagina>1){
    pw.println("<li tabindex=\"0\" class=\"paginate_button previous\" id=\"sample-table-2_previous\" aria-controls=\"sample-table-2\"> <a href=\"javascript:listarSedes('"+(pagina-1)+"');\">Anterior</a></li>\n" );
}
else{
    pw.println("<li tabindex=\"0\" class=\"paginate_button previous disabled\" id=\"sample-table-2_previous\" aria-controls=\"sample-table-2\"> <a>Anterior</a></li>\n" );
}


for(int x=1;x<=(cantidadPaginas+1);x++){
    if(x>=(pagina-0) && x<=(pagina+4)){
    if(pagina==x){
        pw.println("<li tabindex=\"0\" class=\"paginate_button active\" aria-controls=\"sample-table-2\"><a href=\"javascript:void(0);\">"+x+"</a></li>\n" );
    }
    else{
        pw.println("<li tabindex=\"0\" class=\"paginate_button\" aria-controls=\"sample-table-2\"><a href=\"javascript:listarSedes('"+x+"');\">"+x+"</a></li>\n" );
    }}
}
if(pagina<(cantidadPaginas+1)){
    pw.println("<li tabindex=\"0\" class=\"paginate_button next\" id=\"sample-table-2_next\" aria-controls=\"sample-table-2\"> <a href=\"javascript:listarSedes('"+(pagina+1)+"');\">Siguiente</a></li>\n" );
    pw.println("<li tabindex=\"0\" class=\"paginate_button next\" id=\"sample-table-2_next\" aria-controls=\"sample-table-2\"> <a href=\"javascript:listarSedes('"+(cantidadPaginas+1)+"');\"> &gt;&gt; </a></li>\n" );
}
else{
    pw.println("<li tabindex=\"0\" class=\"paginate_button next disabled\" id=\"sample-table-2_next\" aria-controls=\"sample-table-2\"> <a>Siguiente</a></li>\n" );
    pw.println("<li tabindex=\"0\" class=\"paginate_button next disabled\" id=\"sample-table-2_next\" aria-controls=\"sample-table-2\"> <a> &gt;&gt; </a></li>\n" );
}

pw.println("                                                    </ul>                                                  \n" +
"                                                </div>                                             \n" +
"                                            </div>                                              \n" +
"                                            <div class=\"col-xs-5\">\n" +
"                                                <table style=\"width: 100%; height: 72px;\" border=\"0\">\n" +
"                                                    <tbody>\n" +
"                                                        <tr>                                                          \n" +
"                                                            <td style=\"text-align: right; vertical-align: middle; background-color: transparent!important;\">Mostrando del "+((pagina*cantPorPagina)-cantPorPagina+1)+" al "+((pagina*cantPorPagina))+" de "+cantidadRegistros+" Sedes</td> \n" +
"                                                        </tr> \n" +
"                                                    </tbody>\n" +
"                                                </table>\n" +
"                                            </div>  \n" +
"                                        </div>");

pw.println("                                    </div><!-- /.table -->\n" +
"                                    <!--/ End sample table -->\n" +
"                                </div>\n" +
"                            </div>\n" +
"                        </div>");
    pw.println("<div class=\"col-md-1\"></div>\n");
    }
    
    //GENERAR FORMULARIOS
    private void generarFormNuevo(HttpServletRequest request, HttpServletResponse response) throws IOException {
        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        pw.println("<form id=\"form-validate\"><div class=\"form-body\">" +
"                       <fieldset>\n" +
"                           <div class=\"col-sm-6 form-group\">\n" +
"                               <label class=\"control-label\" id=\"etiqueta-busqueda\"><b><span class=\"etiqueta\">Nombre</span> <span class=\"asterisk\">(*)</span></b></label>\n" +
"                               <input type=\"text\" class=\"form-control validate[required]\" id=\"nombre\">\n" +
"                           </div>\n" +
"                           <div class=\"col-sm-6 form-group\">\n" +
"                               <label class=\"control-label\" id=\"etiqueta-busqueda\"><b><span class=\"etiqueta\">Abreviación</span> <span class=\"asterisk\">(*)</span></b></label>\n" +
"                               <input type=\"text\" class=\"form-control validate[required]\" id=\"abreviacion\">\n" +
"                           </div>\n" +
"                           <div class=\"col-sm-12\"></div>\n" +
"                           <div class=\"col-sm-6 form-group\">\n" +
"                               <label class=\"control-label\" id=\"etiqueta-busqueda\"><b><span class=\"etiqueta\">Asociación</span> <span class=\"asterisk\">(*)</span></b></label>\n" +
"                               <select class=\"form-control validate[required] chosen-select\" id=\"asociacion\">\n" +
"                                   <option value=\"\">[SELECCIONE]</option>\n" +
"                                   <option value=\"SACO OLIVEROS\">SACO OLIVEROS</option>\n" +
"                                   <option value=\"APEIRON\">APEIRON</option>\n" +
"                                   <option value=\"HELICOIDAL\">HELICOIDAL</option>\n" +
"                               </select>\n" +
"                           </div>" +
"                           <div class=\"col-sm-6 form-group\" id=\"lista-departamento\">\n" +
"                               <label class=\"control-label\" id=\"etiqueta-busqueda\"><b><span class=\"etiqueta\">Departamento</span> <span class=\"asterisk\">(*)</span></b></label>\n" +
"                               <select class=\"form-control validate[required] chosen-select\" id=\"departamento\">\n" +
"                                   <option value=\"\">[SELECCIONE]</option>\n" +
"                               </select>\n" +
"                           </div>\n" +
"                           <div class=\"col-sm-6 form-group\" id=\"lista-provincia\">\n" +
"                               <label class=\"control-label\" id=\"etiqueta-busqueda\"><b><span class=\"etiqueta\">Provincia</span> <span class=\"asterisk\">(*)</span></b></label>\n" +
"                               <select class=\"form-control validate[required] chosen-select\" id=\"provincia\">\n" +
"                                   <option value=\"\">[SELECCIONE]</option>\n" +
"                               </select>\n" +
"                           </div>" +
"                           <div class=\"col-sm-6 form-group\" id=\"lista-distrito\">\n" +
"                               <label class=\"control-label\" id=\"etiqueta-busqueda\"><b><span class=\"etiqueta\">Distrito</span> <span class=\"asterisk\">(*)</span></b></label>\n" +
"                               <select class=\"form-control validate[required] chosen-select\" id=\"distrito\">\n" +
"                                   <option value=\"0\">[SELECCIONE]</option>\n" +
"                               </select>\n" +
"                           </div>\n" +
"                           <div class=\"col-sm-6 form-group\" id=\"\">\n" +
"                               <label class=\"control-label\" id=\"etiqueta-busqueda\"><b><span class=\"etiqueta\">Dirección</span> <span class=\"asterisk\">(*)</span></b></label>\n" +
"                               <input type=\"text\" class=\"form-control validate[required]\" id=\"direccion\">\n" +
"                           </div>" +
"                           <div class=\"col-sm-6 form-group\" id=\"\">\n" +
"                               <label class=\"control-label\" id=\"etiqueta-busqueda\"><b><span class=\"etiqueta\">Telefono</span> <span class=\"asterisk\">(*)</span></b></label>\n" +
"                               <input type=\"text\" class=\"form-control validate[required]\" id=\"telefono\">\n" +
"                           </div>\n" +
"                           <div class=\"col-sm-6 form-group\" id=\"\">\n" +
"                               <label class=\"control-label\" id=\"etiqueta-busqueda\"><b><span class=\"etiqueta\">Autorización Sunat</span> <span class=\"asterisk\">(*)</span></b></label>\n" +
"                               <input type=\"text\" class=\"form-control validate[required]\" id=\"autorizacion\">\n" +
"                           </div>" +
"                           <div class=\"col-sm-6 form-group\" id=\"\">\n" +
"                               <label class=\"control-label\" id=\"etiqueta-busqueda\"><b><span class=\"etiqueta\">Maquina Registradora</span> <span class=\"asterisk\">(*)</span></b></label>\n" +
"                               <input type=\"text\" class=\"form-control validate[required]\" id=\"ticketera\">\n" +
"                           </div>\n" +
"                           <div class=\"col-sm-6 form-group\" id=\"\">\n" +
"                               <label class=\"control-label\" id=\"etiqueta-busqueda\"><b><span class=\"etiqueta\">Codigo Sede</span> <span class=\"asterisk\">(*)</span></b></label>\n" +
"                               <input type=\"text\" class=\"form-control validate[required]\" id=\"codigo\">\n" +
"                           </div>" +
"                           <div class=\"col-sm-12\"></div>\n" +
"                           <div class=\"col-sm-12\"></div>\n" +
"                       </fieldset>\n" +
"                   </div>" + 
"                   <div class=\"form-footer\">\n" +
"                       <div class=\"pull-right\">\n" +
"                           <button class=\"btn btn-foursquare\" type=\"button\" onclick=\"agregarNuevaSede();\" ><i class=\"fa fa-save\"></i> GUADAR</button>\n" +
"                           <button class=\"btn btn-warning \" type=\"reset\" onclick=\"\" data-dismiss=\"modal\"><i class=\"fa fa-refresh\"></i> CANCELAR</button>\n" +
"                       </div>\n" +
"                       <div class=\"clearfix\"></div>\n" +
"                   </div></form>");
    }
    private void generarFormEditar(HttpServletRequest request, HttpServletResponse response) throws IOException {
        int id = Integer.parseInt(request.getParameter("sede"));
        SedeService servicio = new SedeService();
        Sede objSede = new Sede();
        objSede = servicio.obtenerSede(id);
        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        pw.println("<div class=\"form-body\"><fieldset>\n" +
"                                                \n" +
"<input type=\"hidden\" id=\"identificador\" value=\""+objSede.getIdLocal()+"\">                                                \n" +
"  \n" +
"  <div class=\"col-sm-6 form-group\">\n" +
"                                                    <label class=\"control-label\" id=\"etiqueta-busqueda\"><b><span class=\"etiqueta\">Nombre</span> <span class=\"asterisk\">(*)</span></b></label>\n" +
"                                                    <input type=\"text\" class=\"form-control\" id=\"nombre\" value=\""+objSede.getDesLocal()+"\">\n" +
"                                                </div>\n" +
"  <div class=\"col-sm-6 form-group\">\n" +
"                                                    <label class=\"control-label\" id=\"etiqueta-busqueda\"><b><span class=\"etiqueta\">Abreviación</span> <span class=\"asterisk\">(*)</span></b></label>\n" +
"                                                    <input type=\"text\" class=\"form-control\" id=\"abreviacion\" value=\""+objSede.getAbrev()+"\">\n" +
"                                                </div>\n" +
"  <div class=\"col-sm-12\"></div>\n" +
"  \n" +
"  <div class=\"col-sm-6 form-group\">\n" +
"                                                    <label class=\"control-label\" id=\"etiqueta-busqueda\"><b><span class=\"etiqueta\">Asociación</span> <span class=\"asterisk\">(*)</span></b></label>\n" +
"                                                    <select class=\"form-control chosen-select\" id=\"asociacion\" data-value=\""+objSede.getAsoc()+"\">\n" +
"                                                        <option value=\"\">[SELECCIONE]</option>\n");
if("SACO OLIVEROS".equals(objSede.getAsoc().trim())){pw.print("<option value=\"SACO OLIVEROS\" SELECTED=\"true\">SACO OLIVEROS</option>\n");}else{pw.print("<option value=\"SACO OLIVEROS\">SACO OLIVEROS</option>\n");}
if("APEIRON".equals(objSede.getAsoc().trim())){pw.print("<option value=\"APEIRON\" SELECTED=\"true\">APEIRON</option>\n");}else{pw.print("<option value=\"APEIRON\">APEIRON</option>\n");}
if("HELICOIDAL".equals(objSede.getAsoc().trim())){pw.print("<option value=\"HELICOIDAL\" SELECTED=\"true\">HELICOIDAL</option>\n");}else{pw.print("<option value=\"HELICOIDAL\">HELICOIDAL</option>\n");}
pw.print("</select>\n" +
"                                                </div><div class=\"col-sm-6 form-group\" id=\"lista-departamento\">\n" +
"                                                    <label class=\"control-label\" id=\"etiqueta-busqueda\"><b><span class=\"etiqueta\">Departamento</span> <span class=\"asterisk\">(*)</span></b></label>\n" +
"                                                    <select class=\"form-control chosen-select\" id=\"departamento\" data-value=\""+objSede.getDepartamento()+"\">\n" +
"  <option value=\"\">[SELECCIONE]</option>\n" +
"</select>\n" +
"                                                </div>\n" +
"  \n" +
"  <div class=\"col-sm-6 form-group\" id=\"lista-provincia\">\n" +
"                                                    <label class=\"control-label\" id=\"etiqueta-busqueda\"><b><span class=\"etiqueta\">Provincia</span> <span class=\"asterisk\">(*)</span></b></label>\n" +
"                                                    <select class=\"form-control chosen-select\" id=\"provincia\" data-value=\""+objSede.getProvincia()+"\">\n" +
"  <option value=\"\">[SELECCIONE]</option>\n" +
"</select>\n" +
"                                                </div><div class=\"col-sm-6 form-group\" id=\"lista-distrito\">\n" +
"                                                    <label class=\"control-label\" id=\"etiqueta-busqueda\"><b><span class=\"etiqueta\">Distrito</span> <span class=\"asterisk\">(*)</span></b></label>\n" +
"                                                    <select class=\"form-control chosen-select\" id=\"distrito\" data-value=\""+objSede.getDistrito()+"\">\n" +
"  <option value=\"0\">[SELECCIONE]</option>\n" +
"</select>\n" +
"                                                </div>\n" +
"  \n" +
"  <div class=\"col-sm-12\"></div><div class=\"col-sm-12\"></div>\n" +
"                                                \n" +
"                                                \n" +
"                                            </fieldset>\n" +
"                                        </div>" + 
"                                        <div class=\"form-footer\">\n" +
"                                            <div class=\"pull-right\">\n" +
"                                                <button class=\"btn btn-foursquare  \" type=\"button\" onclick=\"editarSede();\" data-dismiss=\"modal\"><i class=\"fa fa-save\"></i> ACTUALIZAR</button>\n" +
"                                                <button class=\"btn btn-warning \" type=\"reset\" onclick=\"\" data-dismiss=\"modal\"><i class=\"fa fa-refresh\"></i> CANCELAR</button>\n" +
"                                            </div>\n" +
"                                            <div class=\"clearfix\"></div>\n" +
"                                        </div>");
    }
    
    private void generarFormAsignarBoleta(HttpServletRequest request, HttpServletResponse response) throws IOException {
        int id = Integer.parseInt(request.getParameter("sede"));
        BoletaService servicio = new BoletaService();
        ArrayList<Boleta> lista = new ArrayList<>();
        lista = servicio.listarCarreras(id);
        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        pw.println("<div class=\"form-body\">" + 
"                       <fieldset>\n" +
"                           <div class=\"col-sm-8 form-group\">\n" +
"                               <table class=\"table table-saco rounded mb-20 border\"> \n" +
"                                   <thead> \n" +
"                                      <tr> \n" +
"                                          <th class=\"text-center\">Codigo</th> \n" +
"                                          <th class=\"text-center\">Número de Serie</th> \n" +
"                                          <th class=\"text-center\">Inicio Corr.</th> \n" +
"                                          <th class=\"text-center\">Fin Corr.</th> \n" +
"                                          <th class=\"text-center\">Estado</th> \n" +
"                                          <th class=\"text-center\">Eliminar</th> \n" +
"                                      </tr> \n" +
"                                   </thead> \n" +
"                                   <tbody> \n");
        if(lista.size()>0){
            for (int i = 0; i < lista.size(); i++) {
                pw.println("<tr> \n");
                pw.println("<td>"+(i+1)+"</td>\n");
                pw.println("<td>"+lista.get(i).getNum_serie()+"</td>\n");
                pw.println("<td>"+lista.get(i).getDocu_min()+"</td>\n");
                pw.println("<td>"+lista.get(i).getDocu_max()+"</td>\n");
                if(lista.get(i).getEstado()==0){
                    pw.println("<td>Pendiente</td>\n");
                }
                else if(lista.get(i).getEstado()==1){
                    pw.println("<td>En uso</td>\n");
                }
                else if(lista.get(i).getEstado()==2){
                    pw.println("<td>Terminado</td>\n");
                }
                if(lista.get(i).getEstado()==0){
                    pw.println("<td>"+lista.get(i).getCod_boleta()+"</td>\n");
                }
                else{
                    pw.println("<td>-</td>\n");
                }
                pw.println("</tr> \n");
            }
        }
        else{
            pw.println("<tr><td colspan='6'>No se encontraron registros.</td></tr> \n");
        }
pw.println("                                   </tbody> \n" +
"                               </table> \n" +
"                           </div> \n" +
"                           <div class=\"col-sm-4 form-group\">\n" +
"                           <form id='agregar_boleta'>\n" +
"                               <div class=\"col-sm-12 form-group\">\n" +
"                                   <label class=\"control-label\" id=\"etiqueta-busqueda\"><b><span class=\"etiqueta\">N° Serie:</span> <span class=\"asterisk\">(*)</span></b></label>\n" +
"                                   <input type=\"text\" class=\"form-control validate[required,custom[integer]]\" id=\"serie\" value=\"\">\n" +
"                                   <input type=\"hidden\" id=\"identificador\" value=\""+id+"\">\n" +
"                               </div>\n" +
"                               <div class=\"col-sm-12 form-group\">\n" +
"                                   <label class=\"control-label\" id=\"etiqueta-busqueda\"><b><span class=\"etiqueta\">Inicio Correlativo</span> <span class=\"asterisk\">(*)</span></b></label>\n" +
"                                   <input type=\"text\" class=\"form-control validate[required,custom[integer]]\" id=\"min\" value=\"\">\n" +
"                               </div>\n" +
"                               <div class=\"col-sm-12 form-group\">\n" +
"                                   <label class=\"control-label\" id=\"etiqueta-busqueda\"><b><span class=\"etiqueta\">Fin Correlativo</span> <span class=\"asterisk\">(*)</span></b></label>\n" +
"                                   <input type=\"text\" class=\"form-control validate[required,custom[integer]]\" id=\"max\" value=\"\">\n" +
"                               </div>\n" +
"                               <div class=\"col-sm-12 form-group\">\n" +
"                                   <button class=\"btn btn-foursquare\" type=\"button\" onclick=\"AsignarBoleta();\">" +
"                                       <i class=\"fa fa-search\"></i> REGISTRAR" +
"                                   </button>\n" +
"                               </div>\n" +
"                           </form>\n" +
"                           </div>\n" +
"                           <div class=\"col-sm-12\"></div>\n" +
"                       </fieldset>\n" +
"                   </div>" + 
"                   <div class=\"form-footer\">\n" +
"                       <div class=\"pull-right\">\n" +
"                           <button class=\"btn btn-warning \" type=\"reset\" onclick=\"\" data-dismiss=\"modal\"><i class=\"fa fa-refresh\"></i> CERRAR</button>\n" +
"                       </div>\n" +
"                       <div class=\"clearfix\"></div>\n" +
"                   </div>");
    }
    
    private void agregarBoleta(HttpServletRequest request, HttpServletResponse response) throws IOException {
        int sede = Integer.parseInt(request.getParameter("sede"));
        int serie = Integer.parseInt(request.getParameter("serie"));
        int inicio = Integer.parseInt(request.getParameter("inicio"));
        int fin = Integer.parseInt(request.getParameter("fin"));
        
        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        BoletaService servicio = new BoletaService();
        int r = servicio.registrarBoletas(sede, serie, inicio, fin);
        pw.print(r);
    }
    
    //MANTENIMIENTO
    private void cambiarEstadoSede(HttpServletRequest request, HttpServletResponse response) throws IOException {
        int id = Integer.parseInt(request.getParameter("sede"));
        int estado = Integer.parseInt(request.getParameter("estado"));
        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        SedeService servicio = new SedeService();
        int r = servicio.cambiarEstadoSede(id, estado);
        pw.println(r);
    }
    
    private void agregarSede(HttpServletRequest request, HttpServletResponse response) throws IOException {
        String nombre = request.getParameter("nombre");
        String abrevi = request.getParameter("abreviacion");
        String asocia = request.getParameter("asociacion");
        int ubigeo = Integer.parseInt(request.getParameter("ubigeo"));
        String direccion = request.getParameter("dir");
        String telefono = request.getParameter("tel");
        String autorizacion = request.getParameter("autorizacion");
        String ticketera = request.getParameter("ticketera");
        int codsede = Integer.parseInt(request.getParameter("codsede"));
        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        SedeService servicio = new SedeService();
        int r = servicio.agregarSede(nombre, abrevi, asocia, ubigeo,direccion, telefono, autorizacion, ticketera, codsede);
        pw.println(r);
    }
    
    private void editarSede(HttpServletRequest request, HttpServletResponse response) throws IOException {
        int id = Integer.parseInt(request.getParameter("id"));
        String nombre = request.getParameter("nombre");
        String abrevi = request.getParameter("abreviacion");
        String asocia = request.getParameter("asociacion");
        int ubigeo = Integer.parseInt(request.getParameter("ubigeo"));
        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        SedeService servicio = new SedeService();
        int r = servicio.editarSede(id, nombre, abrevi, asocia, ubigeo);
        pw.println(r);
    }
    
    private void guardarSessionesSede(HttpServletRequest request, HttpServletResponse response) throws IOException {
        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        //------------------------Crear la sesiones-------------------------
        int idCentro = Integer.parseInt(request.getParameter("centro"));
        String nomCentro = request.getParameter("nom_centro");
         String nomNivel = request.getParameter("nom_nivel");
        String nomGrado = request.getParameter("nom_grado");
        String nomCiclo = request.getParameter("nom_ciclo");
        int idNivel = Integer.parseInt(request.getParameter("nivel"));
        int idGrado = Integer.parseInt(request.getParameter("grado"));
        int idCiclo = Integer.parseInt(request.getParameter("ciclo"));
        HttpSession session_actual = request.getSession(true);
        session_actual.setAttribute("idCentro",idCentro);
        session_actual.setAttribute("nomCentro",nomCentro);
        session_actual.setAttribute("idNivel",idNivel);
        session_actual.setAttribute("nomNivel",nomNivel);
        session_actual.setAttribute("idGrado",idGrado);
        session_actual.setAttribute("nomGrado",nomGrado);
        session_actual.setAttribute("idCiclo",idCiclo);
        session_actual.setAttribute("nomCiclo",nomCiclo);
        session_actual.setMaxInactiveInterval(10 * 60 * 60); // 10 horas

        //------------------------------------------------------------------
        pw.println("1");
    }
}
