
package pe.siso.academia.Servlets;

import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import pe.siso.academia.Beans.Ubigeo;
import pe.siso.academia.Services.UbigeoService;

public class ServletUbigeo extends HttpServlet {

    
    @Override
    protected void service(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
        String param=request.getParameter("accion");
        if("listarDepartamentos".equals(param)){
            listarDepartamentos(request, response);
        }
        else if("listarDepartamentoEdicion".equals(param)){
            listarDepartamentoEdicion(request, response);
        }
        else if("listarProvincias".equals(param)){
            listarProvincias(request, response);
        }
        else if("listarProvinciaEdicion".equals(param)){
            listarProvinciaEdicion(request, response);
        }
        else if("listarDistritos".equals(param)){
            listarDistritos(request, response);
        }
        else if("listarDistritoEdicion".equals(param)){
            listarDistritoEdicion(request, response);
        }
    }
    
    private void listarDepartamentos(HttpServletRequest request, HttpServletResponse response) throws IOException {
        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        ArrayList<Ubigeo> lista = null;
        UbigeoService servicio = new UbigeoService();
        lista = servicio.listarDepartamentos();
        pw.println("<label class=\"control-label\"><b>Departamento: </b></label>\n" +
"                       <select class=\"form-control chosen-select\" id=\"departamento\" data-referencia=\"12\" onchange=\"listarProvincias(this);agregarAlResumen(this);\">\n" );
        pw.println("        <option value=\"0\">[SELECCIONE]</option>");
        for(int i = 0; i<lista.size();i++){
            pw.println("<option value=\""+lista.get(i).getCodDep()+"\">"+lista.get(i).getNomDep()+"</option>");
        }
        pw.println("                       </select>");
    }
    
    private void listarDepartamentoEdicion(HttpServletRequest request, HttpServletResponse response) throws IOException {
        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        ArrayList<Ubigeo> lista = null;
        UbigeoService servicio = new UbigeoService();
        lista = servicio.listarDepartamentos();
        String dep = request.getParameter("dep");
        pw.println("<label class=\"control-label\"><b>Departamento: </b></label>\n" +
"                       <select class=\"form-control chosen-select\" id=\"departamento\" data-referencia=\"12\" onchange=\"listarProvincias(this);agregarAlResumen(this);\">\n" );
        pw.println("        <option value=\"0\">[SELECCIONE]</option>");
        for(int i = 0; i<lista.size();i++){
            if(dep.trim().equals(lista.get(i).getNomDep().trim())){
                pw.println("<option value=\""+lista.get(i).getCodDep()+"\" SELECTED=\"true\">"+lista.get(i).getNomDep()+"</option>");
            }
            else{
                pw.println("<option value=\""+lista.get(i).getCodDep()+"\">"+lista.get(i).getNomDep()+"</option>");
            }
        }
        pw.println("                       </select>");
    }
    
    private void listarProvincias(HttpServletRequest request, HttpServletResponse response) throws IOException {
        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        ArrayList<Ubigeo> lista = null;
        int codDepa = Integer.parseInt(request.getParameter("departamento"));
        UbigeoService servicio = new UbigeoService();
        lista = servicio.listarProvincias(codDepa);
        pw.println("<label class=\"control-label\"><b>Provincia: </b></label>\n" +
"                       <select class=\"form-control chosen-select\" id=\"provincia\" data-referencia=\"13\" onchange=\"listarDistritos(this);agregarAlResumen(this);\">\n" );
        pw.println("        <option value=\"0\">[SELECCIONE]</option>");
        for(int i = 0; i<lista.size();i++){
            pw.println("<option value=\""+lista.get(i).getCodProv()+"\">"+lista.get(i).getNomProv()+"</option>");
        }
        pw.println("                       </select>");
    }
    
    private void listarProvinciaEdicion(HttpServletRequest request, HttpServletResponse response) throws IOException {
        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        ArrayList<Ubigeo> lista = null;
        int codDepa = Integer.parseInt(request.getParameter("departamento"));
        UbigeoService servicio = new UbigeoService();
        lista = servicio.listarProvincias(codDepa);
        String pro = request.getParameter("pro");
        pw.println("<label class=\"control-label\"><b>Provincia: </b></label>\n" +
"                       <select class=\"form-control chosen-select\" id=\"provincia\" data-referencia=\"13\" onchange=\"listarDistritos(this);agregarAlResumen(this);\">\n" );
        pw.println("        <option value=\"0\">[SELECCIONE]</option>");
        for(int i = 0; i<lista.size();i++){
            if(pro.trim().equals(lista.get(i).getNomProv().trim())){
                pw.println("<option value=\""+lista.get(i).getCodProv()+"\" SELECTED=\"true\">"+lista.get(i).getNomProv()+"</option>");
            }
            else{
                pw.println("<option value=\""+lista.get(i).getCodProv()+"\">"+lista.get(i).getNomProv()+"</option>");
            }
        }
        pw.println("                       </select>");
    }
    
    private void listarDistritos(HttpServletRequest request, HttpServletResponse response) throws IOException {
        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        ArrayList<Ubigeo> lista = null;
        int codProv = Integer.parseInt(request.getParameter("provincia"));
        int codDep = Integer.parseInt(request.getParameter("departamento"));
        UbigeoService servicio = new UbigeoService();
        lista = servicio.listarDistritos(codProv,codDep);
        pw.println("<label class=\"control-label\"><b>Distrito: </b></label>\n" +
"                       <select class=\"form-control chosen-select\" id=\"distrito\" data-referencia=\"14\" onchange=\"agregarAlResumen(this);\">\n" );
        pw.println("        <option value=\"0\">[SELECCIONE]</option>");
        for(int i = 0; i<lista.size();i++){
            pw.println("<option value=\""+lista.get(i).getCodUbigeo()+"\">"+lista.get(i).getNomDis()+"</option>");
        }
        pw.println("                       </select>");
    }
    
    private void listarDistritoEdicion(HttpServletRequest request, HttpServletResponse response) throws IOException {
        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        ArrayList<Ubigeo> lista = null;
        int codProv = Integer.parseInt(request.getParameter("provincia"));
        int codDep = Integer.parseInt(request.getParameter("departamento"));
        UbigeoService servicio = new UbigeoService();
        lista = servicio.listarDistritos(codProv,codDep);
        String dis = request.getParameter("dis");
        pw.println("<label class=\"control-label\"><b>Distrito: </b></label>\n" +
"                       <select class=\"form-control chosen-select\" id=\"distrito\" data-referencia=\"14\" onchange=\"agregarAlResumen(this);\">\n" );
        pw.println("        <option value=\"0\">[SELECCIONE]</option>");
        for(int i = 0; i<lista.size();i++){
            if(dis.trim().equals(lista.get(i).getNomDis().trim())){
                pw.println("<option value=\""+lista.get(i).getCodUbigeo()+"\" SELECTED=\"true\">"+lista.get(i).getNomDis()+"</option>");
            }
            else{
                pw.println("<option value=\""+lista.get(i).getCodUbigeo()+"\">"+lista.get(i).getNomDis()+"</option>");
            }
        }
        pw.println("                       </select>");
    }
}
