
package pe.siso.academia.Servlets;

import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import pe.siso.academia.Beans.Universidad;
import pe.siso.academia.Services.UniversidadService;

public class ServletUniversidad extends HttpServlet {

    @Override
    protected void service(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
        String param=request.getParameter("accion");
        if("listarUniversidades".equals(param)){
            listarUniversidades(request, response);
        }
        else if("listarUniversidadeEdicion".equals(param)){
            listarUniversidadeEdicion(request, response);
        }
    }
    
    private void listarUniversidades(HttpServletRequest request, HttpServletResponse response) throws IOException {
        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        ArrayList<Universidad> lista = null;
        UniversidadService servicio = new UniversidadService();
        lista = servicio.listarUniversidades();
        int datoReferencia = Integer.parseInt(request.getParameter("num_referencia"));
        String orden = request.getParameter("orden");
        if(orden == null){orden="";}
        String idInput = request.getParameter("id_control");
        pw.println("                                 <label class=\"control-label\" for=\""+idInput+"\"><b>"+orden+"Universidad a la que postula: </b></label>\n");
        pw.println("                                 <select class=\"form-control chosen-select\" id=\""+idInput+"\" data-referencia=\""+datoReferencia+"\" onchange=\"agregarAlResumen(this);\">");
        pw.println("                                     <option value=\"0\">[SELECCIONE]</option>");
        for(int i=0;i<lista.size();i++){
            pw.println("                                 <option value=\""+lista.get(i).getCodUniv()+"\">"+lista.get(i).getNomUniv()+"</option>");
        }
        pw.println("                                 </select>\n");
    }
    
    private void listarUniversidadeEdicion(HttpServletRequest request, HttpServletResponse response) throws IOException {
        response.setContentType("text/html");
        PrintWriter pw = response.getWriter();
        ArrayList<Universidad> lista = null;
        UniversidadService servicio = new UniversidadService();
        lista = servicio.listarUniversidades();
        String univ = request.getParameter("univ");
        int datoReferencia = Integer.parseInt(request.getParameter("num_referencia"));
        String orden = request.getParameter("orden");
        if(orden == null){orden="";}
        String idInput = request.getParameter("id_control");
        pw.println("                                 <label class=\"control-label\" for=\""+idInput+"\"><b>"+orden+"Universidad a la que postula: </b></label>\n");
        pw.println("                                 <select class=\"form-control chosen-select\" id=\""+idInput+"\" data-referencia=\""+datoReferencia+"\" onchange=\"agregarAlResumen(this);\">");
        pw.println("                                     <option value=\"0\">[SELECCIONE]</option>");
        for(int i=0;i<lista.size();i++){
            if(univ.trim().equals(lista.get(i).getNomUniv().trim())){
            pw.println("                                 <option value=\""+lista.get(i).getCodUniv()+"\" SELECTED=\"true\">"+lista.get(i).getNomUniv()+"</option>");
            }
            else{
                pw.println("                                 <option value=\""+lista.get(i).getCodUniv()+"\">"+lista.get(i).getNomUniv()+"</option>");
            }
        }
        pw.println("                                 </select>\n");
    }
}
